""" Cisco_IOS_XR_qos_ma_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR qos\-ma\-oper package operational data.

This module contains definitions
for the following management objects\:
  qos\: QoS operational data

Copyright (c) 2013\-2017 by Cisco Systems, Inc.
All rights reserved.

"""
from collections import OrderedDict

from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YError, YModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error



class CacState(Enum):
    """
    CacState (Enum Class)

    CAC/UBRL class states

    .. data:: unknown = 0

    	unknown

    .. data:: admit = 1

    	admit

    .. data:: redirect = 2

    	redirect

    .. data:: ubrl = 3

    	ubrl

    """

    unknown = Enum.YLeaf(0, "unknown")

    admit = Enum.YLeaf(1, "admit")

    redirect = Enum.YLeaf(2, "redirect")

    ubrl = Enum.YLeaf(3, "ubrl")


class PolicyParamUnit(Enum):
    """
    PolicyParamUnit (Enum Class)

    Policy param unit

    .. data:: policy_param_unit_invalid = 0

    	policy param unit invalid

    .. data:: policy_param_unit_bytes = 1

    	policy param unit bytes

    .. data:: policy_param_unit_kbytes = 2

    	policy param unit kbytes

    .. data:: policy_param_unit_mbytes = 3

    	policy param unit mbytes

    .. data:: policy_param_unit_gbytes = 4

    	policy param unit gbytes

    .. data:: policy_param_unit_bitsps = 5

    	policy param unit bitsps

    .. data:: policy_param_unit_kbitsps = 6

    	policy param unit kbitsps

    .. data:: policy_param_unit_mbitsps = 7

    	policy param unit mbitsps

    .. data:: policy_param_unit_gbitsps = 8

    	policy param unit gbitsps

    .. data:: policy_param_unit_cells_ps = 9

    	policy param unit cells ps

    .. data:: policy_param_unit_packets_ps = 10

    	policy param unit packets ps

    .. data:: policy_param_unit_us = 11

    	policy param unit us

    .. data:: policy_param_unit_ms = 12

    	policy param unit ms

    .. data:: policy_param_unit_seconds = 13

    	policy param unit seconds

    .. data:: policy_param_unit_packets = 14

    	policy param unit packets

    .. data:: policy_param_unit_cells = 15

    	policy param unit cells

    .. data:: policy_param_unit_percent = 16

    	policy param unit percent

    .. data:: policy_param_unit_per_thousand = 17

    	policy param unit per thousand

    .. data:: policy_param_unit_per_million = 18

    	policy param unit per million

    .. data:: policy_param_unit_hz = 19

    	policy param unit hz

    .. data:: policy_param_unit_khz = 20

    	policy param unit khz

    .. data:: policy_param_unit_mhz = 21

    	policy param unit mhz

    .. data:: policy_param_unit_ratio = 22

    	policy param unit ratio

    .. data:: policy_param_unit_max = 23

    	policy param unit max

    """

    policy_param_unit_invalid = Enum.YLeaf(0, "policy-param-unit-invalid")

    policy_param_unit_bytes = Enum.YLeaf(1, "policy-param-unit-bytes")

    policy_param_unit_kbytes = Enum.YLeaf(2, "policy-param-unit-kbytes")

    policy_param_unit_mbytes = Enum.YLeaf(3, "policy-param-unit-mbytes")

    policy_param_unit_gbytes = Enum.YLeaf(4, "policy-param-unit-gbytes")

    policy_param_unit_bitsps = Enum.YLeaf(5, "policy-param-unit-bitsps")

    policy_param_unit_kbitsps = Enum.YLeaf(6, "policy-param-unit-kbitsps")

    policy_param_unit_mbitsps = Enum.YLeaf(7, "policy-param-unit-mbitsps")

    policy_param_unit_gbitsps = Enum.YLeaf(8, "policy-param-unit-gbitsps")

    policy_param_unit_cells_ps = Enum.YLeaf(9, "policy-param-unit-cells-ps")

    policy_param_unit_packets_ps = Enum.YLeaf(10, "policy-param-unit-packets-ps")

    policy_param_unit_us = Enum.YLeaf(11, "policy-param-unit-us")

    policy_param_unit_ms = Enum.YLeaf(12, "policy-param-unit-ms")

    policy_param_unit_seconds = Enum.YLeaf(13, "policy-param-unit-seconds")

    policy_param_unit_packets = Enum.YLeaf(14, "policy-param-unit-packets")

    policy_param_unit_cells = Enum.YLeaf(15, "policy-param-unit-cells")

    policy_param_unit_percent = Enum.YLeaf(16, "policy-param-unit-percent")

    policy_param_unit_per_thousand = Enum.YLeaf(17, "policy-param-unit-per-thousand")

    policy_param_unit_per_million = Enum.YLeaf(18, "policy-param-unit-per-million")

    policy_param_unit_hz = Enum.YLeaf(19, "policy-param-unit-hz")

    policy_param_unit_khz = Enum.YLeaf(20, "policy-param-unit-khz")

    policy_param_unit_mhz = Enum.YLeaf(21, "policy-param-unit-mhz")

    policy_param_unit_ratio = Enum.YLeaf(22, "policy-param-unit-ratio")

    policy_param_unit_max = Enum.YLeaf(23, "policy-param-unit-max")


class PolicyState(Enum):
    """
    PolicyState (Enum Class)

    Different Interface states

    .. data:: active = 0

    	active

    .. data:: suspended = 1

    	suspended

    """

    active = Enum.YLeaf(0, "active")

    suspended = Enum.YLeaf(1, "suspended")


class QosCapsOperationEnum(Enum):
    """
    QosCapsOperationEnum (Enum Class)

    Satellite QOS offload operation

    .. data:: add = 0

    	Add

    .. data:: remove = 1

    	Remove

    .. data:: replace = 2

    	Replace

    .. data:: modify = 3

    	Modify

    .. data:: unknown = 4

    	Unknown

    """

    add = Enum.YLeaf(0, "add")

    remove = Enum.YLeaf(1, "remove")

    replace = Enum.YLeaf(2, "replace")

    modify = Enum.YLeaf(3, "modify")

    unknown = Enum.YLeaf(4, "unknown")


class QosMaSatCapsTypeEnum(Enum):
    """
    QosMaSatCapsTypeEnum (Enum Class)

    Satellite capsulation information

    .. data:: input = 0

    	Input

    .. data:: output = 1

    	Output

    .. data:: unknown = 2

    	Unknown

    """

    input = Enum.YLeaf(0, "input")

    output = Enum.YLeaf(1, "output")

    unknown = Enum.YLeaf(2, "unknown")


class Wred(Enum):
    """
    Wred (Enum Class)

    Wred

    .. data:: wred_cos_cmd = 0

    	wred cos cmd

    .. data:: wred_dscp_cmd = 1

    	wred dscp cmd

    .. data:: wred_precedence_cmd = 2

    	wred precedence cmd

    .. data:: wred_discard_class_cmd = 3

    	wred discard class cmd

    .. data:: wred_mpls_exp_cmd = 4

    	wred mpls exp cmd

    .. data:: red_with_user_min_max = 5

    	red with user min max

    .. data:: red_with_default_min_max = 6

    	red with default min max

    .. data:: wred_dei_cmd = 7

    	wred dei cmd

    .. data:: wred_ecn_cmd = 8

    	wred ecn cmd

    .. data:: wred_invalid_cmd = 9

    	wred invalid cmd

    """

    wred_cos_cmd = Enum.YLeaf(0, "wred-cos-cmd")

    wred_dscp_cmd = Enum.YLeaf(1, "wred-dscp-cmd")

    wred_precedence_cmd = Enum.YLeaf(2, "wred-precedence-cmd")

    wred_discard_class_cmd = Enum.YLeaf(3, "wred-discard-class-cmd")

    wred_mpls_exp_cmd = Enum.YLeaf(4, "wred-mpls-exp-cmd")

    red_with_user_min_max = Enum.YLeaf(5, "red-with-user-min-max")

    red_with_default_min_max = Enum.YLeaf(6, "red-with-default-min-max")

    wred_dei_cmd = Enum.YLeaf(7, "wred-dei-cmd")

    wred_ecn_cmd = Enum.YLeaf(8, "wred-ecn-cmd")

    wred_invalid_cmd = Enum.YLeaf(9, "wred-invalid-cmd")



class Qos(Entity):
    """
    QoS operational data
    
    .. attribute:: nv_interface_table
    
    	Operational data for satellite interfaces
    	**type**\:  :py:class:`NvInterfaceTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable>`
    
    .. attribute:: nv_satellite
    
    	Satellite table
    	**type**\:  :py:class:`NvSatellite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite>`
    
    .. attribute:: nodes
    
    	Node\-specific QoS operational data
    	**type**\:  :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes>`
    
    .. attribute:: qos_global
    
    	For global registrations
    	**type**\:  :py:class:`QosGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal>`
    
    .. attribute:: interface_table
    
    	Operational data for all interfaces
    	**type**\:  :py:class:`InterfaceTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable>`
    
    

    """

    _prefix = 'qos-ma-oper'
    _revision = '2017-09-13'

    def __init__(self):
        super(Qos, self).__init__()
        self._top_entity = None

        self.yang_name = "qos"
        self.yang_parent_name = "Cisco-IOS-XR-qos-ma-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self.ylist_key_names = []
        self._child_classes = OrderedDict([("nv-interface-table", ("nv_interface_table", Qos.NvInterfaceTable)), ("nv-satellite", ("nv_satellite", Qos.NvSatellite)), ("nodes", ("nodes", Qos.Nodes)), ("qos-global", ("qos_global", Qos.QosGlobal)), ("interface-table", ("interface_table", Qos.InterfaceTable))])
        self._leafs = OrderedDict()

        self.nv_interface_table = Qos.NvInterfaceTable()
        self.nv_interface_table.parent = self
        self._children_name_map["nv_interface_table"] = "nv-interface-table"

        self.nv_satellite = Qos.NvSatellite()
        self.nv_satellite.parent = self
        self._children_name_map["nv_satellite"] = "nv-satellite"

        self.nodes = Qos.Nodes()
        self.nodes.parent = self
        self._children_name_map["nodes"] = "nodes"

        self.qos_global = Qos.QosGlobal()
        self.qos_global.parent = self
        self._children_name_map["qos_global"] = "qos-global"

        self.interface_table = Qos.InterfaceTable()
        self.interface_table.parent = self
        self._children_name_map["interface_table"] = "interface-table"
        self._segment_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos"
        self._is_frozen = True

    def __setattr__(self, name, value):
        self._perform_setattr(Qos, [], name, value)


    class NvInterfaceTable(Entity):
        """
        Operational data for satellite interfaces
        
        .. attribute:: interface
        
        	QoS policy\-map operational data for a particular interface
        	**type**\: list of  		 :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface>`
        
        

        """

        _prefix = 'qos-ma-oper'
        _revision = '2017-09-13'

        def __init__(self):
            super(Qos.NvInterfaceTable, self).__init__()

            self.yang_name = "nv-interface-table"
            self.yang_parent_name = "qos"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("interface", ("interface", Qos.NvInterfaceTable.Interface))])
            self._leafs = OrderedDict()

            self.interface = YList(self)
            self._segment_path = lambda: "nv-interface-table"
            self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Qos.NvInterfaceTable, [], name, value)


        class Interface(Entity):
            """
            QoS policy\-map operational data for a particular
            interface
            
            .. attribute:: interface_name  (key)
            
            	Name of the interface
            	**type**\: str
            
            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
            
            .. attribute:: nodes
            
            	QoS policy\-map node table
            	**type**\:  :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes>`
            
            .. attribute:: member_interfaces
            
            	QoS policy\-map member interface table
            	**type**\:  :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces>`
            
            .. attribute:: satellite_ids
            
            	Satellite ID information
            	**type**\:  :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds>`
            
            .. attribute:: input
            
            	A piece of QoS policy\-map operational data for an interface
            	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input>`
            
            .. attribute:: output
            
            	A piece of QoS policy\-map operational data for an interface
            	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output>`
            
            

            """

            _prefix = 'qos-ma-oper'
            _revision = '2017-09-13'

            def __init__(self):
                super(Qos.NvInterfaceTable.Interface, self).__init__()

                self.yang_name = "interface"
                self.yang_parent_name = "nv-interface-table"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['interface_name']
                self._child_classes = OrderedDict([("nodes", ("nodes", Qos.NvInterfaceTable.Interface.Nodes)), ("member-interfaces", ("member_interfaces", Qos.NvInterfaceTable.Interface.MemberInterfaces)), ("satellite-ids", ("satellite_ids", Qos.NvInterfaceTable.Interface.SatelliteIds)), ("input", ("input", Qos.NvInterfaceTable.Interface.Input)), ("output", ("output", Qos.NvInterfaceTable.Interface.Output))])
                self._leafs = OrderedDict([
                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                ])
                self.interface_name = None

                self.nodes = Qos.NvInterfaceTable.Interface.Nodes()
                self.nodes.parent = self
                self._children_name_map["nodes"] = "nodes"

                self.member_interfaces = Qos.NvInterfaceTable.Interface.MemberInterfaces()
                self.member_interfaces.parent = self
                self._children_name_map["member_interfaces"] = "member-interfaces"

                self.satellite_ids = Qos.NvInterfaceTable.Interface.SatelliteIds()
                self.satellite_ids.parent = self
                self._children_name_map["satellite_ids"] = "satellite-ids"

                self.input = Qos.NvInterfaceTable.Interface.Input()
                self.input.parent = self
                self._children_name_map["input"] = "input"

                self.output = Qos.NvInterfaceTable.Interface.Output()
                self.output.parent = self
                self._children_name_map["output"] = "output"
                self._segment_path = lambda: "interface" + "[interface-name='" + str(self.interface_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/nv-interface-table/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Qos.NvInterfaceTable.Interface, ['interface_name'], name, value)


            class Nodes(Entity):
                """
                QoS policy\-map node table
                
                .. attribute:: node
                
                	QoS operational data for a particular node
                	**type**\: list of  		 :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.NvInterfaceTable.Interface.Nodes, self).__init__()

                    self.yang_name = "nodes"
                    self.yang_parent_name = "interface"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("node", ("node", Qos.NvInterfaceTable.Interface.Nodes.Node))])
                    self._leafs = OrderedDict()

                    self.node = YList(self)
                    self._segment_path = lambda: "nodes"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes, [], name, value)


                class Node(Entity):
                    """
                    QoS operational data for a particular node
                    
                    .. attribute:: node_name  (key)
                    
                    	The node
                    	**type**\: str
                    
                    	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
                    
                    .. attribute:: input
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input>`
                    
                    .. attribute:: output
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.NvInterfaceTable.Interface.Nodes.Node, self).__init__()

                        self.yang_name = "node"
                        self.yang_parent_name = "nodes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = ['node_name']
                        self._child_classes = OrderedDict([("input", ("input", Qos.NvInterfaceTable.Interface.Nodes.Node.Input)), ("output", ("output", Qos.NvInterfaceTable.Interface.Nodes.Node.Output))])
                        self._leafs = OrderedDict([
                            ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                        ])
                        self.node_name = None

                        self.input = Qos.NvInterfaceTable.Interface.Nodes.Node.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"

                        self.output = Qos.NvInterfaceTable.Interface.Nodes.Node.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                        self._segment_path = lambda: "node" + "[node-name='" + str(self.node_name) + "']"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node, ['node_name'], name, value)


                    class Input(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input, self).__init__()

                            self.yang_name = "input"
                            self.yang_parent_name = "node"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames))])
                            self._leafs = OrderedDict()

                            self.service_policy_names = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._segment_path = lambda: "input"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input, [], name, value)


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "input"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance))])
                                self._leafs = OrderedDict()

                                self.service_policy_instance = YList(self)
                                self._segment_path = lambda: "service-policy-names"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames, [], name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  (key)
                                
                                	Name of the policy instance
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['service_policy_name']
                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                    ])
                                    self.service_policy_name = None

                                    self.statistics = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "service-policy-instance"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.child_policy = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "child-policy"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats_(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                    class Output(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output, self).__init__()

                            self.yang_name = "output"
                            self.yang_parent_name = "node"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames))])
                            self._leafs = OrderedDict()

                            self.service_policy_names = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._segment_path = lambda: "output"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output, [], name, value)


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "output"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance))])
                                self._leafs = OrderedDict()

                                self.service_policy_instance = YList(self)
                                self._segment_path = lambda: "service-policy-names"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames, [], name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  (key)
                                
                                	Name of the policy instance
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['service_policy_name']
                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                    ])
                                    self.service_policy_name = None

                                    self.statistics = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "service-policy-instance"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.child_policy = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "child-policy"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats_(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


            class MemberInterfaces(Entity):
                """
                QoS policy\-map member interface table
                
                .. attribute:: member_interface
                
                	QoS policy\-map member interface statistics
                	**type**\: list of  		 :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces, self).__init__()

                    self.yang_name = "member-interfaces"
                    self.yang_parent_name = "interface"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("member-interface", ("member_interface", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface))])
                    self._leafs = OrderedDict()

                    self.member_interface = YList(self)
                    self._segment_path = lambda: "member-interfaces"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces, [], name, value)


                class MemberInterface(Entity):
                    """
                    QoS policy\-map member interface statistics
                    
                    .. attribute:: interface_name  (key)
                    
                    	Name of member interface
                    	**type**\: str
                    
                    	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                    
                    .. attribute:: satellite_ids
                    
                    	Satellite ID information
                    	**type**\:  :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds>`
                    
                    .. attribute:: input
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input>`
                    
                    .. attribute:: output
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface, self).__init__()

                        self.yang_name = "member-interface"
                        self.yang_parent_name = "member-interfaces"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = ['interface_name']
                        self._child_classes = OrderedDict([("satellite-ids", ("satellite_ids", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds)), ("input", ("input", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input)), ("output", ("output", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output))])
                        self._leafs = OrderedDict([
                            ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ])
                        self.interface_name = None

                        self.satellite_ids = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds()
                        self.satellite_ids.parent = self
                        self._children_name_map["satellite_ids"] = "satellite-ids"

                        self.input = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"

                        self.output = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                        self._segment_path = lambda: "member-interface" + "[interface-name='" + str(self.interface_name) + "']"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface, ['interface_name'], name, value)


                    class SatelliteIds(Entity):
                        """
                        Satellite ID information
                        
                        .. attribute:: satellite_id
                        
                        	Satellite ID information
                        	**type**\: list of  		 :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, self).__init__()

                            self.yang_name = "satellite-ids"
                            self.yang_parent_name = "member-interface"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("satellite-id", ("satellite_id", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId))])
                            self._leafs = OrderedDict()

                            self.satellite_id = YList(self)
                            self._segment_path = lambda: "satellite-ids"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, [], name, value)


                        class SatelliteId(Entity):
                            """
                            Satellite ID information
                            
                            .. attribute:: nv_satellite_id  (key)
                            
                            	Satellite ID
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: input
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input>`
                            
                            .. attribute:: output
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__init__()

                                self.yang_name = "satellite-id"
                                self.yang_parent_name = "satellite-ids"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['nv_satellite_id']
                                self._child_classes = OrderedDict([("input", ("input", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input)), ("output", ("output", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output))])
                                self._leafs = OrderedDict([
                                    ('nv_satellite_id', (YLeaf(YType.int32, 'nv-satellite-id'), ['int'])),
                                ])
                                self.nv_satellite_id = None

                                self.input = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"

                                self.output = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                                self._segment_path = lambda: "satellite-id" + "[nv-satellite-id='" + str(self.nv_satellite_id) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, ['nv_satellite_id'], name, value)


                            class Input(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: service_policy_names
                                
                                	Operational data for all Policy instance
                                	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, self).__init__()

                                    self.yang_name = "input"
                                    self.yang_parent_name = "satellite-id"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames))])
                                    self._leafs = OrderedDict()

                                    self.service_policy_names = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                    self._segment_path = lambda: "input"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, [], name, value)


                                class ServicePolicyNames(Entity):
                                    """
                                    Operational data for all Policy instance
                                    
                                    .. attribute:: service_policy_instance
                                    
                                    	QoS policy\-map operational data for a particular Policy 
                                    	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                        self.yang_name = "service-policy-names"
                                        self.yang_parent_name = "input"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_instance = YList(self)
                                        self._segment_path = lambda: "service-policy-names"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, [], name, value)


                                    class ServicePolicyInstance(Entity):
                                        """
                                        QoS policy\-map operational data for a
                                        particular Policy 
                                        
                                        .. attribute:: service_policy_name  (key)
                                        
                                        	Name of the policy instance
                                        	**type**\: str
                                        
                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                        
                                        .. attribute:: statistics
                                        
                                        	Policy\-map statistics operational data for an interface
                                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                            self.yang_name = "service-policy-instance"
                                            self.yang_parent_name = "service-policy-names"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = ['service_policy_name']
                                            self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                            self._leafs = OrderedDict([
                                                ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                            ])
                                            self.service_policy_name = None

                                            self.statistics = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                            self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                        class Statistics(Entity):
                                            """
                                            Policy\-map statistics operational data for an
                                            interface
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                self.yang_name = "statistics"
                                                self.yang_parent_name = "service-policy-instance"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "statistics"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                
                                                .. attribute:: child_policy
                                                
                                                	child policy
                                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "statistics"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.child_policy = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"

                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class ChildPolicy(Entity):
                                                    """
                                                    child policy
                                                    
                                                    .. attribute:: policy_name
                                                    
                                                    	PolicyName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: state
                                                    
                                                    	State
                                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                    
                                                    .. attribute:: state_description
                                                    
                                                    	StateDescription
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..128
                                                    
                                                    .. attribute:: satid
                                                    
                                                    	to maintain satellite id
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: class_stats
                                                    
                                                    	array of classes contained in policy
                                                    	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                        self.yang_name = "child-policy"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                        self._leafs = OrderedDict([
                                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                        ])
                                                        self.policy_name = None
                                                        self.state = None
                                                        self.state_description = None
                                                        self.satid = None

                                                        self.class_stats = YList(self)
                                                        self._segment_path = lambda: "child-policy"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                    class ClassStats_(Entity):
                                                        """
                                                        array of classes contained in policy
                                                        
                                                        .. attribute:: general_stats
                                                        
                                                        	general stats
                                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                        
                                                        .. attribute:: iphc_stats
                                                        
                                                        	IPHC stats
                                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                        
                                                        .. attribute:: cac_stats
                                                        
                                                        	bag for cac stats
                                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                        
                                                        .. attribute:: counter_validity_bitmask
                                                        
                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: megabyte
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	ClassName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: shared_queue_id
                                                        
                                                        	q\-id of the  shared queue for this class
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_descr
                                                        
                                                        	Description of queue for the class
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..256
                                                        
                                                        .. attribute:: cac_state
                                                        
                                                        	CACState
                                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                        
                                                        .. attribute:: queue_stats_array
                                                        
                                                        	array of queue stats
                                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                        
                                                        .. attribute:: police_stats_array
                                                        
                                                        	array of police stats
                                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                        
                                                        .. attribute:: wred_stats_array
                                                        
                                                        	array of red stats
                                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                            self.yang_name = "class-stats"
                                                            self.yang_parent_name = "child-policy"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                            self._leafs = OrderedDict([
                                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                            ])
                                                            self.counter_validity_bitmask = None
                                                            self.class_name = None
                                                            self.shared_queue_id = None
                                                            self.queue_descr = None
                                                            self.cac_state = None

                                                            self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"

                                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                                            self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"

                                                            self.queue_stats_array = YList(self)
                                                            self.police_stats_array = YList(self)
                                                            self.wred_stats_array = YList(self)
                                                            self._segment_path = lambda: "class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                        class GeneralStats(Entity):
                                                            """
                                                            general stats
                                                            
                                                            .. attribute:: transmit_packets
                                                            
                                                            	Transmitted packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: transmit_bytes
                                                            
                                                            	Transmitted bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_packets
                                                            
                                                            	Dropped packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_bytes
                                                            
                                                            	Dropped bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_rate
                                                            
                                                            	Total drop rate (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: match_data_rate
                                                            
                                                            	Incoming matched data rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: total_transmit_rate
                                                            
                                                            	Total transmit rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: pre_policy_matched_packets
                                                            
                                                            	Matched pkts before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: pre_policy_matched_bytes
                                                            
                                                            	Matched bytes before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                self.yang_name = "general-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                ])
                                                                self.transmit_packets = None
                                                                self.transmit_bytes = None
                                                                self.total_drop_packets = None
                                                                self.total_drop_bytes = None
                                                                self.total_drop_rate = None
                                                                self.match_data_rate = None
                                                                self.total_transmit_rate = None
                                                                self.pre_policy_matched_packets = None
                                                                self.pre_policy_matched_bytes = None
                                                                self._segment_path = lambda: "general-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                        class IphcStats(Entity):
                                                            """
                                                            IPHC stats
                                                            
                                                            .. attribute:: non_tcp_total_out_packets
                                                            
                                                            	TotalNum of Non tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_total_out_bytes
                                                            
                                                            	TotalNum of Non Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_bytes_saved
                                                            
                                                            	Non Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_compressed_packets_out
                                                            
                                                            	Num of non tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                            
                                                            	Compressed Non Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_full_header_packets_out
                                                            
                                                            	Num of non tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_packets
                                                            
                                                            	Total Num of tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_bytes
                                                            
                                                            	TotalNum of Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_bytes_saved
                                                            
                                                            	Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_compressed_packets_out
                                                            
                                                            	Num of tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_bytes_sent_rate
                                                            
                                                            	Compressed Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_full_header_packets_out
                                                            
                                                            	Num of tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                self.yang_name = "iphc-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                ])
                                                                self.non_tcp_total_out_packets = None
                                                                self.non_tcp_total_out_bytes = None
                                                                self.non_tcp_bytes_saved = None
                                                                self.non_tcp_compressed_packets_out = None
                                                                self.non_tcp_bytes_sent_rate = None
                                                                self.non_tcp_full_header_packets_out = None
                                                                self.tcp_total_out_packets = None
                                                                self.tcp_total_out_bytes = None
                                                                self.tcp_bytes_saved = None
                                                                self.tcp_compressed_packets_out = None
                                                                self.tcp_bytes_sent_rate = None
                                                                self.tcp_full_header_packets_out = None
                                                                self._segment_path = lambda: "iphc-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                        class CacStats(Entity):
                                                            """
                                                            bag for cac stats
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	CAC dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	CAC dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_rates
                                                            
                                                            	CAC dropped rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: admitpackets
                                                            
                                                            	Admitted packets (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_bytes
                                                            
                                                            	Admitted bytes (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_rates
                                                            
                                                            	CAC admit rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                self.yang_name = "cac-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.drop_rates = None
                                                                self.admitpackets = None
                                                                self.admit_bytes = None
                                                                self.admit_rates = None
                                                                self._segment_path = lambda: "cac-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                        class QueueStatsArray(Entity):
                                                            """
                                                            array of queue stats
                                                            
                                                            .. attribute:: queue_id
                                                            
                                                            	Queue Id used for Fabric Stats
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: tail_drop_packets
                                                            
                                                            	Packets tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tail_drop_bytes
                                                            
                                                            	Bytes tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp0_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp0_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp1_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp1_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: queue_drop_threshold
                                                            
                                                            	tail drop threshold of the queue in bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: forced_wred_stats_display
                                                            
                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                            	**type**\: bool
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Packets probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Bytes probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_instance_length
                                                            
                                                            	Queue instance length
                                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                            
                                                            .. attribute:: queue_average_length
                                                            
                                                            	Queue average length
                                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                            
                                                            .. attribute:: queue_max_length
                                                            
                                                            	Queue maximum length
                                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                self.yang_name = "queue-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                self._leafs = OrderedDict([
                                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ])
                                                                self.queue_id = None
                                                                self.tail_drop_packets = None
                                                                self.tail_drop_bytes = None
                                                                self.atm_clp0_drop_packets = None
                                                                self.atm_clp0_drop_bytes = None
                                                                self.atm_clp1_drop_packets = None
                                                                self.atm_clp1_drop_bytes = None
                                                                self.queue_drop_threshold = None
                                                                self.forced_wred_stats_display = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None

                                                                self.queue_instance_length = YList(self)
                                                                self.queue_average_length = YList(self)
                                                                self.queue_max_length = YList(self)
                                                                self._segment_path = lambda: "queue-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                            class QueueInstanceLength(Entity):
                                                                """
                                                                Queue instance length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                    self.yang_name = "queue-instance-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-instance-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                            class QueueAverageLength(Entity):
                                                                """
                                                                Queue average length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                    self.yang_name = "queue-average-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-average-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                            class QueueMaxLength(Entity):
                                                                """
                                                                Queue maximum length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                    self.yang_name = "queue-max-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-max-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                        class PoliceStatsArray(Entity):
                                                            """
                                                            array of police stats
                                                            
                                                            .. attribute:: color_class_stats
                                                            
                                                            	color class stats
                                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	Police dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	Police dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_packets
                                                            
                                                            	Packets violating the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_bytes
                                                            
                                                            	Bytes that violate the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: parent_drop_packets
                                                            
                                                            	Dropped pkts by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: parent_drop_bytes
                                                            
                                                            	Dropped bytes by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_rate
                                                            
                                                            	Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                self.yang_name = "police-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.violate_packets = None
                                                                self.violate_bytes = None
                                                                self.parent_drop_packets = None
                                                                self.parent_drop_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None
                                                                self.violate_rate = None

                                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                self._segment_path = lambda: "police-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                            class ColorClassStats(Entity):
                                                                """
                                                                color class stats
                                                                
                                                                .. attribute:: conform_class_conform_packets
                                                                
                                                                	Packets with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_conform_bytes
                                                                
                                                                	Bytes with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_conform_rate
                                                                
                                                                	Conform Class Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_exceed_packets
                                                                
                                                                	Packets with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_exceed_bytes
                                                                
                                                                	Bytes with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_exceed_rate
                                                                
                                                                	Conform Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_violate_packets
                                                                
                                                                	Packets with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_violate_bytes
                                                                
                                                                	Bytes with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_violate_rate
                                                                
                                                                	Conform Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_exceed_packets
                                                                
                                                                	Packets with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_exceed_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_exceed_rate
                                                                
                                                                	Exceed Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_violate_packets
                                                                
                                                                	Packets with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_violate_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_violate_rate
                                                                
                                                                	Exceed Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_class_violate_packets
                                                                
                                                                	Packets with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_class_violate_bytes
                                                                
                                                                	Bytes with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_class_violate_rate
                                                                
                                                                	Violate Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                    self.yang_name = "color-class-stats"
                                                                    self.yang_parent_name = "police-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                    ])
                                                                    self.conform_class_conform_packets = None
                                                                    self.conform_class_conform_bytes = None
                                                                    self.conform_class_conform_rate = None
                                                                    self.conform_class_exceed_packets = None
                                                                    self.conform_class_exceed_bytes = None
                                                                    self.conform_class_exceed_rate = None
                                                                    self.conform_class_violate_packets = None
                                                                    self.conform_class_violate_bytes = None
                                                                    self.conform_class_violate_rate = None
                                                                    self.exceed_class_exceed_packets = None
                                                                    self.exceed_class_exceed_bytes = None
                                                                    self.exceed_class_exceed_rate = None
                                                                    self.exceed_class_violate_packets = None
                                                                    self.exceed_class_violate_bytes = None
                                                                    self.exceed_class_violate_rate = None
                                                                    self.violate_class_violate_packets = None
                                                                    self.violate_class_violate_bytes = None
                                                                    self.violate_class_violate_rate = None
                                                                    self._segment_path = lambda: "color-class-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                        class WredStatsArray(Entity):
                                                            """
                                                            array of red stats
                                                            
                                                            .. attribute:: profile_title
                                                            
                                                            	ProfileTitle
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..300
                                                            
                                                            .. attribute:: red_transmit_packets
                                                            
                                                            	Transmitted packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_transmit_bytes
                                                            
                                                            	Transmitted bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Probabilistically dropped  packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Probabilisticallydropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_ecn_marked_packets
                                                            
                                                            	ECN marked packets 
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_ecn_marked_bytes
                                                            
                                                            	ECN marked bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_label
                                                            
                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                self.yang_name = "wred-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                self._leafs = OrderedDict([
                                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                ])
                                                                self.profile_title = None
                                                                self.red_transmit_packets = None
                                                                self.red_transmit_bytes = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.red_ecn_marked_packets = None
                                                                self.red_ecn_marked_bytes = None

                                                                self.red_label = YList(self)
                                                                self._segment_path = lambda: "wred-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                            class RedLabel(Entity):
                                                                """
                                                                Array of WRED Typevalues as in PRP stats is
                                                                available per threshold   
                                                                
                                                                .. attribute:: wred_type
                                                                
                                                                	WRED type DSCP, EXP, PREC etc
                                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	WRED value for this type
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                    self.yang_name = "red-label"
                                                                    self.yang_parent_name = "wred-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                    ])
                                                                    self.wred_type = None
                                                                    self.value = None
                                                                    self._segment_path = lambda: "red-label"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                            class Output(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: service_policy_names
                                
                                	Operational data for all Policy instance
                                	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, self).__init__()

                                    self.yang_name = "output"
                                    self.yang_parent_name = "satellite-id"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames))])
                                    self._leafs = OrderedDict()

                                    self.service_policy_names = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                    self._segment_path = lambda: "output"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, [], name, value)


                                class ServicePolicyNames(Entity):
                                    """
                                    Operational data for all Policy instance
                                    
                                    .. attribute:: service_policy_instance
                                    
                                    	QoS policy\-map operational data for a particular Policy 
                                    	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                        self.yang_name = "service-policy-names"
                                        self.yang_parent_name = "output"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_instance = YList(self)
                                        self._segment_path = lambda: "service-policy-names"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, [], name, value)


                                    class ServicePolicyInstance(Entity):
                                        """
                                        QoS policy\-map operational data for a
                                        particular Policy 
                                        
                                        .. attribute:: service_policy_name  (key)
                                        
                                        	Name of the policy instance
                                        	**type**\: str
                                        
                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                        
                                        .. attribute:: statistics
                                        
                                        	Policy\-map statistics operational data for an interface
                                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                            self.yang_name = "service-policy-instance"
                                            self.yang_parent_name = "service-policy-names"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = ['service_policy_name']
                                            self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                            self._leafs = OrderedDict([
                                                ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                            ])
                                            self.service_policy_name = None

                                            self.statistics = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                            self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                        class Statistics(Entity):
                                            """
                                            Policy\-map statistics operational data for an
                                            interface
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                self.yang_name = "statistics"
                                                self.yang_parent_name = "service-policy-instance"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "statistics"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                
                                                .. attribute:: child_policy
                                                
                                                	child policy
                                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "statistics"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.child_policy = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"

                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class ChildPolicy(Entity):
                                                    """
                                                    child policy
                                                    
                                                    .. attribute:: policy_name
                                                    
                                                    	PolicyName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: state
                                                    
                                                    	State
                                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                    
                                                    .. attribute:: state_description
                                                    
                                                    	StateDescription
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..128
                                                    
                                                    .. attribute:: satid
                                                    
                                                    	to maintain satellite id
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: class_stats
                                                    
                                                    	array of classes contained in policy
                                                    	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                        self.yang_name = "child-policy"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                        self._leafs = OrderedDict([
                                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                        ])
                                                        self.policy_name = None
                                                        self.state = None
                                                        self.state_description = None
                                                        self.satid = None

                                                        self.class_stats = YList(self)
                                                        self._segment_path = lambda: "child-policy"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                    class ClassStats_(Entity):
                                                        """
                                                        array of classes contained in policy
                                                        
                                                        .. attribute:: general_stats
                                                        
                                                        	general stats
                                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                        
                                                        .. attribute:: iphc_stats
                                                        
                                                        	IPHC stats
                                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                        
                                                        .. attribute:: cac_stats
                                                        
                                                        	bag for cac stats
                                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                        
                                                        .. attribute:: counter_validity_bitmask
                                                        
                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: megabyte
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	ClassName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: shared_queue_id
                                                        
                                                        	q\-id of the  shared queue for this class
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_descr
                                                        
                                                        	Description of queue for the class
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..256
                                                        
                                                        .. attribute:: cac_state
                                                        
                                                        	CACState
                                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                        
                                                        .. attribute:: queue_stats_array
                                                        
                                                        	array of queue stats
                                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                        
                                                        .. attribute:: police_stats_array
                                                        
                                                        	array of police stats
                                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                        
                                                        .. attribute:: wred_stats_array
                                                        
                                                        	array of red stats
                                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                            self.yang_name = "class-stats"
                                                            self.yang_parent_name = "child-policy"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                            self._leafs = OrderedDict([
                                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                            ])
                                                            self.counter_validity_bitmask = None
                                                            self.class_name = None
                                                            self.shared_queue_id = None
                                                            self.queue_descr = None
                                                            self.cac_state = None

                                                            self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"

                                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                                            self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"

                                                            self.queue_stats_array = YList(self)
                                                            self.police_stats_array = YList(self)
                                                            self.wred_stats_array = YList(self)
                                                            self._segment_path = lambda: "class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                        class GeneralStats(Entity):
                                                            """
                                                            general stats
                                                            
                                                            .. attribute:: transmit_packets
                                                            
                                                            	Transmitted packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: transmit_bytes
                                                            
                                                            	Transmitted bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_packets
                                                            
                                                            	Dropped packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_bytes
                                                            
                                                            	Dropped bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_rate
                                                            
                                                            	Total drop rate (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: match_data_rate
                                                            
                                                            	Incoming matched data rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: total_transmit_rate
                                                            
                                                            	Total transmit rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: pre_policy_matched_packets
                                                            
                                                            	Matched pkts before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: pre_policy_matched_bytes
                                                            
                                                            	Matched bytes before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                self.yang_name = "general-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                ])
                                                                self.transmit_packets = None
                                                                self.transmit_bytes = None
                                                                self.total_drop_packets = None
                                                                self.total_drop_bytes = None
                                                                self.total_drop_rate = None
                                                                self.match_data_rate = None
                                                                self.total_transmit_rate = None
                                                                self.pre_policy_matched_packets = None
                                                                self.pre_policy_matched_bytes = None
                                                                self._segment_path = lambda: "general-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                        class IphcStats(Entity):
                                                            """
                                                            IPHC stats
                                                            
                                                            .. attribute:: non_tcp_total_out_packets
                                                            
                                                            	TotalNum of Non tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_total_out_bytes
                                                            
                                                            	TotalNum of Non Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_bytes_saved
                                                            
                                                            	Non Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_compressed_packets_out
                                                            
                                                            	Num of non tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                            
                                                            	Compressed Non Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_full_header_packets_out
                                                            
                                                            	Num of non tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_packets
                                                            
                                                            	Total Num of tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_bytes
                                                            
                                                            	TotalNum of Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_bytes_saved
                                                            
                                                            	Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_compressed_packets_out
                                                            
                                                            	Num of tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_bytes_sent_rate
                                                            
                                                            	Compressed Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_full_header_packets_out
                                                            
                                                            	Num of tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                self.yang_name = "iphc-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                ])
                                                                self.non_tcp_total_out_packets = None
                                                                self.non_tcp_total_out_bytes = None
                                                                self.non_tcp_bytes_saved = None
                                                                self.non_tcp_compressed_packets_out = None
                                                                self.non_tcp_bytes_sent_rate = None
                                                                self.non_tcp_full_header_packets_out = None
                                                                self.tcp_total_out_packets = None
                                                                self.tcp_total_out_bytes = None
                                                                self.tcp_bytes_saved = None
                                                                self.tcp_compressed_packets_out = None
                                                                self.tcp_bytes_sent_rate = None
                                                                self.tcp_full_header_packets_out = None
                                                                self._segment_path = lambda: "iphc-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                        class CacStats(Entity):
                                                            """
                                                            bag for cac stats
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	CAC dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	CAC dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_rates
                                                            
                                                            	CAC dropped rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: admitpackets
                                                            
                                                            	Admitted packets (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_bytes
                                                            
                                                            	Admitted bytes (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_rates
                                                            
                                                            	CAC admit rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                self.yang_name = "cac-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.drop_rates = None
                                                                self.admitpackets = None
                                                                self.admit_bytes = None
                                                                self.admit_rates = None
                                                                self._segment_path = lambda: "cac-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                        class QueueStatsArray(Entity):
                                                            """
                                                            array of queue stats
                                                            
                                                            .. attribute:: queue_id
                                                            
                                                            	Queue Id used for Fabric Stats
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: tail_drop_packets
                                                            
                                                            	Packets tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tail_drop_bytes
                                                            
                                                            	Bytes tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp0_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp0_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp1_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp1_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: queue_drop_threshold
                                                            
                                                            	tail drop threshold of the queue in bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: forced_wred_stats_display
                                                            
                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                            	**type**\: bool
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Packets probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Bytes probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_instance_length
                                                            
                                                            	Queue instance length
                                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                            
                                                            .. attribute:: queue_average_length
                                                            
                                                            	Queue average length
                                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                            
                                                            .. attribute:: queue_max_length
                                                            
                                                            	Queue maximum length
                                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                self.yang_name = "queue-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                self._leafs = OrderedDict([
                                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ])
                                                                self.queue_id = None
                                                                self.tail_drop_packets = None
                                                                self.tail_drop_bytes = None
                                                                self.atm_clp0_drop_packets = None
                                                                self.atm_clp0_drop_bytes = None
                                                                self.atm_clp1_drop_packets = None
                                                                self.atm_clp1_drop_bytes = None
                                                                self.queue_drop_threshold = None
                                                                self.forced_wred_stats_display = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None

                                                                self.queue_instance_length = YList(self)
                                                                self.queue_average_length = YList(self)
                                                                self.queue_max_length = YList(self)
                                                                self._segment_path = lambda: "queue-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                            class QueueInstanceLength(Entity):
                                                                """
                                                                Queue instance length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                    self.yang_name = "queue-instance-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-instance-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                            class QueueAverageLength(Entity):
                                                                """
                                                                Queue average length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                    self.yang_name = "queue-average-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-average-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                            class QueueMaxLength(Entity):
                                                                """
                                                                Queue maximum length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                    self.yang_name = "queue-max-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-max-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                        class PoliceStatsArray(Entity):
                                                            """
                                                            array of police stats
                                                            
                                                            .. attribute:: color_class_stats
                                                            
                                                            	color class stats
                                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	Police dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	Police dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_packets
                                                            
                                                            	Packets violating the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_bytes
                                                            
                                                            	Bytes that violate the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: parent_drop_packets
                                                            
                                                            	Dropped pkts by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: parent_drop_bytes
                                                            
                                                            	Dropped bytes by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_rate
                                                            
                                                            	Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                self.yang_name = "police-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.violate_packets = None
                                                                self.violate_bytes = None
                                                                self.parent_drop_packets = None
                                                                self.parent_drop_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None
                                                                self.violate_rate = None

                                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                self._segment_path = lambda: "police-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                            class ColorClassStats(Entity):
                                                                """
                                                                color class stats
                                                                
                                                                .. attribute:: conform_class_conform_packets
                                                                
                                                                	Packets with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_conform_bytes
                                                                
                                                                	Bytes with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_conform_rate
                                                                
                                                                	Conform Class Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_exceed_packets
                                                                
                                                                	Packets with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_exceed_bytes
                                                                
                                                                	Bytes with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_exceed_rate
                                                                
                                                                	Conform Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_violate_packets
                                                                
                                                                	Packets with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_violate_bytes
                                                                
                                                                	Bytes with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_violate_rate
                                                                
                                                                	Conform Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_exceed_packets
                                                                
                                                                	Packets with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_exceed_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_exceed_rate
                                                                
                                                                	Exceed Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_violate_packets
                                                                
                                                                	Packets with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_violate_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_violate_rate
                                                                
                                                                	Exceed Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_class_violate_packets
                                                                
                                                                	Packets with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_class_violate_bytes
                                                                
                                                                	Bytes with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_class_violate_rate
                                                                
                                                                	Violate Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                    self.yang_name = "color-class-stats"
                                                                    self.yang_parent_name = "police-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                    ])
                                                                    self.conform_class_conform_packets = None
                                                                    self.conform_class_conform_bytes = None
                                                                    self.conform_class_conform_rate = None
                                                                    self.conform_class_exceed_packets = None
                                                                    self.conform_class_exceed_bytes = None
                                                                    self.conform_class_exceed_rate = None
                                                                    self.conform_class_violate_packets = None
                                                                    self.conform_class_violate_bytes = None
                                                                    self.conform_class_violate_rate = None
                                                                    self.exceed_class_exceed_packets = None
                                                                    self.exceed_class_exceed_bytes = None
                                                                    self.exceed_class_exceed_rate = None
                                                                    self.exceed_class_violate_packets = None
                                                                    self.exceed_class_violate_bytes = None
                                                                    self.exceed_class_violate_rate = None
                                                                    self.violate_class_violate_packets = None
                                                                    self.violate_class_violate_bytes = None
                                                                    self.violate_class_violate_rate = None
                                                                    self._segment_path = lambda: "color-class-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                        class WredStatsArray(Entity):
                                                            """
                                                            array of red stats
                                                            
                                                            .. attribute:: profile_title
                                                            
                                                            	ProfileTitle
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..300
                                                            
                                                            .. attribute:: red_transmit_packets
                                                            
                                                            	Transmitted packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_transmit_bytes
                                                            
                                                            	Transmitted bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Probabilistically dropped  packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Probabilisticallydropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_ecn_marked_packets
                                                            
                                                            	ECN marked packets 
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_ecn_marked_bytes
                                                            
                                                            	ECN marked bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_label
                                                            
                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                self.yang_name = "wred-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                self._leafs = OrderedDict([
                                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                ])
                                                                self.profile_title = None
                                                                self.red_transmit_packets = None
                                                                self.red_transmit_bytes = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.red_ecn_marked_packets = None
                                                                self.red_ecn_marked_bytes = None

                                                                self.red_label = YList(self)
                                                                self._segment_path = lambda: "wred-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                            class RedLabel(Entity):
                                                                """
                                                                Array of WRED Typevalues as in PRP stats is
                                                                available per threshold   
                                                                
                                                                .. attribute:: wred_type
                                                                
                                                                	WRED type DSCP, EXP, PREC etc
                                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	WRED value for this type
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                    self.yang_name = "red-label"
                                                                    self.yang_parent_name = "wred-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                    ])
                                                                    self.wred_type = None
                                                                    self.value = None
                                                                    self._segment_path = lambda: "red-label"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                    class Input(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input, self).__init__()

                            self.yang_name = "input"
                            self.yang_parent_name = "member-interface"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames))])
                            self._leafs = OrderedDict()

                            self.service_policy_names = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._segment_path = lambda: "input"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input, [], name, value)


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "input"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance))])
                                self._leafs = OrderedDict()

                                self.service_policy_instance = YList(self)
                                self._segment_path = lambda: "service-policy-names"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, [], name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  (key)
                                
                                	Name of the policy instance
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['service_policy_name']
                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                    ])
                                    self.service_policy_name = None

                                    self.statistics = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "service-policy-instance"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.child_policy = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "child-policy"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats_(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                    class Output(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output, self).__init__()

                            self.yang_name = "output"
                            self.yang_parent_name = "member-interface"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames))])
                            self._leafs = OrderedDict()

                            self.service_policy_names = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._segment_path = lambda: "output"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output, [], name, value)


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "output"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance))])
                                self._leafs = OrderedDict()

                                self.service_policy_instance = YList(self)
                                self._segment_path = lambda: "service-policy-names"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, [], name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  (key)
                                
                                	Name of the policy instance
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['service_policy_name']
                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                    ])
                                    self.service_policy_name = None

                                    self.statistics = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "service-policy-instance"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.child_policy = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "child-policy"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats_(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


            class SatelliteIds(Entity):
                """
                Satellite ID information
                
                .. attribute:: satellite_id
                
                	Satellite ID information
                	**type**\: list of  		 :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.NvInterfaceTable.Interface.SatelliteIds, self).__init__()

                    self.yang_name = "satellite-ids"
                    self.yang_parent_name = "interface"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("satellite-id", ("satellite_id", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId))])
                    self._leafs = OrderedDict()

                    self.satellite_id = YList(self)
                    self._segment_path = lambda: "satellite-ids"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds, [], name, value)


                class SatelliteId(Entity):
                    """
                    Satellite ID information
                    
                    .. attribute:: nv_satellite_id  (key)
                    
                    	Satellite ID
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: input
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input>`
                    
                    .. attribute:: output
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId, self).__init__()

                        self.yang_name = "satellite-id"
                        self.yang_parent_name = "satellite-ids"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = ['nv_satellite_id']
                        self._child_classes = OrderedDict([("input", ("input", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input)), ("output", ("output", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output))])
                        self._leafs = OrderedDict([
                            ('nv_satellite_id', (YLeaf(YType.int32, 'nv-satellite-id'), ['int'])),
                        ])
                        self.nv_satellite_id = None

                        self.input = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"

                        self.output = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                        self._segment_path = lambda: "satellite-id" + "[nv-satellite-id='" + str(self.nv_satellite_id) + "']"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId, ['nv_satellite_id'], name, value)


                    class Input(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input, self).__init__()

                            self.yang_name = "input"
                            self.yang_parent_name = "satellite-id"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames))])
                            self._leafs = OrderedDict()

                            self.service_policy_names = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._segment_path = lambda: "input"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input, [], name, value)


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "input"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance))])
                                self._leafs = OrderedDict()

                                self.service_policy_instance = YList(self)
                                self._segment_path = lambda: "service-policy-names"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, [], name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  (key)
                                
                                	Name of the policy instance
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['service_policy_name']
                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                    ])
                                    self.service_policy_name = None

                                    self.statistics = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "service-policy-instance"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.child_policy = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "child-policy"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats_(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                    class Output(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output, self).__init__()

                            self.yang_name = "output"
                            self.yang_parent_name = "satellite-id"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames))])
                            self._leafs = OrderedDict()

                            self.service_policy_names = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._segment_path = lambda: "output"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output, [], name, value)


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "output"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance))])
                                self._leafs = OrderedDict()

                                self.service_policy_instance = YList(self)
                                self._segment_path = lambda: "service-policy-names"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, [], name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  (key)
                                
                                	Name of the policy instance
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['service_policy_name']
                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                    ])
                                    self.service_policy_name = None

                                    self.statistics = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "service-policy-instance"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.child_policy = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "child-policy"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats_(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


            class Input(Entity):
                """
                A piece of QoS policy\-map operational data for
                an interface
                
                .. attribute:: service_policy_names
                
                	Operational data for all Policy instance
                	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.NvInterfaceTable.Interface.Input, self).__init__()

                    self.yang_name = "input"
                    self.yang_parent_name = "interface"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames))])
                    self._leafs = OrderedDict()

                    self.service_policy_names = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames()
                    self.service_policy_names.parent = self
                    self._children_name_map["service_policy_names"] = "service-policy-names"
                    self._segment_path = lambda: "input"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Input, [], name, value)


                class ServicePolicyNames(Entity):
                    """
                    Operational data for all Policy instance
                    
                    .. attribute:: service_policy_instance
                    
                    	QoS policy\-map operational data for a particular Policy 
                    	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames, self).__init__()

                        self.yang_name = "service-policy-names"
                        self.yang_parent_name = "input"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance))])
                        self._leafs = OrderedDict()

                        self.service_policy_instance = YList(self)
                        self._segment_path = lambda: "service-policy-names"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames, [], name, value)


                    class ServicePolicyInstance(Entity):
                        """
                        QoS policy\-map operational data for a
                        particular Policy 
                        
                        .. attribute:: service_policy_name  (key)
                        
                        	Name of the policy instance
                        	**type**\: str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                            self.yang_name = "service-policy-instance"
                            self.yang_parent_name = "service-policy-names"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['service_policy_name']
                            self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                            self._leafs = OrderedDict([
                                ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                            ])
                            self.service_policy_name = None

                            self.statistics = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\: str
                            
                            	**length:** 0..65
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\: str
                            
                            	**length:** 0..128
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "service-policy-instance"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                self._leafs = OrderedDict([
                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                ])
                                self.policy_name = None
                                self.state = None
                                self.state_description = None
                                self.satid = None

                                self.class_stats = YList(self)
                                self._segment_path = lambda: "statistics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\: str
                                
                                	**length:** 0..65
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\: str
                                
                                	**length:** 0..256
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                    self._leafs = OrderedDict([
                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                    ])
                                    self.counter_validity_bitmask = None
                                    self.class_name = None
                                    self.shared_queue_id = None
                                    self.queue_descr = None
                                    self.cac_state = None

                                    self.general_stats = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"

                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                    self.child_policy = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"

                                    self.cac_stats = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"

                                    self.queue_stats_array = YList(self)
                                    self.police_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)
                                    self._segment_path = lambda: "class-stats"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                        ])
                                        self.transmit_packets = None
                                        self.transmit_bytes = None
                                        self.total_drop_packets = None
                                        self.total_drop_bytes = None
                                        self.total_drop_rate = None
                                        self.match_data_rate = None
                                        self.total_transmit_rate = None
                                        self.pre_policy_matched_packets = None
                                        self.pre_policy_matched_bytes = None
                                        self._segment_path = lambda: "general-stats"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                        ])
                                        self.non_tcp_total_out_packets = None
                                        self.non_tcp_total_out_bytes = None
                                        self.non_tcp_bytes_saved = None
                                        self.non_tcp_compressed_packets_out = None
                                        self.non_tcp_bytes_sent_rate = None
                                        self.non_tcp_full_header_packets_out = None
                                        self.tcp_total_out_packets = None
                                        self.tcp_total_out_bytes = None
                                        self.tcp_bytes_saved = None
                                        self.tcp_compressed_packets_out = None
                                        self.tcp_bytes_sent_rate = None
                                        self.tcp_full_header_packets_out = None
                                        self._segment_path = lambda: "iphc-stats"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "child-policy"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats_(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                        ])
                                        self.drop_packets = None
                                        self.drop_bytes = None
                                        self.drop_rates = None
                                        self.admitpackets = None
                                        self.admit_bytes = None
                                        self.admit_rates = None
                                        self._segment_path = lambda: "cac-stats"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\: bool
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                        self._leafs = OrderedDict([
                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                        ])
                                        self.queue_id = None
                                        self.tail_drop_packets = None
                                        self.tail_drop_bytes = None
                                        self.atm_clp0_drop_packets = None
                                        self.atm_clp0_drop_bytes = None
                                        self.atm_clp1_drop_packets = None
                                        self.atm_clp1_drop_bytes = None
                                        self.queue_drop_threshold = None
                                        self.forced_wred_stats_display = None
                                        self.random_drop_packets = None
                                        self.random_drop_bytes = None
                                        self.max_threshold_packets = None
                                        self.max_threshold_bytes = None
                                        self.conform_packets = None
                                        self.conform_bytes = None
                                        self.exceed_packets = None
                                        self.exceed_bytes = None
                                        self.conform_rate = None
                                        self.exceed_rate = None

                                        self.queue_instance_length = YList(self)
                                        self.queue_average_length = YList(self)
                                        self.queue_max_length = YList(self)
                                        self._segment_path = lambda: "queue-stats-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                            ])
                                            self.value = None
                                            self.unit = None
                                            self._segment_path = lambda: "queue-instance-length"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                            ])
                                            self.value = None
                                            self.unit = None
                                            self._segment_path = lambda: "queue-average-length"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                            ])
                                            self.value = None
                                            self.unit = None
                                            self._segment_path = lambda: "queue-max-length"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                        self._leafs = OrderedDict([
                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                        ])
                                        self.drop_packets = None
                                        self.drop_bytes = None
                                        self.conform_packets = None
                                        self.conform_bytes = None
                                        self.exceed_packets = None
                                        self.exceed_bytes = None
                                        self.violate_packets = None
                                        self.violate_bytes = None
                                        self.parent_drop_packets = None
                                        self.parent_drop_bytes = None
                                        self.conform_rate = None
                                        self.exceed_rate = None
                                        self.violate_rate = None

                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._segment_path = lambda: "police-stats-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                            ])
                                            self.conform_class_conform_packets = None
                                            self.conform_class_conform_bytes = None
                                            self.conform_class_conform_rate = None
                                            self.conform_class_exceed_packets = None
                                            self.conform_class_exceed_bytes = None
                                            self.conform_class_exceed_rate = None
                                            self.conform_class_violate_packets = None
                                            self.conform_class_violate_bytes = None
                                            self.conform_class_violate_rate = None
                                            self.exceed_class_exceed_packets = None
                                            self.exceed_class_exceed_bytes = None
                                            self.exceed_class_exceed_rate = None
                                            self.exceed_class_violate_packets = None
                                            self.exceed_class_violate_bytes = None
                                            self.exceed_class_violate_rate = None
                                            self.violate_class_violate_packets = None
                                            self.violate_class_violate_bytes = None
                                            self.violate_class_violate_rate = None
                                            self._segment_path = lambda: "color-class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\: str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                        self._leafs = OrderedDict([
                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                        ])
                                        self.profile_title = None
                                        self.red_transmit_packets = None
                                        self.red_transmit_bytes = None
                                        self.random_drop_packets = None
                                        self.random_drop_bytes = None
                                        self.max_threshold_packets = None
                                        self.max_threshold_bytes = None
                                        self.red_ecn_marked_packets = None
                                        self.red_ecn_marked_bytes = None

                                        self.red_label = YList(self)
                                        self._segment_path = lambda: "wred-stats-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                            ])
                                            self.wred_type = None
                                            self.value = None
                                            self._segment_path = lambda: "red-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


            class Output(Entity):
                """
                A piece of QoS policy\-map operational data for
                an interface
                
                .. attribute:: service_policy_names
                
                	Operational data for all Policy instance
                	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.NvInterfaceTable.Interface.Output, self).__init__()

                    self.yang_name = "output"
                    self.yang_parent_name = "interface"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames))])
                    self._leafs = OrderedDict()

                    self.service_policy_names = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames()
                    self.service_policy_names.parent = self
                    self._children_name_map["service_policy_names"] = "service-policy-names"
                    self._segment_path = lambda: "output"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Output, [], name, value)


                class ServicePolicyNames(Entity):
                    """
                    Operational data for all Policy instance
                    
                    .. attribute:: service_policy_instance
                    
                    	QoS policy\-map operational data for a particular Policy 
                    	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames, self).__init__()

                        self.yang_name = "service-policy-names"
                        self.yang_parent_name = "output"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance))])
                        self._leafs = OrderedDict()

                        self.service_policy_instance = YList(self)
                        self._segment_path = lambda: "service-policy-names"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames, [], name, value)


                    class ServicePolicyInstance(Entity):
                        """
                        QoS policy\-map operational data for a
                        particular Policy 
                        
                        .. attribute:: service_policy_name  (key)
                        
                        	Name of the policy instance
                        	**type**\: str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                            self.yang_name = "service-policy-instance"
                            self.yang_parent_name = "service-policy-names"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['service_policy_name']
                            self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                            self._leafs = OrderedDict([
                                ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                            ])
                            self.service_policy_name = None

                            self.statistics = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\: str
                            
                            	**length:** 0..65
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\: str
                            
                            	**length:** 0..128
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "service-policy-instance"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                self._leafs = OrderedDict([
                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                ])
                                self.policy_name = None
                                self.state = None
                                self.state_description = None
                                self.satid = None

                                self.class_stats = YList(self)
                                self._segment_path = lambda: "statistics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\: str
                                
                                	**length:** 0..65
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\: str
                                
                                	**length:** 0..256
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                    self._leafs = OrderedDict([
                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                    ])
                                    self.counter_validity_bitmask = None
                                    self.class_name = None
                                    self.shared_queue_id = None
                                    self.queue_descr = None
                                    self.cac_state = None

                                    self.general_stats = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"

                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                    self.child_policy = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"

                                    self.cac_stats = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"

                                    self.queue_stats_array = YList(self)
                                    self.police_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)
                                    self._segment_path = lambda: "class-stats"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                        ])
                                        self.transmit_packets = None
                                        self.transmit_bytes = None
                                        self.total_drop_packets = None
                                        self.total_drop_bytes = None
                                        self.total_drop_rate = None
                                        self.match_data_rate = None
                                        self.total_transmit_rate = None
                                        self.pre_policy_matched_packets = None
                                        self.pre_policy_matched_bytes = None
                                        self._segment_path = lambda: "general-stats"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                        ])
                                        self.non_tcp_total_out_packets = None
                                        self.non_tcp_total_out_bytes = None
                                        self.non_tcp_bytes_saved = None
                                        self.non_tcp_compressed_packets_out = None
                                        self.non_tcp_bytes_sent_rate = None
                                        self.non_tcp_full_header_packets_out = None
                                        self.tcp_total_out_packets = None
                                        self.tcp_total_out_bytes = None
                                        self.tcp_bytes_saved = None
                                        self.tcp_compressed_packets_out = None
                                        self.tcp_bytes_sent_rate = None
                                        self.tcp_full_header_packets_out = None
                                        self._segment_path = lambda: "iphc-stats"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "child-policy"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats_(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                        ])
                                        self.drop_packets = None
                                        self.drop_bytes = None
                                        self.drop_rates = None
                                        self.admitpackets = None
                                        self.admit_bytes = None
                                        self.admit_rates = None
                                        self._segment_path = lambda: "cac-stats"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\: bool
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                        self._leafs = OrderedDict([
                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                        ])
                                        self.queue_id = None
                                        self.tail_drop_packets = None
                                        self.tail_drop_bytes = None
                                        self.atm_clp0_drop_packets = None
                                        self.atm_clp0_drop_bytes = None
                                        self.atm_clp1_drop_packets = None
                                        self.atm_clp1_drop_bytes = None
                                        self.queue_drop_threshold = None
                                        self.forced_wred_stats_display = None
                                        self.random_drop_packets = None
                                        self.random_drop_bytes = None
                                        self.max_threshold_packets = None
                                        self.max_threshold_bytes = None
                                        self.conform_packets = None
                                        self.conform_bytes = None
                                        self.exceed_packets = None
                                        self.exceed_bytes = None
                                        self.conform_rate = None
                                        self.exceed_rate = None

                                        self.queue_instance_length = YList(self)
                                        self.queue_average_length = YList(self)
                                        self.queue_max_length = YList(self)
                                        self._segment_path = lambda: "queue-stats-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                            ])
                                            self.value = None
                                            self.unit = None
                                            self._segment_path = lambda: "queue-instance-length"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                            ])
                                            self.value = None
                                            self.unit = None
                                            self._segment_path = lambda: "queue-average-length"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                            ])
                                            self.value = None
                                            self.unit = None
                                            self._segment_path = lambda: "queue-max-length"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                        self._leafs = OrderedDict([
                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                        ])
                                        self.drop_packets = None
                                        self.drop_bytes = None
                                        self.conform_packets = None
                                        self.conform_bytes = None
                                        self.exceed_packets = None
                                        self.exceed_bytes = None
                                        self.violate_packets = None
                                        self.violate_bytes = None
                                        self.parent_drop_packets = None
                                        self.parent_drop_bytes = None
                                        self.conform_rate = None
                                        self.exceed_rate = None
                                        self.violate_rate = None

                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._segment_path = lambda: "police-stats-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                            ])
                                            self.conform_class_conform_packets = None
                                            self.conform_class_conform_bytes = None
                                            self.conform_class_conform_rate = None
                                            self.conform_class_exceed_packets = None
                                            self.conform_class_exceed_bytes = None
                                            self.conform_class_exceed_rate = None
                                            self.conform_class_violate_packets = None
                                            self.conform_class_violate_bytes = None
                                            self.conform_class_violate_rate = None
                                            self.exceed_class_exceed_packets = None
                                            self.exceed_class_exceed_bytes = None
                                            self.exceed_class_exceed_rate = None
                                            self.exceed_class_violate_packets = None
                                            self.exceed_class_violate_bytes = None
                                            self.exceed_class_violate_rate = None
                                            self.violate_class_violate_packets = None
                                            self.violate_class_violate_bytes = None
                                            self.violate_class_violate_rate = None
                                            self._segment_path = lambda: "color-class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\: str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                        self._leafs = OrderedDict([
                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                        ])
                                        self.profile_title = None
                                        self.red_transmit_packets = None
                                        self.red_transmit_bytes = None
                                        self.random_drop_packets = None
                                        self.random_drop_bytes = None
                                        self.max_threshold_packets = None
                                        self.max_threshold_bytes = None
                                        self.red_ecn_marked_packets = None
                                        self.red_ecn_marked_bytes = None

                                        self.red_label = YList(self)
                                        self._segment_path = lambda: "wred-stats-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                            ])
                                            self.wred_type = None
                                            self.value = None
                                            self._segment_path = lambda: "red-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


    class NvSatellite(Entity):
        """
        Satellite table
        
        .. attribute:: nv_satellite_statistics
        
        	Satellite statistics based on Satellite ID
        	**type**\:  :py:class:`NvSatelliteStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics>`
        
        .. attribute:: nv_satellite_status
        
        	Satellite QOS offload status based on Satellite ID
        	**type**\:  :py:class:`NvSatelliteStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus>`
        
        

        """

        _prefix = 'qos-ma-oper'
        _revision = '2017-09-13'

        def __init__(self):
            super(Qos.NvSatellite, self).__init__()

            self.yang_name = "nv-satellite"
            self.yang_parent_name = "qos"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("nv-satellite-statistics", ("nv_satellite_statistics", Qos.NvSatellite.NvSatelliteStatistics)), ("nv-satellite-status", ("nv_satellite_status", Qos.NvSatellite.NvSatelliteStatus))])
            self._leafs = OrderedDict()

            self.nv_satellite_statistics = Qos.NvSatellite.NvSatelliteStatistics()
            self.nv_satellite_statistics.parent = self
            self._children_name_map["nv_satellite_statistics"] = "nv-satellite-statistics"

            self.nv_satellite_status = Qos.NvSatellite.NvSatelliteStatus()
            self.nv_satellite_status.parent = self
            self._children_name_map["nv_satellite_status"] = "nv-satellite-status"
            self._segment_path = lambda: "nv-satellite"
            self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Qos.NvSatellite, [], name, value)


        class NvSatelliteStatistics(Entity):
            """
            Satellite statistics based on Satellite ID
            
            .. attribute:: nv_satellite_ids
            
            	Satellite ID table
            	**type**\:  :py:class:`NvSatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds>`
            
            

            """

            _prefix = 'qos-ma-oper'
            _revision = '2017-09-13'

            def __init__(self):
                super(Qos.NvSatellite.NvSatelliteStatistics, self).__init__()

                self.yang_name = "nv-satellite-statistics"
                self.yang_parent_name = "nv-satellite"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("nv-satellite-ids", ("nv_satellite_ids", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds))])
                self._leafs = OrderedDict()

                self.nv_satellite_ids = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds()
                self.nv_satellite_ids.parent = self
                self._children_name_map["nv_satellite_ids"] = "nv-satellite-ids"
                self._segment_path = lambda: "nv-satellite-statistics"
                self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/nv-satellite/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics, [], name, value)


            class NvSatelliteIds(Entity):
                """
                Satellite ID table
                
                .. attribute:: nv_satellite_id
                
                	Satellite ID information
                	**type**\: list of  		 :py:class:`NvSatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds, self).__init__()

                    self.yang_name = "nv-satellite-ids"
                    self.yang_parent_name = "nv-satellite-statistics"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("nv-satellite-id", ("nv_satellite_id", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId))])
                    self._leafs = OrderedDict()

                    self.nv_satellite_id = YList(self)
                    self._segment_path = lambda: "nv-satellite-ids"
                    self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/nv-satellite/nv-satellite-statistics/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds, [], name, value)


                class NvSatelliteId(Entity):
                    """
                    Satellite ID information
                    
                    .. attribute:: satellite_id  (key)
                    
                    	Satellite ID
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nv_satellite_interfaces
                    
                    	Operational data of satellite interface of a particular satellite
                    	**type**\:  :py:class:`NvSatelliteInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId, self).__init__()

                        self.yang_name = "nv-satellite-id"
                        self.yang_parent_name = "nv-satellite-ids"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = ['satellite_id']
                        self._child_classes = OrderedDict([("nv-satellite-interfaces", ("nv_satellite_interfaces", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces))])
                        self._leafs = OrderedDict([
                            ('satellite_id', (YLeaf(YType.int32, 'satellite-id'), ['int'])),
                        ])
                        self.satellite_id = None

                        self.nv_satellite_interfaces = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces()
                        self.nv_satellite_interfaces.parent = self
                        self._children_name_map["nv_satellite_interfaces"] = "nv-satellite-interfaces"
                        self._segment_path = lambda: "nv-satellite-id" + "[satellite-id='" + str(self.satellite_id) + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/nv-satellite/nv-satellite-statistics/nv-satellite-ids/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId, ['satellite_id'], name, value)


                    class NvSatelliteInterfaces(Entity):
                        """
                        Operational data of satellite interface of a
                        particular satellite
                        
                        .. attribute:: nv_satellite_interface
                        
                        	Operational data for a particular satellite interface
                        	**type**\: list of  		 :py:class:`NvSatelliteInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces, self).__init__()

                            self.yang_name = "nv-satellite-interfaces"
                            self.yang_parent_name = "nv-satellite-id"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("nv-satellite-interface", ("nv_satellite_interface", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface))])
                            self._leafs = OrderedDict()

                            self.nv_satellite_interface = YList(self)
                            self._segment_path = lambda: "nv-satellite-interfaces"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces, [], name, value)


                        class NvSatelliteInterface(Entity):
                            """
                            Operational data for a particular satellite
                            interface
                            
                            .. attribute:: interface_name  (key)
                            
                            	Name of the interface
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            .. attribute:: member_interfaces
                            
                            	QoS policy\-map member interface table
                            	**type**\:  :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces>`
                            
                            .. attribute:: input
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input>`
                            
                            .. attribute:: output
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface, self).__init__()

                                self.yang_name = "nv-satellite-interface"
                                self.yang_parent_name = "nv-satellite-interfaces"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['interface_name']
                                self._child_classes = OrderedDict([("member-interfaces", ("member_interfaces", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces)), ("input", ("input", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input)), ("output", ("output", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output))])
                                self._leafs = OrderedDict([
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                ])
                                self.interface_name = None

                                self.member_interfaces = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces()
                                self.member_interfaces.parent = self
                                self._children_name_map["member_interfaces"] = "member-interfaces"

                                self.input = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"

                                self.output = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                                self._segment_path = lambda: "nv-satellite-interface" + "[interface-name='" + str(self.interface_name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface, ['interface_name'], name, value)


                            class MemberInterfaces(Entity):
                                """
                                QoS policy\-map member interface table
                                
                                .. attribute:: member_interface
                                
                                	QoS policy\-map member interface statistics
                                	**type**\: list of  		 :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces, self).__init__()

                                    self.yang_name = "member-interfaces"
                                    self.yang_parent_name = "nv-satellite-interface"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("member-interface", ("member_interface", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface))])
                                    self._leafs = OrderedDict()

                                    self.member_interface = YList(self)
                                    self._segment_path = lambda: "member-interfaces"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces, [], name, value)


                                class MemberInterface(Entity):
                                    """
                                    QoS policy\-map member interface statistics
                                    
                                    .. attribute:: interface_name  (key)
                                    
                                    	Name of member interface
                                    	**type**\: str
                                    
                                    	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                    
                                    .. attribute:: satellite_ids
                                    
                                    	Satellite ID information
                                    	**type**\:  :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds>`
                                    
                                    .. attribute:: input
                                    
                                    	A piece of QoS policy\-map operational data for an interface
                                    	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input>`
                                    
                                    .. attribute:: output
                                    
                                    	A piece of QoS policy\-map operational data for an interface
                                    	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface, self).__init__()

                                        self.yang_name = "member-interface"
                                        self.yang_parent_name = "member-interfaces"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = ['interface_name']
                                        self._child_classes = OrderedDict([("satellite-ids", ("satellite_ids", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds)), ("input", ("input", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input)), ("output", ("output", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output))])
                                        self._leafs = OrderedDict([
                                            ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                        ])
                                        self.interface_name = None

                                        self.satellite_ids = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds()
                                        self.satellite_ids.parent = self
                                        self._children_name_map["satellite_ids"] = "satellite-ids"

                                        self.input = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input()
                                        self.input.parent = self
                                        self._children_name_map["input"] = "input"

                                        self.output = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output()
                                        self.output.parent = self
                                        self._children_name_map["output"] = "output"
                                        self._segment_path = lambda: "member-interface" + "[interface-name='" + str(self.interface_name) + "']"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface, ['interface_name'], name, value)


                                    class SatelliteIds(Entity):
                                        """
                                        Satellite ID information
                                        
                                        .. attribute:: satellite_id
                                        
                                        	Satellite ID information
                                        	**type**\: list of  		 :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds, self).__init__()

                                            self.yang_name = "satellite-ids"
                                            self.yang_parent_name = "member-interface"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("satellite-id", ("satellite_id", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId))])
                                            self._leafs = OrderedDict()

                                            self.satellite_id = YList(self)
                                            self._segment_path = lambda: "satellite-ids"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds, [], name, value)


                                        class SatelliteId(Entity):
                                            """
                                            Satellite ID information
                                            
                                            .. attribute:: nv_satellite_id  (key)
                                            
                                            	Satellite ID
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: input
                                            
                                            	A piece of QoS policy\-map operational data for an interface
                                            	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input>`
                                            
                                            .. attribute:: output
                                            
                                            	A piece of QoS policy\-map operational data for an interface
                                            	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__init__()

                                                self.yang_name = "satellite-id"
                                                self.yang_parent_name = "satellite-ids"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = ['nv_satellite_id']
                                                self._child_classes = OrderedDict([("input", ("input", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input)), ("output", ("output", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output))])
                                                self._leafs = OrderedDict([
                                                    ('nv_satellite_id', (YLeaf(YType.int32, 'nv-satellite-id'), ['int'])),
                                                ])
                                                self.nv_satellite_id = None

                                                self.input = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                                self.input.parent = self
                                                self._children_name_map["input"] = "input"

                                                self.output = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                                self.output.parent = self
                                                self._children_name_map["output"] = "output"
                                                self._segment_path = lambda: "satellite-id" + "[nv-satellite-id='" + str(self.nv_satellite_id) + "']"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, ['nv_satellite_id'], name, value)


                                            class Input(Entity):
                                                """
                                                A piece of QoS policy\-map operational data for
                                                an interface
                                                
                                                .. attribute:: service_policy_names
                                                
                                                	Operational data for all Policy instance
                                                	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, self).__init__()

                                                    self.yang_name = "input"
                                                    self.yang_parent_name = "satellite-id"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames))])
                                                    self._leafs = OrderedDict()

                                                    self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                                    self.service_policy_names.parent = self
                                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                                    self._segment_path = lambda: "input"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, [], name, value)


                                                class ServicePolicyNames(Entity):
                                                    """
                                                    Operational data for all Policy instance
                                                    
                                                    .. attribute:: service_policy_instance
                                                    
                                                    	QoS policy\-map operational data for a particular Policy 
                                                    	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                                        self.yang_name = "service-policy-names"
                                                        self.yang_parent_name = "input"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance))])
                                                        self._leafs = OrderedDict()

                                                        self.service_policy_instance = YList(self)
                                                        self._segment_path = lambda: "service-policy-names"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, [], name, value)


                                                    class ServicePolicyInstance(Entity):
                                                        """
                                                        QoS policy\-map operational data for a
                                                        particular Policy 
                                                        
                                                        .. attribute:: service_policy_name  (key)
                                                        
                                                        	Name of the policy instance
                                                        	**type**\: str
                                                        
                                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                        
                                                        .. attribute:: statistics
                                                        
                                                        	Policy\-map statistics operational data for an interface
                                                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                            self.yang_name = "service-policy-instance"
                                                            self.yang_parent_name = "service-policy-names"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = ['service_policy_name']
                                                            self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                            self._leafs = OrderedDict([
                                                                ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                            ])
                                                            self.service_policy_name = None

                                                            self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                            self.statistics.parent = self
                                                            self._children_name_map["statistics"] = "statistics"
                                                            self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                                        class Statistics(Entity):
                                                            """
                                                            Policy\-map statistics operational data for an
                                                            interface
                                                            
                                                            .. attribute:: policy_name
                                                            
                                                            	PolicyName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: state
                                                            
                                                            	State
                                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                            
                                                            .. attribute:: state_description
                                                            
                                                            	StateDescription
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..128
                                                            
                                                            .. attribute:: satid
                                                            
                                                            	to maintain satellite id
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: class_stats
                                                            
                                                            	array of classes contained in policy
                                                            	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                                self.yang_name = "statistics"
                                                                self.yang_parent_name = "service-policy-instance"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                                self._leafs = OrderedDict([
                                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                                ])
                                                                self.policy_name = None
                                                                self.state = None
                                                                self.state_description = None
                                                                self.satid = None

                                                                self.class_stats = YList(self)
                                                                self._segment_path = lambda: "statistics"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                            class ClassStats(Entity):
                                                                """
                                                                array of classes contained in policy
                                                                
                                                                .. attribute:: general_stats
                                                                
                                                                	general stats
                                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                                
                                                                .. attribute:: iphc_stats
                                                                
                                                                	IPHC stats
                                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                                
                                                                .. attribute:: child_policy
                                                                
                                                                	child policy
                                                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                                
                                                                .. attribute:: cac_stats
                                                                
                                                                	bag for cac stats
                                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                                
                                                                .. attribute:: counter_validity_bitmask
                                                                
                                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: megabyte
                                                                
                                                                .. attribute:: class_name
                                                                
                                                                	ClassName
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: shared_queue_id
                                                                
                                                                	q\-id of the  shared queue for this class
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_descr
                                                                
                                                                	Description of queue for the class
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..256
                                                                
                                                                .. attribute:: cac_state
                                                                
                                                                	CACState
                                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                                
                                                                .. attribute:: queue_stats_array
                                                                
                                                                	array of queue stats
                                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                                
                                                                .. attribute:: police_stats_array
                                                                
                                                                	array of police stats
                                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                                
                                                                .. attribute:: wred_stats_array
                                                                
                                                                	array of red stats
                                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                                    self.yang_name = "class-stats"
                                                                    self.yang_parent_name = "statistics"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                                    self._leafs = OrderedDict([
                                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                    ])
                                                                    self.counter_validity_bitmask = None
                                                                    self.class_name = None
                                                                    self.shared_queue_id = None
                                                                    self.queue_descr = None
                                                                    self.cac_state = None

                                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                                    self.general_stats.parent = self
                                                                    self._children_name_map["general_stats"] = "general-stats"

                                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                                    self.iphc_stats.parent = self
                                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                    self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                                    self.child_policy.parent = self
                                                                    self._children_name_map["child_policy"] = "child-policy"

                                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                                    self.cac_stats.parent = self
                                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                                    self.queue_stats_array = YList(self)
                                                                    self.police_stats_array = YList(self)
                                                                    self.wred_stats_array = YList(self)
                                                                    self._segment_path = lambda: "class-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                                class GeneralStats(Entity):
                                                                    """
                                                                    general stats
                                                                    
                                                                    .. attribute:: transmit_packets
                                                                    
                                                                    	Transmitted packets (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: transmit_bytes
                                                                    
                                                                    	Transmitted bytes (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_packets
                                                                    
                                                                    	Dropped packets (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_bytes
                                                                    
                                                                    	Dropped bytes (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_rate
                                                                    
                                                                    	Total drop rate (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: match_data_rate
                                                                    
                                                                    	Incoming matched data rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: total_transmit_rate
                                                                    
                                                                    	Total transmit rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: pre_policy_matched_packets
                                                                    
                                                                    	Matched pkts before applying policy
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: pre_policy_matched_bytes
                                                                    
                                                                    	Matched bytes before applying policy
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                                        self.yang_name = "general-stats"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                        ])
                                                                        self.transmit_packets = None
                                                                        self.transmit_bytes = None
                                                                        self.total_drop_packets = None
                                                                        self.total_drop_bytes = None
                                                                        self.total_drop_rate = None
                                                                        self.match_data_rate = None
                                                                        self.total_transmit_rate = None
                                                                        self.pre_policy_matched_packets = None
                                                                        self.pre_policy_matched_bytes = None
                                                                        self._segment_path = lambda: "general-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                                class IphcStats(Entity):
                                                                    """
                                                                    IPHC stats
                                                                    
                                                                    .. attribute:: non_tcp_total_out_packets
                                                                    
                                                                    	TotalNum of Non tcp pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: non_tcp_total_out_bytes
                                                                    
                                                                    	TotalNum of Non Tcp Bytes sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_bytes_saved
                                                                    
                                                                    	Non Tcp Bytes saved due to compression
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_compressed_packets_out
                                                                    
                                                                    	Num of non tcp compressed pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                                    
                                                                    	Compressed Non Tcp Bytes sent rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_full_header_packets_out
                                                                    
                                                                    	Num of non tcp fullheader pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_total_out_packets
                                                                    
                                                                    	Total Num of tcp pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_total_out_bytes
                                                                    
                                                                    	TotalNum of Tcp Bytes sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_bytes_saved
                                                                    
                                                                    	Tcp Bytes saved due to compression
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_compressed_packets_out
                                                                    
                                                                    	Num of tcp compressed pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_bytes_sent_rate
                                                                    
                                                                    	Compressed Tcp Bytes sent rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_full_header_packets_out
                                                                    
                                                                    	Num of tcp fullheader pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                                        self.yang_name = "iphc-stats"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                        ])
                                                                        self.non_tcp_total_out_packets = None
                                                                        self.non_tcp_total_out_bytes = None
                                                                        self.non_tcp_bytes_saved = None
                                                                        self.non_tcp_compressed_packets_out = None
                                                                        self.non_tcp_bytes_sent_rate = None
                                                                        self.non_tcp_full_header_packets_out = None
                                                                        self.tcp_total_out_packets = None
                                                                        self.tcp_total_out_bytes = None
                                                                        self.tcp_bytes_saved = None
                                                                        self.tcp_compressed_packets_out = None
                                                                        self.tcp_bytes_sent_rate = None
                                                                        self.tcp_full_header_packets_out = None
                                                                        self._segment_path = lambda: "iphc-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                                class ChildPolicy(Entity):
                                                                    """
                                                                    child policy
                                                                    
                                                                    .. attribute:: policy_name
                                                                    
                                                                    	PolicyName
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: state
                                                                    
                                                                    	State
                                                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                                    
                                                                    .. attribute:: state_description
                                                                    
                                                                    	StateDescription
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..128
                                                                    
                                                                    .. attribute:: satid
                                                                    
                                                                    	to maintain satellite id
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: class_stats
                                                                    
                                                                    	array of classes contained in policy
                                                                    	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                                        self.yang_name = "child-policy"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                                        self._leafs = OrderedDict([
                                                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                                        ])
                                                                        self.policy_name = None
                                                                        self.state = None
                                                                        self.state_description = None
                                                                        self.satid = None

                                                                        self.class_stats = YList(self)
                                                                        self._segment_path = lambda: "child-policy"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                                    class ClassStats_(Entity):
                                                                        """
                                                                        array of classes contained in policy
                                                                        
                                                                        .. attribute:: general_stats
                                                                        
                                                                        	general stats
                                                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                                        
                                                                        .. attribute:: iphc_stats
                                                                        
                                                                        	IPHC stats
                                                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                                        
                                                                        .. attribute:: cac_stats
                                                                        
                                                                        	bag for cac stats
                                                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                                        
                                                                        .. attribute:: counter_validity_bitmask
                                                                        
                                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: megabyte
                                                                        
                                                                        .. attribute:: class_name
                                                                        
                                                                        	ClassName
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: shared_queue_id
                                                                        
                                                                        	q\-id of the  shared queue for this class
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: queue_descr
                                                                        
                                                                        	Description of queue for the class
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..256
                                                                        
                                                                        .. attribute:: cac_state
                                                                        
                                                                        	CACState
                                                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                                        
                                                                        .. attribute:: queue_stats_array
                                                                        
                                                                        	array of queue stats
                                                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                                        
                                                                        .. attribute:: police_stats_array
                                                                        
                                                                        	array of police stats
                                                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                                        
                                                                        .. attribute:: wred_stats_array
                                                                        
                                                                        	array of red stats
                                                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                            self.yang_name = "class-stats"
                                                                            self.yang_parent_name = "child-policy"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                            self._leafs = OrderedDict([
                                                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                            ])
                                                                            self.counter_validity_bitmask = None
                                                                            self.class_name = None
                                                                            self.shared_queue_id = None
                                                                            self.queue_descr = None
                                                                            self.cac_state = None

                                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                            self.general_stats.parent = self
                                                                            self._children_name_map["general_stats"] = "general-stats"

                                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                            self.iphc_stats.parent = self
                                                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                            self.cac_stats.parent = self
                                                                            self._children_name_map["cac_stats"] = "cac-stats"

                                                                            self.queue_stats_array = YList(self)
                                                                            self.police_stats_array = YList(self)
                                                                            self.wred_stats_array = YList(self)
                                                                            self._segment_path = lambda: "class-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                                        class GeneralStats(Entity):
                                                                            """
                                                                            general stats
                                                                            
                                                                            .. attribute:: transmit_packets
                                                                            
                                                                            	Transmitted packets (packets/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: transmit_bytes
                                                                            
                                                                            	Transmitted bytes (packets/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: total_drop_packets
                                                                            
                                                                            	Dropped packets (packets/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: total_drop_bytes
                                                                            
                                                                            	Dropped bytes (packets/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: total_drop_rate
                                                                            
                                                                            	Total drop rate (packets/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: match_data_rate
                                                                            
                                                                            	Incoming matched data rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: total_transmit_rate
                                                                            
                                                                            	Total transmit rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: pre_policy_matched_packets
                                                                            
                                                                            	Matched pkts before applying policy
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: pre_policy_matched_bytes
                                                                            
                                                                            	Matched bytes before applying policy
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                                self.yang_name = "general-stats"
                                                                                self.yang_parent_name = "class-stats"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                                ])
                                                                                self.transmit_packets = None
                                                                                self.transmit_bytes = None
                                                                                self.total_drop_packets = None
                                                                                self.total_drop_bytes = None
                                                                                self.total_drop_rate = None
                                                                                self.match_data_rate = None
                                                                                self.total_transmit_rate = None
                                                                                self.pre_policy_matched_packets = None
                                                                                self.pre_policy_matched_bytes = None
                                                                                self._segment_path = lambda: "general-stats"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                                        class IphcStats(Entity):
                                                                            """
                                                                            IPHC stats
                                                                            
                                                                            .. attribute:: non_tcp_total_out_packets
                                                                            
                                                                            	TotalNum of Non tcp pkts sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: non_tcp_total_out_bytes
                                                                            
                                                                            	TotalNum of Non Tcp Bytes sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: non_tcp_bytes_saved
                                                                            
                                                                            	Non Tcp Bytes saved due to compression
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: non_tcp_compressed_packets_out
                                                                            
                                                                            	Num of non tcp compressed pkts sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                                            
                                                                            	Compressed Non Tcp Bytes sent rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: non_tcp_full_header_packets_out
                                                                            
                                                                            	Num of non tcp fullheader pkts sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: tcp_total_out_packets
                                                                            
                                                                            	Total Num of tcp pkts sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: tcp_total_out_bytes
                                                                            
                                                                            	TotalNum of Tcp Bytes sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: tcp_bytes_saved
                                                                            
                                                                            	Tcp Bytes saved due to compression
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: tcp_compressed_packets_out
                                                                            
                                                                            	Num of tcp compressed pkts sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: tcp_bytes_sent_rate
                                                                            
                                                                            	Compressed Tcp Bytes sent rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: tcp_full_header_packets_out
                                                                            
                                                                            	Num of tcp fullheader pkts sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                                self.yang_name = "iphc-stats"
                                                                                self.yang_parent_name = "class-stats"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                                ])
                                                                                self.non_tcp_total_out_packets = None
                                                                                self.non_tcp_total_out_bytes = None
                                                                                self.non_tcp_bytes_saved = None
                                                                                self.non_tcp_compressed_packets_out = None
                                                                                self.non_tcp_bytes_sent_rate = None
                                                                                self.non_tcp_full_header_packets_out = None
                                                                                self.tcp_total_out_packets = None
                                                                                self.tcp_total_out_bytes = None
                                                                                self.tcp_bytes_saved = None
                                                                                self.tcp_compressed_packets_out = None
                                                                                self.tcp_bytes_sent_rate = None
                                                                                self.tcp_full_header_packets_out = None
                                                                                self._segment_path = lambda: "iphc-stats"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                                        class CacStats(Entity):
                                                                            """
                                                                            bag for cac stats
                                                                            
                                                                            .. attribute:: drop_packets
                                                                            
                                                                            	CAC dropped packets
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: drop_bytes
                                                                            
                                                                            	CAC dropped bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: drop_rates
                                                                            
                                                                            	CAC dropped rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: admitpackets
                                                                            
                                                                            	Admitted packets (pkts/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: admit_bytes
                                                                            
                                                                            	Admitted bytes (pkts/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: admit_rates
                                                                            
                                                                            	CAC admit rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                                self.yang_name = "cac-stats"
                                                                                self.yang_parent_name = "class-stats"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                                ])
                                                                                self.drop_packets = None
                                                                                self.drop_bytes = None
                                                                                self.drop_rates = None
                                                                                self.admitpackets = None
                                                                                self.admit_bytes = None
                                                                                self.admit_rates = None
                                                                                self._segment_path = lambda: "cac-stats"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                                        class QueueStatsArray(Entity):
                                                                            """
                                                                            array of queue stats
                                                                            
                                                                            .. attribute:: queue_id
                                                                            
                                                                            	Queue Id used for Fabric Stats
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: tail_drop_packets
                                                                            
                                                                            	Packets tail dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: tail_drop_bytes
                                                                            
                                                                            	Bytes tail dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: atm_clp0_drop_packets
                                                                            
                                                                            	ATP CLP 0 matched packets dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: atm_clp0_drop_bytes
                                                                            
                                                                            	ATP CLP 0 matched bytes dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: atm_clp1_drop_packets
                                                                            
                                                                            	ATP CLP 0 matched packets dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: atm_clp1_drop_bytes
                                                                            
                                                                            	ATP CLP 0 matched bytes dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: queue_drop_threshold
                                                                            
                                                                            	tail drop threshold of the queue in bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: forced_wred_stats_display
                                                                            
                                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                            	**type**\: bool
                                                                            
                                                                            .. attribute:: random_drop_packets
                                                                            
                                                                            	Packets probabilistically dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: random_drop_bytes
                                                                            
                                                                            	Bytes probabilistically dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: max_threshold_packets
                                                                            
                                                                            	Dropped packets with the average queue size at the max\-threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: max_threshold_bytes
                                                                            
                                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_packets
                                                                            
                                                                            	Packets that conform  to the queue rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_bytes
                                                                            
                                                                            	Bytes that conform to the queue rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: exceed_packets
                                                                            
                                                                            	Packets that exceed the queue rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: exceed_bytes
                                                                            
                                                                            	Bytes that exceed  the queue rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_rate
                                                                            
                                                                            	Conform rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: exceed_rate
                                                                            
                                                                            	Exceed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: queue_instance_length
                                                                            
                                                                            	Queue instance length
                                                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                            
                                                                            .. attribute:: queue_average_length
                                                                            
                                                                            	Queue average length
                                                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                            
                                                                            .. attribute:: queue_max_length
                                                                            
                                                                            	Queue maximum length
                                                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                                self.yang_name = "queue-stats-array"
                                                                                self.yang_parent_name = "class-stats"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                                ])
                                                                                self.queue_id = None
                                                                                self.tail_drop_packets = None
                                                                                self.tail_drop_bytes = None
                                                                                self.atm_clp0_drop_packets = None
                                                                                self.atm_clp0_drop_bytes = None
                                                                                self.atm_clp1_drop_packets = None
                                                                                self.atm_clp1_drop_bytes = None
                                                                                self.queue_drop_threshold = None
                                                                                self.forced_wred_stats_display = None
                                                                                self.random_drop_packets = None
                                                                                self.random_drop_bytes = None
                                                                                self.max_threshold_packets = None
                                                                                self.max_threshold_bytes = None
                                                                                self.conform_packets = None
                                                                                self.conform_bytes = None
                                                                                self.exceed_packets = None
                                                                                self.exceed_bytes = None
                                                                                self.conform_rate = None
                                                                                self.exceed_rate = None

                                                                                self.queue_instance_length = YList(self)
                                                                                self.queue_average_length = YList(self)
                                                                                self.queue_max_length = YList(self)
                                                                                self._segment_path = lambda: "queue-stats-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                            class QueueInstanceLength(Entity):
                                                                                """
                                                                                Queue instance length
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'qos-ma-oper'
                                                                                _revision = '2017-09-13'

                                                                                def __init__(self):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                                    self.yang_name = "queue-instance-length"
                                                                                    self.yang_parent_name = "queue-stats-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "queue-instance-length"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                            class QueueAverageLength(Entity):
                                                                                """
                                                                                Queue average length
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'qos-ma-oper'
                                                                                _revision = '2017-09-13'

                                                                                def __init__(self):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                                    self.yang_name = "queue-average-length"
                                                                                    self.yang_parent_name = "queue-stats-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "queue-average-length"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                            class QueueMaxLength(Entity):
                                                                                """
                                                                                Queue maximum length
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'qos-ma-oper'
                                                                                _revision = '2017-09-13'

                                                                                def __init__(self):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                                    self.yang_name = "queue-max-length"
                                                                                    self.yang_parent_name = "queue-stats-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "queue-max-length"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                                        class PoliceStatsArray(Entity):
                                                                            """
                                                                            array of police stats
                                                                            
                                                                            .. attribute:: color_class_stats
                                                                            
                                                                            	color class stats
                                                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                            
                                                                            .. attribute:: drop_packets
                                                                            
                                                                            	Police dropped packets
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: drop_bytes
                                                                            
                                                                            	Police dropped bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_packets
                                                                            
                                                                            	Packets that conform  to the policed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_bytes
                                                                            
                                                                            	Bytes that conform to the policed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: exceed_packets
                                                                            
                                                                            	Packets that exceed the policed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: exceed_bytes
                                                                            
                                                                            	Bytes that exceed  the policed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: violate_packets
                                                                            
                                                                            	Packets violating the policed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: violate_bytes
                                                                            
                                                                            	Bytes that violate the policed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: parent_drop_packets
                                                                            
                                                                            	Dropped pkts by the parent policer
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: parent_drop_bytes
                                                                            
                                                                            	Dropped bytes by the parent policer
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_rate
                                                                            
                                                                            	Conform rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: exceed_rate
                                                                            
                                                                            	Exceed rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: violate_rate
                                                                            
                                                                            	Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                                self.yang_name = "police-stats-array"
                                                                                self.yang_parent_name = "class-stats"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                                ])
                                                                                self.drop_packets = None
                                                                                self.drop_bytes = None
                                                                                self.conform_packets = None
                                                                                self.conform_bytes = None
                                                                                self.exceed_packets = None
                                                                                self.exceed_bytes = None
                                                                                self.violate_packets = None
                                                                                self.violate_bytes = None
                                                                                self.parent_drop_packets = None
                                                                                self.parent_drop_bytes = None
                                                                                self.conform_rate = None
                                                                                self.exceed_rate = None
                                                                                self.violate_rate = None

                                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                                self.color_class_stats.parent = self
                                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                                self._segment_path = lambda: "police-stats-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                            class ColorClassStats(Entity):
                                                                                """
                                                                                color class stats
                                                                                
                                                                                .. attribute:: conform_class_conform_packets
                                                                                
                                                                                	Packets with classification result conform and policer result conform
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: conform_class_conform_bytes
                                                                                
                                                                                	Bytes with classification result conform and policer result conform
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                	**units**\: byte
                                                                                
                                                                                .. attribute:: conform_class_conform_rate
                                                                                
                                                                                	Conform Class Conform rate in kbps
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                	**units**\: kbit/s
                                                                                
                                                                                .. attribute:: conform_class_exceed_packets
                                                                                
                                                                                	Packets with classification result conform and policer result exceed
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: conform_class_exceed_bytes
                                                                                
                                                                                	Bytes with classification result conform and policer result exceed
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                	**units**\: byte
                                                                                
                                                                                .. attribute:: conform_class_exceed_rate
                                                                                
                                                                                	Conform Class Exceed rate in kbps
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                	**units**\: kbit/s
                                                                                
                                                                                .. attribute:: conform_class_violate_packets
                                                                                
                                                                                	Packets with classification result conform and policer result violate
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: conform_class_violate_bytes
                                                                                
                                                                                	Bytes with classification result conform and policer result violate
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                	**units**\: byte
                                                                                
                                                                                .. attribute:: conform_class_violate_rate
                                                                                
                                                                                	Conform Class Violate rate in kbps
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                	**units**\: kbit/s
                                                                                
                                                                                .. attribute:: exceed_class_exceed_packets
                                                                                
                                                                                	Packets with classification result exceed and policer result exceed
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: exceed_class_exceed_bytes
                                                                                
                                                                                	Bytes with classification result exceed and policer result exceed
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                	**units**\: byte
                                                                                
                                                                                .. attribute:: exceed_class_exceed_rate
                                                                                
                                                                                	Exceed Class Exceed rate in kbps
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                	**units**\: kbit/s
                                                                                
                                                                                .. attribute:: exceed_class_violate_packets
                                                                                
                                                                                	Packets with classification result exceed and policer result violate
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: exceed_class_violate_bytes
                                                                                
                                                                                	Bytes with classification result exceed and policer result violate
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                	**units**\: byte
                                                                                
                                                                                .. attribute:: exceed_class_violate_rate
                                                                                
                                                                                	Exceed Class Violate rate in kbps
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                	**units**\: kbit/s
                                                                                
                                                                                .. attribute:: violate_class_violate_packets
                                                                                
                                                                                	Packets with classification result violate and policer result violate
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: violate_class_violate_bytes
                                                                                
                                                                                	Bytes with classification result violate and policer result violate
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                	**units**\: byte
                                                                                
                                                                                .. attribute:: violate_class_violate_rate
                                                                                
                                                                                	Violate Class Violate rate in kbps
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                	**units**\: kbit/s
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'qos-ma-oper'
                                                                                _revision = '2017-09-13'

                                                                                def __init__(self):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                                    self.yang_name = "color-class-stats"
                                                                                    self.yang_parent_name = "police-stats-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                                    ])
                                                                                    self.conform_class_conform_packets = None
                                                                                    self.conform_class_conform_bytes = None
                                                                                    self.conform_class_conform_rate = None
                                                                                    self.conform_class_exceed_packets = None
                                                                                    self.conform_class_exceed_bytes = None
                                                                                    self.conform_class_exceed_rate = None
                                                                                    self.conform_class_violate_packets = None
                                                                                    self.conform_class_violate_bytes = None
                                                                                    self.conform_class_violate_rate = None
                                                                                    self.exceed_class_exceed_packets = None
                                                                                    self.exceed_class_exceed_bytes = None
                                                                                    self.exceed_class_exceed_rate = None
                                                                                    self.exceed_class_violate_packets = None
                                                                                    self.exceed_class_violate_bytes = None
                                                                                    self.exceed_class_violate_rate = None
                                                                                    self.violate_class_violate_packets = None
                                                                                    self.violate_class_violate_bytes = None
                                                                                    self.violate_class_violate_rate = None
                                                                                    self._segment_path = lambda: "color-class-stats"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                                        class WredStatsArray(Entity):
                                                                            """
                                                                            array of red stats
                                                                            
                                                                            .. attribute:: profile_title
                                                                            
                                                                            	ProfileTitle
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..300
                                                                            
                                                                            .. attribute:: red_transmit_packets
                                                                            
                                                                            	Transmitted packets
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: red_transmit_bytes
                                                                            
                                                                            	Transmitted bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: random_drop_packets
                                                                            
                                                                            	Probabilistically dropped  packets
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: random_drop_bytes
                                                                            
                                                                            	Probabilisticallydropped bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: max_threshold_packets
                                                                            
                                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: max_threshold_bytes
                                                                            
                                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: red_ecn_marked_packets
                                                                            
                                                                            	ECN marked packets 
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: red_ecn_marked_bytes
                                                                            
                                                                            	ECN marked bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: red_label
                                                                            
                                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                                self.yang_name = "wred-stats-array"
                                                                                self.yang_parent_name = "class-stats"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                                ])
                                                                                self.profile_title = None
                                                                                self.red_transmit_packets = None
                                                                                self.red_transmit_bytes = None
                                                                                self.random_drop_packets = None
                                                                                self.random_drop_bytes = None
                                                                                self.max_threshold_packets = None
                                                                                self.max_threshold_bytes = None
                                                                                self.red_ecn_marked_packets = None
                                                                                self.red_ecn_marked_bytes = None

                                                                                self.red_label = YList(self)
                                                                                self._segment_path = lambda: "wred-stats-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                            class RedLabel(Entity):
                                                                                """
                                                                                Array of WRED Typevalues as in PRP stats is
                                                                                available per threshold   
                                                                                
                                                                                .. attribute:: wred_type
                                                                                
                                                                                	WRED type DSCP, EXP, PREC etc
                                                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	WRED value for this type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'qos-ma-oper'
                                                                                _revision = '2017-09-13'

                                                                                def __init__(self):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                                    self.yang_name = "red-label"
                                                                                    self.yang_parent_name = "wred-stats-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.wred_type = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "red-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                                class CacStats(Entity):
                                                                    """
                                                                    bag for cac stats
                                                                    
                                                                    .. attribute:: drop_packets
                                                                    
                                                                    	CAC dropped packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: drop_bytes
                                                                    
                                                                    	CAC dropped bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: drop_rates
                                                                    
                                                                    	CAC dropped rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: admitpackets
                                                                    
                                                                    	Admitted packets (pkts/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: admit_bytes
                                                                    
                                                                    	Admitted bytes (pkts/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: admit_rates
                                                                    
                                                                    	CAC admit rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                                        self.yang_name = "cac-stats"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                        ])
                                                                        self.drop_packets = None
                                                                        self.drop_bytes = None
                                                                        self.drop_rates = None
                                                                        self.admitpackets = None
                                                                        self.admit_bytes = None
                                                                        self.admit_rates = None
                                                                        self._segment_path = lambda: "cac-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                                class QueueStatsArray(Entity):
                                                                    """
                                                                    array of queue stats
                                                                    
                                                                    .. attribute:: queue_id
                                                                    
                                                                    	Queue Id used for Fabric Stats
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: tail_drop_packets
                                                                    
                                                                    	Packets tail dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tail_drop_bytes
                                                                    
                                                                    	Bytes tail dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: atm_clp0_drop_packets
                                                                    
                                                                    	ATP CLP 0 matched packets dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: atm_clp0_drop_bytes
                                                                    
                                                                    	ATP CLP 0 matched bytes dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: atm_clp1_drop_packets
                                                                    
                                                                    	ATP CLP 0 matched packets dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: atm_clp1_drop_bytes
                                                                    
                                                                    	ATP CLP 0 matched bytes dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: queue_drop_threshold
                                                                    
                                                                    	tail drop threshold of the queue in bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: forced_wred_stats_display
                                                                    
                                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                    	**type**\: bool
                                                                    
                                                                    .. attribute:: random_drop_packets
                                                                    
                                                                    	Packets probabilistically dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: random_drop_bytes
                                                                    
                                                                    	Bytes probabilistically dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: max_threshold_packets
                                                                    
                                                                    	Dropped packets with the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: max_threshold_bytes
                                                                    
                                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_packets
                                                                    
                                                                    	Packets that conform  to the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_bytes
                                                                    
                                                                    	Bytes that conform to the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_packets
                                                                    
                                                                    	Packets that exceed the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_bytes
                                                                    
                                                                    	Bytes that exceed  the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_rate
                                                                    
                                                                    	Conform rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: exceed_rate
                                                                    
                                                                    	Exceed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: queue_instance_length
                                                                    
                                                                    	Queue instance length
                                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                                    
                                                                    .. attribute:: queue_average_length
                                                                    
                                                                    	Queue average length
                                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                                    
                                                                    .. attribute:: queue_max_length
                                                                    
                                                                    	Queue maximum length
                                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                                        self.yang_name = "queue-stats-array"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                                        self._leafs = OrderedDict([
                                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ])
                                                                        self.queue_id = None
                                                                        self.tail_drop_packets = None
                                                                        self.tail_drop_bytes = None
                                                                        self.atm_clp0_drop_packets = None
                                                                        self.atm_clp0_drop_bytes = None
                                                                        self.atm_clp1_drop_packets = None
                                                                        self.atm_clp1_drop_bytes = None
                                                                        self.queue_drop_threshold = None
                                                                        self.forced_wred_stats_display = None
                                                                        self.random_drop_packets = None
                                                                        self.random_drop_bytes = None
                                                                        self.max_threshold_packets = None
                                                                        self.max_threshold_bytes = None
                                                                        self.conform_packets = None
                                                                        self.conform_bytes = None
                                                                        self.exceed_packets = None
                                                                        self.exceed_bytes = None
                                                                        self.conform_rate = None
                                                                        self.exceed_rate = None

                                                                        self.queue_instance_length = YList(self)
                                                                        self.queue_average_length = YList(self)
                                                                        self.queue_max_length = YList(self)
                                                                        self._segment_path = lambda: "queue-stats-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                    class QueueInstanceLength(Entity):
                                                                        """
                                                                        Queue instance length
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                            self.yang_name = "queue-instance-length"
                                                                            self.yang_parent_name = "queue-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "queue-instance-length"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                    class QueueAverageLength(Entity):
                                                                        """
                                                                        Queue average length
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                            self.yang_name = "queue-average-length"
                                                                            self.yang_parent_name = "queue-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "queue-average-length"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                    class QueueMaxLength(Entity):
                                                                        """
                                                                        Queue maximum length
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                            self.yang_name = "queue-max-length"
                                                                            self.yang_parent_name = "queue-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "queue-max-length"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                                class PoliceStatsArray(Entity):
                                                                    """
                                                                    array of police stats
                                                                    
                                                                    .. attribute:: color_class_stats
                                                                    
                                                                    	color class stats
                                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                                    
                                                                    .. attribute:: drop_packets
                                                                    
                                                                    	Police dropped packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: drop_bytes
                                                                    
                                                                    	Police dropped bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_packets
                                                                    
                                                                    	Packets that conform  to the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_bytes
                                                                    
                                                                    	Bytes that conform to the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_packets
                                                                    
                                                                    	Packets that exceed the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_bytes
                                                                    
                                                                    	Bytes that exceed  the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_packets
                                                                    
                                                                    	Packets violating the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_bytes
                                                                    
                                                                    	Bytes that violate the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: parent_drop_packets
                                                                    
                                                                    	Dropped pkts by the parent policer
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: parent_drop_bytes
                                                                    
                                                                    	Dropped bytes by the parent policer
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_rate
                                                                    
                                                                    	Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_rate
                                                                    
                                                                    	Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_rate
                                                                    
                                                                    	Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                                        self.yang_name = "police-stats-array"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                                        self._leafs = OrderedDict([
                                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                        ])
                                                                        self.drop_packets = None
                                                                        self.drop_bytes = None
                                                                        self.conform_packets = None
                                                                        self.conform_bytes = None
                                                                        self.exceed_packets = None
                                                                        self.exceed_bytes = None
                                                                        self.violate_packets = None
                                                                        self.violate_bytes = None
                                                                        self.parent_drop_packets = None
                                                                        self.parent_drop_bytes = None
                                                                        self.conform_rate = None
                                                                        self.exceed_rate = None
                                                                        self.violate_rate = None

                                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                        self.color_class_stats.parent = self
                                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                        self._segment_path = lambda: "police-stats-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                    class ColorClassStats(Entity):
                                                                        """
                                                                        color class stats
                                                                        
                                                                        .. attribute:: conform_class_conform_packets
                                                                        
                                                                        	Packets with classification result conform and policer result conform
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_conform_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result conform
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_conform_rate
                                                                        
                                                                        	Conform Class Conform rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: conform_class_exceed_packets
                                                                        
                                                                        	Packets with classification result conform and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_exceed_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_exceed_rate
                                                                        
                                                                        	Conform Class Exceed rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: conform_class_violate_packets
                                                                        
                                                                        	Packets with classification result conform and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_violate_rate
                                                                        
                                                                        	Conform Class Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_class_exceed_packets
                                                                        
                                                                        	Packets with classification result exceed and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_class_exceed_bytes
                                                                        
                                                                        	Bytes with classification result exceed and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_class_exceed_rate
                                                                        
                                                                        	Exceed Class Exceed rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_class_violate_packets
                                                                        
                                                                        	Packets with classification result exceed and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result exceed and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_class_violate_rate
                                                                        
                                                                        	Exceed Class Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: violate_class_violate_packets
                                                                        
                                                                        	Packets with classification result violate and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: violate_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result violate and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: violate_class_violate_rate
                                                                        
                                                                        	Violate Class Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                            self.yang_name = "color-class-stats"
                                                                            self.yang_parent_name = "police-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                            ])
                                                                            self.conform_class_conform_packets = None
                                                                            self.conform_class_conform_bytes = None
                                                                            self.conform_class_conform_rate = None
                                                                            self.conform_class_exceed_packets = None
                                                                            self.conform_class_exceed_bytes = None
                                                                            self.conform_class_exceed_rate = None
                                                                            self.conform_class_violate_packets = None
                                                                            self.conform_class_violate_bytes = None
                                                                            self.conform_class_violate_rate = None
                                                                            self.exceed_class_exceed_packets = None
                                                                            self.exceed_class_exceed_bytes = None
                                                                            self.exceed_class_exceed_rate = None
                                                                            self.exceed_class_violate_packets = None
                                                                            self.exceed_class_violate_bytes = None
                                                                            self.exceed_class_violate_rate = None
                                                                            self.violate_class_violate_packets = None
                                                                            self.violate_class_violate_bytes = None
                                                                            self.violate_class_violate_rate = None
                                                                            self._segment_path = lambda: "color-class-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                                class WredStatsArray(Entity):
                                                                    """
                                                                    array of red stats
                                                                    
                                                                    .. attribute:: profile_title
                                                                    
                                                                    	ProfileTitle
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..300
                                                                    
                                                                    .. attribute:: red_transmit_packets
                                                                    
                                                                    	Transmitted packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: red_transmit_bytes
                                                                    
                                                                    	Transmitted bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: random_drop_packets
                                                                    
                                                                    	Probabilistically dropped  packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: random_drop_bytes
                                                                    
                                                                    	Probabilisticallydropped bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: max_threshold_packets
                                                                    
                                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: max_threshold_bytes
                                                                    
                                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: red_ecn_marked_packets
                                                                    
                                                                    	ECN marked packets 
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: red_ecn_marked_bytes
                                                                    
                                                                    	ECN marked bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: red_label
                                                                    
                                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                                        self.yang_name = "wred-stats-array"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                                        self._leafs = OrderedDict([
                                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                        ])
                                                                        self.profile_title = None
                                                                        self.red_transmit_packets = None
                                                                        self.red_transmit_bytes = None
                                                                        self.random_drop_packets = None
                                                                        self.random_drop_bytes = None
                                                                        self.max_threshold_packets = None
                                                                        self.max_threshold_bytes = None
                                                                        self.red_ecn_marked_packets = None
                                                                        self.red_ecn_marked_bytes = None

                                                                        self.red_label = YList(self)
                                                                        self._segment_path = lambda: "wred-stats-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                    class RedLabel(Entity):
                                                                        """
                                                                        Array of WRED Typevalues as in PRP stats is
                                                                        available per threshold   
                                                                        
                                                                        .. attribute:: wred_type
                                                                        
                                                                        	WRED type DSCP, EXP, PREC etc
                                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	WRED value for this type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                            self.yang_name = "red-label"
                                                                            self.yang_parent_name = "wred-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                            ])
                                                                            self.wred_type = None
                                                                            self.value = None
                                                                            self._segment_path = lambda: "red-label"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                            class Output(Entity):
                                                """
                                                A piece of QoS policy\-map operational data for
                                                an interface
                                                
                                                .. attribute:: service_policy_names
                                                
                                                	Operational data for all Policy instance
                                                	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, self).__init__()

                                                    self.yang_name = "output"
                                                    self.yang_parent_name = "satellite-id"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames))])
                                                    self._leafs = OrderedDict()

                                                    self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                                    self.service_policy_names.parent = self
                                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                                    self._segment_path = lambda: "output"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, [], name, value)


                                                class ServicePolicyNames(Entity):
                                                    """
                                                    Operational data for all Policy instance
                                                    
                                                    .. attribute:: service_policy_instance
                                                    
                                                    	QoS policy\-map operational data for a particular Policy 
                                                    	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                                        self.yang_name = "service-policy-names"
                                                        self.yang_parent_name = "output"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance))])
                                                        self._leafs = OrderedDict()

                                                        self.service_policy_instance = YList(self)
                                                        self._segment_path = lambda: "service-policy-names"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, [], name, value)


                                                    class ServicePolicyInstance(Entity):
                                                        """
                                                        QoS policy\-map operational data for a
                                                        particular Policy 
                                                        
                                                        .. attribute:: service_policy_name  (key)
                                                        
                                                        	Name of the policy instance
                                                        	**type**\: str
                                                        
                                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                        
                                                        .. attribute:: statistics
                                                        
                                                        	Policy\-map statistics operational data for an interface
                                                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                            self.yang_name = "service-policy-instance"
                                                            self.yang_parent_name = "service-policy-names"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = ['service_policy_name']
                                                            self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                            self._leafs = OrderedDict([
                                                                ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                            ])
                                                            self.service_policy_name = None

                                                            self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                            self.statistics.parent = self
                                                            self._children_name_map["statistics"] = "statistics"
                                                            self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                                        class Statistics(Entity):
                                                            """
                                                            Policy\-map statistics operational data for an
                                                            interface
                                                            
                                                            .. attribute:: policy_name
                                                            
                                                            	PolicyName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: state
                                                            
                                                            	State
                                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                            
                                                            .. attribute:: state_description
                                                            
                                                            	StateDescription
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..128
                                                            
                                                            .. attribute:: satid
                                                            
                                                            	to maintain satellite id
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: class_stats
                                                            
                                                            	array of classes contained in policy
                                                            	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                                self.yang_name = "statistics"
                                                                self.yang_parent_name = "service-policy-instance"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                                self._leafs = OrderedDict([
                                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                                ])
                                                                self.policy_name = None
                                                                self.state = None
                                                                self.state_description = None
                                                                self.satid = None

                                                                self.class_stats = YList(self)
                                                                self._segment_path = lambda: "statistics"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                            class ClassStats(Entity):
                                                                """
                                                                array of classes contained in policy
                                                                
                                                                .. attribute:: general_stats
                                                                
                                                                	general stats
                                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                                
                                                                .. attribute:: iphc_stats
                                                                
                                                                	IPHC stats
                                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                                
                                                                .. attribute:: child_policy
                                                                
                                                                	child policy
                                                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                                
                                                                .. attribute:: cac_stats
                                                                
                                                                	bag for cac stats
                                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                                
                                                                .. attribute:: counter_validity_bitmask
                                                                
                                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: megabyte
                                                                
                                                                .. attribute:: class_name
                                                                
                                                                	ClassName
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: shared_queue_id
                                                                
                                                                	q\-id of the  shared queue for this class
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_descr
                                                                
                                                                	Description of queue for the class
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..256
                                                                
                                                                .. attribute:: cac_state
                                                                
                                                                	CACState
                                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                                
                                                                .. attribute:: queue_stats_array
                                                                
                                                                	array of queue stats
                                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                                
                                                                .. attribute:: police_stats_array
                                                                
                                                                	array of police stats
                                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                                
                                                                .. attribute:: wred_stats_array
                                                                
                                                                	array of red stats
                                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                                    self.yang_name = "class-stats"
                                                                    self.yang_parent_name = "statistics"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                                    self._leafs = OrderedDict([
                                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                    ])
                                                                    self.counter_validity_bitmask = None
                                                                    self.class_name = None
                                                                    self.shared_queue_id = None
                                                                    self.queue_descr = None
                                                                    self.cac_state = None

                                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                                    self.general_stats.parent = self
                                                                    self._children_name_map["general_stats"] = "general-stats"

                                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                                    self.iphc_stats.parent = self
                                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                    self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                                    self.child_policy.parent = self
                                                                    self._children_name_map["child_policy"] = "child-policy"

                                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                                    self.cac_stats.parent = self
                                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                                    self.queue_stats_array = YList(self)
                                                                    self.police_stats_array = YList(self)
                                                                    self.wred_stats_array = YList(self)
                                                                    self._segment_path = lambda: "class-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                                class GeneralStats(Entity):
                                                                    """
                                                                    general stats
                                                                    
                                                                    .. attribute:: transmit_packets
                                                                    
                                                                    	Transmitted packets (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: transmit_bytes
                                                                    
                                                                    	Transmitted bytes (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_packets
                                                                    
                                                                    	Dropped packets (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_bytes
                                                                    
                                                                    	Dropped bytes (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_rate
                                                                    
                                                                    	Total drop rate (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: match_data_rate
                                                                    
                                                                    	Incoming matched data rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: total_transmit_rate
                                                                    
                                                                    	Total transmit rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: pre_policy_matched_packets
                                                                    
                                                                    	Matched pkts before applying policy
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: pre_policy_matched_bytes
                                                                    
                                                                    	Matched bytes before applying policy
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                                        self.yang_name = "general-stats"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                        ])
                                                                        self.transmit_packets = None
                                                                        self.transmit_bytes = None
                                                                        self.total_drop_packets = None
                                                                        self.total_drop_bytes = None
                                                                        self.total_drop_rate = None
                                                                        self.match_data_rate = None
                                                                        self.total_transmit_rate = None
                                                                        self.pre_policy_matched_packets = None
                                                                        self.pre_policy_matched_bytes = None
                                                                        self._segment_path = lambda: "general-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                                class IphcStats(Entity):
                                                                    """
                                                                    IPHC stats
                                                                    
                                                                    .. attribute:: non_tcp_total_out_packets
                                                                    
                                                                    	TotalNum of Non tcp pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: non_tcp_total_out_bytes
                                                                    
                                                                    	TotalNum of Non Tcp Bytes sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_bytes_saved
                                                                    
                                                                    	Non Tcp Bytes saved due to compression
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_compressed_packets_out
                                                                    
                                                                    	Num of non tcp compressed pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                                    
                                                                    	Compressed Non Tcp Bytes sent rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_full_header_packets_out
                                                                    
                                                                    	Num of non tcp fullheader pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_total_out_packets
                                                                    
                                                                    	Total Num of tcp pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_total_out_bytes
                                                                    
                                                                    	TotalNum of Tcp Bytes sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_bytes_saved
                                                                    
                                                                    	Tcp Bytes saved due to compression
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_compressed_packets_out
                                                                    
                                                                    	Num of tcp compressed pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_bytes_sent_rate
                                                                    
                                                                    	Compressed Tcp Bytes sent rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_full_header_packets_out
                                                                    
                                                                    	Num of tcp fullheader pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                                        self.yang_name = "iphc-stats"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                        ])
                                                                        self.non_tcp_total_out_packets = None
                                                                        self.non_tcp_total_out_bytes = None
                                                                        self.non_tcp_bytes_saved = None
                                                                        self.non_tcp_compressed_packets_out = None
                                                                        self.non_tcp_bytes_sent_rate = None
                                                                        self.non_tcp_full_header_packets_out = None
                                                                        self.tcp_total_out_packets = None
                                                                        self.tcp_total_out_bytes = None
                                                                        self.tcp_bytes_saved = None
                                                                        self.tcp_compressed_packets_out = None
                                                                        self.tcp_bytes_sent_rate = None
                                                                        self.tcp_full_header_packets_out = None
                                                                        self._segment_path = lambda: "iphc-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                                class ChildPolicy(Entity):
                                                                    """
                                                                    child policy
                                                                    
                                                                    .. attribute:: policy_name
                                                                    
                                                                    	PolicyName
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: state
                                                                    
                                                                    	State
                                                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                                    
                                                                    .. attribute:: state_description
                                                                    
                                                                    	StateDescription
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..128
                                                                    
                                                                    .. attribute:: satid
                                                                    
                                                                    	to maintain satellite id
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: class_stats
                                                                    
                                                                    	array of classes contained in policy
                                                                    	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                                        self.yang_name = "child-policy"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                                        self._leafs = OrderedDict([
                                                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                                        ])
                                                                        self.policy_name = None
                                                                        self.state = None
                                                                        self.state_description = None
                                                                        self.satid = None

                                                                        self.class_stats = YList(self)
                                                                        self._segment_path = lambda: "child-policy"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                                    class ClassStats_(Entity):
                                                                        """
                                                                        array of classes contained in policy
                                                                        
                                                                        .. attribute:: general_stats
                                                                        
                                                                        	general stats
                                                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                                        
                                                                        .. attribute:: iphc_stats
                                                                        
                                                                        	IPHC stats
                                                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                                        
                                                                        .. attribute:: cac_stats
                                                                        
                                                                        	bag for cac stats
                                                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                                        
                                                                        .. attribute:: counter_validity_bitmask
                                                                        
                                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: megabyte
                                                                        
                                                                        .. attribute:: class_name
                                                                        
                                                                        	ClassName
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: shared_queue_id
                                                                        
                                                                        	q\-id of the  shared queue for this class
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: queue_descr
                                                                        
                                                                        	Description of queue for the class
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..256
                                                                        
                                                                        .. attribute:: cac_state
                                                                        
                                                                        	CACState
                                                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                                        
                                                                        .. attribute:: queue_stats_array
                                                                        
                                                                        	array of queue stats
                                                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                                        
                                                                        .. attribute:: police_stats_array
                                                                        
                                                                        	array of police stats
                                                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                                        
                                                                        .. attribute:: wred_stats_array
                                                                        
                                                                        	array of red stats
                                                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                            self.yang_name = "class-stats"
                                                                            self.yang_parent_name = "child-policy"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                            self._leafs = OrderedDict([
                                                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                            ])
                                                                            self.counter_validity_bitmask = None
                                                                            self.class_name = None
                                                                            self.shared_queue_id = None
                                                                            self.queue_descr = None
                                                                            self.cac_state = None

                                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                            self.general_stats.parent = self
                                                                            self._children_name_map["general_stats"] = "general-stats"

                                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                            self.iphc_stats.parent = self
                                                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                            self.cac_stats.parent = self
                                                                            self._children_name_map["cac_stats"] = "cac-stats"

                                                                            self.queue_stats_array = YList(self)
                                                                            self.police_stats_array = YList(self)
                                                                            self.wred_stats_array = YList(self)
                                                                            self._segment_path = lambda: "class-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                                        class GeneralStats(Entity):
                                                                            """
                                                                            general stats
                                                                            
                                                                            .. attribute:: transmit_packets
                                                                            
                                                                            	Transmitted packets (packets/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: transmit_bytes
                                                                            
                                                                            	Transmitted bytes (packets/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: total_drop_packets
                                                                            
                                                                            	Dropped packets (packets/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: total_drop_bytes
                                                                            
                                                                            	Dropped bytes (packets/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: total_drop_rate
                                                                            
                                                                            	Total drop rate (packets/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: match_data_rate
                                                                            
                                                                            	Incoming matched data rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: total_transmit_rate
                                                                            
                                                                            	Total transmit rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: pre_policy_matched_packets
                                                                            
                                                                            	Matched pkts before applying policy
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: pre_policy_matched_bytes
                                                                            
                                                                            	Matched bytes before applying policy
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                                self.yang_name = "general-stats"
                                                                                self.yang_parent_name = "class-stats"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                                ])
                                                                                self.transmit_packets = None
                                                                                self.transmit_bytes = None
                                                                                self.total_drop_packets = None
                                                                                self.total_drop_bytes = None
                                                                                self.total_drop_rate = None
                                                                                self.match_data_rate = None
                                                                                self.total_transmit_rate = None
                                                                                self.pre_policy_matched_packets = None
                                                                                self.pre_policy_matched_bytes = None
                                                                                self._segment_path = lambda: "general-stats"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                                        class IphcStats(Entity):
                                                                            """
                                                                            IPHC stats
                                                                            
                                                                            .. attribute:: non_tcp_total_out_packets
                                                                            
                                                                            	TotalNum of Non tcp pkts sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: non_tcp_total_out_bytes
                                                                            
                                                                            	TotalNum of Non Tcp Bytes sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: non_tcp_bytes_saved
                                                                            
                                                                            	Non Tcp Bytes saved due to compression
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: non_tcp_compressed_packets_out
                                                                            
                                                                            	Num of non tcp compressed pkts sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                                            
                                                                            	Compressed Non Tcp Bytes sent rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: non_tcp_full_header_packets_out
                                                                            
                                                                            	Num of non tcp fullheader pkts sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: tcp_total_out_packets
                                                                            
                                                                            	Total Num of tcp pkts sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: tcp_total_out_bytes
                                                                            
                                                                            	TotalNum of Tcp Bytes sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: tcp_bytes_saved
                                                                            
                                                                            	Tcp Bytes saved due to compression
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: tcp_compressed_packets_out
                                                                            
                                                                            	Num of tcp compressed pkts sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: tcp_bytes_sent_rate
                                                                            
                                                                            	Compressed Tcp Bytes sent rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: tcp_full_header_packets_out
                                                                            
                                                                            	Num of tcp fullheader pkts sent
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                                self.yang_name = "iphc-stats"
                                                                                self.yang_parent_name = "class-stats"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                                ])
                                                                                self.non_tcp_total_out_packets = None
                                                                                self.non_tcp_total_out_bytes = None
                                                                                self.non_tcp_bytes_saved = None
                                                                                self.non_tcp_compressed_packets_out = None
                                                                                self.non_tcp_bytes_sent_rate = None
                                                                                self.non_tcp_full_header_packets_out = None
                                                                                self.tcp_total_out_packets = None
                                                                                self.tcp_total_out_bytes = None
                                                                                self.tcp_bytes_saved = None
                                                                                self.tcp_compressed_packets_out = None
                                                                                self.tcp_bytes_sent_rate = None
                                                                                self.tcp_full_header_packets_out = None
                                                                                self._segment_path = lambda: "iphc-stats"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                                        class CacStats(Entity):
                                                                            """
                                                                            bag for cac stats
                                                                            
                                                                            .. attribute:: drop_packets
                                                                            
                                                                            	CAC dropped packets
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: drop_bytes
                                                                            
                                                                            	CAC dropped bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: drop_rates
                                                                            
                                                                            	CAC dropped rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: admitpackets
                                                                            
                                                                            	Admitted packets (pkts/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: admit_bytes
                                                                            
                                                                            	Admitted bytes (pkts/bytes)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: admit_rates
                                                                            
                                                                            	CAC admit rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                                self.yang_name = "cac-stats"
                                                                                self.yang_parent_name = "class-stats"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                                ])
                                                                                self.drop_packets = None
                                                                                self.drop_bytes = None
                                                                                self.drop_rates = None
                                                                                self.admitpackets = None
                                                                                self.admit_bytes = None
                                                                                self.admit_rates = None
                                                                                self._segment_path = lambda: "cac-stats"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                                        class QueueStatsArray(Entity):
                                                                            """
                                                                            array of queue stats
                                                                            
                                                                            .. attribute:: queue_id
                                                                            
                                                                            	Queue Id used for Fabric Stats
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: tail_drop_packets
                                                                            
                                                                            	Packets tail dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: tail_drop_bytes
                                                                            
                                                                            	Bytes tail dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: atm_clp0_drop_packets
                                                                            
                                                                            	ATP CLP 0 matched packets dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: atm_clp0_drop_bytes
                                                                            
                                                                            	ATP CLP 0 matched bytes dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: atm_clp1_drop_packets
                                                                            
                                                                            	ATP CLP 0 matched packets dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: atm_clp1_drop_bytes
                                                                            
                                                                            	ATP CLP 0 matched bytes dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: queue_drop_threshold
                                                                            
                                                                            	tail drop threshold of the queue in bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: forced_wred_stats_display
                                                                            
                                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                            	**type**\: bool
                                                                            
                                                                            .. attribute:: random_drop_packets
                                                                            
                                                                            	Packets probabilistically dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: random_drop_bytes
                                                                            
                                                                            	Bytes probabilistically dropped
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: max_threshold_packets
                                                                            
                                                                            	Dropped packets with the average queue size at the max\-threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: max_threshold_bytes
                                                                            
                                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_packets
                                                                            
                                                                            	Packets that conform  to the queue rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_bytes
                                                                            
                                                                            	Bytes that conform to the queue rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: exceed_packets
                                                                            
                                                                            	Packets that exceed the queue rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: exceed_bytes
                                                                            
                                                                            	Bytes that exceed  the queue rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_rate
                                                                            
                                                                            	Conform rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: exceed_rate
                                                                            
                                                                            	Exceed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: queue_instance_length
                                                                            
                                                                            	Queue instance length
                                                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                            
                                                                            .. attribute:: queue_average_length
                                                                            
                                                                            	Queue average length
                                                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                            
                                                                            .. attribute:: queue_max_length
                                                                            
                                                                            	Queue maximum length
                                                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                                self.yang_name = "queue-stats-array"
                                                                                self.yang_parent_name = "class-stats"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                                ])
                                                                                self.queue_id = None
                                                                                self.tail_drop_packets = None
                                                                                self.tail_drop_bytes = None
                                                                                self.atm_clp0_drop_packets = None
                                                                                self.atm_clp0_drop_bytes = None
                                                                                self.atm_clp1_drop_packets = None
                                                                                self.atm_clp1_drop_bytes = None
                                                                                self.queue_drop_threshold = None
                                                                                self.forced_wred_stats_display = None
                                                                                self.random_drop_packets = None
                                                                                self.random_drop_bytes = None
                                                                                self.max_threshold_packets = None
                                                                                self.max_threshold_bytes = None
                                                                                self.conform_packets = None
                                                                                self.conform_bytes = None
                                                                                self.exceed_packets = None
                                                                                self.exceed_bytes = None
                                                                                self.conform_rate = None
                                                                                self.exceed_rate = None

                                                                                self.queue_instance_length = YList(self)
                                                                                self.queue_average_length = YList(self)
                                                                                self.queue_max_length = YList(self)
                                                                                self._segment_path = lambda: "queue-stats-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                            class QueueInstanceLength(Entity):
                                                                                """
                                                                                Queue instance length
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'qos-ma-oper'
                                                                                _revision = '2017-09-13'

                                                                                def __init__(self):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                                    self.yang_name = "queue-instance-length"
                                                                                    self.yang_parent_name = "queue-stats-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "queue-instance-length"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                            class QueueAverageLength(Entity):
                                                                                """
                                                                                Queue average length
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'qos-ma-oper'
                                                                                _revision = '2017-09-13'

                                                                                def __init__(self):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                                    self.yang_name = "queue-average-length"
                                                                                    self.yang_parent_name = "queue-stats-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "queue-average-length"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                            class QueueMaxLength(Entity):
                                                                                """
                                                                                Queue maximum length
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'qos-ma-oper'
                                                                                _revision = '2017-09-13'

                                                                                def __init__(self):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                                    self.yang_name = "queue-max-length"
                                                                                    self.yang_parent_name = "queue-stats-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "queue-max-length"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                                        class PoliceStatsArray(Entity):
                                                                            """
                                                                            array of police stats
                                                                            
                                                                            .. attribute:: color_class_stats
                                                                            
                                                                            	color class stats
                                                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                            
                                                                            .. attribute:: drop_packets
                                                                            
                                                                            	Police dropped packets
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: drop_bytes
                                                                            
                                                                            	Police dropped bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_packets
                                                                            
                                                                            	Packets that conform  to the policed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_bytes
                                                                            
                                                                            	Bytes that conform to the policed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: exceed_packets
                                                                            
                                                                            	Packets that exceed the policed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: exceed_bytes
                                                                            
                                                                            	Bytes that exceed  the policed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: violate_packets
                                                                            
                                                                            	Packets violating the policed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: violate_bytes
                                                                            
                                                                            	Bytes that violate the policed rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: parent_drop_packets
                                                                            
                                                                            	Dropped pkts by the parent policer
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: parent_drop_bytes
                                                                            
                                                                            	Dropped bytes by the parent policer
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_rate
                                                                            
                                                                            	Conform rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: exceed_rate
                                                                            
                                                                            	Exceed rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: violate_rate
                                                                            
                                                                            	Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                                self.yang_name = "police-stats-array"
                                                                                self.yang_parent_name = "class-stats"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                                ])
                                                                                self.drop_packets = None
                                                                                self.drop_bytes = None
                                                                                self.conform_packets = None
                                                                                self.conform_bytes = None
                                                                                self.exceed_packets = None
                                                                                self.exceed_bytes = None
                                                                                self.violate_packets = None
                                                                                self.violate_bytes = None
                                                                                self.parent_drop_packets = None
                                                                                self.parent_drop_bytes = None
                                                                                self.conform_rate = None
                                                                                self.exceed_rate = None
                                                                                self.violate_rate = None

                                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                                self.color_class_stats.parent = self
                                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                                self._segment_path = lambda: "police-stats-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                            class ColorClassStats(Entity):
                                                                                """
                                                                                color class stats
                                                                                
                                                                                .. attribute:: conform_class_conform_packets
                                                                                
                                                                                	Packets with classification result conform and policer result conform
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: conform_class_conform_bytes
                                                                                
                                                                                	Bytes with classification result conform and policer result conform
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                	**units**\: byte
                                                                                
                                                                                .. attribute:: conform_class_conform_rate
                                                                                
                                                                                	Conform Class Conform rate in kbps
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                	**units**\: kbit/s
                                                                                
                                                                                .. attribute:: conform_class_exceed_packets
                                                                                
                                                                                	Packets with classification result conform and policer result exceed
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: conform_class_exceed_bytes
                                                                                
                                                                                	Bytes with classification result conform and policer result exceed
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                	**units**\: byte
                                                                                
                                                                                .. attribute:: conform_class_exceed_rate
                                                                                
                                                                                	Conform Class Exceed rate in kbps
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                	**units**\: kbit/s
                                                                                
                                                                                .. attribute:: conform_class_violate_packets
                                                                                
                                                                                	Packets with classification result conform and policer result violate
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: conform_class_violate_bytes
                                                                                
                                                                                	Bytes with classification result conform and policer result violate
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                	**units**\: byte
                                                                                
                                                                                .. attribute:: conform_class_violate_rate
                                                                                
                                                                                	Conform Class Violate rate in kbps
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                	**units**\: kbit/s
                                                                                
                                                                                .. attribute:: exceed_class_exceed_packets
                                                                                
                                                                                	Packets with classification result exceed and policer result exceed
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: exceed_class_exceed_bytes
                                                                                
                                                                                	Bytes with classification result exceed and policer result exceed
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                	**units**\: byte
                                                                                
                                                                                .. attribute:: exceed_class_exceed_rate
                                                                                
                                                                                	Exceed Class Exceed rate in kbps
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                	**units**\: kbit/s
                                                                                
                                                                                .. attribute:: exceed_class_violate_packets
                                                                                
                                                                                	Packets with classification result exceed and policer result violate
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: exceed_class_violate_bytes
                                                                                
                                                                                	Bytes with classification result exceed and policer result violate
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                	**units**\: byte
                                                                                
                                                                                .. attribute:: exceed_class_violate_rate
                                                                                
                                                                                	Exceed Class Violate rate in kbps
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                	**units**\: kbit/s
                                                                                
                                                                                .. attribute:: violate_class_violate_packets
                                                                                
                                                                                	Packets with classification result violate and policer result violate
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: violate_class_violate_bytes
                                                                                
                                                                                	Bytes with classification result violate and policer result violate
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                	**units**\: byte
                                                                                
                                                                                .. attribute:: violate_class_violate_rate
                                                                                
                                                                                	Violate Class Violate rate in kbps
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                	**units**\: kbit/s
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'qos-ma-oper'
                                                                                _revision = '2017-09-13'

                                                                                def __init__(self):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                                    self.yang_name = "color-class-stats"
                                                                                    self.yang_parent_name = "police-stats-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                                    ])
                                                                                    self.conform_class_conform_packets = None
                                                                                    self.conform_class_conform_bytes = None
                                                                                    self.conform_class_conform_rate = None
                                                                                    self.conform_class_exceed_packets = None
                                                                                    self.conform_class_exceed_bytes = None
                                                                                    self.conform_class_exceed_rate = None
                                                                                    self.conform_class_violate_packets = None
                                                                                    self.conform_class_violate_bytes = None
                                                                                    self.conform_class_violate_rate = None
                                                                                    self.exceed_class_exceed_packets = None
                                                                                    self.exceed_class_exceed_bytes = None
                                                                                    self.exceed_class_exceed_rate = None
                                                                                    self.exceed_class_violate_packets = None
                                                                                    self.exceed_class_violate_bytes = None
                                                                                    self.exceed_class_violate_rate = None
                                                                                    self.violate_class_violate_packets = None
                                                                                    self.violate_class_violate_bytes = None
                                                                                    self.violate_class_violate_rate = None
                                                                                    self._segment_path = lambda: "color-class-stats"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                                        class WredStatsArray(Entity):
                                                                            """
                                                                            array of red stats
                                                                            
                                                                            .. attribute:: profile_title
                                                                            
                                                                            	ProfileTitle
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..300
                                                                            
                                                                            .. attribute:: red_transmit_packets
                                                                            
                                                                            	Transmitted packets
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: red_transmit_bytes
                                                                            
                                                                            	Transmitted bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: random_drop_packets
                                                                            
                                                                            	Probabilistically dropped  packets
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: random_drop_bytes
                                                                            
                                                                            	Probabilisticallydropped bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: max_threshold_packets
                                                                            
                                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: max_threshold_bytes
                                                                            
                                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: red_ecn_marked_packets
                                                                            
                                                                            	ECN marked packets 
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: red_ecn_marked_bytes
                                                                            
                                                                            	ECN marked bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: red_label
                                                                            
                                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                                self.yang_name = "wred-stats-array"
                                                                                self.yang_parent_name = "class-stats"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                                ])
                                                                                self.profile_title = None
                                                                                self.red_transmit_packets = None
                                                                                self.red_transmit_bytes = None
                                                                                self.random_drop_packets = None
                                                                                self.random_drop_bytes = None
                                                                                self.max_threshold_packets = None
                                                                                self.max_threshold_bytes = None
                                                                                self.red_ecn_marked_packets = None
                                                                                self.red_ecn_marked_bytes = None

                                                                                self.red_label = YList(self)
                                                                                self._segment_path = lambda: "wred-stats-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                            class RedLabel(Entity):
                                                                                """
                                                                                Array of WRED Typevalues as in PRP stats is
                                                                                available per threshold   
                                                                                
                                                                                .. attribute:: wred_type
                                                                                
                                                                                	WRED type DSCP, EXP, PREC etc
                                                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	WRED value for this type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'qos-ma-oper'
                                                                                _revision = '2017-09-13'

                                                                                def __init__(self):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                                    self.yang_name = "red-label"
                                                                                    self.yang_parent_name = "wred-stats-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.wred_type = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "red-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                                class CacStats(Entity):
                                                                    """
                                                                    bag for cac stats
                                                                    
                                                                    .. attribute:: drop_packets
                                                                    
                                                                    	CAC dropped packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: drop_bytes
                                                                    
                                                                    	CAC dropped bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: drop_rates
                                                                    
                                                                    	CAC dropped rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: admitpackets
                                                                    
                                                                    	Admitted packets (pkts/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: admit_bytes
                                                                    
                                                                    	Admitted bytes (pkts/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: admit_rates
                                                                    
                                                                    	CAC admit rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                                        self.yang_name = "cac-stats"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                        ])
                                                                        self.drop_packets = None
                                                                        self.drop_bytes = None
                                                                        self.drop_rates = None
                                                                        self.admitpackets = None
                                                                        self.admit_bytes = None
                                                                        self.admit_rates = None
                                                                        self._segment_path = lambda: "cac-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                                class QueueStatsArray(Entity):
                                                                    """
                                                                    array of queue stats
                                                                    
                                                                    .. attribute:: queue_id
                                                                    
                                                                    	Queue Id used for Fabric Stats
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: tail_drop_packets
                                                                    
                                                                    	Packets tail dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tail_drop_bytes
                                                                    
                                                                    	Bytes tail dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: atm_clp0_drop_packets
                                                                    
                                                                    	ATP CLP 0 matched packets dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: atm_clp0_drop_bytes
                                                                    
                                                                    	ATP CLP 0 matched bytes dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: atm_clp1_drop_packets
                                                                    
                                                                    	ATP CLP 0 matched packets dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: atm_clp1_drop_bytes
                                                                    
                                                                    	ATP CLP 0 matched bytes dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: queue_drop_threshold
                                                                    
                                                                    	tail drop threshold of the queue in bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: forced_wred_stats_display
                                                                    
                                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                    	**type**\: bool
                                                                    
                                                                    .. attribute:: random_drop_packets
                                                                    
                                                                    	Packets probabilistically dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: random_drop_bytes
                                                                    
                                                                    	Bytes probabilistically dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: max_threshold_packets
                                                                    
                                                                    	Dropped packets with the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: max_threshold_bytes
                                                                    
                                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_packets
                                                                    
                                                                    	Packets that conform  to the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_bytes
                                                                    
                                                                    	Bytes that conform to the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_packets
                                                                    
                                                                    	Packets that exceed the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_bytes
                                                                    
                                                                    	Bytes that exceed  the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_rate
                                                                    
                                                                    	Conform rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: exceed_rate
                                                                    
                                                                    	Exceed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: queue_instance_length
                                                                    
                                                                    	Queue instance length
                                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                                    
                                                                    .. attribute:: queue_average_length
                                                                    
                                                                    	Queue average length
                                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                                    
                                                                    .. attribute:: queue_max_length
                                                                    
                                                                    	Queue maximum length
                                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                                        self.yang_name = "queue-stats-array"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                                        self._leafs = OrderedDict([
                                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ])
                                                                        self.queue_id = None
                                                                        self.tail_drop_packets = None
                                                                        self.tail_drop_bytes = None
                                                                        self.atm_clp0_drop_packets = None
                                                                        self.atm_clp0_drop_bytes = None
                                                                        self.atm_clp1_drop_packets = None
                                                                        self.atm_clp1_drop_bytes = None
                                                                        self.queue_drop_threshold = None
                                                                        self.forced_wred_stats_display = None
                                                                        self.random_drop_packets = None
                                                                        self.random_drop_bytes = None
                                                                        self.max_threshold_packets = None
                                                                        self.max_threshold_bytes = None
                                                                        self.conform_packets = None
                                                                        self.conform_bytes = None
                                                                        self.exceed_packets = None
                                                                        self.exceed_bytes = None
                                                                        self.conform_rate = None
                                                                        self.exceed_rate = None

                                                                        self.queue_instance_length = YList(self)
                                                                        self.queue_average_length = YList(self)
                                                                        self.queue_max_length = YList(self)
                                                                        self._segment_path = lambda: "queue-stats-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                    class QueueInstanceLength(Entity):
                                                                        """
                                                                        Queue instance length
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                            self.yang_name = "queue-instance-length"
                                                                            self.yang_parent_name = "queue-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "queue-instance-length"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                    class QueueAverageLength(Entity):
                                                                        """
                                                                        Queue average length
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                            self.yang_name = "queue-average-length"
                                                                            self.yang_parent_name = "queue-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "queue-average-length"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                    class QueueMaxLength(Entity):
                                                                        """
                                                                        Queue maximum length
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                            self.yang_name = "queue-max-length"
                                                                            self.yang_parent_name = "queue-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "queue-max-length"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                                class PoliceStatsArray(Entity):
                                                                    """
                                                                    array of police stats
                                                                    
                                                                    .. attribute:: color_class_stats
                                                                    
                                                                    	color class stats
                                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                                    
                                                                    .. attribute:: drop_packets
                                                                    
                                                                    	Police dropped packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: drop_bytes
                                                                    
                                                                    	Police dropped bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_packets
                                                                    
                                                                    	Packets that conform  to the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_bytes
                                                                    
                                                                    	Bytes that conform to the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_packets
                                                                    
                                                                    	Packets that exceed the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_bytes
                                                                    
                                                                    	Bytes that exceed  the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_packets
                                                                    
                                                                    	Packets violating the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_bytes
                                                                    
                                                                    	Bytes that violate the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: parent_drop_packets
                                                                    
                                                                    	Dropped pkts by the parent policer
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: parent_drop_bytes
                                                                    
                                                                    	Dropped bytes by the parent policer
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_rate
                                                                    
                                                                    	Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_rate
                                                                    
                                                                    	Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_rate
                                                                    
                                                                    	Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                                        self.yang_name = "police-stats-array"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                                        self._leafs = OrderedDict([
                                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                        ])
                                                                        self.drop_packets = None
                                                                        self.drop_bytes = None
                                                                        self.conform_packets = None
                                                                        self.conform_bytes = None
                                                                        self.exceed_packets = None
                                                                        self.exceed_bytes = None
                                                                        self.violate_packets = None
                                                                        self.violate_bytes = None
                                                                        self.parent_drop_packets = None
                                                                        self.parent_drop_bytes = None
                                                                        self.conform_rate = None
                                                                        self.exceed_rate = None
                                                                        self.violate_rate = None

                                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                        self.color_class_stats.parent = self
                                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                        self._segment_path = lambda: "police-stats-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                    class ColorClassStats(Entity):
                                                                        """
                                                                        color class stats
                                                                        
                                                                        .. attribute:: conform_class_conform_packets
                                                                        
                                                                        	Packets with classification result conform and policer result conform
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_conform_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result conform
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_conform_rate
                                                                        
                                                                        	Conform Class Conform rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: conform_class_exceed_packets
                                                                        
                                                                        	Packets with classification result conform and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_exceed_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_exceed_rate
                                                                        
                                                                        	Conform Class Exceed rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: conform_class_violate_packets
                                                                        
                                                                        	Packets with classification result conform and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_violate_rate
                                                                        
                                                                        	Conform Class Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_class_exceed_packets
                                                                        
                                                                        	Packets with classification result exceed and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_class_exceed_bytes
                                                                        
                                                                        	Bytes with classification result exceed and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_class_exceed_rate
                                                                        
                                                                        	Exceed Class Exceed rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_class_violate_packets
                                                                        
                                                                        	Packets with classification result exceed and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result exceed and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_class_violate_rate
                                                                        
                                                                        	Exceed Class Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: violate_class_violate_packets
                                                                        
                                                                        	Packets with classification result violate and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: violate_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result violate and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: violate_class_violate_rate
                                                                        
                                                                        	Violate Class Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                            self.yang_name = "color-class-stats"
                                                                            self.yang_parent_name = "police-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                            ])
                                                                            self.conform_class_conform_packets = None
                                                                            self.conform_class_conform_bytes = None
                                                                            self.conform_class_conform_rate = None
                                                                            self.conform_class_exceed_packets = None
                                                                            self.conform_class_exceed_bytes = None
                                                                            self.conform_class_exceed_rate = None
                                                                            self.conform_class_violate_packets = None
                                                                            self.conform_class_violate_bytes = None
                                                                            self.conform_class_violate_rate = None
                                                                            self.exceed_class_exceed_packets = None
                                                                            self.exceed_class_exceed_bytes = None
                                                                            self.exceed_class_exceed_rate = None
                                                                            self.exceed_class_violate_packets = None
                                                                            self.exceed_class_violate_bytes = None
                                                                            self.exceed_class_violate_rate = None
                                                                            self.violate_class_violate_packets = None
                                                                            self.violate_class_violate_bytes = None
                                                                            self.violate_class_violate_rate = None
                                                                            self._segment_path = lambda: "color-class-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                                class WredStatsArray(Entity):
                                                                    """
                                                                    array of red stats
                                                                    
                                                                    .. attribute:: profile_title
                                                                    
                                                                    	ProfileTitle
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..300
                                                                    
                                                                    .. attribute:: red_transmit_packets
                                                                    
                                                                    	Transmitted packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: red_transmit_bytes
                                                                    
                                                                    	Transmitted bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: random_drop_packets
                                                                    
                                                                    	Probabilistically dropped  packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: random_drop_bytes
                                                                    
                                                                    	Probabilisticallydropped bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: max_threshold_packets
                                                                    
                                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: max_threshold_bytes
                                                                    
                                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: red_ecn_marked_packets
                                                                    
                                                                    	ECN marked packets 
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: red_ecn_marked_bytes
                                                                    
                                                                    	ECN marked bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: red_label
                                                                    
                                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                                        self.yang_name = "wred-stats-array"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                                        self._leafs = OrderedDict([
                                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                        ])
                                                                        self.profile_title = None
                                                                        self.red_transmit_packets = None
                                                                        self.red_transmit_bytes = None
                                                                        self.random_drop_packets = None
                                                                        self.random_drop_bytes = None
                                                                        self.max_threshold_packets = None
                                                                        self.max_threshold_bytes = None
                                                                        self.red_ecn_marked_packets = None
                                                                        self.red_ecn_marked_bytes = None

                                                                        self.red_label = YList(self)
                                                                        self._segment_path = lambda: "wred-stats-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                    class RedLabel(Entity):
                                                                        """
                                                                        Array of WRED Typevalues as in PRP stats is
                                                                        available per threshold   
                                                                        
                                                                        .. attribute:: wred_type
                                                                        
                                                                        	WRED type DSCP, EXP, PREC etc
                                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	WRED value for this type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                            self.yang_name = "red-label"
                                                                            self.yang_parent_name = "wred-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                            ])
                                                                            self.wred_type = None
                                                                            self.value = None
                                                                            self._segment_path = lambda: "red-label"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                    class Input(Entity):
                                        """
                                        A piece of QoS policy\-map operational data for
                                        an interface
                                        
                                        .. attribute:: service_policy_names
                                        
                                        	Operational data for all Policy instance
                                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input, self).__init__()

                                            self.yang_name = "input"
                                            self.yang_parent_name = "member-interface"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames))])
                                            self._leafs = OrderedDict()

                                            self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                                            self.service_policy_names.parent = self
                                            self._children_name_map["service_policy_names"] = "service-policy-names"
                                            self._segment_path = lambda: "input"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input, [], name, value)


                                        class ServicePolicyNames(Entity):
                                            """
                                            Operational data for all Policy instance
                                            
                                            .. attribute:: service_policy_instance
                                            
                                            	QoS policy\-map operational data for a particular Policy 
                                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__init__()

                                                self.yang_name = "service-policy-names"
                                                self.yang_parent_name = "input"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance))])
                                                self._leafs = OrderedDict()

                                                self.service_policy_instance = YList(self)
                                                self._segment_path = lambda: "service-policy-names"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, [], name, value)


                                            class ServicePolicyInstance(Entity):
                                                """
                                                QoS policy\-map operational data for a
                                                particular Policy 
                                                
                                                .. attribute:: service_policy_name  (key)
                                                
                                                	Name of the policy instance
                                                	**type**\: str
                                                
                                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                
                                                .. attribute:: statistics
                                                
                                                	Policy\-map statistics operational data for an interface
                                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                    self.yang_name = "service-policy-instance"
                                                    self.yang_parent_name = "service-policy-names"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = ['service_policy_name']
                                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                    self._leafs = OrderedDict([
                                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                    ])
                                                    self.service_policy_name = None

                                                    self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                    self.statistics.parent = self
                                                    self._children_name_map["statistics"] = "statistics"
                                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                                class Statistics(Entity):
                                                    """
                                                    Policy\-map statistics operational data for an
                                                    interface
                                                    
                                                    .. attribute:: policy_name
                                                    
                                                    	PolicyName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: state
                                                    
                                                    	State
                                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                    
                                                    .. attribute:: state_description
                                                    
                                                    	StateDescription
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..128
                                                    
                                                    .. attribute:: satid
                                                    
                                                    	to maintain satellite id
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: class_stats
                                                    
                                                    	array of classes contained in policy
                                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                        self.yang_name = "statistics"
                                                        self.yang_parent_name = "service-policy-instance"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                        ])
                                                        self.policy_name = None
                                                        self.state = None
                                                        self.state_description = None
                                                        self.satid = None

                                                        self.class_stats = YList(self)
                                                        self._segment_path = lambda: "statistics"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                    class ClassStats(Entity):
                                                        """
                                                        array of classes contained in policy
                                                        
                                                        .. attribute:: general_stats
                                                        
                                                        	general stats
                                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                        
                                                        .. attribute:: iphc_stats
                                                        
                                                        	IPHC stats
                                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                        
                                                        .. attribute:: child_policy
                                                        
                                                        	child policy
                                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                        
                                                        .. attribute:: cac_stats
                                                        
                                                        	bag for cac stats
                                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                        
                                                        .. attribute:: counter_validity_bitmask
                                                        
                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: megabyte
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	ClassName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: shared_queue_id
                                                        
                                                        	q\-id of the  shared queue for this class
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_descr
                                                        
                                                        	Description of queue for the class
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..256
                                                        
                                                        .. attribute:: cac_state
                                                        
                                                        	CACState
                                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                        
                                                        .. attribute:: queue_stats_array
                                                        
                                                        	array of queue stats
                                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                        
                                                        .. attribute:: police_stats_array
                                                        
                                                        	array of police stats
                                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                        
                                                        .. attribute:: wred_stats_array
                                                        
                                                        	array of red stats
                                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                            self.yang_name = "class-stats"
                                                            self.yang_parent_name = "statistics"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                            self._leafs = OrderedDict([
                                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                            ])
                                                            self.counter_validity_bitmask = None
                                                            self.class_name = None
                                                            self.shared_queue_id = None
                                                            self.queue_descr = None
                                                            self.cac_state = None

                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"

                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                                            self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                            self.child_policy.parent = self
                                                            self._children_name_map["child_policy"] = "child-policy"

                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"

                                                            self.queue_stats_array = YList(self)
                                                            self.police_stats_array = YList(self)
                                                            self.wred_stats_array = YList(self)
                                                            self._segment_path = lambda: "class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                        class GeneralStats(Entity):
                                                            """
                                                            general stats
                                                            
                                                            .. attribute:: transmit_packets
                                                            
                                                            	Transmitted packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: transmit_bytes
                                                            
                                                            	Transmitted bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_packets
                                                            
                                                            	Dropped packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_bytes
                                                            
                                                            	Dropped bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_rate
                                                            
                                                            	Total drop rate (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: match_data_rate
                                                            
                                                            	Incoming matched data rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: total_transmit_rate
                                                            
                                                            	Total transmit rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: pre_policy_matched_packets
                                                            
                                                            	Matched pkts before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: pre_policy_matched_bytes
                                                            
                                                            	Matched bytes before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                                self.yang_name = "general-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                ])
                                                                self.transmit_packets = None
                                                                self.transmit_bytes = None
                                                                self.total_drop_packets = None
                                                                self.total_drop_bytes = None
                                                                self.total_drop_rate = None
                                                                self.match_data_rate = None
                                                                self.total_transmit_rate = None
                                                                self.pre_policy_matched_packets = None
                                                                self.pre_policy_matched_bytes = None
                                                                self._segment_path = lambda: "general-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                        class IphcStats(Entity):
                                                            """
                                                            IPHC stats
                                                            
                                                            .. attribute:: non_tcp_total_out_packets
                                                            
                                                            	TotalNum of Non tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_total_out_bytes
                                                            
                                                            	TotalNum of Non Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_bytes_saved
                                                            
                                                            	Non Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_compressed_packets_out
                                                            
                                                            	Num of non tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                            
                                                            	Compressed Non Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_full_header_packets_out
                                                            
                                                            	Num of non tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_packets
                                                            
                                                            	Total Num of tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_bytes
                                                            
                                                            	TotalNum of Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_bytes_saved
                                                            
                                                            	Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_compressed_packets_out
                                                            
                                                            	Num of tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_bytes_sent_rate
                                                            
                                                            	Compressed Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_full_header_packets_out
                                                            
                                                            	Num of tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                                self.yang_name = "iphc-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                ])
                                                                self.non_tcp_total_out_packets = None
                                                                self.non_tcp_total_out_bytes = None
                                                                self.non_tcp_bytes_saved = None
                                                                self.non_tcp_compressed_packets_out = None
                                                                self.non_tcp_bytes_sent_rate = None
                                                                self.non_tcp_full_header_packets_out = None
                                                                self.tcp_total_out_packets = None
                                                                self.tcp_total_out_bytes = None
                                                                self.tcp_bytes_saved = None
                                                                self.tcp_compressed_packets_out = None
                                                                self.tcp_bytes_sent_rate = None
                                                                self.tcp_full_header_packets_out = None
                                                                self._segment_path = lambda: "iphc-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                        class ChildPolicy(Entity):
                                                            """
                                                            child policy
                                                            
                                                            .. attribute:: policy_name
                                                            
                                                            	PolicyName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: state
                                                            
                                                            	State
                                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                            
                                                            .. attribute:: state_description
                                                            
                                                            	StateDescription
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..128
                                                            
                                                            .. attribute:: satid
                                                            
                                                            	to maintain satellite id
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: class_stats
                                                            
                                                            	array of classes contained in policy
                                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                                self.yang_name = "child-policy"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                                self._leafs = OrderedDict([
                                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                                ])
                                                                self.policy_name = None
                                                                self.state = None
                                                                self.state_description = None
                                                                self.satid = None

                                                                self.class_stats = YList(self)
                                                                self._segment_path = lambda: "child-policy"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                            class ClassStats_(Entity):
                                                                """
                                                                array of classes contained in policy
                                                                
                                                                .. attribute:: general_stats
                                                                
                                                                	general stats
                                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                                
                                                                .. attribute:: iphc_stats
                                                                
                                                                	IPHC stats
                                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                                
                                                                .. attribute:: cac_stats
                                                                
                                                                	bag for cac stats
                                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                                
                                                                .. attribute:: counter_validity_bitmask
                                                                
                                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: megabyte
                                                                
                                                                .. attribute:: class_name
                                                                
                                                                	ClassName
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: shared_queue_id
                                                                
                                                                	q\-id of the  shared queue for this class
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_descr
                                                                
                                                                	Description of queue for the class
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..256
                                                                
                                                                .. attribute:: cac_state
                                                                
                                                                	CACState
                                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                                
                                                                .. attribute:: queue_stats_array
                                                                
                                                                	array of queue stats
                                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                                
                                                                .. attribute:: police_stats_array
                                                                
                                                                	array of police stats
                                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                                
                                                                .. attribute:: wred_stats_array
                                                                
                                                                	array of red stats
                                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                    self.yang_name = "class-stats"
                                                                    self.yang_parent_name = "child-policy"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                    self._leafs = OrderedDict([
                                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                    ])
                                                                    self.counter_validity_bitmask = None
                                                                    self.class_name = None
                                                                    self.shared_queue_id = None
                                                                    self.queue_descr = None
                                                                    self.cac_state = None

                                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                    self.general_stats.parent = self
                                                                    self._children_name_map["general_stats"] = "general-stats"

                                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                    self.iphc_stats.parent = self
                                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                    self.cac_stats.parent = self
                                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                                    self.queue_stats_array = YList(self)
                                                                    self.police_stats_array = YList(self)
                                                                    self.wred_stats_array = YList(self)
                                                                    self._segment_path = lambda: "class-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                                class GeneralStats(Entity):
                                                                    """
                                                                    general stats
                                                                    
                                                                    .. attribute:: transmit_packets
                                                                    
                                                                    	Transmitted packets (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: transmit_bytes
                                                                    
                                                                    	Transmitted bytes (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_packets
                                                                    
                                                                    	Dropped packets (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_bytes
                                                                    
                                                                    	Dropped bytes (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_rate
                                                                    
                                                                    	Total drop rate (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: match_data_rate
                                                                    
                                                                    	Incoming matched data rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: total_transmit_rate
                                                                    
                                                                    	Total transmit rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: pre_policy_matched_packets
                                                                    
                                                                    	Matched pkts before applying policy
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: pre_policy_matched_bytes
                                                                    
                                                                    	Matched bytes before applying policy
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                        self.yang_name = "general-stats"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                        ])
                                                                        self.transmit_packets = None
                                                                        self.transmit_bytes = None
                                                                        self.total_drop_packets = None
                                                                        self.total_drop_bytes = None
                                                                        self.total_drop_rate = None
                                                                        self.match_data_rate = None
                                                                        self.total_transmit_rate = None
                                                                        self.pre_policy_matched_packets = None
                                                                        self.pre_policy_matched_bytes = None
                                                                        self._segment_path = lambda: "general-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                                class IphcStats(Entity):
                                                                    """
                                                                    IPHC stats
                                                                    
                                                                    .. attribute:: non_tcp_total_out_packets
                                                                    
                                                                    	TotalNum of Non tcp pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: non_tcp_total_out_bytes
                                                                    
                                                                    	TotalNum of Non Tcp Bytes sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_bytes_saved
                                                                    
                                                                    	Non Tcp Bytes saved due to compression
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_compressed_packets_out
                                                                    
                                                                    	Num of non tcp compressed pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                                    
                                                                    	Compressed Non Tcp Bytes sent rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_full_header_packets_out
                                                                    
                                                                    	Num of non tcp fullheader pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_total_out_packets
                                                                    
                                                                    	Total Num of tcp pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_total_out_bytes
                                                                    
                                                                    	TotalNum of Tcp Bytes sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_bytes_saved
                                                                    
                                                                    	Tcp Bytes saved due to compression
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_compressed_packets_out
                                                                    
                                                                    	Num of tcp compressed pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_bytes_sent_rate
                                                                    
                                                                    	Compressed Tcp Bytes sent rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_full_header_packets_out
                                                                    
                                                                    	Num of tcp fullheader pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                        self.yang_name = "iphc-stats"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                        ])
                                                                        self.non_tcp_total_out_packets = None
                                                                        self.non_tcp_total_out_bytes = None
                                                                        self.non_tcp_bytes_saved = None
                                                                        self.non_tcp_compressed_packets_out = None
                                                                        self.non_tcp_bytes_sent_rate = None
                                                                        self.non_tcp_full_header_packets_out = None
                                                                        self.tcp_total_out_packets = None
                                                                        self.tcp_total_out_bytes = None
                                                                        self.tcp_bytes_saved = None
                                                                        self.tcp_compressed_packets_out = None
                                                                        self.tcp_bytes_sent_rate = None
                                                                        self.tcp_full_header_packets_out = None
                                                                        self._segment_path = lambda: "iphc-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                                class CacStats(Entity):
                                                                    """
                                                                    bag for cac stats
                                                                    
                                                                    .. attribute:: drop_packets
                                                                    
                                                                    	CAC dropped packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: drop_bytes
                                                                    
                                                                    	CAC dropped bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: drop_rates
                                                                    
                                                                    	CAC dropped rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: admitpackets
                                                                    
                                                                    	Admitted packets (pkts/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: admit_bytes
                                                                    
                                                                    	Admitted bytes (pkts/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: admit_rates
                                                                    
                                                                    	CAC admit rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                        self.yang_name = "cac-stats"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                        ])
                                                                        self.drop_packets = None
                                                                        self.drop_bytes = None
                                                                        self.drop_rates = None
                                                                        self.admitpackets = None
                                                                        self.admit_bytes = None
                                                                        self.admit_rates = None
                                                                        self._segment_path = lambda: "cac-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                                class QueueStatsArray(Entity):
                                                                    """
                                                                    array of queue stats
                                                                    
                                                                    .. attribute:: queue_id
                                                                    
                                                                    	Queue Id used for Fabric Stats
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: tail_drop_packets
                                                                    
                                                                    	Packets tail dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tail_drop_bytes
                                                                    
                                                                    	Bytes tail dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: atm_clp0_drop_packets
                                                                    
                                                                    	ATP CLP 0 matched packets dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: atm_clp0_drop_bytes
                                                                    
                                                                    	ATP CLP 0 matched bytes dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: atm_clp1_drop_packets
                                                                    
                                                                    	ATP CLP 0 matched packets dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: atm_clp1_drop_bytes
                                                                    
                                                                    	ATP CLP 0 matched bytes dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: queue_drop_threshold
                                                                    
                                                                    	tail drop threshold of the queue in bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: forced_wred_stats_display
                                                                    
                                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                    	**type**\: bool
                                                                    
                                                                    .. attribute:: random_drop_packets
                                                                    
                                                                    	Packets probabilistically dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: random_drop_bytes
                                                                    
                                                                    	Bytes probabilistically dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: max_threshold_packets
                                                                    
                                                                    	Dropped packets with the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: max_threshold_bytes
                                                                    
                                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_packets
                                                                    
                                                                    	Packets that conform  to the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_bytes
                                                                    
                                                                    	Bytes that conform to the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_packets
                                                                    
                                                                    	Packets that exceed the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_bytes
                                                                    
                                                                    	Bytes that exceed  the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_rate
                                                                    
                                                                    	Conform rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: exceed_rate
                                                                    
                                                                    	Exceed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: queue_instance_length
                                                                    
                                                                    	Queue instance length
                                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                    
                                                                    .. attribute:: queue_average_length
                                                                    
                                                                    	Queue average length
                                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                    
                                                                    .. attribute:: queue_max_length
                                                                    
                                                                    	Queue maximum length
                                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                        self.yang_name = "queue-stats-array"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                        self._leafs = OrderedDict([
                                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ])
                                                                        self.queue_id = None
                                                                        self.tail_drop_packets = None
                                                                        self.tail_drop_bytes = None
                                                                        self.atm_clp0_drop_packets = None
                                                                        self.atm_clp0_drop_bytes = None
                                                                        self.atm_clp1_drop_packets = None
                                                                        self.atm_clp1_drop_bytes = None
                                                                        self.queue_drop_threshold = None
                                                                        self.forced_wred_stats_display = None
                                                                        self.random_drop_packets = None
                                                                        self.random_drop_bytes = None
                                                                        self.max_threshold_packets = None
                                                                        self.max_threshold_bytes = None
                                                                        self.conform_packets = None
                                                                        self.conform_bytes = None
                                                                        self.exceed_packets = None
                                                                        self.exceed_bytes = None
                                                                        self.conform_rate = None
                                                                        self.exceed_rate = None

                                                                        self.queue_instance_length = YList(self)
                                                                        self.queue_average_length = YList(self)
                                                                        self.queue_max_length = YList(self)
                                                                        self._segment_path = lambda: "queue-stats-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                    class QueueInstanceLength(Entity):
                                                                        """
                                                                        Queue instance length
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                            self.yang_name = "queue-instance-length"
                                                                            self.yang_parent_name = "queue-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "queue-instance-length"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                    class QueueAverageLength(Entity):
                                                                        """
                                                                        Queue average length
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                            self.yang_name = "queue-average-length"
                                                                            self.yang_parent_name = "queue-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "queue-average-length"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                    class QueueMaxLength(Entity):
                                                                        """
                                                                        Queue maximum length
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                            self.yang_name = "queue-max-length"
                                                                            self.yang_parent_name = "queue-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "queue-max-length"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                                class PoliceStatsArray(Entity):
                                                                    """
                                                                    array of police stats
                                                                    
                                                                    .. attribute:: color_class_stats
                                                                    
                                                                    	color class stats
                                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                    
                                                                    .. attribute:: drop_packets
                                                                    
                                                                    	Police dropped packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: drop_bytes
                                                                    
                                                                    	Police dropped bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_packets
                                                                    
                                                                    	Packets that conform  to the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_bytes
                                                                    
                                                                    	Bytes that conform to the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_packets
                                                                    
                                                                    	Packets that exceed the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_bytes
                                                                    
                                                                    	Bytes that exceed  the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_packets
                                                                    
                                                                    	Packets violating the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_bytes
                                                                    
                                                                    	Bytes that violate the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: parent_drop_packets
                                                                    
                                                                    	Dropped pkts by the parent policer
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: parent_drop_bytes
                                                                    
                                                                    	Dropped bytes by the parent policer
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_rate
                                                                    
                                                                    	Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_rate
                                                                    
                                                                    	Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_rate
                                                                    
                                                                    	Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                        self.yang_name = "police-stats-array"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                        self._leafs = OrderedDict([
                                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                        ])
                                                                        self.drop_packets = None
                                                                        self.drop_bytes = None
                                                                        self.conform_packets = None
                                                                        self.conform_bytes = None
                                                                        self.exceed_packets = None
                                                                        self.exceed_bytes = None
                                                                        self.violate_packets = None
                                                                        self.violate_bytes = None
                                                                        self.parent_drop_packets = None
                                                                        self.parent_drop_bytes = None
                                                                        self.conform_rate = None
                                                                        self.exceed_rate = None
                                                                        self.violate_rate = None

                                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                        self.color_class_stats.parent = self
                                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                        self._segment_path = lambda: "police-stats-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                    class ColorClassStats(Entity):
                                                                        """
                                                                        color class stats
                                                                        
                                                                        .. attribute:: conform_class_conform_packets
                                                                        
                                                                        	Packets with classification result conform and policer result conform
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_conform_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result conform
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_conform_rate
                                                                        
                                                                        	Conform Class Conform rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: conform_class_exceed_packets
                                                                        
                                                                        	Packets with classification result conform and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_exceed_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_exceed_rate
                                                                        
                                                                        	Conform Class Exceed rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: conform_class_violate_packets
                                                                        
                                                                        	Packets with classification result conform and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_violate_rate
                                                                        
                                                                        	Conform Class Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_class_exceed_packets
                                                                        
                                                                        	Packets with classification result exceed and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_class_exceed_bytes
                                                                        
                                                                        	Bytes with classification result exceed and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_class_exceed_rate
                                                                        
                                                                        	Exceed Class Exceed rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_class_violate_packets
                                                                        
                                                                        	Packets with classification result exceed and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result exceed and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_class_violate_rate
                                                                        
                                                                        	Exceed Class Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: violate_class_violate_packets
                                                                        
                                                                        	Packets with classification result violate and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: violate_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result violate and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: violate_class_violate_rate
                                                                        
                                                                        	Violate Class Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                            self.yang_name = "color-class-stats"
                                                                            self.yang_parent_name = "police-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                            ])
                                                                            self.conform_class_conform_packets = None
                                                                            self.conform_class_conform_bytes = None
                                                                            self.conform_class_conform_rate = None
                                                                            self.conform_class_exceed_packets = None
                                                                            self.conform_class_exceed_bytes = None
                                                                            self.conform_class_exceed_rate = None
                                                                            self.conform_class_violate_packets = None
                                                                            self.conform_class_violate_bytes = None
                                                                            self.conform_class_violate_rate = None
                                                                            self.exceed_class_exceed_packets = None
                                                                            self.exceed_class_exceed_bytes = None
                                                                            self.exceed_class_exceed_rate = None
                                                                            self.exceed_class_violate_packets = None
                                                                            self.exceed_class_violate_bytes = None
                                                                            self.exceed_class_violate_rate = None
                                                                            self.violate_class_violate_packets = None
                                                                            self.violate_class_violate_bytes = None
                                                                            self.violate_class_violate_rate = None
                                                                            self._segment_path = lambda: "color-class-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                                class WredStatsArray(Entity):
                                                                    """
                                                                    array of red stats
                                                                    
                                                                    .. attribute:: profile_title
                                                                    
                                                                    	ProfileTitle
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..300
                                                                    
                                                                    .. attribute:: red_transmit_packets
                                                                    
                                                                    	Transmitted packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: red_transmit_bytes
                                                                    
                                                                    	Transmitted bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: random_drop_packets
                                                                    
                                                                    	Probabilistically dropped  packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: random_drop_bytes
                                                                    
                                                                    	Probabilisticallydropped bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: max_threshold_packets
                                                                    
                                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: max_threshold_bytes
                                                                    
                                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: red_ecn_marked_packets
                                                                    
                                                                    	ECN marked packets 
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: red_ecn_marked_bytes
                                                                    
                                                                    	ECN marked bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: red_label
                                                                    
                                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                        self.yang_name = "wred-stats-array"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                        self._leafs = OrderedDict([
                                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                        ])
                                                                        self.profile_title = None
                                                                        self.red_transmit_packets = None
                                                                        self.red_transmit_bytes = None
                                                                        self.random_drop_packets = None
                                                                        self.random_drop_bytes = None
                                                                        self.max_threshold_packets = None
                                                                        self.max_threshold_bytes = None
                                                                        self.red_ecn_marked_packets = None
                                                                        self.red_ecn_marked_bytes = None

                                                                        self.red_label = YList(self)
                                                                        self._segment_path = lambda: "wred-stats-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                    class RedLabel(Entity):
                                                                        """
                                                                        Array of WRED Typevalues as in PRP stats is
                                                                        available per threshold   
                                                                        
                                                                        .. attribute:: wred_type
                                                                        
                                                                        	WRED type DSCP, EXP, PREC etc
                                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	WRED value for this type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                            self.yang_name = "red-label"
                                                                            self.yang_parent_name = "wred-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                            ])
                                                                            self.wred_type = None
                                                                            self.value = None
                                                                            self._segment_path = lambda: "red-label"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                        class CacStats(Entity):
                                                            """
                                                            bag for cac stats
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	CAC dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	CAC dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_rates
                                                            
                                                            	CAC dropped rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: admitpackets
                                                            
                                                            	Admitted packets (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_bytes
                                                            
                                                            	Admitted bytes (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_rates
                                                            
                                                            	CAC admit rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                                self.yang_name = "cac-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.drop_rates = None
                                                                self.admitpackets = None
                                                                self.admit_bytes = None
                                                                self.admit_rates = None
                                                                self._segment_path = lambda: "cac-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                        class QueueStatsArray(Entity):
                                                            """
                                                            array of queue stats
                                                            
                                                            .. attribute:: queue_id
                                                            
                                                            	Queue Id used for Fabric Stats
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: tail_drop_packets
                                                            
                                                            	Packets tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tail_drop_bytes
                                                            
                                                            	Bytes tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp0_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp0_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp1_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp1_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: queue_drop_threshold
                                                            
                                                            	tail drop threshold of the queue in bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: forced_wred_stats_display
                                                            
                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                            	**type**\: bool
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Packets probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Bytes probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_instance_length
                                                            
                                                            	Queue instance length
                                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                            
                                                            .. attribute:: queue_average_length
                                                            
                                                            	Queue average length
                                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                            
                                                            .. attribute:: queue_max_length
                                                            
                                                            	Queue maximum length
                                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                                self.yang_name = "queue-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                                self._leafs = OrderedDict([
                                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ])
                                                                self.queue_id = None
                                                                self.tail_drop_packets = None
                                                                self.tail_drop_bytes = None
                                                                self.atm_clp0_drop_packets = None
                                                                self.atm_clp0_drop_bytes = None
                                                                self.atm_clp1_drop_packets = None
                                                                self.atm_clp1_drop_bytes = None
                                                                self.queue_drop_threshold = None
                                                                self.forced_wred_stats_display = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None

                                                                self.queue_instance_length = YList(self)
                                                                self.queue_average_length = YList(self)
                                                                self.queue_max_length = YList(self)
                                                                self._segment_path = lambda: "queue-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                            class QueueInstanceLength(Entity):
                                                                """
                                                                Queue instance length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                    self.yang_name = "queue-instance-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-instance-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                            class QueueAverageLength(Entity):
                                                                """
                                                                Queue average length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                    self.yang_name = "queue-average-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-average-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                            class QueueMaxLength(Entity):
                                                                """
                                                                Queue maximum length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                    self.yang_name = "queue-max-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-max-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                        class PoliceStatsArray(Entity):
                                                            """
                                                            array of police stats
                                                            
                                                            .. attribute:: color_class_stats
                                                            
                                                            	color class stats
                                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	Police dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	Police dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_packets
                                                            
                                                            	Packets violating the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_bytes
                                                            
                                                            	Bytes that violate the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: parent_drop_packets
                                                            
                                                            	Dropped pkts by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: parent_drop_bytes
                                                            
                                                            	Dropped bytes by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_rate
                                                            
                                                            	Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                                self.yang_name = "police-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.violate_packets = None
                                                                self.violate_bytes = None
                                                                self.parent_drop_packets = None
                                                                self.parent_drop_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None
                                                                self.violate_rate = None

                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                self._segment_path = lambda: "police-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                            class ColorClassStats(Entity):
                                                                """
                                                                color class stats
                                                                
                                                                .. attribute:: conform_class_conform_packets
                                                                
                                                                	Packets with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_conform_bytes
                                                                
                                                                	Bytes with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_conform_rate
                                                                
                                                                	Conform Class Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_exceed_packets
                                                                
                                                                	Packets with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_exceed_bytes
                                                                
                                                                	Bytes with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_exceed_rate
                                                                
                                                                	Conform Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_violate_packets
                                                                
                                                                	Packets with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_violate_bytes
                                                                
                                                                	Bytes with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_violate_rate
                                                                
                                                                	Conform Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_exceed_packets
                                                                
                                                                	Packets with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_exceed_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_exceed_rate
                                                                
                                                                	Exceed Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_violate_packets
                                                                
                                                                	Packets with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_violate_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_violate_rate
                                                                
                                                                	Exceed Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_class_violate_packets
                                                                
                                                                	Packets with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_class_violate_bytes
                                                                
                                                                	Bytes with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_class_violate_rate
                                                                
                                                                	Violate Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                    self.yang_name = "color-class-stats"
                                                                    self.yang_parent_name = "police-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                    ])
                                                                    self.conform_class_conform_packets = None
                                                                    self.conform_class_conform_bytes = None
                                                                    self.conform_class_conform_rate = None
                                                                    self.conform_class_exceed_packets = None
                                                                    self.conform_class_exceed_bytes = None
                                                                    self.conform_class_exceed_rate = None
                                                                    self.conform_class_violate_packets = None
                                                                    self.conform_class_violate_bytes = None
                                                                    self.conform_class_violate_rate = None
                                                                    self.exceed_class_exceed_packets = None
                                                                    self.exceed_class_exceed_bytes = None
                                                                    self.exceed_class_exceed_rate = None
                                                                    self.exceed_class_violate_packets = None
                                                                    self.exceed_class_violate_bytes = None
                                                                    self.exceed_class_violate_rate = None
                                                                    self.violate_class_violate_packets = None
                                                                    self.violate_class_violate_bytes = None
                                                                    self.violate_class_violate_rate = None
                                                                    self._segment_path = lambda: "color-class-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                        class WredStatsArray(Entity):
                                                            """
                                                            array of red stats
                                                            
                                                            .. attribute:: profile_title
                                                            
                                                            	ProfileTitle
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..300
                                                            
                                                            .. attribute:: red_transmit_packets
                                                            
                                                            	Transmitted packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_transmit_bytes
                                                            
                                                            	Transmitted bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Probabilistically dropped  packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Probabilisticallydropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_ecn_marked_packets
                                                            
                                                            	ECN marked packets 
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_ecn_marked_bytes
                                                            
                                                            	ECN marked bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_label
                                                            
                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                                self.yang_name = "wred-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                                self._leafs = OrderedDict([
                                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                ])
                                                                self.profile_title = None
                                                                self.red_transmit_packets = None
                                                                self.red_transmit_bytes = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.red_ecn_marked_packets = None
                                                                self.red_ecn_marked_bytes = None

                                                                self.red_label = YList(self)
                                                                self._segment_path = lambda: "wred-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                            class RedLabel(Entity):
                                                                """
                                                                Array of WRED Typevalues as in PRP stats is
                                                                available per threshold   
                                                                
                                                                .. attribute:: wred_type
                                                                
                                                                	WRED type DSCP, EXP, PREC etc
                                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	WRED value for this type
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                    self.yang_name = "red-label"
                                                                    self.yang_parent_name = "wred-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                    ])
                                                                    self.wred_type = None
                                                                    self.value = None
                                                                    self._segment_path = lambda: "red-label"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                    class Output(Entity):
                                        """
                                        A piece of QoS policy\-map operational data for
                                        an interface
                                        
                                        .. attribute:: service_policy_names
                                        
                                        	Operational data for all Policy instance
                                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output, self).__init__()

                                            self.yang_name = "output"
                                            self.yang_parent_name = "member-interface"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames))])
                                            self._leafs = OrderedDict()

                                            self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                                            self.service_policy_names.parent = self
                                            self._children_name_map["service_policy_names"] = "service-policy-names"
                                            self._segment_path = lambda: "output"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output, [], name, value)


                                        class ServicePolicyNames(Entity):
                                            """
                                            Operational data for all Policy instance
                                            
                                            .. attribute:: service_policy_instance
                                            
                                            	QoS policy\-map operational data for a particular Policy 
                                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__init__()

                                                self.yang_name = "service-policy-names"
                                                self.yang_parent_name = "output"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance))])
                                                self._leafs = OrderedDict()

                                                self.service_policy_instance = YList(self)
                                                self._segment_path = lambda: "service-policy-names"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, [], name, value)


                                            class ServicePolicyInstance(Entity):
                                                """
                                                QoS policy\-map operational data for a
                                                particular Policy 
                                                
                                                .. attribute:: service_policy_name  (key)
                                                
                                                	Name of the policy instance
                                                	**type**\: str
                                                
                                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                
                                                .. attribute:: statistics
                                                
                                                	Policy\-map statistics operational data for an interface
                                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                    self.yang_name = "service-policy-instance"
                                                    self.yang_parent_name = "service-policy-names"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = ['service_policy_name']
                                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                    self._leafs = OrderedDict([
                                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                    ])
                                                    self.service_policy_name = None

                                                    self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                    self.statistics.parent = self
                                                    self._children_name_map["statistics"] = "statistics"
                                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                                class Statistics(Entity):
                                                    """
                                                    Policy\-map statistics operational data for an
                                                    interface
                                                    
                                                    .. attribute:: policy_name
                                                    
                                                    	PolicyName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: state
                                                    
                                                    	State
                                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                    
                                                    .. attribute:: state_description
                                                    
                                                    	StateDescription
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..128
                                                    
                                                    .. attribute:: satid
                                                    
                                                    	to maintain satellite id
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: class_stats
                                                    
                                                    	array of classes contained in policy
                                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                        self.yang_name = "statistics"
                                                        self.yang_parent_name = "service-policy-instance"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                        ])
                                                        self.policy_name = None
                                                        self.state = None
                                                        self.state_description = None
                                                        self.satid = None

                                                        self.class_stats = YList(self)
                                                        self._segment_path = lambda: "statistics"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                    class ClassStats(Entity):
                                                        """
                                                        array of classes contained in policy
                                                        
                                                        .. attribute:: general_stats
                                                        
                                                        	general stats
                                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                        
                                                        .. attribute:: iphc_stats
                                                        
                                                        	IPHC stats
                                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                        
                                                        .. attribute:: child_policy
                                                        
                                                        	child policy
                                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                        
                                                        .. attribute:: cac_stats
                                                        
                                                        	bag for cac stats
                                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                        
                                                        .. attribute:: counter_validity_bitmask
                                                        
                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: megabyte
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	ClassName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: shared_queue_id
                                                        
                                                        	q\-id of the  shared queue for this class
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_descr
                                                        
                                                        	Description of queue for the class
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..256
                                                        
                                                        .. attribute:: cac_state
                                                        
                                                        	CACState
                                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                        
                                                        .. attribute:: queue_stats_array
                                                        
                                                        	array of queue stats
                                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                        
                                                        .. attribute:: police_stats_array
                                                        
                                                        	array of police stats
                                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                        
                                                        .. attribute:: wred_stats_array
                                                        
                                                        	array of red stats
                                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                            self.yang_name = "class-stats"
                                                            self.yang_parent_name = "statistics"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                            self._leafs = OrderedDict([
                                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                            ])
                                                            self.counter_validity_bitmask = None
                                                            self.class_name = None
                                                            self.shared_queue_id = None
                                                            self.queue_descr = None
                                                            self.cac_state = None

                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"

                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                                            self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                            self.child_policy.parent = self
                                                            self._children_name_map["child_policy"] = "child-policy"

                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"

                                                            self.queue_stats_array = YList(self)
                                                            self.police_stats_array = YList(self)
                                                            self.wred_stats_array = YList(self)
                                                            self._segment_path = lambda: "class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                        class GeneralStats(Entity):
                                                            """
                                                            general stats
                                                            
                                                            .. attribute:: transmit_packets
                                                            
                                                            	Transmitted packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: transmit_bytes
                                                            
                                                            	Transmitted bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_packets
                                                            
                                                            	Dropped packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_bytes
                                                            
                                                            	Dropped bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_rate
                                                            
                                                            	Total drop rate (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: match_data_rate
                                                            
                                                            	Incoming matched data rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: total_transmit_rate
                                                            
                                                            	Total transmit rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: pre_policy_matched_packets
                                                            
                                                            	Matched pkts before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: pre_policy_matched_bytes
                                                            
                                                            	Matched bytes before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                                self.yang_name = "general-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                ])
                                                                self.transmit_packets = None
                                                                self.transmit_bytes = None
                                                                self.total_drop_packets = None
                                                                self.total_drop_bytes = None
                                                                self.total_drop_rate = None
                                                                self.match_data_rate = None
                                                                self.total_transmit_rate = None
                                                                self.pre_policy_matched_packets = None
                                                                self.pre_policy_matched_bytes = None
                                                                self._segment_path = lambda: "general-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                        class IphcStats(Entity):
                                                            """
                                                            IPHC stats
                                                            
                                                            .. attribute:: non_tcp_total_out_packets
                                                            
                                                            	TotalNum of Non tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_total_out_bytes
                                                            
                                                            	TotalNum of Non Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_bytes_saved
                                                            
                                                            	Non Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_compressed_packets_out
                                                            
                                                            	Num of non tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                            
                                                            	Compressed Non Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_full_header_packets_out
                                                            
                                                            	Num of non tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_packets
                                                            
                                                            	Total Num of tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_bytes
                                                            
                                                            	TotalNum of Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_bytes_saved
                                                            
                                                            	Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_compressed_packets_out
                                                            
                                                            	Num of tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_bytes_sent_rate
                                                            
                                                            	Compressed Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_full_header_packets_out
                                                            
                                                            	Num of tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                                self.yang_name = "iphc-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                ])
                                                                self.non_tcp_total_out_packets = None
                                                                self.non_tcp_total_out_bytes = None
                                                                self.non_tcp_bytes_saved = None
                                                                self.non_tcp_compressed_packets_out = None
                                                                self.non_tcp_bytes_sent_rate = None
                                                                self.non_tcp_full_header_packets_out = None
                                                                self.tcp_total_out_packets = None
                                                                self.tcp_total_out_bytes = None
                                                                self.tcp_bytes_saved = None
                                                                self.tcp_compressed_packets_out = None
                                                                self.tcp_bytes_sent_rate = None
                                                                self.tcp_full_header_packets_out = None
                                                                self._segment_path = lambda: "iphc-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                        class ChildPolicy(Entity):
                                                            """
                                                            child policy
                                                            
                                                            .. attribute:: policy_name
                                                            
                                                            	PolicyName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: state
                                                            
                                                            	State
                                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                            
                                                            .. attribute:: state_description
                                                            
                                                            	StateDescription
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..128
                                                            
                                                            .. attribute:: satid
                                                            
                                                            	to maintain satellite id
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: class_stats
                                                            
                                                            	array of classes contained in policy
                                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                                self.yang_name = "child-policy"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                                self._leafs = OrderedDict([
                                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                                ])
                                                                self.policy_name = None
                                                                self.state = None
                                                                self.state_description = None
                                                                self.satid = None

                                                                self.class_stats = YList(self)
                                                                self._segment_path = lambda: "child-policy"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                            class ClassStats_(Entity):
                                                                """
                                                                array of classes contained in policy
                                                                
                                                                .. attribute:: general_stats
                                                                
                                                                	general stats
                                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                                
                                                                .. attribute:: iphc_stats
                                                                
                                                                	IPHC stats
                                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                                
                                                                .. attribute:: cac_stats
                                                                
                                                                	bag for cac stats
                                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                                
                                                                .. attribute:: counter_validity_bitmask
                                                                
                                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: megabyte
                                                                
                                                                .. attribute:: class_name
                                                                
                                                                	ClassName
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: shared_queue_id
                                                                
                                                                	q\-id of the  shared queue for this class
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_descr
                                                                
                                                                	Description of queue for the class
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..256
                                                                
                                                                .. attribute:: cac_state
                                                                
                                                                	CACState
                                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                                
                                                                .. attribute:: queue_stats_array
                                                                
                                                                	array of queue stats
                                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                                
                                                                .. attribute:: police_stats_array
                                                                
                                                                	array of police stats
                                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                                
                                                                .. attribute:: wred_stats_array
                                                                
                                                                	array of red stats
                                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                    self.yang_name = "class-stats"
                                                                    self.yang_parent_name = "child-policy"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                    self._leafs = OrderedDict([
                                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                    ])
                                                                    self.counter_validity_bitmask = None
                                                                    self.class_name = None
                                                                    self.shared_queue_id = None
                                                                    self.queue_descr = None
                                                                    self.cac_state = None

                                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                    self.general_stats.parent = self
                                                                    self._children_name_map["general_stats"] = "general-stats"

                                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                    self.iphc_stats.parent = self
                                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                    self.cac_stats.parent = self
                                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                                    self.queue_stats_array = YList(self)
                                                                    self.police_stats_array = YList(self)
                                                                    self.wred_stats_array = YList(self)
                                                                    self._segment_path = lambda: "class-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                                class GeneralStats(Entity):
                                                                    """
                                                                    general stats
                                                                    
                                                                    .. attribute:: transmit_packets
                                                                    
                                                                    	Transmitted packets (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: transmit_bytes
                                                                    
                                                                    	Transmitted bytes (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_packets
                                                                    
                                                                    	Dropped packets (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_bytes
                                                                    
                                                                    	Dropped bytes (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_rate
                                                                    
                                                                    	Total drop rate (packets/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: match_data_rate
                                                                    
                                                                    	Incoming matched data rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: total_transmit_rate
                                                                    
                                                                    	Total transmit rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: pre_policy_matched_packets
                                                                    
                                                                    	Matched pkts before applying policy
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: pre_policy_matched_bytes
                                                                    
                                                                    	Matched bytes before applying policy
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                        self.yang_name = "general-stats"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                        ])
                                                                        self.transmit_packets = None
                                                                        self.transmit_bytes = None
                                                                        self.total_drop_packets = None
                                                                        self.total_drop_bytes = None
                                                                        self.total_drop_rate = None
                                                                        self.match_data_rate = None
                                                                        self.total_transmit_rate = None
                                                                        self.pre_policy_matched_packets = None
                                                                        self.pre_policy_matched_bytes = None
                                                                        self._segment_path = lambda: "general-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                                class IphcStats(Entity):
                                                                    """
                                                                    IPHC stats
                                                                    
                                                                    .. attribute:: non_tcp_total_out_packets
                                                                    
                                                                    	TotalNum of Non tcp pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: non_tcp_total_out_bytes
                                                                    
                                                                    	TotalNum of Non Tcp Bytes sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_bytes_saved
                                                                    
                                                                    	Non Tcp Bytes saved due to compression
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_compressed_packets_out
                                                                    
                                                                    	Num of non tcp compressed pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                                    
                                                                    	Compressed Non Tcp Bytes sent rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_full_header_packets_out
                                                                    
                                                                    	Num of non tcp fullheader pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_total_out_packets
                                                                    
                                                                    	Total Num of tcp pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_total_out_bytes
                                                                    
                                                                    	TotalNum of Tcp Bytes sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_bytes_saved
                                                                    
                                                                    	Tcp Bytes saved due to compression
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_compressed_packets_out
                                                                    
                                                                    	Num of tcp compressed pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_bytes_sent_rate
                                                                    
                                                                    	Compressed Tcp Bytes sent rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_full_header_packets_out
                                                                    
                                                                    	Num of tcp fullheader pkts sent
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                        self.yang_name = "iphc-stats"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                        ])
                                                                        self.non_tcp_total_out_packets = None
                                                                        self.non_tcp_total_out_bytes = None
                                                                        self.non_tcp_bytes_saved = None
                                                                        self.non_tcp_compressed_packets_out = None
                                                                        self.non_tcp_bytes_sent_rate = None
                                                                        self.non_tcp_full_header_packets_out = None
                                                                        self.tcp_total_out_packets = None
                                                                        self.tcp_total_out_bytes = None
                                                                        self.tcp_bytes_saved = None
                                                                        self.tcp_compressed_packets_out = None
                                                                        self.tcp_bytes_sent_rate = None
                                                                        self.tcp_full_header_packets_out = None
                                                                        self._segment_path = lambda: "iphc-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                                class CacStats(Entity):
                                                                    """
                                                                    bag for cac stats
                                                                    
                                                                    .. attribute:: drop_packets
                                                                    
                                                                    	CAC dropped packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: drop_bytes
                                                                    
                                                                    	CAC dropped bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: drop_rates
                                                                    
                                                                    	CAC dropped rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: admitpackets
                                                                    
                                                                    	Admitted packets (pkts/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: admit_bytes
                                                                    
                                                                    	Admitted bytes (pkts/bytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: admit_rates
                                                                    
                                                                    	CAC admit rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                        self.yang_name = "cac-stats"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                        ])
                                                                        self.drop_packets = None
                                                                        self.drop_bytes = None
                                                                        self.drop_rates = None
                                                                        self.admitpackets = None
                                                                        self.admit_bytes = None
                                                                        self.admit_rates = None
                                                                        self._segment_path = lambda: "cac-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                                class QueueStatsArray(Entity):
                                                                    """
                                                                    array of queue stats
                                                                    
                                                                    .. attribute:: queue_id
                                                                    
                                                                    	Queue Id used for Fabric Stats
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: tail_drop_packets
                                                                    
                                                                    	Packets tail dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tail_drop_bytes
                                                                    
                                                                    	Bytes tail dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: atm_clp0_drop_packets
                                                                    
                                                                    	ATP CLP 0 matched packets dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: atm_clp0_drop_bytes
                                                                    
                                                                    	ATP CLP 0 matched bytes dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: atm_clp1_drop_packets
                                                                    
                                                                    	ATP CLP 0 matched packets dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: atm_clp1_drop_bytes
                                                                    
                                                                    	ATP CLP 0 matched bytes dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: queue_drop_threshold
                                                                    
                                                                    	tail drop threshold of the queue in bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: forced_wred_stats_display
                                                                    
                                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                    	**type**\: bool
                                                                    
                                                                    .. attribute:: random_drop_packets
                                                                    
                                                                    	Packets probabilistically dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: random_drop_bytes
                                                                    
                                                                    	Bytes probabilistically dropped
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: max_threshold_packets
                                                                    
                                                                    	Dropped packets with the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: max_threshold_bytes
                                                                    
                                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_packets
                                                                    
                                                                    	Packets that conform  to the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_bytes
                                                                    
                                                                    	Bytes that conform to the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_packets
                                                                    
                                                                    	Packets that exceed the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_bytes
                                                                    
                                                                    	Bytes that exceed  the queue rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_rate
                                                                    
                                                                    	Conform rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: exceed_rate
                                                                    
                                                                    	Exceed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: queue_instance_length
                                                                    
                                                                    	Queue instance length
                                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                    
                                                                    .. attribute:: queue_average_length
                                                                    
                                                                    	Queue average length
                                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                    
                                                                    .. attribute:: queue_max_length
                                                                    
                                                                    	Queue maximum length
                                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                        self.yang_name = "queue-stats-array"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                        self._leafs = OrderedDict([
                                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ])
                                                                        self.queue_id = None
                                                                        self.tail_drop_packets = None
                                                                        self.tail_drop_bytes = None
                                                                        self.atm_clp0_drop_packets = None
                                                                        self.atm_clp0_drop_bytes = None
                                                                        self.atm_clp1_drop_packets = None
                                                                        self.atm_clp1_drop_bytes = None
                                                                        self.queue_drop_threshold = None
                                                                        self.forced_wred_stats_display = None
                                                                        self.random_drop_packets = None
                                                                        self.random_drop_bytes = None
                                                                        self.max_threshold_packets = None
                                                                        self.max_threshold_bytes = None
                                                                        self.conform_packets = None
                                                                        self.conform_bytes = None
                                                                        self.exceed_packets = None
                                                                        self.exceed_bytes = None
                                                                        self.conform_rate = None
                                                                        self.exceed_rate = None

                                                                        self.queue_instance_length = YList(self)
                                                                        self.queue_average_length = YList(self)
                                                                        self.queue_max_length = YList(self)
                                                                        self._segment_path = lambda: "queue-stats-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                    class QueueInstanceLength(Entity):
                                                                        """
                                                                        Queue instance length
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                            self.yang_name = "queue-instance-length"
                                                                            self.yang_parent_name = "queue-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "queue-instance-length"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                    class QueueAverageLength(Entity):
                                                                        """
                                                                        Queue average length
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                            self.yang_name = "queue-average-length"
                                                                            self.yang_parent_name = "queue-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "queue-average-length"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                    class QueueMaxLength(Entity):
                                                                        """
                                                                        Queue maximum length
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                            self.yang_name = "queue-max-length"
                                                                            self.yang_parent_name = "queue-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "queue-max-length"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                                class PoliceStatsArray(Entity):
                                                                    """
                                                                    array of police stats
                                                                    
                                                                    .. attribute:: color_class_stats
                                                                    
                                                                    	color class stats
                                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                    
                                                                    .. attribute:: drop_packets
                                                                    
                                                                    	Police dropped packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: drop_bytes
                                                                    
                                                                    	Police dropped bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_packets
                                                                    
                                                                    	Packets that conform  to the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_bytes
                                                                    
                                                                    	Bytes that conform to the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_packets
                                                                    
                                                                    	Packets that exceed the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_bytes
                                                                    
                                                                    	Bytes that exceed  the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_packets
                                                                    
                                                                    	Packets violating the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_bytes
                                                                    
                                                                    	Bytes that violate the policed rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: parent_drop_packets
                                                                    
                                                                    	Dropped pkts by the parent policer
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: parent_drop_bytes
                                                                    
                                                                    	Dropped bytes by the parent policer
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_rate
                                                                    
                                                                    	Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_rate
                                                                    
                                                                    	Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_rate
                                                                    
                                                                    	Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                        self.yang_name = "police-stats-array"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                        self._leafs = OrderedDict([
                                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                        ])
                                                                        self.drop_packets = None
                                                                        self.drop_bytes = None
                                                                        self.conform_packets = None
                                                                        self.conform_bytes = None
                                                                        self.exceed_packets = None
                                                                        self.exceed_bytes = None
                                                                        self.violate_packets = None
                                                                        self.violate_bytes = None
                                                                        self.parent_drop_packets = None
                                                                        self.parent_drop_bytes = None
                                                                        self.conform_rate = None
                                                                        self.exceed_rate = None
                                                                        self.violate_rate = None

                                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                        self.color_class_stats.parent = self
                                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                        self._segment_path = lambda: "police-stats-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                    class ColorClassStats(Entity):
                                                                        """
                                                                        color class stats
                                                                        
                                                                        .. attribute:: conform_class_conform_packets
                                                                        
                                                                        	Packets with classification result conform and policer result conform
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_conform_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result conform
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_conform_rate
                                                                        
                                                                        	Conform Class Conform rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: conform_class_exceed_packets
                                                                        
                                                                        	Packets with classification result conform and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_exceed_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_exceed_rate
                                                                        
                                                                        	Conform Class Exceed rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: conform_class_violate_packets
                                                                        
                                                                        	Packets with classification result conform and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_violate_rate
                                                                        
                                                                        	Conform Class Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_class_exceed_packets
                                                                        
                                                                        	Packets with classification result exceed and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_class_exceed_bytes
                                                                        
                                                                        	Bytes with classification result exceed and policer result exceed
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_class_exceed_rate
                                                                        
                                                                        	Exceed Class Exceed rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_class_violate_packets
                                                                        
                                                                        	Packets with classification result exceed and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result exceed and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_class_violate_rate
                                                                        
                                                                        	Exceed Class Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: violate_class_violate_packets
                                                                        
                                                                        	Packets with classification result violate and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: violate_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result violate and policer result violate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: violate_class_violate_rate
                                                                        
                                                                        	Violate Class Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                            self.yang_name = "color-class-stats"
                                                                            self.yang_parent_name = "police-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                            ])
                                                                            self.conform_class_conform_packets = None
                                                                            self.conform_class_conform_bytes = None
                                                                            self.conform_class_conform_rate = None
                                                                            self.conform_class_exceed_packets = None
                                                                            self.conform_class_exceed_bytes = None
                                                                            self.conform_class_exceed_rate = None
                                                                            self.conform_class_violate_packets = None
                                                                            self.conform_class_violate_bytes = None
                                                                            self.conform_class_violate_rate = None
                                                                            self.exceed_class_exceed_packets = None
                                                                            self.exceed_class_exceed_bytes = None
                                                                            self.exceed_class_exceed_rate = None
                                                                            self.exceed_class_violate_packets = None
                                                                            self.exceed_class_violate_bytes = None
                                                                            self.exceed_class_violate_rate = None
                                                                            self.violate_class_violate_packets = None
                                                                            self.violate_class_violate_bytes = None
                                                                            self.violate_class_violate_rate = None
                                                                            self._segment_path = lambda: "color-class-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                                class WredStatsArray(Entity):
                                                                    """
                                                                    array of red stats
                                                                    
                                                                    .. attribute:: profile_title
                                                                    
                                                                    	ProfileTitle
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..300
                                                                    
                                                                    .. attribute:: red_transmit_packets
                                                                    
                                                                    	Transmitted packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: red_transmit_bytes
                                                                    
                                                                    	Transmitted bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: random_drop_packets
                                                                    
                                                                    	Probabilistically dropped  packets
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: random_drop_bytes
                                                                    
                                                                    	Probabilisticallydropped bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: max_threshold_packets
                                                                    
                                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: max_threshold_bytes
                                                                    
                                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: red_ecn_marked_packets
                                                                    
                                                                    	ECN marked packets 
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: red_ecn_marked_bytes
                                                                    
                                                                    	ECN marked bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: red_label
                                                                    
                                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                        self.yang_name = "wred-stats-array"
                                                                        self.yang_parent_name = "class-stats"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                        self._leafs = OrderedDict([
                                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                        ])
                                                                        self.profile_title = None
                                                                        self.red_transmit_packets = None
                                                                        self.red_transmit_bytes = None
                                                                        self.random_drop_packets = None
                                                                        self.random_drop_bytes = None
                                                                        self.max_threshold_packets = None
                                                                        self.max_threshold_bytes = None
                                                                        self.red_ecn_marked_packets = None
                                                                        self.red_ecn_marked_bytes = None

                                                                        self.red_label = YList(self)
                                                                        self._segment_path = lambda: "wred-stats-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                    class RedLabel(Entity):
                                                                        """
                                                                        Array of WRED Typevalues as in PRP stats is
                                                                        available per threshold   
                                                                        
                                                                        .. attribute:: wred_type
                                                                        
                                                                        	WRED type DSCP, EXP, PREC etc
                                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	WRED value for this type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                            self.yang_name = "red-label"
                                                                            self.yang_parent_name = "wred-stats-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                            ])
                                                                            self.wred_type = None
                                                                            self.value = None
                                                                            self._segment_path = lambda: "red-label"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                        class CacStats(Entity):
                                                            """
                                                            bag for cac stats
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	CAC dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	CAC dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_rates
                                                            
                                                            	CAC dropped rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: admitpackets
                                                            
                                                            	Admitted packets (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_bytes
                                                            
                                                            	Admitted bytes (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_rates
                                                            
                                                            	CAC admit rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                                self.yang_name = "cac-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.drop_rates = None
                                                                self.admitpackets = None
                                                                self.admit_bytes = None
                                                                self.admit_rates = None
                                                                self._segment_path = lambda: "cac-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                        class QueueStatsArray(Entity):
                                                            """
                                                            array of queue stats
                                                            
                                                            .. attribute:: queue_id
                                                            
                                                            	Queue Id used for Fabric Stats
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: tail_drop_packets
                                                            
                                                            	Packets tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tail_drop_bytes
                                                            
                                                            	Bytes tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp0_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp0_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp1_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp1_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: queue_drop_threshold
                                                            
                                                            	tail drop threshold of the queue in bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: forced_wred_stats_display
                                                            
                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                            	**type**\: bool
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Packets probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Bytes probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_instance_length
                                                            
                                                            	Queue instance length
                                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                            
                                                            .. attribute:: queue_average_length
                                                            
                                                            	Queue average length
                                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                            
                                                            .. attribute:: queue_max_length
                                                            
                                                            	Queue maximum length
                                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                                self.yang_name = "queue-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                                self._leafs = OrderedDict([
                                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ])
                                                                self.queue_id = None
                                                                self.tail_drop_packets = None
                                                                self.tail_drop_bytes = None
                                                                self.atm_clp0_drop_packets = None
                                                                self.atm_clp0_drop_bytes = None
                                                                self.atm_clp1_drop_packets = None
                                                                self.atm_clp1_drop_bytes = None
                                                                self.queue_drop_threshold = None
                                                                self.forced_wred_stats_display = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None

                                                                self.queue_instance_length = YList(self)
                                                                self.queue_average_length = YList(self)
                                                                self.queue_max_length = YList(self)
                                                                self._segment_path = lambda: "queue-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                            class QueueInstanceLength(Entity):
                                                                """
                                                                Queue instance length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                    self.yang_name = "queue-instance-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-instance-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                            class QueueAverageLength(Entity):
                                                                """
                                                                Queue average length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                    self.yang_name = "queue-average-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-average-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                            class QueueMaxLength(Entity):
                                                                """
                                                                Queue maximum length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                    self.yang_name = "queue-max-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-max-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                        class PoliceStatsArray(Entity):
                                                            """
                                                            array of police stats
                                                            
                                                            .. attribute:: color_class_stats
                                                            
                                                            	color class stats
                                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	Police dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	Police dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_packets
                                                            
                                                            	Packets violating the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_bytes
                                                            
                                                            	Bytes that violate the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: parent_drop_packets
                                                            
                                                            	Dropped pkts by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: parent_drop_bytes
                                                            
                                                            	Dropped bytes by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_rate
                                                            
                                                            	Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                                self.yang_name = "police-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.violate_packets = None
                                                                self.violate_bytes = None
                                                                self.parent_drop_packets = None
                                                                self.parent_drop_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None
                                                                self.violate_rate = None

                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                self._segment_path = lambda: "police-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                            class ColorClassStats(Entity):
                                                                """
                                                                color class stats
                                                                
                                                                .. attribute:: conform_class_conform_packets
                                                                
                                                                	Packets with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_conform_bytes
                                                                
                                                                	Bytes with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_conform_rate
                                                                
                                                                	Conform Class Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_exceed_packets
                                                                
                                                                	Packets with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_exceed_bytes
                                                                
                                                                	Bytes with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_exceed_rate
                                                                
                                                                	Conform Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_violate_packets
                                                                
                                                                	Packets with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_violate_bytes
                                                                
                                                                	Bytes with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_violate_rate
                                                                
                                                                	Conform Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_exceed_packets
                                                                
                                                                	Packets with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_exceed_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_exceed_rate
                                                                
                                                                	Exceed Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_violate_packets
                                                                
                                                                	Packets with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_violate_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_violate_rate
                                                                
                                                                	Exceed Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_class_violate_packets
                                                                
                                                                	Packets with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_class_violate_bytes
                                                                
                                                                	Bytes with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_class_violate_rate
                                                                
                                                                	Violate Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                    self.yang_name = "color-class-stats"
                                                                    self.yang_parent_name = "police-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                    ])
                                                                    self.conform_class_conform_packets = None
                                                                    self.conform_class_conform_bytes = None
                                                                    self.conform_class_conform_rate = None
                                                                    self.conform_class_exceed_packets = None
                                                                    self.conform_class_exceed_bytes = None
                                                                    self.conform_class_exceed_rate = None
                                                                    self.conform_class_violate_packets = None
                                                                    self.conform_class_violate_bytes = None
                                                                    self.conform_class_violate_rate = None
                                                                    self.exceed_class_exceed_packets = None
                                                                    self.exceed_class_exceed_bytes = None
                                                                    self.exceed_class_exceed_rate = None
                                                                    self.exceed_class_violate_packets = None
                                                                    self.exceed_class_violate_bytes = None
                                                                    self.exceed_class_violate_rate = None
                                                                    self.violate_class_violate_packets = None
                                                                    self.violate_class_violate_bytes = None
                                                                    self.violate_class_violate_rate = None
                                                                    self._segment_path = lambda: "color-class-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                        class WredStatsArray(Entity):
                                                            """
                                                            array of red stats
                                                            
                                                            .. attribute:: profile_title
                                                            
                                                            	ProfileTitle
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..300
                                                            
                                                            .. attribute:: red_transmit_packets
                                                            
                                                            	Transmitted packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_transmit_bytes
                                                            
                                                            	Transmitted bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Probabilistically dropped  packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Probabilisticallydropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_ecn_marked_packets
                                                            
                                                            	ECN marked packets 
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_ecn_marked_bytes
                                                            
                                                            	ECN marked bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_label
                                                            
                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                                self.yang_name = "wred-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                                self._leafs = OrderedDict([
                                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                ])
                                                                self.profile_title = None
                                                                self.red_transmit_packets = None
                                                                self.red_transmit_bytes = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.red_ecn_marked_packets = None
                                                                self.red_ecn_marked_bytes = None

                                                                self.red_label = YList(self)
                                                                self._segment_path = lambda: "wred-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                            class RedLabel(Entity):
                                                                """
                                                                Array of WRED Typevalues as in PRP stats is
                                                                available per threshold   
                                                                
                                                                .. attribute:: wred_type
                                                                
                                                                	WRED type DSCP, EXP, PREC etc
                                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	WRED value for this type
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                    self.yang_name = "red-label"
                                                                    self.yang_parent_name = "wred-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                    ])
                                                                    self.wred_type = None
                                                                    self.value = None
                                                                    self._segment_path = lambda: "red-label"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                            class Input(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: service_policy_names
                                
                                	Operational data for all Policy instance
                                	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input, self).__init__()

                                    self.yang_name = "input"
                                    self.yang_parent_name = "nv-satellite-interface"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames))])
                                    self._leafs = OrderedDict()

                                    self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                    self._segment_path = lambda: "input"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input, [], name, value)


                                class ServicePolicyNames(Entity):
                                    """
                                    Operational data for all Policy instance
                                    
                                    .. attribute:: service_policy_instance
                                    
                                    	QoS policy\-map operational data for a particular Policy 
                                    	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames, self).__init__()

                                        self.yang_name = "service-policy-names"
                                        self.yang_parent_name = "input"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_instance = YList(self)
                                        self._segment_path = lambda: "service-policy-names"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames, [], name, value)


                                    class ServicePolicyInstance(Entity):
                                        """
                                        QoS policy\-map operational data for a
                                        particular Policy 
                                        
                                        .. attribute:: service_policy_name  (key)
                                        
                                        	Name of the policy instance
                                        	**type**\: str
                                        
                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                        
                                        .. attribute:: statistics
                                        
                                        	Policy\-map statistics operational data for an interface
                                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                            self.yang_name = "service-policy-instance"
                                            self.yang_parent_name = "service-policy-names"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = ['service_policy_name']
                                            self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                            self._leafs = OrderedDict([
                                                ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                            ])
                                            self.service_policy_name = None

                                            self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                            self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                        class Statistics(Entity):
                                            """
                                            Policy\-map statistics operational data for an
                                            interface
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                self.yang_name = "statistics"
                                                self.yang_parent_name = "service-policy-instance"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "statistics"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                
                                                .. attribute:: child_policy
                                                
                                                	child policy
                                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "statistics"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"

                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class ChildPolicy(Entity):
                                                    """
                                                    child policy
                                                    
                                                    .. attribute:: policy_name
                                                    
                                                    	PolicyName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: state
                                                    
                                                    	State
                                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                    
                                                    .. attribute:: state_description
                                                    
                                                    	StateDescription
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..128
                                                    
                                                    .. attribute:: satid
                                                    
                                                    	to maintain satellite id
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: class_stats
                                                    
                                                    	array of classes contained in policy
                                                    	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                        self.yang_name = "child-policy"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                        self._leafs = OrderedDict([
                                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                        ])
                                                        self.policy_name = None
                                                        self.state = None
                                                        self.state_description = None
                                                        self.satid = None

                                                        self.class_stats = YList(self)
                                                        self._segment_path = lambda: "child-policy"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                    class ClassStats_(Entity):
                                                        """
                                                        array of classes contained in policy
                                                        
                                                        .. attribute:: general_stats
                                                        
                                                        	general stats
                                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                        
                                                        .. attribute:: iphc_stats
                                                        
                                                        	IPHC stats
                                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                        
                                                        .. attribute:: cac_stats
                                                        
                                                        	bag for cac stats
                                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                        
                                                        .. attribute:: counter_validity_bitmask
                                                        
                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: megabyte
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	ClassName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: shared_queue_id
                                                        
                                                        	q\-id of the  shared queue for this class
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_descr
                                                        
                                                        	Description of queue for the class
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..256
                                                        
                                                        .. attribute:: cac_state
                                                        
                                                        	CACState
                                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                        
                                                        .. attribute:: queue_stats_array
                                                        
                                                        	array of queue stats
                                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                        
                                                        .. attribute:: police_stats_array
                                                        
                                                        	array of police stats
                                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                        
                                                        .. attribute:: wred_stats_array
                                                        
                                                        	array of red stats
                                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                            self.yang_name = "class-stats"
                                                            self.yang_parent_name = "child-policy"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                            self._leafs = OrderedDict([
                                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                            ])
                                                            self.counter_validity_bitmask = None
                                                            self.class_name = None
                                                            self.shared_queue_id = None
                                                            self.queue_descr = None
                                                            self.cac_state = None

                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"

                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"

                                                            self.queue_stats_array = YList(self)
                                                            self.police_stats_array = YList(self)
                                                            self.wred_stats_array = YList(self)
                                                            self._segment_path = lambda: "class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                        class GeneralStats(Entity):
                                                            """
                                                            general stats
                                                            
                                                            .. attribute:: transmit_packets
                                                            
                                                            	Transmitted packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: transmit_bytes
                                                            
                                                            	Transmitted bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_packets
                                                            
                                                            	Dropped packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_bytes
                                                            
                                                            	Dropped bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_rate
                                                            
                                                            	Total drop rate (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: match_data_rate
                                                            
                                                            	Incoming matched data rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: total_transmit_rate
                                                            
                                                            	Total transmit rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: pre_policy_matched_packets
                                                            
                                                            	Matched pkts before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: pre_policy_matched_bytes
                                                            
                                                            	Matched bytes before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                self.yang_name = "general-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                ])
                                                                self.transmit_packets = None
                                                                self.transmit_bytes = None
                                                                self.total_drop_packets = None
                                                                self.total_drop_bytes = None
                                                                self.total_drop_rate = None
                                                                self.match_data_rate = None
                                                                self.total_transmit_rate = None
                                                                self.pre_policy_matched_packets = None
                                                                self.pre_policy_matched_bytes = None
                                                                self._segment_path = lambda: "general-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                        class IphcStats(Entity):
                                                            """
                                                            IPHC stats
                                                            
                                                            .. attribute:: non_tcp_total_out_packets
                                                            
                                                            	TotalNum of Non tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_total_out_bytes
                                                            
                                                            	TotalNum of Non Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_bytes_saved
                                                            
                                                            	Non Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_compressed_packets_out
                                                            
                                                            	Num of non tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                            
                                                            	Compressed Non Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_full_header_packets_out
                                                            
                                                            	Num of non tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_packets
                                                            
                                                            	Total Num of tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_bytes
                                                            
                                                            	TotalNum of Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_bytes_saved
                                                            
                                                            	Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_compressed_packets_out
                                                            
                                                            	Num of tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_bytes_sent_rate
                                                            
                                                            	Compressed Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_full_header_packets_out
                                                            
                                                            	Num of tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                self.yang_name = "iphc-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                ])
                                                                self.non_tcp_total_out_packets = None
                                                                self.non_tcp_total_out_bytes = None
                                                                self.non_tcp_bytes_saved = None
                                                                self.non_tcp_compressed_packets_out = None
                                                                self.non_tcp_bytes_sent_rate = None
                                                                self.non_tcp_full_header_packets_out = None
                                                                self.tcp_total_out_packets = None
                                                                self.tcp_total_out_bytes = None
                                                                self.tcp_bytes_saved = None
                                                                self.tcp_compressed_packets_out = None
                                                                self.tcp_bytes_sent_rate = None
                                                                self.tcp_full_header_packets_out = None
                                                                self._segment_path = lambda: "iphc-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                        class CacStats(Entity):
                                                            """
                                                            bag for cac stats
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	CAC dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	CAC dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_rates
                                                            
                                                            	CAC dropped rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: admitpackets
                                                            
                                                            	Admitted packets (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_bytes
                                                            
                                                            	Admitted bytes (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_rates
                                                            
                                                            	CAC admit rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                self.yang_name = "cac-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.drop_rates = None
                                                                self.admitpackets = None
                                                                self.admit_bytes = None
                                                                self.admit_rates = None
                                                                self._segment_path = lambda: "cac-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                        class QueueStatsArray(Entity):
                                                            """
                                                            array of queue stats
                                                            
                                                            .. attribute:: queue_id
                                                            
                                                            	Queue Id used for Fabric Stats
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: tail_drop_packets
                                                            
                                                            	Packets tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tail_drop_bytes
                                                            
                                                            	Bytes tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp0_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp0_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp1_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp1_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: queue_drop_threshold
                                                            
                                                            	tail drop threshold of the queue in bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: forced_wred_stats_display
                                                            
                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                            	**type**\: bool
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Packets probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Bytes probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_instance_length
                                                            
                                                            	Queue instance length
                                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                            
                                                            .. attribute:: queue_average_length
                                                            
                                                            	Queue average length
                                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                            
                                                            .. attribute:: queue_max_length
                                                            
                                                            	Queue maximum length
                                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                self.yang_name = "queue-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                self._leafs = OrderedDict([
                                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ])
                                                                self.queue_id = None
                                                                self.tail_drop_packets = None
                                                                self.tail_drop_bytes = None
                                                                self.atm_clp0_drop_packets = None
                                                                self.atm_clp0_drop_bytes = None
                                                                self.atm_clp1_drop_packets = None
                                                                self.atm_clp1_drop_bytes = None
                                                                self.queue_drop_threshold = None
                                                                self.forced_wred_stats_display = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None

                                                                self.queue_instance_length = YList(self)
                                                                self.queue_average_length = YList(self)
                                                                self.queue_max_length = YList(self)
                                                                self._segment_path = lambda: "queue-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                            class QueueInstanceLength(Entity):
                                                                """
                                                                Queue instance length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                    self.yang_name = "queue-instance-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-instance-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                            class QueueAverageLength(Entity):
                                                                """
                                                                Queue average length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                    self.yang_name = "queue-average-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-average-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                            class QueueMaxLength(Entity):
                                                                """
                                                                Queue maximum length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                    self.yang_name = "queue-max-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-max-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                        class PoliceStatsArray(Entity):
                                                            """
                                                            array of police stats
                                                            
                                                            .. attribute:: color_class_stats
                                                            
                                                            	color class stats
                                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	Police dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	Police dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_packets
                                                            
                                                            	Packets violating the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_bytes
                                                            
                                                            	Bytes that violate the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: parent_drop_packets
                                                            
                                                            	Dropped pkts by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: parent_drop_bytes
                                                            
                                                            	Dropped bytes by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_rate
                                                            
                                                            	Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                self.yang_name = "police-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.violate_packets = None
                                                                self.violate_bytes = None
                                                                self.parent_drop_packets = None
                                                                self.parent_drop_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None
                                                                self.violate_rate = None

                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                self._segment_path = lambda: "police-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                            class ColorClassStats(Entity):
                                                                """
                                                                color class stats
                                                                
                                                                .. attribute:: conform_class_conform_packets
                                                                
                                                                	Packets with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_conform_bytes
                                                                
                                                                	Bytes with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_conform_rate
                                                                
                                                                	Conform Class Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_exceed_packets
                                                                
                                                                	Packets with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_exceed_bytes
                                                                
                                                                	Bytes with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_exceed_rate
                                                                
                                                                	Conform Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_violate_packets
                                                                
                                                                	Packets with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_violate_bytes
                                                                
                                                                	Bytes with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_violate_rate
                                                                
                                                                	Conform Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_exceed_packets
                                                                
                                                                	Packets with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_exceed_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_exceed_rate
                                                                
                                                                	Exceed Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_violate_packets
                                                                
                                                                	Packets with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_violate_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_violate_rate
                                                                
                                                                	Exceed Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_class_violate_packets
                                                                
                                                                	Packets with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_class_violate_bytes
                                                                
                                                                	Bytes with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_class_violate_rate
                                                                
                                                                	Violate Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                    self.yang_name = "color-class-stats"
                                                                    self.yang_parent_name = "police-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                    ])
                                                                    self.conform_class_conform_packets = None
                                                                    self.conform_class_conform_bytes = None
                                                                    self.conform_class_conform_rate = None
                                                                    self.conform_class_exceed_packets = None
                                                                    self.conform_class_exceed_bytes = None
                                                                    self.conform_class_exceed_rate = None
                                                                    self.conform_class_violate_packets = None
                                                                    self.conform_class_violate_bytes = None
                                                                    self.conform_class_violate_rate = None
                                                                    self.exceed_class_exceed_packets = None
                                                                    self.exceed_class_exceed_bytes = None
                                                                    self.exceed_class_exceed_rate = None
                                                                    self.exceed_class_violate_packets = None
                                                                    self.exceed_class_violate_bytes = None
                                                                    self.exceed_class_violate_rate = None
                                                                    self.violate_class_violate_packets = None
                                                                    self.violate_class_violate_bytes = None
                                                                    self.violate_class_violate_rate = None
                                                                    self._segment_path = lambda: "color-class-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                        class WredStatsArray(Entity):
                                                            """
                                                            array of red stats
                                                            
                                                            .. attribute:: profile_title
                                                            
                                                            	ProfileTitle
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..300
                                                            
                                                            .. attribute:: red_transmit_packets
                                                            
                                                            	Transmitted packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_transmit_bytes
                                                            
                                                            	Transmitted bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Probabilistically dropped  packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Probabilisticallydropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_ecn_marked_packets
                                                            
                                                            	ECN marked packets 
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_ecn_marked_bytes
                                                            
                                                            	ECN marked bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_label
                                                            
                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                self.yang_name = "wred-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                self._leafs = OrderedDict([
                                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                ])
                                                                self.profile_title = None
                                                                self.red_transmit_packets = None
                                                                self.red_transmit_bytes = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.red_ecn_marked_packets = None
                                                                self.red_ecn_marked_bytes = None

                                                                self.red_label = YList(self)
                                                                self._segment_path = lambda: "wred-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                            class RedLabel(Entity):
                                                                """
                                                                Array of WRED Typevalues as in PRP stats is
                                                                available per threshold   
                                                                
                                                                .. attribute:: wred_type
                                                                
                                                                	WRED type DSCP, EXP, PREC etc
                                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	WRED value for this type
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                    self.yang_name = "red-label"
                                                                    self.yang_parent_name = "wred-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                    ])
                                                                    self.wred_type = None
                                                                    self.value = None
                                                                    self._segment_path = lambda: "red-label"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                            class Output(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: service_policy_names
                                
                                	Operational data for all Policy instance
                                	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output, self).__init__()

                                    self.yang_name = "output"
                                    self.yang_parent_name = "nv-satellite-interface"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames))])
                                    self._leafs = OrderedDict()

                                    self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                    self._segment_path = lambda: "output"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output, [], name, value)


                                class ServicePolicyNames(Entity):
                                    """
                                    Operational data for all Policy instance
                                    
                                    .. attribute:: service_policy_instance
                                    
                                    	QoS policy\-map operational data for a particular Policy 
                                    	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames, self).__init__()

                                        self.yang_name = "service-policy-names"
                                        self.yang_parent_name = "output"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_instance = YList(self)
                                        self._segment_path = lambda: "service-policy-names"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames, [], name, value)


                                    class ServicePolicyInstance(Entity):
                                        """
                                        QoS policy\-map operational data for a
                                        particular Policy 
                                        
                                        .. attribute:: service_policy_name  (key)
                                        
                                        	Name of the policy instance
                                        	**type**\: str
                                        
                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                        
                                        .. attribute:: statistics
                                        
                                        	Policy\-map statistics operational data for an interface
                                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                            self.yang_name = "service-policy-instance"
                                            self.yang_parent_name = "service-policy-names"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = ['service_policy_name']
                                            self._child_classes = OrderedDict([("statistics", ("statistics", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                            self._leafs = OrderedDict([
                                                ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                            ])
                                            self.service_policy_name = None

                                            self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                            self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                        class Statistics(Entity):
                                            """
                                            Policy\-map statistics operational data for an
                                            interface
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                self.yang_name = "statistics"
                                                self.yang_parent_name = "service-policy-instance"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "statistics"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                
                                                .. attribute:: child_policy
                                                
                                                	child policy
                                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "statistics"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"

                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class ChildPolicy(Entity):
                                                    """
                                                    child policy
                                                    
                                                    .. attribute:: policy_name
                                                    
                                                    	PolicyName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: state
                                                    
                                                    	State
                                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                    
                                                    .. attribute:: state_description
                                                    
                                                    	StateDescription
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..128
                                                    
                                                    .. attribute:: satid
                                                    
                                                    	to maintain satellite id
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: class_stats
                                                    
                                                    	array of classes contained in policy
                                                    	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                        self.yang_name = "child-policy"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                        self._leafs = OrderedDict([
                                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                        ])
                                                        self.policy_name = None
                                                        self.state = None
                                                        self.state_description = None
                                                        self.satid = None

                                                        self.class_stats = YList(self)
                                                        self._segment_path = lambda: "child-policy"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                    class ClassStats_(Entity):
                                                        """
                                                        array of classes contained in policy
                                                        
                                                        .. attribute:: general_stats
                                                        
                                                        	general stats
                                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                        
                                                        .. attribute:: iphc_stats
                                                        
                                                        	IPHC stats
                                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                        
                                                        .. attribute:: cac_stats
                                                        
                                                        	bag for cac stats
                                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                        
                                                        .. attribute:: counter_validity_bitmask
                                                        
                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: megabyte
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	ClassName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: shared_queue_id
                                                        
                                                        	q\-id of the  shared queue for this class
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_descr
                                                        
                                                        	Description of queue for the class
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..256
                                                        
                                                        .. attribute:: cac_state
                                                        
                                                        	CACState
                                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                        
                                                        .. attribute:: queue_stats_array
                                                        
                                                        	array of queue stats
                                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                        
                                                        .. attribute:: police_stats_array
                                                        
                                                        	array of police stats
                                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                        
                                                        .. attribute:: wred_stats_array
                                                        
                                                        	array of red stats
                                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                            self.yang_name = "class-stats"
                                                            self.yang_parent_name = "child-policy"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                            self._leafs = OrderedDict([
                                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                            ])
                                                            self.counter_validity_bitmask = None
                                                            self.class_name = None
                                                            self.shared_queue_id = None
                                                            self.queue_descr = None
                                                            self.cac_state = None

                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"

                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"

                                                            self.queue_stats_array = YList(self)
                                                            self.police_stats_array = YList(self)
                                                            self.wred_stats_array = YList(self)
                                                            self._segment_path = lambda: "class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                        class GeneralStats(Entity):
                                                            """
                                                            general stats
                                                            
                                                            .. attribute:: transmit_packets
                                                            
                                                            	Transmitted packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: transmit_bytes
                                                            
                                                            	Transmitted bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_packets
                                                            
                                                            	Dropped packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_bytes
                                                            
                                                            	Dropped bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_rate
                                                            
                                                            	Total drop rate (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: match_data_rate
                                                            
                                                            	Incoming matched data rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: total_transmit_rate
                                                            
                                                            	Total transmit rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: pre_policy_matched_packets
                                                            
                                                            	Matched pkts before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: pre_policy_matched_bytes
                                                            
                                                            	Matched bytes before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                self.yang_name = "general-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                ])
                                                                self.transmit_packets = None
                                                                self.transmit_bytes = None
                                                                self.total_drop_packets = None
                                                                self.total_drop_bytes = None
                                                                self.total_drop_rate = None
                                                                self.match_data_rate = None
                                                                self.total_transmit_rate = None
                                                                self.pre_policy_matched_packets = None
                                                                self.pre_policy_matched_bytes = None
                                                                self._segment_path = lambda: "general-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                        class IphcStats(Entity):
                                                            """
                                                            IPHC stats
                                                            
                                                            .. attribute:: non_tcp_total_out_packets
                                                            
                                                            	TotalNum of Non tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_total_out_bytes
                                                            
                                                            	TotalNum of Non Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_bytes_saved
                                                            
                                                            	Non Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_compressed_packets_out
                                                            
                                                            	Num of non tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                            
                                                            	Compressed Non Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_full_header_packets_out
                                                            
                                                            	Num of non tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_packets
                                                            
                                                            	Total Num of tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_bytes
                                                            
                                                            	TotalNum of Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_bytes_saved
                                                            
                                                            	Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_compressed_packets_out
                                                            
                                                            	Num of tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_bytes_sent_rate
                                                            
                                                            	Compressed Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_full_header_packets_out
                                                            
                                                            	Num of tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                self.yang_name = "iphc-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                ])
                                                                self.non_tcp_total_out_packets = None
                                                                self.non_tcp_total_out_bytes = None
                                                                self.non_tcp_bytes_saved = None
                                                                self.non_tcp_compressed_packets_out = None
                                                                self.non_tcp_bytes_sent_rate = None
                                                                self.non_tcp_full_header_packets_out = None
                                                                self.tcp_total_out_packets = None
                                                                self.tcp_total_out_bytes = None
                                                                self.tcp_bytes_saved = None
                                                                self.tcp_compressed_packets_out = None
                                                                self.tcp_bytes_sent_rate = None
                                                                self.tcp_full_header_packets_out = None
                                                                self._segment_path = lambda: "iphc-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                        class CacStats(Entity):
                                                            """
                                                            bag for cac stats
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	CAC dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	CAC dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_rates
                                                            
                                                            	CAC dropped rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: admitpackets
                                                            
                                                            	Admitted packets (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_bytes
                                                            
                                                            	Admitted bytes (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_rates
                                                            
                                                            	CAC admit rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                self.yang_name = "cac-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.drop_rates = None
                                                                self.admitpackets = None
                                                                self.admit_bytes = None
                                                                self.admit_rates = None
                                                                self._segment_path = lambda: "cac-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                        class QueueStatsArray(Entity):
                                                            """
                                                            array of queue stats
                                                            
                                                            .. attribute:: queue_id
                                                            
                                                            	Queue Id used for Fabric Stats
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: tail_drop_packets
                                                            
                                                            	Packets tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tail_drop_bytes
                                                            
                                                            	Bytes tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp0_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp0_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp1_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp1_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: queue_drop_threshold
                                                            
                                                            	tail drop threshold of the queue in bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: forced_wred_stats_display
                                                            
                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                            	**type**\: bool
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Packets probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Bytes probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_instance_length
                                                            
                                                            	Queue instance length
                                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                            
                                                            .. attribute:: queue_average_length
                                                            
                                                            	Queue average length
                                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                            
                                                            .. attribute:: queue_max_length
                                                            
                                                            	Queue maximum length
                                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                self.yang_name = "queue-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                self._leafs = OrderedDict([
                                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ])
                                                                self.queue_id = None
                                                                self.tail_drop_packets = None
                                                                self.tail_drop_bytes = None
                                                                self.atm_clp0_drop_packets = None
                                                                self.atm_clp0_drop_bytes = None
                                                                self.atm_clp1_drop_packets = None
                                                                self.atm_clp1_drop_bytes = None
                                                                self.queue_drop_threshold = None
                                                                self.forced_wred_stats_display = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None

                                                                self.queue_instance_length = YList(self)
                                                                self.queue_average_length = YList(self)
                                                                self.queue_max_length = YList(self)
                                                                self._segment_path = lambda: "queue-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                            class QueueInstanceLength(Entity):
                                                                """
                                                                Queue instance length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                    self.yang_name = "queue-instance-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-instance-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                            class QueueAverageLength(Entity):
                                                                """
                                                                Queue average length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                    self.yang_name = "queue-average-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-average-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                            class QueueMaxLength(Entity):
                                                                """
                                                                Queue maximum length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                    self.yang_name = "queue-max-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-max-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                        class PoliceStatsArray(Entity):
                                                            """
                                                            array of police stats
                                                            
                                                            .. attribute:: color_class_stats
                                                            
                                                            	color class stats
                                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	Police dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	Police dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_packets
                                                            
                                                            	Packets violating the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_bytes
                                                            
                                                            	Bytes that violate the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: parent_drop_packets
                                                            
                                                            	Dropped pkts by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: parent_drop_bytes
                                                            
                                                            	Dropped bytes by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_rate
                                                            
                                                            	Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                self.yang_name = "police-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.violate_packets = None
                                                                self.violate_bytes = None
                                                                self.parent_drop_packets = None
                                                                self.parent_drop_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None
                                                                self.violate_rate = None

                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                self._segment_path = lambda: "police-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                            class ColorClassStats(Entity):
                                                                """
                                                                color class stats
                                                                
                                                                .. attribute:: conform_class_conform_packets
                                                                
                                                                	Packets with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_conform_bytes
                                                                
                                                                	Bytes with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_conform_rate
                                                                
                                                                	Conform Class Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_exceed_packets
                                                                
                                                                	Packets with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_exceed_bytes
                                                                
                                                                	Bytes with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_exceed_rate
                                                                
                                                                	Conform Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_violate_packets
                                                                
                                                                	Packets with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_violate_bytes
                                                                
                                                                	Bytes with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_violate_rate
                                                                
                                                                	Conform Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_exceed_packets
                                                                
                                                                	Packets with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_exceed_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_exceed_rate
                                                                
                                                                	Exceed Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_violate_packets
                                                                
                                                                	Packets with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_violate_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_violate_rate
                                                                
                                                                	Exceed Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_class_violate_packets
                                                                
                                                                	Packets with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_class_violate_bytes
                                                                
                                                                	Bytes with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_class_violate_rate
                                                                
                                                                	Violate Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                    self.yang_name = "color-class-stats"
                                                                    self.yang_parent_name = "police-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                    ])
                                                                    self.conform_class_conform_packets = None
                                                                    self.conform_class_conform_bytes = None
                                                                    self.conform_class_conform_rate = None
                                                                    self.conform_class_exceed_packets = None
                                                                    self.conform_class_exceed_bytes = None
                                                                    self.conform_class_exceed_rate = None
                                                                    self.conform_class_violate_packets = None
                                                                    self.conform_class_violate_bytes = None
                                                                    self.conform_class_violate_rate = None
                                                                    self.exceed_class_exceed_packets = None
                                                                    self.exceed_class_exceed_bytes = None
                                                                    self.exceed_class_exceed_rate = None
                                                                    self.exceed_class_violate_packets = None
                                                                    self.exceed_class_violate_bytes = None
                                                                    self.exceed_class_violate_rate = None
                                                                    self.violate_class_violate_packets = None
                                                                    self.violate_class_violate_bytes = None
                                                                    self.violate_class_violate_rate = None
                                                                    self._segment_path = lambda: "color-class-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                        class WredStatsArray(Entity):
                                                            """
                                                            array of red stats
                                                            
                                                            .. attribute:: profile_title
                                                            
                                                            	ProfileTitle
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..300
                                                            
                                                            .. attribute:: red_transmit_packets
                                                            
                                                            	Transmitted packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_transmit_bytes
                                                            
                                                            	Transmitted bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Probabilistically dropped  packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Probabilisticallydropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_ecn_marked_packets
                                                            
                                                            	ECN marked packets 
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_ecn_marked_bytes
                                                            
                                                            	ECN marked bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_label
                                                            
                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                self.yang_name = "wred-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                self._leafs = OrderedDict([
                                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                ])
                                                                self.profile_title = None
                                                                self.red_transmit_packets = None
                                                                self.red_transmit_bytes = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.red_ecn_marked_packets = None
                                                                self.red_ecn_marked_bytes = None

                                                                self.red_label = YList(self)
                                                                self._segment_path = lambda: "wred-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                            class RedLabel(Entity):
                                                                """
                                                                Array of WRED Typevalues as in PRP stats is
                                                                available per threshold   
                                                                
                                                                .. attribute:: wred_type
                                                                
                                                                	WRED type DSCP, EXP, PREC etc
                                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	WRED value for this type
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                    self.yang_name = "red-label"
                                                                    self.yang_parent_name = "wred-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                    ])
                                                                    self.wred_type = None
                                                                    self.value = None
                                                                    self._segment_path = lambda: "red-label"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


        class NvSatelliteStatus(Entity):
            """
            Satellite QOS offload status based on Satellite
            ID
            
            .. attribute:: nv_satellite_ids
            
            	Satellite ID table
            	**type**\:  :py:class:`NvSatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds>`
            
            

            """

            _prefix = 'qos-ma-oper'
            _revision = '2017-09-13'

            def __init__(self):
                super(Qos.NvSatellite.NvSatelliteStatus, self).__init__()

                self.yang_name = "nv-satellite-status"
                self.yang_parent_name = "nv-satellite"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("nv-satellite-ids", ("nv_satellite_ids", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds))])
                self._leafs = OrderedDict()

                self.nv_satellite_ids = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds()
                self.nv_satellite_ids.parent = self
                self._children_name_map["nv_satellite_ids"] = "nv-satellite-ids"
                self._segment_path = lambda: "nv-satellite-status"
                self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/nv-satellite/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus, [], name, value)


            class NvSatelliteIds(Entity):
                """
                Satellite ID table
                
                .. attribute:: nv_satellite_id
                
                	Satellite ID information
                	**type**\: list of  		 :py:class:`NvSatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds, self).__init__()

                    self.yang_name = "nv-satellite-ids"
                    self.yang_parent_name = "nv-satellite-status"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("nv-satellite-id", ("nv_satellite_id", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId))])
                    self._leafs = OrderedDict()

                    self.nv_satellite_id = YList(self)
                    self._segment_path = lambda: "nv-satellite-ids"
                    self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/nv-satellite/nv-satellite-status/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds, [], name, value)


                class NvSatelliteId(Entity):
                    """
                    Satellite ID information
                    
                    .. attribute:: satellite_id  (key)
                    
                    	Satellite ID
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nv_satellite_interfaces
                    
                    	QOS offload status of satellite interface of a particular satellite
                    	**type**\:  :py:class:`NvSatelliteInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId, self).__init__()

                        self.yang_name = "nv-satellite-id"
                        self.yang_parent_name = "nv-satellite-ids"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = ['satellite_id']
                        self._child_classes = OrderedDict([("nv-satellite-interfaces", ("nv_satellite_interfaces", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces))])
                        self._leafs = OrderedDict([
                            ('satellite_id', (YLeaf(YType.int32, 'satellite-id'), ['int'])),
                        ])
                        self.satellite_id = None

                        self.nv_satellite_interfaces = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces()
                        self.nv_satellite_interfaces.parent = self
                        self._children_name_map["nv_satellite_interfaces"] = "nv-satellite-interfaces"
                        self._segment_path = lambda: "nv-satellite-id" + "[satellite-id='" + str(self.satellite_id) + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/nv-satellite/nv-satellite-status/nv-satellite-ids/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId, ['satellite_id'], name, value)


                    class NvSatelliteInterfaces(Entity):
                        """
                        QOS offload status of satellite interface of
                        a particular satellite
                        
                        .. attribute:: nv_satellite_interface
                        
                        	QOS offload status for a particular satellite interface
                        	**type**\: list of  		 :py:class:`NvSatelliteInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces, self).__init__()

                            self.yang_name = "nv-satellite-interfaces"
                            self.yang_parent_name = "nv-satellite-id"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("nv-satellite-interface", ("nv_satellite_interface", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface))])
                            self._leafs = OrderedDict()

                            self.nv_satellite_interface = YList(self)
                            self._segment_path = lambda: "nv-satellite-interfaces"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces, [], name, value)


                        class NvSatelliteInterface(Entity):
                            """
                            QOS offload status for a particular
                            satellite interface
                            
                            .. attribute:: interface_name  (key)
                            
                            	Name of the interface
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            .. attribute:: member_interfaces
                            
                            	Satellite member interface table
                            	**type**\:  :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces>`
                            
                            .. attribute:: input
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input>`
                            
                            .. attribute:: status
                            
                            	Policy\-map status operational data for an interface
                            	**type**\:  :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Status>`
                            
                            .. attribute:: output
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface, self).__init__()

                                self.yang_name = "nv-satellite-interface"
                                self.yang_parent_name = "nv-satellite-interfaces"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['interface_name']
                                self._child_classes = OrderedDict([("member-interfaces", ("member_interfaces", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces)), ("input", ("input", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input)), ("status", ("status", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Status)), ("output", ("output", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output))])
                                self._leafs = OrderedDict([
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                ])
                                self.interface_name = None

                                self.member_interfaces = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces()
                                self.member_interfaces.parent = self
                                self._children_name_map["member_interfaces"] = "member-interfaces"

                                self.input = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"

                                self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Status()
                                self.status.parent = self
                                self._children_name_map["status"] = "status"

                                self.output = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                                self._segment_path = lambda: "nv-satellite-interface" + "[interface-name='" + str(self.interface_name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface, ['interface_name'], name, value)


                            class MemberInterfaces(Entity):
                                """
                                Satellite member interface table
                                
                                .. attribute:: member_interface
                                
                                	Satellite member interface statistics
                                	**type**\: list of  		 :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces, self).__init__()

                                    self.yang_name = "member-interfaces"
                                    self.yang_parent_name = "nv-satellite-interface"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("member-interface", ("member_interface", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface))])
                                    self._leafs = OrderedDict()

                                    self.member_interface = YList(self)
                                    self._segment_path = lambda: "member-interfaces"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces, [], name, value)


                                class MemberInterface(Entity):
                                    """
                                    Satellite member interface statistics
                                    
                                    .. attribute:: interface_name  (key)
                                    
                                    	Name of member interface
                                    	**type**\: str
                                    
                                    	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                    
                                    .. attribute:: input
                                    
                                    	A piece of QoS policy\-map operational data for an interface
                                    	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input>`
                                    
                                    .. attribute:: output
                                    
                                    	A piece of QoS policy\-map operational data for an interface
                                    	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface, self).__init__()

                                        self.yang_name = "member-interface"
                                        self.yang_parent_name = "member-interfaces"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = ['interface_name']
                                        self._child_classes = OrderedDict([("input", ("input", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input)), ("output", ("output", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output))])
                                        self._leafs = OrderedDict([
                                            ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                        ])
                                        self.interface_name = None

                                        self.input = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input()
                                        self.input.parent = self
                                        self._children_name_map["input"] = "input"

                                        self.output = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output()
                                        self.output.parent = self
                                        self._children_name_map["output"] = "output"
                                        self._segment_path = lambda: "member-interface" + "[interface-name='" + str(self.interface_name) + "']"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface, ['interface_name'], name, value)


                                    class Input(Entity):
                                        """
                                        A piece of QoS policy\-map operational data for
                                        an interface
                                        
                                        .. attribute:: status
                                        
                                        	Policy\-map status operational data for an interface
                                        	**type**\:  :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Status>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input, self).__init__()

                                            self.yang_name = "input"
                                            self.yang_parent_name = "member-interface"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("status", ("status", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Status))])
                                            self._leafs = OrderedDict()

                                            self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Status()
                                            self.status.parent = self
                                            self._children_name_map["status"] = "status"
                                            self._segment_path = lambda: "input"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input, [], name, value)


                                        class Status(Entity):
                                            """
                                            Policy\-map status operational data for an
                                            interface
                                            
                                            .. attribute:: policy_name
                                            
                                            	Service policy name
                                            	**type**\: str
                                            
                                            .. attribute:: direction
                                            
                                            	Satellite caps type
                                            	**type**\:  :py:class:`QosMaSatCapsTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosMaSatCapsTypeEnum>`
                                            
                                            .. attribute:: last_operation
                                            
                                            	Previous caps operation
                                            	**type**\:  :py:class:`QosCapsOperationEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosCapsOperationEnum>`
                                            
                                            .. attribute:: status
                                            
                                            	Status of offload
                                            	**type**\: str
                                            
                                            .. attribute:: error_message
                                            
                                            	Error message
                                            	**type**\: str
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Status, self).__init__()

                                                self.yang_name = "status"
                                                self.yang_parent_name = "input"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('direction', (YLeaf(YType.enumeration, 'direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'QosMaSatCapsTypeEnum', '')])),
                                                    ('last_operation', (YLeaf(YType.enumeration, 'last-operation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'QosCapsOperationEnum', '')])),
                                                    ('status', (YLeaf(YType.str, 'status'), ['str'])),
                                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                                ])
                                                self.policy_name = None
                                                self.direction = None
                                                self.last_operation = None
                                                self.status = None
                                                self.error_message = None
                                                self._segment_path = lambda: "status"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Status, ['policy_name', 'direction', 'last_operation', 'status', 'error_message'], name, value)


                                    class Output(Entity):
                                        """
                                        A piece of QoS policy\-map operational data for
                                        an interface
                                        
                                        .. attribute:: status
                                        
                                        	Policy\-map status operational data for an interface
                                        	**type**\:  :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Status>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output, self).__init__()

                                            self.yang_name = "output"
                                            self.yang_parent_name = "member-interface"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("status", ("status", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Status))])
                                            self._leafs = OrderedDict()

                                            self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Status()
                                            self.status.parent = self
                                            self._children_name_map["status"] = "status"
                                            self._segment_path = lambda: "output"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output, [], name, value)


                                        class Status(Entity):
                                            """
                                            Policy\-map status operational data for an
                                            interface
                                            
                                            .. attribute:: policy_name
                                            
                                            	Service policy name
                                            	**type**\: str
                                            
                                            .. attribute:: direction
                                            
                                            	Satellite caps type
                                            	**type**\:  :py:class:`QosMaSatCapsTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosMaSatCapsTypeEnum>`
                                            
                                            .. attribute:: last_operation
                                            
                                            	Previous caps operation
                                            	**type**\:  :py:class:`QosCapsOperationEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosCapsOperationEnum>`
                                            
                                            .. attribute:: status
                                            
                                            	Status of offload
                                            	**type**\: str
                                            
                                            .. attribute:: error_message
                                            
                                            	Error message
                                            	**type**\: str
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Status, self).__init__()

                                                self.yang_name = "status"
                                                self.yang_parent_name = "output"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('direction', (YLeaf(YType.enumeration, 'direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'QosMaSatCapsTypeEnum', '')])),
                                                    ('last_operation', (YLeaf(YType.enumeration, 'last-operation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'QosCapsOperationEnum', '')])),
                                                    ('status', (YLeaf(YType.str, 'status'), ['str'])),
                                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                                ])
                                                self.policy_name = None
                                                self.direction = None
                                                self.last_operation = None
                                                self.status = None
                                                self.error_message = None
                                                self._segment_path = lambda: "status"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Status, ['policy_name', 'direction', 'last_operation', 'status', 'error_message'], name, value)


                            class Input(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: status
                                
                                	Policy\-map status operational data for an interface
                                	**type**\:  :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Status>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input, self).__init__()

                                    self.yang_name = "input"
                                    self.yang_parent_name = "nv-satellite-interface"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("status", ("status", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Status))])
                                    self._leafs = OrderedDict()

                                    self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Status()
                                    self.status.parent = self
                                    self._children_name_map["status"] = "status"
                                    self._segment_path = lambda: "input"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input, [], name, value)


                                class Status(Entity):
                                    """
                                    Policy\-map status operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	Service policy name
                                    	**type**\: str
                                    
                                    .. attribute:: direction
                                    
                                    	Satellite caps type
                                    	**type**\:  :py:class:`QosMaSatCapsTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosMaSatCapsTypeEnum>`
                                    
                                    .. attribute:: last_operation
                                    
                                    	Previous caps operation
                                    	**type**\:  :py:class:`QosCapsOperationEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosCapsOperationEnum>`
                                    
                                    .. attribute:: status
                                    
                                    	Status of offload
                                    	**type**\: str
                                    
                                    .. attribute:: error_message
                                    
                                    	Error message
                                    	**type**\: str
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Status, self).__init__()

                                        self.yang_name = "status"
                                        self.yang_parent_name = "input"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('direction', (YLeaf(YType.enumeration, 'direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'QosMaSatCapsTypeEnum', '')])),
                                            ('last_operation', (YLeaf(YType.enumeration, 'last-operation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'QosCapsOperationEnum', '')])),
                                            ('status', (YLeaf(YType.str, 'status'), ['str'])),
                                            ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ])
                                        self.policy_name = None
                                        self.direction = None
                                        self.last_operation = None
                                        self.status = None
                                        self.error_message = None
                                        self._segment_path = lambda: "status"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Status, ['policy_name', 'direction', 'last_operation', 'status', 'error_message'], name, value)


                            class Status(Entity):
                                """
                                Policy\-map status operational data for an
                                interface
                                
                                .. attribute:: policy_name
                                
                                	Service policy name
                                	**type**\: str
                                
                                .. attribute:: direction
                                
                                	Satellite caps type
                                	**type**\:  :py:class:`QosMaSatCapsTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosMaSatCapsTypeEnum>`
                                
                                .. attribute:: last_operation
                                
                                	Previous caps operation
                                	**type**\:  :py:class:`QosCapsOperationEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosCapsOperationEnum>`
                                
                                .. attribute:: status
                                
                                	Status of offload
                                	**type**\: str
                                
                                .. attribute:: error_message
                                
                                	Error message
                                	**type**\: str
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Status, self).__init__()

                                    self.yang_name = "status"
                                    self.yang_parent_name = "nv-satellite-interface"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                        ('direction', (YLeaf(YType.enumeration, 'direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'QosMaSatCapsTypeEnum', '')])),
                                        ('last_operation', (YLeaf(YType.enumeration, 'last-operation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'QosCapsOperationEnum', '')])),
                                        ('status', (YLeaf(YType.str, 'status'), ['str'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ])
                                    self.policy_name = None
                                    self.direction = None
                                    self.last_operation = None
                                    self.status = None
                                    self.error_message = None
                                    self._segment_path = lambda: "status"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Status, ['policy_name', 'direction', 'last_operation', 'status', 'error_message'], name, value)


                            class Output(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: status
                                
                                	Policy\-map status operational data for an interface
                                	**type**\:  :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Status>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output, self).__init__()

                                    self.yang_name = "output"
                                    self.yang_parent_name = "nv-satellite-interface"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("status", ("status", Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Status))])
                                    self._leafs = OrderedDict()

                                    self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Status()
                                    self.status.parent = self
                                    self._children_name_map["status"] = "status"
                                    self._segment_path = lambda: "output"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output, [], name, value)


                                class Status(Entity):
                                    """
                                    Policy\-map status operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	Service policy name
                                    	**type**\: str
                                    
                                    .. attribute:: direction
                                    
                                    	Satellite caps type
                                    	**type**\:  :py:class:`QosMaSatCapsTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosMaSatCapsTypeEnum>`
                                    
                                    .. attribute:: last_operation
                                    
                                    	Previous caps operation
                                    	**type**\:  :py:class:`QosCapsOperationEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosCapsOperationEnum>`
                                    
                                    .. attribute:: status
                                    
                                    	Status of offload
                                    	**type**\: str
                                    
                                    .. attribute:: error_message
                                    
                                    	Error message
                                    	**type**\: str
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Status, self).__init__()

                                        self.yang_name = "status"
                                        self.yang_parent_name = "output"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('direction', (YLeaf(YType.enumeration, 'direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'QosMaSatCapsTypeEnum', '')])),
                                            ('last_operation', (YLeaf(YType.enumeration, 'last-operation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'QosCapsOperationEnum', '')])),
                                            ('status', (YLeaf(YType.str, 'status'), ['str'])),
                                            ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ])
                                        self.policy_name = None
                                        self.direction = None
                                        self.last_operation = None
                                        self.status = None
                                        self.error_message = None
                                        self._segment_path = lambda: "status"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Status, ['policy_name', 'direction', 'last_operation', 'status', 'error_message'], name, value)


    class Nodes(Entity):
        """
        Node\-specific QoS operational data
        
        .. attribute:: node
        
        	QoS operational data for a particular node
        	**type**\: list of  		 :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node>`
        
        

        """

        _prefix = 'qos-ma-oper'
        _revision = '2017-09-13'

        def __init__(self):
            super(Qos.Nodes, self).__init__()

            self.yang_name = "nodes"
            self.yang_parent_name = "qos"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("node", ("node", Qos.Nodes.Node))])
            self._leafs = OrderedDict()

            self.node = YList(self)
            self._segment_path = lambda: "nodes"
            self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Qos.Nodes, [], name, value)


        class Node(Entity):
            """
            QoS operational data for a particular node
            
            .. attribute:: node_name  (key)
            
            	The node
            	**type**\: str
            
            	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
            
            .. attribute:: policy_map
            
            	Operational data for policymaps
            	**type**\:  :py:class:`PolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap>`
            
            

            """

            _prefix = 'qos-ma-oper'
            _revision = '2017-09-13'

            def __init__(self):
                super(Qos.Nodes.Node, self).__init__()

                self.yang_name = "node"
                self.yang_parent_name = "nodes"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['node_name']
                self._child_classes = OrderedDict([("policy-map", ("policy_map", Qos.Nodes.Node.PolicyMap))])
                self._leafs = OrderedDict([
                    ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                ])
                self.node_name = None

                self.policy_map = Qos.Nodes.Node.PolicyMap()
                self.policy_map.parent = self
                self._children_name_map["policy_map"] = "policy-map"
                self._segment_path = lambda: "node" + "[node-name='" + str(self.node_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/nodes/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Qos.Nodes.Node, ['node_name'], name, value)


            class PolicyMap(Entity):
                """
                Operational data for policymaps
                
                .. attribute:: shared_policy_instances
                
                	Operational data for all SPI
                	**type**\:  :py:class:`SharedPolicyInstances <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances>`
                
                .. attribute:: interface_table
                
                	Operational data for all interfaces
                	**type**\:  :py:class:`InterfaceTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.Nodes.Node.PolicyMap, self).__init__()

                    self.yang_name = "policy-map"
                    self.yang_parent_name = "node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("shared-policy-instances", ("shared_policy_instances", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances)), ("interface-table", ("interface_table", Qos.Nodes.Node.PolicyMap.InterfaceTable))])
                    self._leafs = OrderedDict()

                    self.shared_policy_instances = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances()
                    self.shared_policy_instances.parent = self
                    self._children_name_map["shared_policy_instances"] = "shared-policy-instances"

                    self.interface_table = Qos.Nodes.Node.PolicyMap.InterfaceTable()
                    self.interface_table.parent = self
                    self._children_name_map["interface_table"] = "interface-table"
                    self._segment_path = lambda: "policy-map"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.Nodes.Node.PolicyMap, [], name, value)


                class SharedPolicyInstances(Entity):
                    """
                    Operational data for all SPI
                    
                    .. attribute:: shared_policy_instance
                    
                    	QoS policy\-map operational data for a particular SPI 
                    	**type**\: list of  		 :py:class:`SharedPolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances, self).__init__()

                        self.yang_name = "shared-policy-instances"
                        self.yang_parent_name = "policy-map"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("shared-policy-instance", ("shared_policy_instance", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance))])
                        self._leafs = OrderedDict()

                        self.shared_policy_instance = YList(self)
                        self._segment_path = lambda: "shared-policy-instances"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances, [], name, value)


                    class SharedPolicyInstance(Entity):
                        """
                        QoS policy\-map operational data for a
                        particular SPI 
                        
                        .. attribute:: spi_name  (key)
                        
                        	Name of the shared policy instance
                        	**type**\: str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        .. attribute:: member_interfaces
                        
                        	QoS policy\-map member interface table
                        	**type**\:  :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces>`
                        
                        .. attribute:: input
                        
                        	A piece of QoS policy\-map operational data for an interface
                        	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input>`
                        
                        .. attribute:: output
                        
                        	A piece of QoS policy\-map operational data for an interface
                        	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance, self).__init__()

                            self.yang_name = "shared-policy-instance"
                            self.yang_parent_name = "shared-policy-instances"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['spi_name']
                            self._child_classes = OrderedDict([("member-interfaces", ("member_interfaces", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces)), ("input", ("input", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input)), ("output", ("output", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output))])
                            self._leafs = OrderedDict([
                                ('spi_name', (YLeaf(YType.str, 'spi-name'), ['str'])),
                            ])
                            self.spi_name = None

                            self.member_interfaces = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces()
                            self.member_interfaces.parent = self
                            self._children_name_map["member_interfaces"] = "member-interfaces"

                            self.input = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input()
                            self.input.parent = self
                            self._children_name_map["input"] = "input"

                            self.output = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output()
                            self.output.parent = self
                            self._children_name_map["output"] = "output"
                            self._segment_path = lambda: "shared-policy-instance" + "[spi-name='" + str(self.spi_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance, ['spi_name'], name, value)


                        class MemberInterfaces(Entity):
                            """
                            QoS policy\-map member interface table
                            
                            .. attribute:: member_interface
                            
                            	QoS policy\-map member interface statistics
                            	**type**\: list of  		 :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces, self).__init__()

                                self.yang_name = "member-interfaces"
                                self.yang_parent_name = "shared-policy-instance"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("member-interface", ("member_interface", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface))])
                                self._leafs = OrderedDict()

                                self.member_interface = YList(self)
                                self._segment_path = lambda: "member-interfaces"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces, [], name, value)


                            class MemberInterface(Entity):
                                """
                                QoS policy\-map member interface statistics
                                
                                .. attribute:: interface_name  (key)
                                
                                	Name of member interface
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                .. attribute:: satellite_ids
                                
                                	Satellite ID information
                                	**type**\:  :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds>`
                                
                                .. attribute:: input
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input>`
                                
                                .. attribute:: output
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface, self).__init__()

                                    self.yang_name = "member-interface"
                                    self.yang_parent_name = "member-interfaces"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['interface_name']
                                    self._child_classes = OrderedDict([("satellite-ids", ("satellite_ids", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds)), ("input", ("input", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input)), ("output", ("output", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output))])
                                    self._leafs = OrderedDict([
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ])
                                    self.interface_name = None

                                    self.satellite_ids = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds()
                                    self.satellite_ids.parent = self
                                    self._children_name_map["satellite_ids"] = "satellite-ids"

                                    self.input = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input()
                                    self.input.parent = self
                                    self._children_name_map["input"] = "input"

                                    self.output = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output()
                                    self.output.parent = self
                                    self._children_name_map["output"] = "output"
                                    self._segment_path = lambda: "member-interface" + "[interface-name='" + str(self.interface_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface, ['interface_name'], name, value)


                                class SatelliteIds(Entity):
                                    """
                                    Satellite ID information
                                    
                                    .. attribute:: satellite_id
                                    
                                    	Satellite ID information
                                    	**type**\: list of  		 :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds, self).__init__()

                                        self.yang_name = "satellite-ids"
                                        self.yang_parent_name = "member-interface"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("satellite-id", ("satellite_id", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId))])
                                        self._leafs = OrderedDict()

                                        self.satellite_id = YList(self)
                                        self._segment_path = lambda: "satellite-ids"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds, [], name, value)


                                    class SatelliteId(Entity):
                                        """
                                        Satellite ID information
                                        
                                        .. attribute:: nv_satellite_id  (key)
                                        
                                        	Satellite ID
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: input
                                        
                                        	A piece of QoS policy\-map operational data for an interface
                                        	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input>`
                                        
                                        .. attribute:: output
                                        
                                        	A piece of QoS policy\-map operational data for an interface
                                        	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__init__()

                                            self.yang_name = "satellite-id"
                                            self.yang_parent_name = "satellite-ids"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = ['nv_satellite_id']
                                            self._child_classes = OrderedDict([("input", ("input", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input)), ("output", ("output", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output))])
                                            self._leafs = OrderedDict([
                                                ('nv_satellite_id', (YLeaf(YType.int32, 'nv-satellite-id'), ['int'])),
                                            ])
                                            self.nv_satellite_id = None

                                            self.input = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                            self.input.parent = self
                                            self._children_name_map["input"] = "input"

                                            self.output = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                            self.output.parent = self
                                            self._children_name_map["output"] = "output"
                                            self._segment_path = lambda: "satellite-id" + "[nv-satellite-id='" + str(self.nv_satellite_id) + "']"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, ['nv_satellite_id'], name, value)


                                        class Input(Entity):
                                            """
                                            A piece of QoS policy\-map operational data for
                                            an interface
                                            
                                            .. attribute:: service_policy_names
                                            
                                            	Operational data for all Policy instance
                                            	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, self).__init__()

                                                self.yang_name = "input"
                                                self.yang_parent_name = "satellite-id"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames))])
                                                self._leafs = OrderedDict()

                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                                self._segment_path = lambda: "input"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, [], name, value)


                                            class ServicePolicyNames(Entity):
                                                """
                                                Operational data for all Policy instance
                                                
                                                .. attribute:: service_policy_instance
                                                
                                                	QoS policy\-map operational data for a particular Policy 
                                                	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                                    self.yang_name = "service-policy-names"
                                                    self.yang_parent_name = "input"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance))])
                                                    self._leafs = OrderedDict()

                                                    self.service_policy_instance = YList(self)
                                                    self._segment_path = lambda: "service-policy-names"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, [], name, value)


                                                class ServicePolicyInstance(Entity):
                                                    """
                                                    QoS policy\-map operational data for a
                                                    particular Policy 
                                                    
                                                    .. attribute:: service_policy_name  (key)
                                                    
                                                    	Name of the policy instance
                                                    	**type**\: str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    .. attribute:: statistics
                                                    
                                                    	Policy\-map statistics operational data for an interface
                                                    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                        self.yang_name = "service-policy-instance"
                                                        self.yang_parent_name = "service-policy-names"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = ['service_policy_name']
                                                        self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                        self._leafs = OrderedDict([
                                                            ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                        ])
                                                        self.service_policy_name = None

                                                        self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                        self.statistics.parent = self
                                                        self._children_name_map["statistics"] = "statistics"
                                                        self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                                    class Statistics(Entity):
                                                        """
                                                        Policy\-map statistics operational data for an
                                                        interface
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                            self.yang_name = "statistics"
                                                            self.yang_parent_name = "service-policy-instance"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                            ])
                                                            self.policy_name = None
                                                            self.state = None
                                                            self.state_description = None
                                                            self.satid = None

                                                            self.class_stats = YList(self)
                                                            self._segment_path = lambda: "statistics"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                        class ClassStats(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                            
                                                            .. attribute:: child_policy
                                                            
                                                            	child policy
                                                            	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "statistics"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                                self._leafs = OrderedDict([
                                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                ])
                                                                self.counter_validity_bitmask = None
                                                                self.class_name = None
                                                                self.shared_queue_id = None
                                                                self.queue_descr = None
                                                                self.cac_state = None

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                                self.child_policy.parent = self
                                                                self._children_name_map["child_policy"] = "child-policy"

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                                self.queue_stats_array = YList(self)
                                                                self.police_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)
                                                                self._segment_path = lambda: "class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                    ])
                                                                    self.transmit_packets = None
                                                                    self.transmit_bytes = None
                                                                    self.total_drop_packets = None
                                                                    self.total_drop_bytes = None
                                                                    self.total_drop_rate = None
                                                                    self.match_data_rate = None
                                                                    self.total_transmit_rate = None
                                                                    self.pre_policy_matched_packets = None
                                                                    self.pre_policy_matched_bytes = None
                                                                    self._segment_path = lambda: "general-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                    ])
                                                                    self.non_tcp_total_out_packets = None
                                                                    self.non_tcp_total_out_bytes = None
                                                                    self.non_tcp_bytes_saved = None
                                                                    self.non_tcp_compressed_packets_out = None
                                                                    self.non_tcp_bytes_sent_rate = None
                                                                    self.non_tcp_full_header_packets_out = None
                                                                    self.tcp_total_out_packets = None
                                                                    self.tcp_total_out_bytes = None
                                                                    self.tcp_bytes_saved = None
                                                                    self.tcp_compressed_packets_out = None
                                                                    self.tcp_bytes_sent_rate = None
                                                                    self.tcp_full_header_packets_out = None
                                                                    self._segment_path = lambda: "iphc-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                            class ChildPolicy(Entity):
                                                                """
                                                                child policy
                                                                
                                                                .. attribute:: policy_name
                                                                
                                                                	PolicyName
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: state
                                                                
                                                                	State
                                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                                
                                                                .. attribute:: state_description
                                                                
                                                                	StateDescription
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..128
                                                                
                                                                .. attribute:: satid
                                                                
                                                                	to maintain satellite id
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: class_stats
                                                                
                                                                	array of classes contained in policy
                                                                	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                                    self.yang_name = "child-policy"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                                    self._leafs = OrderedDict([
                                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                                    ])
                                                                    self.policy_name = None
                                                                    self.state = None
                                                                    self.state_description = None
                                                                    self.satid = None

                                                                    self.class_stats = YList(self)
                                                                    self._segment_path = lambda: "child-policy"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                                class ClassStats_(Entity):
                                                                    """
                                                                    array of classes contained in policy
                                                                    
                                                                    .. attribute:: general_stats
                                                                    
                                                                    	general stats
                                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                                    
                                                                    .. attribute:: iphc_stats
                                                                    
                                                                    	IPHC stats
                                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                                    
                                                                    .. attribute:: cac_stats
                                                                    
                                                                    	bag for cac stats
                                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                                    
                                                                    .. attribute:: counter_validity_bitmask
                                                                    
                                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: megabyte
                                                                    
                                                                    .. attribute:: class_name
                                                                    
                                                                    	ClassName
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: shared_queue_id
                                                                    
                                                                    	q\-id of the  shared queue for this class
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: queue_descr
                                                                    
                                                                    	Description of queue for the class
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..256
                                                                    
                                                                    .. attribute:: cac_state
                                                                    
                                                                    	CACState
                                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                                    
                                                                    .. attribute:: queue_stats_array
                                                                    
                                                                    	array of queue stats
                                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                                    
                                                                    .. attribute:: police_stats_array
                                                                    
                                                                    	array of police stats
                                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                                    
                                                                    .. attribute:: wred_stats_array
                                                                    
                                                                    	array of red stats
                                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                        self.yang_name = "class-stats"
                                                                        self.yang_parent_name = "child-policy"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                        self._leafs = OrderedDict([
                                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                        ])
                                                                        self.counter_validity_bitmask = None
                                                                        self.class_name = None
                                                                        self.shared_queue_id = None
                                                                        self.queue_descr = None
                                                                        self.cac_state = None

                                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                        self.general_stats.parent = self
                                                                        self._children_name_map["general_stats"] = "general-stats"

                                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                        self.iphc_stats.parent = self
                                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                        self.cac_stats.parent = self
                                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                                        self.queue_stats_array = YList(self)
                                                                        self.police_stats_array = YList(self)
                                                                        self.wred_stats_array = YList(self)
                                                                        self._segment_path = lambda: "class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                                    class GeneralStats(Entity):
                                                                        """
                                                                        general stats
                                                                        
                                                                        .. attribute:: transmit_packets
                                                                        
                                                                        	Transmitted packets (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: transmit_bytes
                                                                        
                                                                        	Transmitted bytes (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: total_drop_packets
                                                                        
                                                                        	Dropped packets (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: total_drop_bytes
                                                                        
                                                                        	Dropped bytes (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: total_drop_rate
                                                                        
                                                                        	Total drop rate (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: match_data_rate
                                                                        
                                                                        	Incoming matched data rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: total_transmit_rate
                                                                        
                                                                        	Total transmit rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: pre_policy_matched_packets
                                                                        
                                                                        	Matched pkts before applying policy
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: pre_policy_matched_bytes
                                                                        
                                                                        	Matched bytes before applying policy
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                            self.yang_name = "general-stats"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                            ])
                                                                            self.transmit_packets = None
                                                                            self.transmit_bytes = None
                                                                            self.total_drop_packets = None
                                                                            self.total_drop_bytes = None
                                                                            self.total_drop_rate = None
                                                                            self.match_data_rate = None
                                                                            self.total_transmit_rate = None
                                                                            self.pre_policy_matched_packets = None
                                                                            self.pre_policy_matched_bytes = None
                                                                            self._segment_path = lambda: "general-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                                    class IphcStats(Entity):
                                                                        """
                                                                        IPHC stats
                                                                        
                                                                        .. attribute:: non_tcp_total_out_packets
                                                                        
                                                                        	TotalNum of Non tcp pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: non_tcp_total_out_bytes
                                                                        
                                                                        	TotalNum of Non Tcp Bytes sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: non_tcp_bytes_saved
                                                                        
                                                                        	Non Tcp Bytes saved due to compression
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: non_tcp_compressed_packets_out
                                                                        
                                                                        	Num of non tcp compressed pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                                        
                                                                        	Compressed Non Tcp Bytes sent rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: non_tcp_full_header_packets_out
                                                                        
                                                                        	Num of non tcp fullheader pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tcp_total_out_packets
                                                                        
                                                                        	Total Num of tcp pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tcp_total_out_bytes
                                                                        
                                                                        	TotalNum of Tcp Bytes sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: tcp_bytes_saved
                                                                        
                                                                        	Tcp Bytes saved due to compression
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: tcp_compressed_packets_out
                                                                        
                                                                        	Num of tcp compressed pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tcp_bytes_sent_rate
                                                                        
                                                                        	Compressed Tcp Bytes sent rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: tcp_full_header_packets_out
                                                                        
                                                                        	Num of tcp fullheader pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                            self.yang_name = "iphc-stats"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                            ])
                                                                            self.non_tcp_total_out_packets = None
                                                                            self.non_tcp_total_out_bytes = None
                                                                            self.non_tcp_bytes_saved = None
                                                                            self.non_tcp_compressed_packets_out = None
                                                                            self.non_tcp_bytes_sent_rate = None
                                                                            self.non_tcp_full_header_packets_out = None
                                                                            self.tcp_total_out_packets = None
                                                                            self.tcp_total_out_bytes = None
                                                                            self.tcp_bytes_saved = None
                                                                            self.tcp_compressed_packets_out = None
                                                                            self.tcp_bytes_sent_rate = None
                                                                            self.tcp_full_header_packets_out = None
                                                                            self._segment_path = lambda: "iphc-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                                    class CacStats(Entity):
                                                                        """
                                                                        bag for cac stats
                                                                        
                                                                        .. attribute:: drop_packets
                                                                        
                                                                        	CAC dropped packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: drop_bytes
                                                                        
                                                                        	CAC dropped bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: drop_rates
                                                                        
                                                                        	CAC dropped rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: admitpackets
                                                                        
                                                                        	Admitted packets (pkts/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: admit_bytes
                                                                        
                                                                        	Admitted bytes (pkts/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: admit_rates
                                                                        
                                                                        	CAC admit rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                            self.yang_name = "cac-stats"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                            ])
                                                                            self.drop_packets = None
                                                                            self.drop_bytes = None
                                                                            self.drop_rates = None
                                                                            self.admitpackets = None
                                                                            self.admit_bytes = None
                                                                            self.admit_rates = None
                                                                            self._segment_path = lambda: "cac-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                                    class QueueStatsArray(Entity):
                                                                        """
                                                                        array of queue stats
                                                                        
                                                                        .. attribute:: queue_id
                                                                        
                                                                        	Queue Id used for Fabric Stats
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: tail_drop_packets
                                                                        
                                                                        	Packets tail dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tail_drop_bytes
                                                                        
                                                                        	Bytes tail dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: atm_clp0_drop_packets
                                                                        
                                                                        	ATP CLP 0 matched packets dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: atm_clp0_drop_bytes
                                                                        
                                                                        	ATP CLP 0 matched bytes dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: atm_clp1_drop_packets
                                                                        
                                                                        	ATP CLP 0 matched packets dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: atm_clp1_drop_bytes
                                                                        
                                                                        	ATP CLP 0 matched bytes dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: queue_drop_threshold
                                                                        
                                                                        	tail drop threshold of the queue in bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: forced_wred_stats_display
                                                                        
                                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                        	**type**\: bool
                                                                        
                                                                        .. attribute:: random_drop_packets
                                                                        
                                                                        	Packets probabilistically dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: random_drop_bytes
                                                                        
                                                                        	Bytes probabilistically dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: max_threshold_packets
                                                                        
                                                                        	Dropped packets with the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: max_threshold_bytes
                                                                        
                                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_packets
                                                                        
                                                                        	Packets that conform  to the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_bytes
                                                                        
                                                                        	Bytes that conform to the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_packets
                                                                        
                                                                        	Packets that exceed the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_bytes
                                                                        
                                                                        	Bytes that exceed  the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_rate
                                                                        
                                                                        	Conform rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: exceed_rate
                                                                        
                                                                        	Exceed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: queue_instance_length
                                                                        
                                                                        	Queue instance length
                                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                        
                                                                        .. attribute:: queue_average_length
                                                                        
                                                                        	Queue average length
                                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                        
                                                                        .. attribute:: queue_max_length
                                                                        
                                                                        	Queue maximum length
                                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                            self.yang_name = "queue-stats-array"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                            self._leafs = OrderedDict([
                                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                            ])
                                                                            self.queue_id = None
                                                                            self.tail_drop_packets = None
                                                                            self.tail_drop_bytes = None
                                                                            self.atm_clp0_drop_packets = None
                                                                            self.atm_clp0_drop_bytes = None
                                                                            self.atm_clp1_drop_packets = None
                                                                            self.atm_clp1_drop_bytes = None
                                                                            self.queue_drop_threshold = None
                                                                            self.forced_wred_stats_display = None
                                                                            self.random_drop_packets = None
                                                                            self.random_drop_bytes = None
                                                                            self.max_threshold_packets = None
                                                                            self.max_threshold_bytes = None
                                                                            self.conform_packets = None
                                                                            self.conform_bytes = None
                                                                            self.exceed_packets = None
                                                                            self.exceed_bytes = None
                                                                            self.conform_rate = None
                                                                            self.exceed_rate = None

                                                                            self.queue_instance_length = YList(self)
                                                                            self.queue_average_length = YList(self)
                                                                            self.queue_max_length = YList(self)
                                                                            self._segment_path = lambda: "queue-stats-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                        class QueueInstanceLength(Entity):
                                                                            """
                                                                            Queue instance length
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                                self.yang_name = "queue-instance-length"
                                                                                self.yang_parent_name = "queue-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "queue-instance-length"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                        class QueueAverageLength(Entity):
                                                                            """
                                                                            Queue average length
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                                self.yang_name = "queue-average-length"
                                                                                self.yang_parent_name = "queue-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "queue-average-length"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                        class QueueMaxLength(Entity):
                                                                            """
                                                                            Queue maximum length
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                                self.yang_name = "queue-max-length"
                                                                                self.yang_parent_name = "queue-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "queue-max-length"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                                    class PoliceStatsArray(Entity):
                                                                        """
                                                                        array of police stats
                                                                        
                                                                        .. attribute:: color_class_stats
                                                                        
                                                                        	color class stats
                                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                        
                                                                        .. attribute:: drop_packets
                                                                        
                                                                        	Police dropped packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: drop_bytes
                                                                        
                                                                        	Police dropped bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_packets
                                                                        
                                                                        	Packets that conform  to the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_bytes
                                                                        
                                                                        	Bytes that conform to the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_packets
                                                                        
                                                                        	Packets that exceed the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_bytes
                                                                        
                                                                        	Bytes that exceed  the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: violate_packets
                                                                        
                                                                        	Packets violating the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: violate_bytes
                                                                        
                                                                        	Bytes that violate the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: parent_drop_packets
                                                                        
                                                                        	Dropped pkts by the parent policer
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: parent_drop_bytes
                                                                        
                                                                        	Dropped bytes by the parent policer
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_rate
                                                                        
                                                                        	Conform rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_rate
                                                                        
                                                                        	Exceed rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: violate_rate
                                                                        
                                                                        	Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                            self.yang_name = "police-stats-array"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                            self._leafs = OrderedDict([
                                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                            ])
                                                                            self.drop_packets = None
                                                                            self.drop_bytes = None
                                                                            self.conform_packets = None
                                                                            self.conform_bytes = None
                                                                            self.exceed_packets = None
                                                                            self.exceed_bytes = None
                                                                            self.violate_packets = None
                                                                            self.violate_bytes = None
                                                                            self.parent_drop_packets = None
                                                                            self.parent_drop_bytes = None
                                                                            self.conform_rate = None
                                                                            self.exceed_rate = None
                                                                            self.violate_rate = None

                                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                            self.color_class_stats.parent = self
                                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                            self._segment_path = lambda: "police-stats-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                        class ColorClassStats(Entity):
                                                                            """
                                                                            color class stats
                                                                            
                                                                            .. attribute:: conform_class_conform_packets
                                                                            
                                                                            	Packets with classification result conform and policer result conform
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_class_conform_bytes
                                                                            
                                                                            	Bytes with classification result conform and policer result conform
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_class_conform_rate
                                                                            
                                                                            	Conform Class Conform rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: conform_class_exceed_packets
                                                                            
                                                                            	Packets with classification result conform and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_class_exceed_bytes
                                                                            
                                                                            	Bytes with classification result conform and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_class_exceed_rate
                                                                            
                                                                            	Conform Class Exceed rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: conform_class_violate_packets
                                                                            
                                                                            	Packets with classification result conform and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_class_violate_bytes
                                                                            
                                                                            	Bytes with classification result conform and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_class_violate_rate
                                                                            
                                                                            	Conform Class Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: exceed_class_exceed_packets
                                                                            
                                                                            	Packets with classification result exceed and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: exceed_class_exceed_bytes
                                                                            
                                                                            	Bytes with classification result exceed and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: exceed_class_exceed_rate
                                                                            
                                                                            	Exceed Class Exceed rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: exceed_class_violate_packets
                                                                            
                                                                            	Packets with classification result exceed and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: exceed_class_violate_bytes
                                                                            
                                                                            	Bytes with classification result exceed and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: exceed_class_violate_rate
                                                                            
                                                                            	Exceed Class Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: violate_class_violate_packets
                                                                            
                                                                            	Packets with classification result violate and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: violate_class_violate_bytes
                                                                            
                                                                            	Bytes with classification result violate and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: violate_class_violate_rate
                                                                            
                                                                            	Violate Class Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                                self.yang_name = "color-class-stats"
                                                                                self.yang_parent_name = "police-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                                ])
                                                                                self.conform_class_conform_packets = None
                                                                                self.conform_class_conform_bytes = None
                                                                                self.conform_class_conform_rate = None
                                                                                self.conform_class_exceed_packets = None
                                                                                self.conform_class_exceed_bytes = None
                                                                                self.conform_class_exceed_rate = None
                                                                                self.conform_class_violate_packets = None
                                                                                self.conform_class_violate_bytes = None
                                                                                self.conform_class_violate_rate = None
                                                                                self.exceed_class_exceed_packets = None
                                                                                self.exceed_class_exceed_bytes = None
                                                                                self.exceed_class_exceed_rate = None
                                                                                self.exceed_class_violate_packets = None
                                                                                self.exceed_class_violate_bytes = None
                                                                                self.exceed_class_violate_rate = None
                                                                                self.violate_class_violate_packets = None
                                                                                self.violate_class_violate_bytes = None
                                                                                self.violate_class_violate_rate = None
                                                                                self._segment_path = lambda: "color-class-stats"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                                    class WredStatsArray(Entity):
                                                                        """
                                                                        array of red stats
                                                                        
                                                                        .. attribute:: profile_title
                                                                        
                                                                        	ProfileTitle
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..300
                                                                        
                                                                        .. attribute:: red_transmit_packets
                                                                        
                                                                        	Transmitted packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: red_transmit_bytes
                                                                        
                                                                        	Transmitted bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: random_drop_packets
                                                                        
                                                                        	Probabilistically dropped  packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: random_drop_bytes
                                                                        
                                                                        	Probabilisticallydropped bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: max_threshold_packets
                                                                        
                                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: max_threshold_bytes
                                                                        
                                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: red_ecn_marked_packets
                                                                        
                                                                        	ECN marked packets 
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: red_ecn_marked_bytes
                                                                        
                                                                        	ECN marked bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: red_label
                                                                        
                                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                            self.yang_name = "wred-stats-array"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                            self._leafs = OrderedDict([
                                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                            ])
                                                                            self.profile_title = None
                                                                            self.red_transmit_packets = None
                                                                            self.red_transmit_bytes = None
                                                                            self.random_drop_packets = None
                                                                            self.random_drop_bytes = None
                                                                            self.max_threshold_packets = None
                                                                            self.max_threshold_bytes = None
                                                                            self.red_ecn_marked_packets = None
                                                                            self.red_ecn_marked_bytes = None

                                                                            self.red_label = YList(self)
                                                                            self._segment_path = lambda: "wred-stats-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                        class RedLabel(Entity):
                                                                            """
                                                                            Array of WRED Typevalues as in PRP stats is
                                                                            available per threshold   
                                                                            
                                                                            .. attribute:: wred_type
                                                                            
                                                                            	WRED type DSCP, EXP, PREC etc
                                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	WRED value for this type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                                self.yang_name = "red-label"
                                                                                self.yang_parent_name = "wred-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                                ])
                                                                                self.wred_type = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "red-label"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.drop_rates = None
                                                                    self.admitpackets = None
                                                                    self.admit_bytes = None
                                                                    self.admit_rates = None
                                                                    self._segment_path = lambda: "cac-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\: bool
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                                    self._leafs = OrderedDict([
                                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ])
                                                                    self.queue_id = None
                                                                    self.tail_drop_packets = None
                                                                    self.tail_drop_bytes = None
                                                                    self.atm_clp0_drop_packets = None
                                                                    self.atm_clp0_drop_bytes = None
                                                                    self.atm_clp1_drop_packets = None
                                                                    self.atm_clp1_drop_bytes = None
                                                                    self.queue_drop_threshold = None
                                                                    self.forced_wred_stats_display = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None

                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_max_length = YList(self)
                                                                    self._segment_path = lambda: "queue-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-instance-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-average-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-max-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.violate_packets = None
                                                                    self.violate_bytes = None
                                                                    self.parent_drop_packets = None
                                                                    self.parent_drop_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None
                                                                    self.violate_rate = None

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._segment_path = lambda: "police-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                        ])
                                                                        self.conform_class_conform_packets = None
                                                                        self.conform_class_conform_bytes = None
                                                                        self.conform_class_conform_rate = None
                                                                        self.conform_class_exceed_packets = None
                                                                        self.conform_class_exceed_bytes = None
                                                                        self.conform_class_exceed_rate = None
                                                                        self.conform_class_violate_packets = None
                                                                        self.conform_class_violate_bytes = None
                                                                        self.conform_class_violate_rate = None
                                                                        self.exceed_class_exceed_packets = None
                                                                        self.exceed_class_exceed_bytes = None
                                                                        self.exceed_class_exceed_rate = None
                                                                        self.exceed_class_violate_packets = None
                                                                        self.exceed_class_violate_bytes = None
                                                                        self.exceed_class_violate_rate = None
                                                                        self.violate_class_violate_packets = None
                                                                        self.violate_class_violate_bytes = None
                                                                        self.violate_class_violate_rate = None
                                                                        self._segment_path = lambda: "color-class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                                    self._leafs = OrderedDict([
                                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                    ])
                                                                    self.profile_title = None
                                                                    self.red_transmit_packets = None
                                                                    self.red_transmit_bytes = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.red_ecn_marked_packets = None
                                                                    self.red_ecn_marked_bytes = None

                                                                    self.red_label = YList(self)
                                                                    self._segment_path = lambda: "wred-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                        ])
                                                                        self.wred_type = None
                                                                        self.value = None
                                                                        self._segment_path = lambda: "red-label"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class Output(Entity):
                                            """
                                            A piece of QoS policy\-map operational data for
                                            an interface
                                            
                                            .. attribute:: service_policy_names
                                            
                                            	Operational data for all Policy instance
                                            	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, self).__init__()

                                                self.yang_name = "output"
                                                self.yang_parent_name = "satellite-id"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames))])
                                                self._leafs = OrderedDict()

                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                                self._segment_path = lambda: "output"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, [], name, value)


                                            class ServicePolicyNames(Entity):
                                                """
                                                Operational data for all Policy instance
                                                
                                                .. attribute:: service_policy_instance
                                                
                                                	QoS policy\-map operational data for a particular Policy 
                                                	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                                    self.yang_name = "service-policy-names"
                                                    self.yang_parent_name = "output"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance))])
                                                    self._leafs = OrderedDict()

                                                    self.service_policy_instance = YList(self)
                                                    self._segment_path = lambda: "service-policy-names"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, [], name, value)


                                                class ServicePolicyInstance(Entity):
                                                    """
                                                    QoS policy\-map operational data for a
                                                    particular Policy 
                                                    
                                                    .. attribute:: service_policy_name  (key)
                                                    
                                                    	Name of the policy instance
                                                    	**type**\: str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    .. attribute:: statistics
                                                    
                                                    	Policy\-map statistics operational data for an interface
                                                    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                        self.yang_name = "service-policy-instance"
                                                        self.yang_parent_name = "service-policy-names"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = ['service_policy_name']
                                                        self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                        self._leafs = OrderedDict([
                                                            ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                        ])
                                                        self.service_policy_name = None

                                                        self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                        self.statistics.parent = self
                                                        self._children_name_map["statistics"] = "statistics"
                                                        self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                                    class Statistics(Entity):
                                                        """
                                                        Policy\-map statistics operational data for an
                                                        interface
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                            self.yang_name = "statistics"
                                                            self.yang_parent_name = "service-policy-instance"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                            ])
                                                            self.policy_name = None
                                                            self.state = None
                                                            self.state_description = None
                                                            self.satid = None

                                                            self.class_stats = YList(self)
                                                            self._segment_path = lambda: "statistics"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                        class ClassStats(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                            
                                                            .. attribute:: child_policy
                                                            
                                                            	child policy
                                                            	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "statistics"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                                self._leafs = OrderedDict([
                                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                ])
                                                                self.counter_validity_bitmask = None
                                                                self.class_name = None
                                                                self.shared_queue_id = None
                                                                self.queue_descr = None
                                                                self.cac_state = None

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                                self.child_policy.parent = self
                                                                self._children_name_map["child_policy"] = "child-policy"

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                                self.queue_stats_array = YList(self)
                                                                self.police_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)
                                                                self._segment_path = lambda: "class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                    ])
                                                                    self.transmit_packets = None
                                                                    self.transmit_bytes = None
                                                                    self.total_drop_packets = None
                                                                    self.total_drop_bytes = None
                                                                    self.total_drop_rate = None
                                                                    self.match_data_rate = None
                                                                    self.total_transmit_rate = None
                                                                    self.pre_policy_matched_packets = None
                                                                    self.pre_policy_matched_bytes = None
                                                                    self._segment_path = lambda: "general-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                    ])
                                                                    self.non_tcp_total_out_packets = None
                                                                    self.non_tcp_total_out_bytes = None
                                                                    self.non_tcp_bytes_saved = None
                                                                    self.non_tcp_compressed_packets_out = None
                                                                    self.non_tcp_bytes_sent_rate = None
                                                                    self.non_tcp_full_header_packets_out = None
                                                                    self.tcp_total_out_packets = None
                                                                    self.tcp_total_out_bytes = None
                                                                    self.tcp_bytes_saved = None
                                                                    self.tcp_compressed_packets_out = None
                                                                    self.tcp_bytes_sent_rate = None
                                                                    self.tcp_full_header_packets_out = None
                                                                    self._segment_path = lambda: "iphc-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                            class ChildPolicy(Entity):
                                                                """
                                                                child policy
                                                                
                                                                .. attribute:: policy_name
                                                                
                                                                	PolicyName
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: state
                                                                
                                                                	State
                                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                                
                                                                .. attribute:: state_description
                                                                
                                                                	StateDescription
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..128
                                                                
                                                                .. attribute:: satid
                                                                
                                                                	to maintain satellite id
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: class_stats
                                                                
                                                                	array of classes contained in policy
                                                                	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                                    self.yang_name = "child-policy"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                                    self._leafs = OrderedDict([
                                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                                    ])
                                                                    self.policy_name = None
                                                                    self.state = None
                                                                    self.state_description = None
                                                                    self.satid = None

                                                                    self.class_stats = YList(self)
                                                                    self._segment_path = lambda: "child-policy"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                                class ClassStats_(Entity):
                                                                    """
                                                                    array of classes contained in policy
                                                                    
                                                                    .. attribute:: general_stats
                                                                    
                                                                    	general stats
                                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                                    
                                                                    .. attribute:: iphc_stats
                                                                    
                                                                    	IPHC stats
                                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                                    
                                                                    .. attribute:: cac_stats
                                                                    
                                                                    	bag for cac stats
                                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                                    
                                                                    .. attribute:: counter_validity_bitmask
                                                                    
                                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: megabyte
                                                                    
                                                                    .. attribute:: class_name
                                                                    
                                                                    	ClassName
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: shared_queue_id
                                                                    
                                                                    	q\-id of the  shared queue for this class
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: queue_descr
                                                                    
                                                                    	Description of queue for the class
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..256
                                                                    
                                                                    .. attribute:: cac_state
                                                                    
                                                                    	CACState
                                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                                    
                                                                    .. attribute:: queue_stats_array
                                                                    
                                                                    	array of queue stats
                                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                                    
                                                                    .. attribute:: police_stats_array
                                                                    
                                                                    	array of police stats
                                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                                    
                                                                    .. attribute:: wred_stats_array
                                                                    
                                                                    	array of red stats
                                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                        self.yang_name = "class-stats"
                                                                        self.yang_parent_name = "child-policy"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                        self._leafs = OrderedDict([
                                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                        ])
                                                                        self.counter_validity_bitmask = None
                                                                        self.class_name = None
                                                                        self.shared_queue_id = None
                                                                        self.queue_descr = None
                                                                        self.cac_state = None

                                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                        self.general_stats.parent = self
                                                                        self._children_name_map["general_stats"] = "general-stats"

                                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                        self.iphc_stats.parent = self
                                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                        self.cac_stats.parent = self
                                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                                        self.queue_stats_array = YList(self)
                                                                        self.police_stats_array = YList(self)
                                                                        self.wred_stats_array = YList(self)
                                                                        self._segment_path = lambda: "class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                                    class GeneralStats(Entity):
                                                                        """
                                                                        general stats
                                                                        
                                                                        .. attribute:: transmit_packets
                                                                        
                                                                        	Transmitted packets (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: transmit_bytes
                                                                        
                                                                        	Transmitted bytes (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: total_drop_packets
                                                                        
                                                                        	Dropped packets (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: total_drop_bytes
                                                                        
                                                                        	Dropped bytes (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: total_drop_rate
                                                                        
                                                                        	Total drop rate (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: match_data_rate
                                                                        
                                                                        	Incoming matched data rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: total_transmit_rate
                                                                        
                                                                        	Total transmit rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: pre_policy_matched_packets
                                                                        
                                                                        	Matched pkts before applying policy
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: pre_policy_matched_bytes
                                                                        
                                                                        	Matched bytes before applying policy
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                            self.yang_name = "general-stats"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                            ])
                                                                            self.transmit_packets = None
                                                                            self.transmit_bytes = None
                                                                            self.total_drop_packets = None
                                                                            self.total_drop_bytes = None
                                                                            self.total_drop_rate = None
                                                                            self.match_data_rate = None
                                                                            self.total_transmit_rate = None
                                                                            self.pre_policy_matched_packets = None
                                                                            self.pre_policy_matched_bytes = None
                                                                            self._segment_path = lambda: "general-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                                    class IphcStats(Entity):
                                                                        """
                                                                        IPHC stats
                                                                        
                                                                        .. attribute:: non_tcp_total_out_packets
                                                                        
                                                                        	TotalNum of Non tcp pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: non_tcp_total_out_bytes
                                                                        
                                                                        	TotalNum of Non Tcp Bytes sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: non_tcp_bytes_saved
                                                                        
                                                                        	Non Tcp Bytes saved due to compression
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: non_tcp_compressed_packets_out
                                                                        
                                                                        	Num of non tcp compressed pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                                        
                                                                        	Compressed Non Tcp Bytes sent rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: non_tcp_full_header_packets_out
                                                                        
                                                                        	Num of non tcp fullheader pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tcp_total_out_packets
                                                                        
                                                                        	Total Num of tcp pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tcp_total_out_bytes
                                                                        
                                                                        	TotalNum of Tcp Bytes sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: tcp_bytes_saved
                                                                        
                                                                        	Tcp Bytes saved due to compression
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: tcp_compressed_packets_out
                                                                        
                                                                        	Num of tcp compressed pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tcp_bytes_sent_rate
                                                                        
                                                                        	Compressed Tcp Bytes sent rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: tcp_full_header_packets_out
                                                                        
                                                                        	Num of tcp fullheader pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                            self.yang_name = "iphc-stats"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                            ])
                                                                            self.non_tcp_total_out_packets = None
                                                                            self.non_tcp_total_out_bytes = None
                                                                            self.non_tcp_bytes_saved = None
                                                                            self.non_tcp_compressed_packets_out = None
                                                                            self.non_tcp_bytes_sent_rate = None
                                                                            self.non_tcp_full_header_packets_out = None
                                                                            self.tcp_total_out_packets = None
                                                                            self.tcp_total_out_bytes = None
                                                                            self.tcp_bytes_saved = None
                                                                            self.tcp_compressed_packets_out = None
                                                                            self.tcp_bytes_sent_rate = None
                                                                            self.tcp_full_header_packets_out = None
                                                                            self._segment_path = lambda: "iphc-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                                    class CacStats(Entity):
                                                                        """
                                                                        bag for cac stats
                                                                        
                                                                        .. attribute:: drop_packets
                                                                        
                                                                        	CAC dropped packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: drop_bytes
                                                                        
                                                                        	CAC dropped bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: drop_rates
                                                                        
                                                                        	CAC dropped rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: admitpackets
                                                                        
                                                                        	Admitted packets (pkts/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: admit_bytes
                                                                        
                                                                        	Admitted bytes (pkts/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: admit_rates
                                                                        
                                                                        	CAC admit rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                            self.yang_name = "cac-stats"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                            ])
                                                                            self.drop_packets = None
                                                                            self.drop_bytes = None
                                                                            self.drop_rates = None
                                                                            self.admitpackets = None
                                                                            self.admit_bytes = None
                                                                            self.admit_rates = None
                                                                            self._segment_path = lambda: "cac-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                                    class QueueStatsArray(Entity):
                                                                        """
                                                                        array of queue stats
                                                                        
                                                                        .. attribute:: queue_id
                                                                        
                                                                        	Queue Id used for Fabric Stats
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: tail_drop_packets
                                                                        
                                                                        	Packets tail dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tail_drop_bytes
                                                                        
                                                                        	Bytes tail dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: atm_clp0_drop_packets
                                                                        
                                                                        	ATP CLP 0 matched packets dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: atm_clp0_drop_bytes
                                                                        
                                                                        	ATP CLP 0 matched bytes dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: atm_clp1_drop_packets
                                                                        
                                                                        	ATP CLP 0 matched packets dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: atm_clp1_drop_bytes
                                                                        
                                                                        	ATP CLP 0 matched bytes dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: queue_drop_threshold
                                                                        
                                                                        	tail drop threshold of the queue in bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: forced_wred_stats_display
                                                                        
                                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                        	**type**\: bool
                                                                        
                                                                        .. attribute:: random_drop_packets
                                                                        
                                                                        	Packets probabilistically dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: random_drop_bytes
                                                                        
                                                                        	Bytes probabilistically dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: max_threshold_packets
                                                                        
                                                                        	Dropped packets with the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: max_threshold_bytes
                                                                        
                                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_packets
                                                                        
                                                                        	Packets that conform  to the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_bytes
                                                                        
                                                                        	Bytes that conform to the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_packets
                                                                        
                                                                        	Packets that exceed the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_bytes
                                                                        
                                                                        	Bytes that exceed  the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_rate
                                                                        
                                                                        	Conform rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: exceed_rate
                                                                        
                                                                        	Exceed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: queue_instance_length
                                                                        
                                                                        	Queue instance length
                                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                        
                                                                        .. attribute:: queue_average_length
                                                                        
                                                                        	Queue average length
                                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                        
                                                                        .. attribute:: queue_max_length
                                                                        
                                                                        	Queue maximum length
                                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                            self.yang_name = "queue-stats-array"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                            self._leafs = OrderedDict([
                                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                            ])
                                                                            self.queue_id = None
                                                                            self.tail_drop_packets = None
                                                                            self.tail_drop_bytes = None
                                                                            self.atm_clp0_drop_packets = None
                                                                            self.atm_clp0_drop_bytes = None
                                                                            self.atm_clp1_drop_packets = None
                                                                            self.atm_clp1_drop_bytes = None
                                                                            self.queue_drop_threshold = None
                                                                            self.forced_wred_stats_display = None
                                                                            self.random_drop_packets = None
                                                                            self.random_drop_bytes = None
                                                                            self.max_threshold_packets = None
                                                                            self.max_threshold_bytes = None
                                                                            self.conform_packets = None
                                                                            self.conform_bytes = None
                                                                            self.exceed_packets = None
                                                                            self.exceed_bytes = None
                                                                            self.conform_rate = None
                                                                            self.exceed_rate = None

                                                                            self.queue_instance_length = YList(self)
                                                                            self.queue_average_length = YList(self)
                                                                            self.queue_max_length = YList(self)
                                                                            self._segment_path = lambda: "queue-stats-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                        class QueueInstanceLength(Entity):
                                                                            """
                                                                            Queue instance length
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                                self.yang_name = "queue-instance-length"
                                                                                self.yang_parent_name = "queue-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "queue-instance-length"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                        class QueueAverageLength(Entity):
                                                                            """
                                                                            Queue average length
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                                self.yang_name = "queue-average-length"
                                                                                self.yang_parent_name = "queue-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "queue-average-length"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                        class QueueMaxLength(Entity):
                                                                            """
                                                                            Queue maximum length
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                                self.yang_name = "queue-max-length"
                                                                                self.yang_parent_name = "queue-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "queue-max-length"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                                    class PoliceStatsArray(Entity):
                                                                        """
                                                                        array of police stats
                                                                        
                                                                        .. attribute:: color_class_stats
                                                                        
                                                                        	color class stats
                                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                        
                                                                        .. attribute:: drop_packets
                                                                        
                                                                        	Police dropped packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: drop_bytes
                                                                        
                                                                        	Police dropped bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_packets
                                                                        
                                                                        	Packets that conform  to the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_bytes
                                                                        
                                                                        	Bytes that conform to the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_packets
                                                                        
                                                                        	Packets that exceed the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_bytes
                                                                        
                                                                        	Bytes that exceed  the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: violate_packets
                                                                        
                                                                        	Packets violating the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: violate_bytes
                                                                        
                                                                        	Bytes that violate the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: parent_drop_packets
                                                                        
                                                                        	Dropped pkts by the parent policer
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: parent_drop_bytes
                                                                        
                                                                        	Dropped bytes by the parent policer
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_rate
                                                                        
                                                                        	Conform rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_rate
                                                                        
                                                                        	Exceed rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: violate_rate
                                                                        
                                                                        	Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                            self.yang_name = "police-stats-array"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                            self._leafs = OrderedDict([
                                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                            ])
                                                                            self.drop_packets = None
                                                                            self.drop_bytes = None
                                                                            self.conform_packets = None
                                                                            self.conform_bytes = None
                                                                            self.exceed_packets = None
                                                                            self.exceed_bytes = None
                                                                            self.violate_packets = None
                                                                            self.violate_bytes = None
                                                                            self.parent_drop_packets = None
                                                                            self.parent_drop_bytes = None
                                                                            self.conform_rate = None
                                                                            self.exceed_rate = None
                                                                            self.violate_rate = None

                                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                            self.color_class_stats.parent = self
                                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                            self._segment_path = lambda: "police-stats-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                        class ColorClassStats(Entity):
                                                                            """
                                                                            color class stats
                                                                            
                                                                            .. attribute:: conform_class_conform_packets
                                                                            
                                                                            	Packets with classification result conform and policer result conform
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_class_conform_bytes
                                                                            
                                                                            	Bytes with classification result conform and policer result conform
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_class_conform_rate
                                                                            
                                                                            	Conform Class Conform rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: conform_class_exceed_packets
                                                                            
                                                                            	Packets with classification result conform and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_class_exceed_bytes
                                                                            
                                                                            	Bytes with classification result conform and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_class_exceed_rate
                                                                            
                                                                            	Conform Class Exceed rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: conform_class_violate_packets
                                                                            
                                                                            	Packets with classification result conform and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_class_violate_bytes
                                                                            
                                                                            	Bytes with classification result conform and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_class_violate_rate
                                                                            
                                                                            	Conform Class Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: exceed_class_exceed_packets
                                                                            
                                                                            	Packets with classification result exceed and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: exceed_class_exceed_bytes
                                                                            
                                                                            	Bytes with classification result exceed and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: exceed_class_exceed_rate
                                                                            
                                                                            	Exceed Class Exceed rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: exceed_class_violate_packets
                                                                            
                                                                            	Packets with classification result exceed and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: exceed_class_violate_bytes
                                                                            
                                                                            	Bytes with classification result exceed and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: exceed_class_violate_rate
                                                                            
                                                                            	Exceed Class Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: violate_class_violate_packets
                                                                            
                                                                            	Packets with classification result violate and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: violate_class_violate_bytes
                                                                            
                                                                            	Bytes with classification result violate and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: violate_class_violate_rate
                                                                            
                                                                            	Violate Class Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                                self.yang_name = "color-class-stats"
                                                                                self.yang_parent_name = "police-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                                ])
                                                                                self.conform_class_conform_packets = None
                                                                                self.conform_class_conform_bytes = None
                                                                                self.conform_class_conform_rate = None
                                                                                self.conform_class_exceed_packets = None
                                                                                self.conform_class_exceed_bytes = None
                                                                                self.conform_class_exceed_rate = None
                                                                                self.conform_class_violate_packets = None
                                                                                self.conform_class_violate_bytes = None
                                                                                self.conform_class_violate_rate = None
                                                                                self.exceed_class_exceed_packets = None
                                                                                self.exceed_class_exceed_bytes = None
                                                                                self.exceed_class_exceed_rate = None
                                                                                self.exceed_class_violate_packets = None
                                                                                self.exceed_class_violate_bytes = None
                                                                                self.exceed_class_violate_rate = None
                                                                                self.violate_class_violate_packets = None
                                                                                self.violate_class_violate_bytes = None
                                                                                self.violate_class_violate_rate = None
                                                                                self._segment_path = lambda: "color-class-stats"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                                    class WredStatsArray(Entity):
                                                                        """
                                                                        array of red stats
                                                                        
                                                                        .. attribute:: profile_title
                                                                        
                                                                        	ProfileTitle
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..300
                                                                        
                                                                        .. attribute:: red_transmit_packets
                                                                        
                                                                        	Transmitted packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: red_transmit_bytes
                                                                        
                                                                        	Transmitted bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: random_drop_packets
                                                                        
                                                                        	Probabilistically dropped  packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: random_drop_bytes
                                                                        
                                                                        	Probabilisticallydropped bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: max_threshold_packets
                                                                        
                                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: max_threshold_bytes
                                                                        
                                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: red_ecn_marked_packets
                                                                        
                                                                        	ECN marked packets 
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: red_ecn_marked_bytes
                                                                        
                                                                        	ECN marked bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: red_label
                                                                        
                                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                            self.yang_name = "wred-stats-array"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                            self._leafs = OrderedDict([
                                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                            ])
                                                                            self.profile_title = None
                                                                            self.red_transmit_packets = None
                                                                            self.red_transmit_bytes = None
                                                                            self.random_drop_packets = None
                                                                            self.random_drop_bytes = None
                                                                            self.max_threshold_packets = None
                                                                            self.max_threshold_bytes = None
                                                                            self.red_ecn_marked_packets = None
                                                                            self.red_ecn_marked_bytes = None

                                                                            self.red_label = YList(self)
                                                                            self._segment_path = lambda: "wred-stats-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                        class RedLabel(Entity):
                                                                            """
                                                                            Array of WRED Typevalues as in PRP stats is
                                                                            available per threshold   
                                                                            
                                                                            .. attribute:: wred_type
                                                                            
                                                                            	WRED type DSCP, EXP, PREC etc
                                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	WRED value for this type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                                self.yang_name = "red-label"
                                                                                self.yang_parent_name = "wred-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                                ])
                                                                                self.wred_type = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "red-label"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.drop_rates = None
                                                                    self.admitpackets = None
                                                                    self.admit_bytes = None
                                                                    self.admit_rates = None
                                                                    self._segment_path = lambda: "cac-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\: bool
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                                    self._leafs = OrderedDict([
                                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ])
                                                                    self.queue_id = None
                                                                    self.tail_drop_packets = None
                                                                    self.tail_drop_bytes = None
                                                                    self.atm_clp0_drop_packets = None
                                                                    self.atm_clp0_drop_bytes = None
                                                                    self.atm_clp1_drop_packets = None
                                                                    self.atm_clp1_drop_bytes = None
                                                                    self.queue_drop_threshold = None
                                                                    self.forced_wred_stats_display = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None

                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_max_length = YList(self)
                                                                    self._segment_path = lambda: "queue-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-instance-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-average-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-max-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.violate_packets = None
                                                                    self.violate_bytes = None
                                                                    self.parent_drop_packets = None
                                                                    self.parent_drop_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None
                                                                    self.violate_rate = None

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._segment_path = lambda: "police-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                        ])
                                                                        self.conform_class_conform_packets = None
                                                                        self.conform_class_conform_bytes = None
                                                                        self.conform_class_conform_rate = None
                                                                        self.conform_class_exceed_packets = None
                                                                        self.conform_class_exceed_bytes = None
                                                                        self.conform_class_exceed_rate = None
                                                                        self.conform_class_violate_packets = None
                                                                        self.conform_class_violate_bytes = None
                                                                        self.conform_class_violate_rate = None
                                                                        self.exceed_class_exceed_packets = None
                                                                        self.exceed_class_exceed_bytes = None
                                                                        self.exceed_class_exceed_rate = None
                                                                        self.exceed_class_violate_packets = None
                                                                        self.exceed_class_violate_bytes = None
                                                                        self.exceed_class_violate_rate = None
                                                                        self.violate_class_violate_packets = None
                                                                        self.violate_class_violate_bytes = None
                                                                        self.violate_class_violate_rate = None
                                                                        self._segment_path = lambda: "color-class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                                    self._leafs = OrderedDict([
                                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                    ])
                                                                    self.profile_title = None
                                                                    self.red_transmit_packets = None
                                                                    self.red_transmit_bytes = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.red_ecn_marked_packets = None
                                                                    self.red_ecn_marked_bytes = None

                                                                    self.red_label = YList(self)
                                                                    self._segment_path = lambda: "wred-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                        ])
                                                                        self.wred_type = None
                                                                        self.value = None
                                                                        self._segment_path = lambda: "red-label"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                class Input(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input, self).__init__()

                                        self.yang_name = "input"
                                        self.yang_parent_name = "member-interface"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._segment_path = lambda: "input"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input, [], name, value)


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "input"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance))])
                                            self._leafs = OrderedDict()

                                            self.service_policy_instance = YList(self)
                                            self._segment_path = lambda: "service-policy-names"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, [], name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  (key)
                                            
                                            	Name of the policy instance
                                            	**type**\: str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            .. attribute:: statistics
                                            
                                            	Policy\-map statistics operational data for an interface
                                            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = ['service_policy_name']
                                                self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                self._leafs = OrderedDict([
                                                    ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                ])
                                                self.service_policy_name = None

                                                self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                                self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                            class Statistics(Entity):
                                                """
                                                Policy\-map statistics operational data for an
                                                interface
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                    self.yang_name = "statistics"
                                                    self.yang_parent_name = "service-policy-instance"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "statistics"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: child_policy
                                                    
                                                    	child policy
                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "statistics"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class ChildPolicy(Entity):
                                                        """
                                                        child policy
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                            self.yang_name = "child-policy"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                            ])
                                                            self.policy_name = None
                                                            self.state = None
                                                            self.state_description = None
                                                            self.satid = None

                                                            self.class_stats = YList(self)
                                                            self._segment_path = lambda: "child-policy"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                        class ClassStats_(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "child-policy"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                self._leafs = OrderedDict([
                                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                ])
                                                                self.counter_validity_bitmask = None
                                                                self.class_name = None
                                                                self.shared_queue_id = None
                                                                self.queue_descr = None
                                                                self.cac_state = None

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                                self.queue_stats_array = YList(self)
                                                                self.police_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)
                                                                self._segment_path = lambda: "class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                    ])
                                                                    self.transmit_packets = None
                                                                    self.transmit_bytes = None
                                                                    self.total_drop_packets = None
                                                                    self.total_drop_bytes = None
                                                                    self.total_drop_rate = None
                                                                    self.match_data_rate = None
                                                                    self.total_transmit_rate = None
                                                                    self.pre_policy_matched_packets = None
                                                                    self.pre_policy_matched_bytes = None
                                                                    self._segment_path = lambda: "general-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                    ])
                                                                    self.non_tcp_total_out_packets = None
                                                                    self.non_tcp_total_out_bytes = None
                                                                    self.non_tcp_bytes_saved = None
                                                                    self.non_tcp_compressed_packets_out = None
                                                                    self.non_tcp_bytes_sent_rate = None
                                                                    self.non_tcp_full_header_packets_out = None
                                                                    self.tcp_total_out_packets = None
                                                                    self.tcp_total_out_bytes = None
                                                                    self.tcp_bytes_saved = None
                                                                    self.tcp_compressed_packets_out = None
                                                                    self.tcp_bytes_sent_rate = None
                                                                    self.tcp_full_header_packets_out = None
                                                                    self._segment_path = lambda: "iphc-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.drop_rates = None
                                                                    self.admitpackets = None
                                                                    self.admit_bytes = None
                                                                    self.admit_rates = None
                                                                    self._segment_path = lambda: "cac-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\: bool
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                    self._leafs = OrderedDict([
                                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ])
                                                                    self.queue_id = None
                                                                    self.tail_drop_packets = None
                                                                    self.tail_drop_bytes = None
                                                                    self.atm_clp0_drop_packets = None
                                                                    self.atm_clp0_drop_bytes = None
                                                                    self.atm_clp1_drop_packets = None
                                                                    self.atm_clp1_drop_bytes = None
                                                                    self.queue_drop_threshold = None
                                                                    self.forced_wred_stats_display = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None

                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_max_length = YList(self)
                                                                    self._segment_path = lambda: "queue-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-instance-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-average-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-max-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.violate_packets = None
                                                                    self.violate_bytes = None
                                                                    self.parent_drop_packets = None
                                                                    self.parent_drop_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None
                                                                    self.violate_rate = None

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._segment_path = lambda: "police-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                        ])
                                                                        self.conform_class_conform_packets = None
                                                                        self.conform_class_conform_bytes = None
                                                                        self.conform_class_conform_rate = None
                                                                        self.conform_class_exceed_packets = None
                                                                        self.conform_class_exceed_bytes = None
                                                                        self.conform_class_exceed_rate = None
                                                                        self.conform_class_violate_packets = None
                                                                        self.conform_class_violate_bytes = None
                                                                        self.conform_class_violate_rate = None
                                                                        self.exceed_class_exceed_packets = None
                                                                        self.exceed_class_exceed_bytes = None
                                                                        self.exceed_class_exceed_rate = None
                                                                        self.exceed_class_violate_packets = None
                                                                        self.exceed_class_violate_bytes = None
                                                                        self.exceed_class_violate_rate = None
                                                                        self.violate_class_violate_packets = None
                                                                        self.violate_class_violate_bytes = None
                                                                        self.violate_class_violate_rate = None
                                                                        self._segment_path = lambda: "color-class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                    self._leafs = OrderedDict([
                                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                    ])
                                                                    self.profile_title = None
                                                                    self.red_transmit_packets = None
                                                                    self.red_transmit_bytes = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.red_ecn_marked_packets = None
                                                                    self.red_ecn_marked_bytes = None

                                                                    self.red_label = YList(self)
                                                                    self._segment_path = lambda: "wred-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                        ])
                                                                        self.wred_type = None
                                                                        self.value = None
                                                                        self._segment_path = lambda: "red-label"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                class Output(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output, self).__init__()

                                        self.yang_name = "output"
                                        self.yang_parent_name = "member-interface"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._segment_path = lambda: "output"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output, [], name, value)


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "output"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance))])
                                            self._leafs = OrderedDict()

                                            self.service_policy_instance = YList(self)
                                            self._segment_path = lambda: "service-policy-names"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, [], name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  (key)
                                            
                                            	Name of the policy instance
                                            	**type**\: str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            .. attribute:: statistics
                                            
                                            	Policy\-map statistics operational data for an interface
                                            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = ['service_policy_name']
                                                self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                self._leafs = OrderedDict([
                                                    ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                ])
                                                self.service_policy_name = None

                                                self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                                self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                            class Statistics(Entity):
                                                """
                                                Policy\-map statistics operational data for an
                                                interface
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                    self.yang_name = "statistics"
                                                    self.yang_parent_name = "service-policy-instance"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "statistics"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: child_policy
                                                    
                                                    	child policy
                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "statistics"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class ChildPolicy(Entity):
                                                        """
                                                        child policy
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                            self.yang_name = "child-policy"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                            ])
                                                            self.policy_name = None
                                                            self.state = None
                                                            self.state_description = None
                                                            self.satid = None

                                                            self.class_stats = YList(self)
                                                            self._segment_path = lambda: "child-policy"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                        class ClassStats_(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "child-policy"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                self._leafs = OrderedDict([
                                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                ])
                                                                self.counter_validity_bitmask = None
                                                                self.class_name = None
                                                                self.shared_queue_id = None
                                                                self.queue_descr = None
                                                                self.cac_state = None

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                                self.queue_stats_array = YList(self)
                                                                self.police_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)
                                                                self._segment_path = lambda: "class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                    ])
                                                                    self.transmit_packets = None
                                                                    self.transmit_bytes = None
                                                                    self.total_drop_packets = None
                                                                    self.total_drop_bytes = None
                                                                    self.total_drop_rate = None
                                                                    self.match_data_rate = None
                                                                    self.total_transmit_rate = None
                                                                    self.pre_policy_matched_packets = None
                                                                    self.pre_policy_matched_bytes = None
                                                                    self._segment_path = lambda: "general-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                    ])
                                                                    self.non_tcp_total_out_packets = None
                                                                    self.non_tcp_total_out_bytes = None
                                                                    self.non_tcp_bytes_saved = None
                                                                    self.non_tcp_compressed_packets_out = None
                                                                    self.non_tcp_bytes_sent_rate = None
                                                                    self.non_tcp_full_header_packets_out = None
                                                                    self.tcp_total_out_packets = None
                                                                    self.tcp_total_out_bytes = None
                                                                    self.tcp_bytes_saved = None
                                                                    self.tcp_compressed_packets_out = None
                                                                    self.tcp_bytes_sent_rate = None
                                                                    self.tcp_full_header_packets_out = None
                                                                    self._segment_path = lambda: "iphc-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.drop_rates = None
                                                                    self.admitpackets = None
                                                                    self.admit_bytes = None
                                                                    self.admit_rates = None
                                                                    self._segment_path = lambda: "cac-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\: bool
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                    self._leafs = OrderedDict([
                                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ])
                                                                    self.queue_id = None
                                                                    self.tail_drop_packets = None
                                                                    self.tail_drop_bytes = None
                                                                    self.atm_clp0_drop_packets = None
                                                                    self.atm_clp0_drop_bytes = None
                                                                    self.atm_clp1_drop_packets = None
                                                                    self.atm_clp1_drop_bytes = None
                                                                    self.queue_drop_threshold = None
                                                                    self.forced_wred_stats_display = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None

                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_max_length = YList(self)
                                                                    self._segment_path = lambda: "queue-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-instance-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-average-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-max-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.violate_packets = None
                                                                    self.violate_bytes = None
                                                                    self.parent_drop_packets = None
                                                                    self.parent_drop_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None
                                                                    self.violate_rate = None

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._segment_path = lambda: "police-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                        ])
                                                                        self.conform_class_conform_packets = None
                                                                        self.conform_class_conform_bytes = None
                                                                        self.conform_class_conform_rate = None
                                                                        self.conform_class_exceed_packets = None
                                                                        self.conform_class_exceed_bytes = None
                                                                        self.conform_class_exceed_rate = None
                                                                        self.conform_class_violate_packets = None
                                                                        self.conform_class_violate_bytes = None
                                                                        self.conform_class_violate_rate = None
                                                                        self.exceed_class_exceed_packets = None
                                                                        self.exceed_class_exceed_bytes = None
                                                                        self.exceed_class_exceed_rate = None
                                                                        self.exceed_class_violate_packets = None
                                                                        self.exceed_class_violate_bytes = None
                                                                        self.exceed_class_violate_rate = None
                                                                        self.violate_class_violate_packets = None
                                                                        self.violate_class_violate_bytes = None
                                                                        self.violate_class_violate_rate = None
                                                                        self._segment_path = lambda: "color-class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                    self._leafs = OrderedDict([
                                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                    ])
                                                                    self.profile_title = None
                                                                    self.red_transmit_packets = None
                                                                    self.red_transmit_bytes = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.red_ecn_marked_packets = None
                                                                    self.red_ecn_marked_bytes = None

                                                                    self.red_label = YList(self)
                                                                    self._segment_path = lambda: "wred-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                        ])
                                                                        self.wred_type = None
                                                                        self.value = None
                                                                        self._segment_path = lambda: "red-label"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                        class Input(Entity):
                            """
                            A piece of QoS policy\-map operational data for
                            an interface
                            
                            .. attribute:: service_policy_names
                            
                            	Operational data for all Policy instance
                            	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input, self).__init__()

                                self.yang_name = "input"
                                self.yang_parent_name = "shared-policy-instance"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames))])
                                self._leafs = OrderedDict()

                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames()
                                self.service_policy_names.parent = self
                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                self._segment_path = lambda: "input"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input, [], name, value)


                            class ServicePolicyNames(Entity):
                                """
                                Operational data for all Policy instance
                                
                                .. attribute:: service_policy_instance
                                
                                	QoS policy\-map operational data for a particular Policy 
                                	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames, self).__init__()

                                    self.yang_name = "service-policy-names"
                                    self.yang_parent_name = "input"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance))])
                                    self._leafs = OrderedDict()

                                    self.service_policy_instance = YList(self)
                                    self._segment_path = lambda: "service-policy-names"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames, [], name, value)


                                class ServicePolicyInstance(Entity):
                                    """
                                    QoS policy\-map operational data for a
                                    particular Policy 
                                    
                                    .. attribute:: service_policy_name  (key)
                                    
                                    	Name of the policy instance
                                    	**type**\: str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    .. attribute:: statistics
                                    
                                    	Policy\-map statistics operational data for an interface
                                    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                        self.yang_name = "service-policy-instance"
                                        self.yang_parent_name = "service-policy-names"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = ['service_policy_name']
                                        self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                        self._leafs = OrderedDict([
                                            ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                        ])
                                        self.service_policy_name = None

                                        self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                        self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                    class Statistics(Entity):
                                        """
                                        Policy\-map statistics operational data for an
                                        interface
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\: str
                                        
                                        	**length:** 0..128
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                            self.yang_name = "statistics"
                                            self.yang_parent_name = "service-policy-instance"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                            self._leafs = OrderedDict([
                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                            ])
                                            self.policy_name = None
                                            self.state = None
                                            self.state_description = None
                                            self.satid = None

                                            self.class_stats = YList(self)
                                            self._segment_path = lambda: "statistics"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\: str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "statistics"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                self._leafs = OrderedDict([
                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                ])
                                                self.counter_validity_bitmask = None
                                                self.class_name = None
                                                self.shared_queue_id = None
                                                self.queue_descr = None
                                                self.cac_state = None

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                self.queue_stats_array = YList(self)
                                                self.police_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)
                                                self._segment_path = lambda: "class-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                    ])
                                                    self.transmit_packets = None
                                                    self.transmit_bytes = None
                                                    self.total_drop_packets = None
                                                    self.total_drop_bytes = None
                                                    self.total_drop_rate = None
                                                    self.match_data_rate = None
                                                    self.total_transmit_rate = None
                                                    self.pre_policy_matched_packets = None
                                                    self.pre_policy_matched_bytes = None
                                                    self._segment_path = lambda: "general-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                    ])
                                                    self.non_tcp_total_out_packets = None
                                                    self.non_tcp_total_out_bytes = None
                                                    self.non_tcp_bytes_saved = None
                                                    self.non_tcp_compressed_packets_out = None
                                                    self.non_tcp_bytes_sent_rate = None
                                                    self.non_tcp_full_header_packets_out = None
                                                    self.tcp_total_out_packets = None
                                                    self.tcp_total_out_bytes = None
                                                    self.tcp_bytes_saved = None
                                                    self.tcp_compressed_packets_out = None
                                                    self.tcp_bytes_sent_rate = None
                                                    self.tcp_full_header_packets_out = None
                                                    self._segment_path = lambda: "iphc-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "child-policy"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats_(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.drop_rates = None
                                                    self.admitpackets = None
                                                    self.admit_bytes = None
                                                    self.admit_rates = None
                                                    self._segment_path = lambda: "cac-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\: bool
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                    self._leafs = OrderedDict([
                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ])
                                                    self.queue_id = None
                                                    self.tail_drop_packets = None
                                                    self.tail_drop_bytes = None
                                                    self.atm_clp0_drop_packets = None
                                                    self.atm_clp0_drop_bytes = None
                                                    self.atm_clp1_drop_packets = None
                                                    self.atm_clp1_drop_bytes = None
                                                    self.queue_drop_threshold = None
                                                    self.forced_wred_stats_display = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None

                                                    self.queue_instance_length = YList(self)
                                                    self.queue_average_length = YList(self)
                                                    self.queue_max_length = YList(self)
                                                    self._segment_path = lambda: "queue-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-instance-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-average-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-max-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.violate_packets = None
                                                    self.violate_bytes = None
                                                    self.parent_drop_packets = None
                                                    self.parent_drop_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None
                                                    self.violate_rate = None

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._segment_path = lambda: "police-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                        ])
                                                        self.conform_class_conform_packets = None
                                                        self.conform_class_conform_bytes = None
                                                        self.conform_class_conform_rate = None
                                                        self.conform_class_exceed_packets = None
                                                        self.conform_class_exceed_bytes = None
                                                        self.conform_class_exceed_rate = None
                                                        self.conform_class_violate_packets = None
                                                        self.conform_class_violate_bytes = None
                                                        self.conform_class_violate_rate = None
                                                        self.exceed_class_exceed_packets = None
                                                        self.exceed_class_exceed_bytes = None
                                                        self.exceed_class_exceed_rate = None
                                                        self.exceed_class_violate_packets = None
                                                        self.exceed_class_violate_bytes = None
                                                        self.exceed_class_violate_rate = None
                                                        self.violate_class_violate_packets = None
                                                        self.violate_class_violate_bytes = None
                                                        self.violate_class_violate_rate = None
                                                        self._segment_path = lambda: "color-class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\: str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                    self._leafs = OrderedDict([
                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                    ])
                                                    self.profile_title = None
                                                    self.red_transmit_packets = None
                                                    self.red_transmit_bytes = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.red_ecn_marked_packets = None
                                                    self.red_ecn_marked_bytes = None

                                                    self.red_label = YList(self)
                                                    self._segment_path = lambda: "wred-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                        ])
                                                        self.wred_type = None
                                                        self.value = None
                                                        self._segment_path = lambda: "red-label"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                        class Output(Entity):
                            """
                            A piece of QoS policy\-map operational data for
                            an interface
                            
                            .. attribute:: service_policy_names
                            
                            	Operational data for all Policy instance
                            	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output, self).__init__()

                                self.yang_name = "output"
                                self.yang_parent_name = "shared-policy-instance"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames))])
                                self._leafs = OrderedDict()

                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames()
                                self.service_policy_names.parent = self
                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                self._segment_path = lambda: "output"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output, [], name, value)


                            class ServicePolicyNames(Entity):
                                """
                                Operational data for all Policy instance
                                
                                .. attribute:: service_policy_instance
                                
                                	QoS policy\-map operational data for a particular Policy 
                                	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames, self).__init__()

                                    self.yang_name = "service-policy-names"
                                    self.yang_parent_name = "output"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance))])
                                    self._leafs = OrderedDict()

                                    self.service_policy_instance = YList(self)
                                    self._segment_path = lambda: "service-policy-names"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames, [], name, value)


                                class ServicePolicyInstance(Entity):
                                    """
                                    QoS policy\-map operational data for a
                                    particular Policy 
                                    
                                    .. attribute:: service_policy_name  (key)
                                    
                                    	Name of the policy instance
                                    	**type**\: str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    .. attribute:: statistics
                                    
                                    	Policy\-map statistics operational data for an interface
                                    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                        self.yang_name = "service-policy-instance"
                                        self.yang_parent_name = "service-policy-names"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = ['service_policy_name']
                                        self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                        self._leafs = OrderedDict([
                                            ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                        ])
                                        self.service_policy_name = None

                                        self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                        self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                    class Statistics(Entity):
                                        """
                                        Policy\-map statistics operational data for an
                                        interface
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\: str
                                        
                                        	**length:** 0..128
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                            self.yang_name = "statistics"
                                            self.yang_parent_name = "service-policy-instance"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                            self._leafs = OrderedDict([
                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                            ])
                                            self.policy_name = None
                                            self.state = None
                                            self.state_description = None
                                            self.satid = None

                                            self.class_stats = YList(self)
                                            self._segment_path = lambda: "statistics"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\: str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "statistics"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                self._leafs = OrderedDict([
                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                ])
                                                self.counter_validity_bitmask = None
                                                self.class_name = None
                                                self.shared_queue_id = None
                                                self.queue_descr = None
                                                self.cac_state = None

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                self.queue_stats_array = YList(self)
                                                self.police_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)
                                                self._segment_path = lambda: "class-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                    ])
                                                    self.transmit_packets = None
                                                    self.transmit_bytes = None
                                                    self.total_drop_packets = None
                                                    self.total_drop_bytes = None
                                                    self.total_drop_rate = None
                                                    self.match_data_rate = None
                                                    self.total_transmit_rate = None
                                                    self.pre_policy_matched_packets = None
                                                    self.pre_policy_matched_bytes = None
                                                    self._segment_path = lambda: "general-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                    ])
                                                    self.non_tcp_total_out_packets = None
                                                    self.non_tcp_total_out_bytes = None
                                                    self.non_tcp_bytes_saved = None
                                                    self.non_tcp_compressed_packets_out = None
                                                    self.non_tcp_bytes_sent_rate = None
                                                    self.non_tcp_full_header_packets_out = None
                                                    self.tcp_total_out_packets = None
                                                    self.tcp_total_out_bytes = None
                                                    self.tcp_bytes_saved = None
                                                    self.tcp_compressed_packets_out = None
                                                    self.tcp_bytes_sent_rate = None
                                                    self.tcp_full_header_packets_out = None
                                                    self._segment_path = lambda: "iphc-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "child-policy"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats_(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.drop_rates = None
                                                    self.admitpackets = None
                                                    self.admit_bytes = None
                                                    self.admit_rates = None
                                                    self._segment_path = lambda: "cac-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\: bool
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                    self._leafs = OrderedDict([
                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ])
                                                    self.queue_id = None
                                                    self.tail_drop_packets = None
                                                    self.tail_drop_bytes = None
                                                    self.atm_clp0_drop_packets = None
                                                    self.atm_clp0_drop_bytes = None
                                                    self.atm_clp1_drop_packets = None
                                                    self.atm_clp1_drop_bytes = None
                                                    self.queue_drop_threshold = None
                                                    self.forced_wred_stats_display = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None

                                                    self.queue_instance_length = YList(self)
                                                    self.queue_average_length = YList(self)
                                                    self.queue_max_length = YList(self)
                                                    self._segment_path = lambda: "queue-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-instance-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-average-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-max-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.violate_packets = None
                                                    self.violate_bytes = None
                                                    self.parent_drop_packets = None
                                                    self.parent_drop_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None
                                                    self.violate_rate = None

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._segment_path = lambda: "police-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                        ])
                                                        self.conform_class_conform_packets = None
                                                        self.conform_class_conform_bytes = None
                                                        self.conform_class_conform_rate = None
                                                        self.conform_class_exceed_packets = None
                                                        self.conform_class_exceed_bytes = None
                                                        self.conform_class_exceed_rate = None
                                                        self.conform_class_violate_packets = None
                                                        self.conform_class_violate_bytes = None
                                                        self.conform_class_violate_rate = None
                                                        self.exceed_class_exceed_packets = None
                                                        self.exceed_class_exceed_bytes = None
                                                        self.exceed_class_exceed_rate = None
                                                        self.exceed_class_violate_packets = None
                                                        self.exceed_class_violate_bytes = None
                                                        self.exceed_class_violate_rate = None
                                                        self.violate_class_violate_packets = None
                                                        self.violate_class_violate_bytes = None
                                                        self.violate_class_violate_rate = None
                                                        self._segment_path = lambda: "color-class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\: str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                    self._leafs = OrderedDict([
                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                    ])
                                                    self.profile_title = None
                                                    self.red_transmit_packets = None
                                                    self.red_transmit_bytes = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.red_ecn_marked_packets = None
                                                    self.red_ecn_marked_bytes = None

                                                    self.red_label = YList(self)
                                                    self._segment_path = lambda: "wred-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                        ])
                                                        self.wred_type = None
                                                        self.value = None
                                                        self._segment_path = lambda: "red-label"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                class InterfaceTable(Entity):
                    """
                    Operational data for all interfaces
                    
                    .. attribute:: interface
                    
                    	QoS policy\-map operational data for a particular interface
                    	**type**\: list of  		 :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable, self).__init__()

                        self.yang_name = "interface-table"
                        self.yang_parent_name = "policy-map"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("interface", ("interface", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface))])
                        self._leafs = OrderedDict()

                        self.interface = YList(self)
                        self._segment_path = lambda: "interface-table"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable, [], name, value)


                    class Interface(Entity):
                        """
                        QoS policy\-map operational data for a particular
                        interface
                        
                        .. attribute:: interface_name  (key)
                        
                        	Name of the interface
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        .. attribute:: nodes
                        
                        	QoS policy\-map node table
                        	**type**\:  :py:class:`Nodes_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_>`
                        
                        .. attribute:: member_interfaces
                        
                        	QoS policy\-map member interface table
                        	**type**\:  :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces>`
                        
                        .. attribute:: satellite_ids
                        
                        	Satellite ID information
                        	**type**\:  :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds>`
                        
                        .. attribute:: input
                        
                        	A piece of QoS policy\-map operational data for an interface
                        	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input>`
                        
                        .. attribute:: output
                        
                        	A piece of QoS policy\-map operational data for an interface
                        	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface, self).__init__()

                            self.yang_name = "interface"
                            self.yang_parent_name = "interface-table"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['interface_name']
                            self._child_classes = OrderedDict([("nodes", ("nodes", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_)), ("member-interfaces", ("member_interfaces", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces)), ("satellite-ids", ("satellite_ids", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds)), ("input", ("input", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input)), ("output", ("output", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output))])
                            self._leafs = OrderedDict([
                                ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                            ])
                            self.interface_name = None

                            self.nodes = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_()
                            self.nodes.parent = self
                            self._children_name_map["nodes"] = "nodes"

                            self.member_interfaces = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces()
                            self.member_interfaces.parent = self
                            self._children_name_map["member_interfaces"] = "member-interfaces"

                            self.satellite_ids = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds()
                            self.satellite_ids.parent = self
                            self._children_name_map["satellite_ids"] = "satellite-ids"

                            self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input()
                            self.input.parent = self
                            self._children_name_map["input"] = "input"

                            self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output()
                            self.output.parent = self
                            self._children_name_map["output"] = "output"
                            self._segment_path = lambda: "interface" + "[interface-name='" + str(self.interface_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface, ['interface_name'], name, value)


                        class Nodes_(Entity):
                            """
                            QoS policy\-map node table
                            
                            .. attribute:: node
                            
                            	QoS operational data for a particular node
                            	**type**\: list of  		 :py:class:`Node_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_, self).__init__()

                                self.yang_name = "nodes"
                                self.yang_parent_name = "interface"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("node", ("node", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_))])
                                self._leafs = OrderedDict()

                                self.node = YList(self)
                                self._segment_path = lambda: "nodes"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_, [], name, value)


                            class Node_(Entity):
                                """
                                QoS operational data for a particular node
                                
                                .. attribute:: node_name  (key)
                                
                                	The node
                                	**type**\: str
                                
                                	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
                                
                                .. attribute:: input
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input>`
                                
                                .. attribute:: output
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_, self).__init__()

                                    self.yang_name = "node"
                                    self.yang_parent_name = "nodes"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['node_name']
                                    self._child_classes = OrderedDict([("input", ("input", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input)), ("output", ("output", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output))])
                                    self._leafs = OrderedDict([
                                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                    ])
                                    self.node_name = None

                                    self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input()
                                    self.input.parent = self
                                    self._children_name_map["input"] = "input"

                                    self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output()
                                    self.output.parent = self
                                    self._children_name_map["output"] = "output"
                                    self._segment_path = lambda: "node" + "[node-name='" + str(self.node_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_, ['node_name'], name, value)


                                class Input(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input, self).__init__()

                                        self.yang_name = "input"
                                        self.yang_parent_name = "node"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._segment_path = lambda: "input"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input, [], name, value)


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "input"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance))])
                                            self._leafs = OrderedDict()

                                            self.service_policy_instance = YList(self)
                                            self._segment_path = lambda: "service-policy-names"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames, [], name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  (key)
                                            
                                            	Name of the policy instance
                                            	**type**\: str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            .. attribute:: statistics
                                            
                                            	Policy\-map statistics operational data for an interface
                                            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = ['service_policy_name']
                                                self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                self._leafs = OrderedDict([
                                                    ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                ])
                                                self.service_policy_name = None

                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                                self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                            class Statistics(Entity):
                                                """
                                                Policy\-map statistics operational data for an
                                                interface
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                    self.yang_name = "statistics"
                                                    self.yang_parent_name = "service-policy-instance"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "statistics"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: child_policy
                                                    
                                                    	child policy
                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "statistics"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class ChildPolicy(Entity):
                                                        """
                                                        child policy
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                            self.yang_name = "child-policy"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                            ])
                                                            self.policy_name = None
                                                            self.state = None
                                                            self.state_description = None
                                                            self.satid = None

                                                            self.class_stats = YList(self)
                                                            self._segment_path = lambda: "child-policy"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                        class ClassStats_(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "child-policy"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                self._leafs = OrderedDict([
                                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                ])
                                                                self.counter_validity_bitmask = None
                                                                self.class_name = None
                                                                self.shared_queue_id = None
                                                                self.queue_descr = None
                                                                self.cac_state = None

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                                self.queue_stats_array = YList(self)
                                                                self.police_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)
                                                                self._segment_path = lambda: "class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                    ])
                                                                    self.transmit_packets = None
                                                                    self.transmit_bytes = None
                                                                    self.total_drop_packets = None
                                                                    self.total_drop_bytes = None
                                                                    self.total_drop_rate = None
                                                                    self.match_data_rate = None
                                                                    self.total_transmit_rate = None
                                                                    self.pre_policy_matched_packets = None
                                                                    self.pre_policy_matched_bytes = None
                                                                    self._segment_path = lambda: "general-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                    ])
                                                                    self.non_tcp_total_out_packets = None
                                                                    self.non_tcp_total_out_bytes = None
                                                                    self.non_tcp_bytes_saved = None
                                                                    self.non_tcp_compressed_packets_out = None
                                                                    self.non_tcp_bytes_sent_rate = None
                                                                    self.non_tcp_full_header_packets_out = None
                                                                    self.tcp_total_out_packets = None
                                                                    self.tcp_total_out_bytes = None
                                                                    self.tcp_bytes_saved = None
                                                                    self.tcp_compressed_packets_out = None
                                                                    self.tcp_bytes_sent_rate = None
                                                                    self.tcp_full_header_packets_out = None
                                                                    self._segment_path = lambda: "iphc-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.drop_rates = None
                                                                    self.admitpackets = None
                                                                    self.admit_bytes = None
                                                                    self.admit_rates = None
                                                                    self._segment_path = lambda: "cac-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\: bool
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                    self._leafs = OrderedDict([
                                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ])
                                                                    self.queue_id = None
                                                                    self.tail_drop_packets = None
                                                                    self.tail_drop_bytes = None
                                                                    self.atm_clp0_drop_packets = None
                                                                    self.atm_clp0_drop_bytes = None
                                                                    self.atm_clp1_drop_packets = None
                                                                    self.atm_clp1_drop_bytes = None
                                                                    self.queue_drop_threshold = None
                                                                    self.forced_wred_stats_display = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None

                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_max_length = YList(self)
                                                                    self._segment_path = lambda: "queue-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-instance-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-average-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-max-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.violate_packets = None
                                                                    self.violate_bytes = None
                                                                    self.parent_drop_packets = None
                                                                    self.parent_drop_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None
                                                                    self.violate_rate = None

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._segment_path = lambda: "police-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                        ])
                                                                        self.conform_class_conform_packets = None
                                                                        self.conform_class_conform_bytes = None
                                                                        self.conform_class_conform_rate = None
                                                                        self.conform_class_exceed_packets = None
                                                                        self.conform_class_exceed_bytes = None
                                                                        self.conform_class_exceed_rate = None
                                                                        self.conform_class_violate_packets = None
                                                                        self.conform_class_violate_bytes = None
                                                                        self.conform_class_violate_rate = None
                                                                        self.exceed_class_exceed_packets = None
                                                                        self.exceed_class_exceed_bytes = None
                                                                        self.exceed_class_exceed_rate = None
                                                                        self.exceed_class_violate_packets = None
                                                                        self.exceed_class_violate_bytes = None
                                                                        self.exceed_class_violate_rate = None
                                                                        self.violate_class_violate_packets = None
                                                                        self.violate_class_violate_bytes = None
                                                                        self.violate_class_violate_rate = None
                                                                        self._segment_path = lambda: "color-class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                    self._leafs = OrderedDict([
                                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                    ])
                                                                    self.profile_title = None
                                                                    self.red_transmit_packets = None
                                                                    self.red_transmit_bytes = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.red_ecn_marked_packets = None
                                                                    self.red_ecn_marked_bytes = None

                                                                    self.red_label = YList(self)
                                                                    self._segment_path = lambda: "wred-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                        ])
                                                                        self.wred_type = None
                                                                        self.value = None
                                                                        self._segment_path = lambda: "red-label"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                class Output(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output, self).__init__()

                                        self.yang_name = "output"
                                        self.yang_parent_name = "node"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._segment_path = lambda: "output"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output, [], name, value)


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "output"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance))])
                                            self._leafs = OrderedDict()

                                            self.service_policy_instance = YList(self)
                                            self._segment_path = lambda: "service-policy-names"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames, [], name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  (key)
                                            
                                            	Name of the policy instance
                                            	**type**\: str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            .. attribute:: statistics
                                            
                                            	Policy\-map statistics operational data for an interface
                                            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = ['service_policy_name']
                                                self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                self._leafs = OrderedDict([
                                                    ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                ])
                                                self.service_policy_name = None

                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                                self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                            class Statistics(Entity):
                                                """
                                                Policy\-map statistics operational data for an
                                                interface
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                    self.yang_name = "statistics"
                                                    self.yang_parent_name = "service-policy-instance"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "statistics"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: child_policy
                                                    
                                                    	child policy
                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "statistics"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class ChildPolicy(Entity):
                                                        """
                                                        child policy
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                            self.yang_name = "child-policy"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                            ])
                                                            self.policy_name = None
                                                            self.state = None
                                                            self.state_description = None
                                                            self.satid = None

                                                            self.class_stats = YList(self)
                                                            self._segment_path = lambda: "child-policy"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                        class ClassStats_(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "child-policy"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                self._leafs = OrderedDict([
                                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                ])
                                                                self.counter_validity_bitmask = None
                                                                self.class_name = None
                                                                self.shared_queue_id = None
                                                                self.queue_descr = None
                                                                self.cac_state = None

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                                self.queue_stats_array = YList(self)
                                                                self.police_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)
                                                                self._segment_path = lambda: "class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                    ])
                                                                    self.transmit_packets = None
                                                                    self.transmit_bytes = None
                                                                    self.total_drop_packets = None
                                                                    self.total_drop_bytes = None
                                                                    self.total_drop_rate = None
                                                                    self.match_data_rate = None
                                                                    self.total_transmit_rate = None
                                                                    self.pre_policy_matched_packets = None
                                                                    self.pre_policy_matched_bytes = None
                                                                    self._segment_path = lambda: "general-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                    ])
                                                                    self.non_tcp_total_out_packets = None
                                                                    self.non_tcp_total_out_bytes = None
                                                                    self.non_tcp_bytes_saved = None
                                                                    self.non_tcp_compressed_packets_out = None
                                                                    self.non_tcp_bytes_sent_rate = None
                                                                    self.non_tcp_full_header_packets_out = None
                                                                    self.tcp_total_out_packets = None
                                                                    self.tcp_total_out_bytes = None
                                                                    self.tcp_bytes_saved = None
                                                                    self.tcp_compressed_packets_out = None
                                                                    self.tcp_bytes_sent_rate = None
                                                                    self.tcp_full_header_packets_out = None
                                                                    self._segment_path = lambda: "iphc-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.drop_rates = None
                                                                    self.admitpackets = None
                                                                    self.admit_bytes = None
                                                                    self.admit_rates = None
                                                                    self._segment_path = lambda: "cac-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\: bool
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                    self._leafs = OrderedDict([
                                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ])
                                                                    self.queue_id = None
                                                                    self.tail_drop_packets = None
                                                                    self.tail_drop_bytes = None
                                                                    self.atm_clp0_drop_packets = None
                                                                    self.atm_clp0_drop_bytes = None
                                                                    self.atm_clp1_drop_packets = None
                                                                    self.atm_clp1_drop_bytes = None
                                                                    self.queue_drop_threshold = None
                                                                    self.forced_wred_stats_display = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None

                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_max_length = YList(self)
                                                                    self._segment_path = lambda: "queue-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-instance-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-average-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-max-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.violate_packets = None
                                                                    self.violate_bytes = None
                                                                    self.parent_drop_packets = None
                                                                    self.parent_drop_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None
                                                                    self.violate_rate = None

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._segment_path = lambda: "police-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                        ])
                                                                        self.conform_class_conform_packets = None
                                                                        self.conform_class_conform_bytes = None
                                                                        self.conform_class_conform_rate = None
                                                                        self.conform_class_exceed_packets = None
                                                                        self.conform_class_exceed_bytes = None
                                                                        self.conform_class_exceed_rate = None
                                                                        self.conform_class_violate_packets = None
                                                                        self.conform_class_violate_bytes = None
                                                                        self.conform_class_violate_rate = None
                                                                        self.exceed_class_exceed_packets = None
                                                                        self.exceed_class_exceed_bytes = None
                                                                        self.exceed_class_exceed_rate = None
                                                                        self.exceed_class_violate_packets = None
                                                                        self.exceed_class_violate_bytes = None
                                                                        self.exceed_class_violate_rate = None
                                                                        self.violate_class_violate_packets = None
                                                                        self.violate_class_violate_bytes = None
                                                                        self.violate_class_violate_rate = None
                                                                        self._segment_path = lambda: "color-class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                    self._leafs = OrderedDict([
                                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                    ])
                                                                    self.profile_title = None
                                                                    self.red_transmit_packets = None
                                                                    self.red_transmit_bytes = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.red_ecn_marked_packets = None
                                                                    self.red_ecn_marked_bytes = None

                                                                    self.red_label = YList(self)
                                                                    self._segment_path = lambda: "wred-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                        ])
                                                                        self.wred_type = None
                                                                        self.value = None
                                                                        self._segment_path = lambda: "red-label"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes_.Node_.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                        class MemberInterfaces(Entity):
                            """
                            QoS policy\-map member interface table
                            
                            .. attribute:: member_interface
                            
                            	QoS policy\-map member interface statistics
                            	**type**\: list of  		 :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces, self).__init__()

                                self.yang_name = "member-interfaces"
                                self.yang_parent_name = "interface"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("member-interface", ("member_interface", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface))])
                                self._leafs = OrderedDict()

                                self.member_interface = YList(self)
                                self._segment_path = lambda: "member-interfaces"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces, [], name, value)


                            class MemberInterface(Entity):
                                """
                                QoS policy\-map member interface statistics
                                
                                .. attribute:: interface_name  (key)
                                
                                	Name of member interface
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                .. attribute:: satellite_ids
                                
                                	Satellite ID information
                                	**type**\:  :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds>`
                                
                                .. attribute:: input
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input>`
                                
                                .. attribute:: output
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface, self).__init__()

                                    self.yang_name = "member-interface"
                                    self.yang_parent_name = "member-interfaces"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['interface_name']
                                    self._child_classes = OrderedDict([("satellite-ids", ("satellite_ids", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds)), ("input", ("input", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input)), ("output", ("output", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output))])
                                    self._leafs = OrderedDict([
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ])
                                    self.interface_name = None

                                    self.satellite_ids = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds()
                                    self.satellite_ids.parent = self
                                    self._children_name_map["satellite_ids"] = "satellite-ids"

                                    self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input()
                                    self.input.parent = self
                                    self._children_name_map["input"] = "input"

                                    self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output()
                                    self.output.parent = self
                                    self._children_name_map["output"] = "output"
                                    self._segment_path = lambda: "member-interface" + "[interface-name='" + str(self.interface_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface, ['interface_name'], name, value)


                                class SatelliteIds(Entity):
                                    """
                                    Satellite ID information
                                    
                                    .. attribute:: satellite_id
                                    
                                    	Satellite ID information
                                    	**type**\: list of  		 :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, self).__init__()

                                        self.yang_name = "satellite-ids"
                                        self.yang_parent_name = "member-interface"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("satellite-id", ("satellite_id", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId))])
                                        self._leafs = OrderedDict()

                                        self.satellite_id = YList(self)
                                        self._segment_path = lambda: "satellite-ids"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, [], name, value)


                                    class SatelliteId(Entity):
                                        """
                                        Satellite ID information
                                        
                                        .. attribute:: nv_satellite_id  (key)
                                        
                                        	Satellite ID
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: input
                                        
                                        	A piece of QoS policy\-map operational data for an interface
                                        	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input>`
                                        
                                        .. attribute:: output
                                        
                                        	A piece of QoS policy\-map operational data for an interface
                                        	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__init__()

                                            self.yang_name = "satellite-id"
                                            self.yang_parent_name = "satellite-ids"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = ['nv_satellite_id']
                                            self._child_classes = OrderedDict([("input", ("input", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input)), ("output", ("output", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output))])
                                            self._leafs = OrderedDict([
                                                ('nv_satellite_id', (YLeaf(YType.int32, 'nv-satellite-id'), ['int'])),
                                            ])
                                            self.nv_satellite_id = None

                                            self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                            self.input.parent = self
                                            self._children_name_map["input"] = "input"

                                            self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                            self.output.parent = self
                                            self._children_name_map["output"] = "output"
                                            self._segment_path = lambda: "satellite-id" + "[nv-satellite-id='" + str(self.nv_satellite_id) + "']"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, ['nv_satellite_id'], name, value)


                                        class Input(Entity):
                                            """
                                            A piece of QoS policy\-map operational data for
                                            an interface
                                            
                                            .. attribute:: service_policy_names
                                            
                                            	Operational data for all Policy instance
                                            	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, self).__init__()

                                                self.yang_name = "input"
                                                self.yang_parent_name = "satellite-id"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames))])
                                                self._leafs = OrderedDict()

                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                                self._segment_path = lambda: "input"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, [], name, value)


                                            class ServicePolicyNames(Entity):
                                                """
                                                Operational data for all Policy instance
                                                
                                                .. attribute:: service_policy_instance
                                                
                                                	QoS policy\-map operational data for a particular Policy 
                                                	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                                    self.yang_name = "service-policy-names"
                                                    self.yang_parent_name = "input"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance))])
                                                    self._leafs = OrderedDict()

                                                    self.service_policy_instance = YList(self)
                                                    self._segment_path = lambda: "service-policy-names"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, [], name, value)


                                                class ServicePolicyInstance(Entity):
                                                    """
                                                    QoS policy\-map operational data for a
                                                    particular Policy 
                                                    
                                                    .. attribute:: service_policy_name  (key)
                                                    
                                                    	Name of the policy instance
                                                    	**type**\: str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    .. attribute:: statistics
                                                    
                                                    	Policy\-map statistics operational data for an interface
                                                    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                        self.yang_name = "service-policy-instance"
                                                        self.yang_parent_name = "service-policy-names"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = ['service_policy_name']
                                                        self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                        self._leafs = OrderedDict([
                                                            ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                        ])
                                                        self.service_policy_name = None

                                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                        self.statistics.parent = self
                                                        self._children_name_map["statistics"] = "statistics"
                                                        self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                                    class Statistics(Entity):
                                                        """
                                                        Policy\-map statistics operational data for an
                                                        interface
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                            self.yang_name = "statistics"
                                                            self.yang_parent_name = "service-policy-instance"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                            ])
                                                            self.policy_name = None
                                                            self.state = None
                                                            self.state_description = None
                                                            self.satid = None

                                                            self.class_stats = YList(self)
                                                            self._segment_path = lambda: "statistics"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                        class ClassStats(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                            
                                                            .. attribute:: child_policy
                                                            
                                                            	child policy
                                                            	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "statistics"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                                self._leafs = OrderedDict([
                                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                ])
                                                                self.counter_validity_bitmask = None
                                                                self.class_name = None
                                                                self.shared_queue_id = None
                                                                self.queue_descr = None
                                                                self.cac_state = None

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                                self.child_policy.parent = self
                                                                self._children_name_map["child_policy"] = "child-policy"

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                                self.queue_stats_array = YList(self)
                                                                self.police_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)
                                                                self._segment_path = lambda: "class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                    ])
                                                                    self.transmit_packets = None
                                                                    self.transmit_bytes = None
                                                                    self.total_drop_packets = None
                                                                    self.total_drop_bytes = None
                                                                    self.total_drop_rate = None
                                                                    self.match_data_rate = None
                                                                    self.total_transmit_rate = None
                                                                    self.pre_policy_matched_packets = None
                                                                    self.pre_policy_matched_bytes = None
                                                                    self._segment_path = lambda: "general-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                    ])
                                                                    self.non_tcp_total_out_packets = None
                                                                    self.non_tcp_total_out_bytes = None
                                                                    self.non_tcp_bytes_saved = None
                                                                    self.non_tcp_compressed_packets_out = None
                                                                    self.non_tcp_bytes_sent_rate = None
                                                                    self.non_tcp_full_header_packets_out = None
                                                                    self.tcp_total_out_packets = None
                                                                    self.tcp_total_out_bytes = None
                                                                    self.tcp_bytes_saved = None
                                                                    self.tcp_compressed_packets_out = None
                                                                    self.tcp_bytes_sent_rate = None
                                                                    self.tcp_full_header_packets_out = None
                                                                    self._segment_path = lambda: "iphc-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                            class ChildPolicy(Entity):
                                                                """
                                                                child policy
                                                                
                                                                .. attribute:: policy_name
                                                                
                                                                	PolicyName
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: state
                                                                
                                                                	State
                                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                                
                                                                .. attribute:: state_description
                                                                
                                                                	StateDescription
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..128
                                                                
                                                                .. attribute:: satid
                                                                
                                                                	to maintain satellite id
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: class_stats
                                                                
                                                                	array of classes contained in policy
                                                                	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                                    self.yang_name = "child-policy"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                                    self._leafs = OrderedDict([
                                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                                    ])
                                                                    self.policy_name = None
                                                                    self.state = None
                                                                    self.state_description = None
                                                                    self.satid = None

                                                                    self.class_stats = YList(self)
                                                                    self._segment_path = lambda: "child-policy"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                                class ClassStats_(Entity):
                                                                    """
                                                                    array of classes contained in policy
                                                                    
                                                                    .. attribute:: general_stats
                                                                    
                                                                    	general stats
                                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                                    
                                                                    .. attribute:: iphc_stats
                                                                    
                                                                    	IPHC stats
                                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                                    
                                                                    .. attribute:: cac_stats
                                                                    
                                                                    	bag for cac stats
                                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                                    
                                                                    .. attribute:: counter_validity_bitmask
                                                                    
                                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: megabyte
                                                                    
                                                                    .. attribute:: class_name
                                                                    
                                                                    	ClassName
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: shared_queue_id
                                                                    
                                                                    	q\-id of the  shared queue for this class
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: queue_descr
                                                                    
                                                                    	Description of queue for the class
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..256
                                                                    
                                                                    .. attribute:: cac_state
                                                                    
                                                                    	CACState
                                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                                    
                                                                    .. attribute:: queue_stats_array
                                                                    
                                                                    	array of queue stats
                                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                                    
                                                                    .. attribute:: police_stats_array
                                                                    
                                                                    	array of police stats
                                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                                    
                                                                    .. attribute:: wred_stats_array
                                                                    
                                                                    	array of red stats
                                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                        self.yang_name = "class-stats"
                                                                        self.yang_parent_name = "child-policy"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                        self._leafs = OrderedDict([
                                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                        ])
                                                                        self.counter_validity_bitmask = None
                                                                        self.class_name = None
                                                                        self.shared_queue_id = None
                                                                        self.queue_descr = None
                                                                        self.cac_state = None

                                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                        self.general_stats.parent = self
                                                                        self._children_name_map["general_stats"] = "general-stats"

                                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                        self.iphc_stats.parent = self
                                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                        self.cac_stats.parent = self
                                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                                        self.queue_stats_array = YList(self)
                                                                        self.police_stats_array = YList(self)
                                                                        self.wred_stats_array = YList(self)
                                                                        self._segment_path = lambda: "class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                                    class GeneralStats(Entity):
                                                                        """
                                                                        general stats
                                                                        
                                                                        .. attribute:: transmit_packets
                                                                        
                                                                        	Transmitted packets (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: transmit_bytes
                                                                        
                                                                        	Transmitted bytes (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: total_drop_packets
                                                                        
                                                                        	Dropped packets (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: total_drop_bytes
                                                                        
                                                                        	Dropped bytes (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: total_drop_rate
                                                                        
                                                                        	Total drop rate (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: match_data_rate
                                                                        
                                                                        	Incoming matched data rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: total_transmit_rate
                                                                        
                                                                        	Total transmit rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: pre_policy_matched_packets
                                                                        
                                                                        	Matched pkts before applying policy
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: pre_policy_matched_bytes
                                                                        
                                                                        	Matched bytes before applying policy
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                            self.yang_name = "general-stats"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                            ])
                                                                            self.transmit_packets = None
                                                                            self.transmit_bytes = None
                                                                            self.total_drop_packets = None
                                                                            self.total_drop_bytes = None
                                                                            self.total_drop_rate = None
                                                                            self.match_data_rate = None
                                                                            self.total_transmit_rate = None
                                                                            self.pre_policy_matched_packets = None
                                                                            self.pre_policy_matched_bytes = None
                                                                            self._segment_path = lambda: "general-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                                    class IphcStats(Entity):
                                                                        """
                                                                        IPHC stats
                                                                        
                                                                        .. attribute:: non_tcp_total_out_packets
                                                                        
                                                                        	TotalNum of Non tcp pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: non_tcp_total_out_bytes
                                                                        
                                                                        	TotalNum of Non Tcp Bytes sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: non_tcp_bytes_saved
                                                                        
                                                                        	Non Tcp Bytes saved due to compression
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: non_tcp_compressed_packets_out
                                                                        
                                                                        	Num of non tcp compressed pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                                        
                                                                        	Compressed Non Tcp Bytes sent rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: non_tcp_full_header_packets_out
                                                                        
                                                                        	Num of non tcp fullheader pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tcp_total_out_packets
                                                                        
                                                                        	Total Num of tcp pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tcp_total_out_bytes
                                                                        
                                                                        	TotalNum of Tcp Bytes sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: tcp_bytes_saved
                                                                        
                                                                        	Tcp Bytes saved due to compression
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: tcp_compressed_packets_out
                                                                        
                                                                        	Num of tcp compressed pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tcp_bytes_sent_rate
                                                                        
                                                                        	Compressed Tcp Bytes sent rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: tcp_full_header_packets_out
                                                                        
                                                                        	Num of tcp fullheader pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                            self.yang_name = "iphc-stats"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                            ])
                                                                            self.non_tcp_total_out_packets = None
                                                                            self.non_tcp_total_out_bytes = None
                                                                            self.non_tcp_bytes_saved = None
                                                                            self.non_tcp_compressed_packets_out = None
                                                                            self.non_tcp_bytes_sent_rate = None
                                                                            self.non_tcp_full_header_packets_out = None
                                                                            self.tcp_total_out_packets = None
                                                                            self.tcp_total_out_bytes = None
                                                                            self.tcp_bytes_saved = None
                                                                            self.tcp_compressed_packets_out = None
                                                                            self.tcp_bytes_sent_rate = None
                                                                            self.tcp_full_header_packets_out = None
                                                                            self._segment_path = lambda: "iphc-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                                    class CacStats(Entity):
                                                                        """
                                                                        bag for cac stats
                                                                        
                                                                        .. attribute:: drop_packets
                                                                        
                                                                        	CAC dropped packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: drop_bytes
                                                                        
                                                                        	CAC dropped bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: drop_rates
                                                                        
                                                                        	CAC dropped rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: admitpackets
                                                                        
                                                                        	Admitted packets (pkts/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: admit_bytes
                                                                        
                                                                        	Admitted bytes (pkts/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: admit_rates
                                                                        
                                                                        	CAC admit rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                            self.yang_name = "cac-stats"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                            ])
                                                                            self.drop_packets = None
                                                                            self.drop_bytes = None
                                                                            self.drop_rates = None
                                                                            self.admitpackets = None
                                                                            self.admit_bytes = None
                                                                            self.admit_rates = None
                                                                            self._segment_path = lambda: "cac-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                                    class QueueStatsArray(Entity):
                                                                        """
                                                                        array of queue stats
                                                                        
                                                                        .. attribute:: queue_id
                                                                        
                                                                        	Queue Id used for Fabric Stats
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: tail_drop_packets
                                                                        
                                                                        	Packets tail dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tail_drop_bytes
                                                                        
                                                                        	Bytes tail dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: atm_clp0_drop_packets
                                                                        
                                                                        	ATP CLP 0 matched packets dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: atm_clp0_drop_bytes
                                                                        
                                                                        	ATP CLP 0 matched bytes dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: atm_clp1_drop_packets
                                                                        
                                                                        	ATP CLP 0 matched packets dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: atm_clp1_drop_bytes
                                                                        
                                                                        	ATP CLP 0 matched bytes dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: queue_drop_threshold
                                                                        
                                                                        	tail drop threshold of the queue in bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: forced_wred_stats_display
                                                                        
                                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                        	**type**\: bool
                                                                        
                                                                        .. attribute:: random_drop_packets
                                                                        
                                                                        	Packets probabilistically dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: random_drop_bytes
                                                                        
                                                                        	Bytes probabilistically dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: max_threshold_packets
                                                                        
                                                                        	Dropped packets with the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: max_threshold_bytes
                                                                        
                                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_packets
                                                                        
                                                                        	Packets that conform  to the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_bytes
                                                                        
                                                                        	Bytes that conform to the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_packets
                                                                        
                                                                        	Packets that exceed the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_bytes
                                                                        
                                                                        	Bytes that exceed  the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_rate
                                                                        
                                                                        	Conform rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: exceed_rate
                                                                        
                                                                        	Exceed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: queue_instance_length
                                                                        
                                                                        	Queue instance length
                                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                        
                                                                        .. attribute:: queue_average_length
                                                                        
                                                                        	Queue average length
                                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                        
                                                                        .. attribute:: queue_max_length
                                                                        
                                                                        	Queue maximum length
                                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                            self.yang_name = "queue-stats-array"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                            self._leafs = OrderedDict([
                                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                            ])
                                                                            self.queue_id = None
                                                                            self.tail_drop_packets = None
                                                                            self.tail_drop_bytes = None
                                                                            self.atm_clp0_drop_packets = None
                                                                            self.atm_clp0_drop_bytes = None
                                                                            self.atm_clp1_drop_packets = None
                                                                            self.atm_clp1_drop_bytes = None
                                                                            self.queue_drop_threshold = None
                                                                            self.forced_wred_stats_display = None
                                                                            self.random_drop_packets = None
                                                                            self.random_drop_bytes = None
                                                                            self.max_threshold_packets = None
                                                                            self.max_threshold_bytes = None
                                                                            self.conform_packets = None
                                                                            self.conform_bytes = None
                                                                            self.exceed_packets = None
                                                                            self.exceed_bytes = None
                                                                            self.conform_rate = None
                                                                            self.exceed_rate = None

                                                                            self.queue_instance_length = YList(self)
                                                                            self.queue_average_length = YList(self)
                                                                            self.queue_max_length = YList(self)
                                                                            self._segment_path = lambda: "queue-stats-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                        class QueueInstanceLength(Entity):
                                                                            """
                                                                            Queue instance length
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                                self.yang_name = "queue-instance-length"
                                                                                self.yang_parent_name = "queue-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "queue-instance-length"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                        class QueueAverageLength(Entity):
                                                                            """
                                                                            Queue average length
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                                self.yang_name = "queue-average-length"
                                                                                self.yang_parent_name = "queue-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "queue-average-length"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                        class QueueMaxLength(Entity):
                                                                            """
                                                                            Queue maximum length
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                                self.yang_name = "queue-max-length"
                                                                                self.yang_parent_name = "queue-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "queue-max-length"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                                    class PoliceStatsArray(Entity):
                                                                        """
                                                                        array of police stats
                                                                        
                                                                        .. attribute:: color_class_stats
                                                                        
                                                                        	color class stats
                                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                        
                                                                        .. attribute:: drop_packets
                                                                        
                                                                        	Police dropped packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: drop_bytes
                                                                        
                                                                        	Police dropped bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_packets
                                                                        
                                                                        	Packets that conform  to the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_bytes
                                                                        
                                                                        	Bytes that conform to the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_packets
                                                                        
                                                                        	Packets that exceed the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_bytes
                                                                        
                                                                        	Bytes that exceed  the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: violate_packets
                                                                        
                                                                        	Packets violating the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: violate_bytes
                                                                        
                                                                        	Bytes that violate the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: parent_drop_packets
                                                                        
                                                                        	Dropped pkts by the parent policer
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: parent_drop_bytes
                                                                        
                                                                        	Dropped bytes by the parent policer
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_rate
                                                                        
                                                                        	Conform rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_rate
                                                                        
                                                                        	Exceed rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: violate_rate
                                                                        
                                                                        	Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                            self.yang_name = "police-stats-array"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                            self._leafs = OrderedDict([
                                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                            ])
                                                                            self.drop_packets = None
                                                                            self.drop_bytes = None
                                                                            self.conform_packets = None
                                                                            self.conform_bytes = None
                                                                            self.exceed_packets = None
                                                                            self.exceed_bytes = None
                                                                            self.violate_packets = None
                                                                            self.violate_bytes = None
                                                                            self.parent_drop_packets = None
                                                                            self.parent_drop_bytes = None
                                                                            self.conform_rate = None
                                                                            self.exceed_rate = None
                                                                            self.violate_rate = None

                                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                            self.color_class_stats.parent = self
                                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                            self._segment_path = lambda: "police-stats-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                        class ColorClassStats(Entity):
                                                                            """
                                                                            color class stats
                                                                            
                                                                            .. attribute:: conform_class_conform_packets
                                                                            
                                                                            	Packets with classification result conform and policer result conform
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_class_conform_bytes
                                                                            
                                                                            	Bytes with classification result conform and policer result conform
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_class_conform_rate
                                                                            
                                                                            	Conform Class Conform rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: conform_class_exceed_packets
                                                                            
                                                                            	Packets with classification result conform and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_class_exceed_bytes
                                                                            
                                                                            	Bytes with classification result conform and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_class_exceed_rate
                                                                            
                                                                            	Conform Class Exceed rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: conform_class_violate_packets
                                                                            
                                                                            	Packets with classification result conform and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_class_violate_bytes
                                                                            
                                                                            	Bytes with classification result conform and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_class_violate_rate
                                                                            
                                                                            	Conform Class Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: exceed_class_exceed_packets
                                                                            
                                                                            	Packets with classification result exceed and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: exceed_class_exceed_bytes
                                                                            
                                                                            	Bytes with classification result exceed and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: exceed_class_exceed_rate
                                                                            
                                                                            	Exceed Class Exceed rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: exceed_class_violate_packets
                                                                            
                                                                            	Packets with classification result exceed and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: exceed_class_violate_bytes
                                                                            
                                                                            	Bytes with classification result exceed and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: exceed_class_violate_rate
                                                                            
                                                                            	Exceed Class Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: violate_class_violate_packets
                                                                            
                                                                            	Packets with classification result violate and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: violate_class_violate_bytes
                                                                            
                                                                            	Bytes with classification result violate and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: violate_class_violate_rate
                                                                            
                                                                            	Violate Class Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                                self.yang_name = "color-class-stats"
                                                                                self.yang_parent_name = "police-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                                ])
                                                                                self.conform_class_conform_packets = None
                                                                                self.conform_class_conform_bytes = None
                                                                                self.conform_class_conform_rate = None
                                                                                self.conform_class_exceed_packets = None
                                                                                self.conform_class_exceed_bytes = None
                                                                                self.conform_class_exceed_rate = None
                                                                                self.conform_class_violate_packets = None
                                                                                self.conform_class_violate_bytes = None
                                                                                self.conform_class_violate_rate = None
                                                                                self.exceed_class_exceed_packets = None
                                                                                self.exceed_class_exceed_bytes = None
                                                                                self.exceed_class_exceed_rate = None
                                                                                self.exceed_class_violate_packets = None
                                                                                self.exceed_class_violate_bytes = None
                                                                                self.exceed_class_violate_rate = None
                                                                                self.violate_class_violate_packets = None
                                                                                self.violate_class_violate_bytes = None
                                                                                self.violate_class_violate_rate = None
                                                                                self._segment_path = lambda: "color-class-stats"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                                    class WredStatsArray(Entity):
                                                                        """
                                                                        array of red stats
                                                                        
                                                                        .. attribute:: profile_title
                                                                        
                                                                        	ProfileTitle
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..300
                                                                        
                                                                        .. attribute:: red_transmit_packets
                                                                        
                                                                        	Transmitted packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: red_transmit_bytes
                                                                        
                                                                        	Transmitted bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: random_drop_packets
                                                                        
                                                                        	Probabilistically dropped  packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: random_drop_bytes
                                                                        
                                                                        	Probabilisticallydropped bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: max_threshold_packets
                                                                        
                                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: max_threshold_bytes
                                                                        
                                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: red_ecn_marked_packets
                                                                        
                                                                        	ECN marked packets 
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: red_ecn_marked_bytes
                                                                        
                                                                        	ECN marked bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: red_label
                                                                        
                                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                            self.yang_name = "wred-stats-array"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                            self._leafs = OrderedDict([
                                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                            ])
                                                                            self.profile_title = None
                                                                            self.red_transmit_packets = None
                                                                            self.red_transmit_bytes = None
                                                                            self.random_drop_packets = None
                                                                            self.random_drop_bytes = None
                                                                            self.max_threshold_packets = None
                                                                            self.max_threshold_bytes = None
                                                                            self.red_ecn_marked_packets = None
                                                                            self.red_ecn_marked_bytes = None

                                                                            self.red_label = YList(self)
                                                                            self._segment_path = lambda: "wred-stats-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                        class RedLabel(Entity):
                                                                            """
                                                                            Array of WRED Typevalues as in PRP stats is
                                                                            available per threshold   
                                                                            
                                                                            .. attribute:: wred_type
                                                                            
                                                                            	WRED type DSCP, EXP, PREC etc
                                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	WRED value for this type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                                self.yang_name = "red-label"
                                                                                self.yang_parent_name = "wred-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                                ])
                                                                                self.wred_type = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "red-label"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.drop_rates = None
                                                                    self.admitpackets = None
                                                                    self.admit_bytes = None
                                                                    self.admit_rates = None
                                                                    self._segment_path = lambda: "cac-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\: bool
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                                    self._leafs = OrderedDict([
                                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ])
                                                                    self.queue_id = None
                                                                    self.tail_drop_packets = None
                                                                    self.tail_drop_bytes = None
                                                                    self.atm_clp0_drop_packets = None
                                                                    self.atm_clp0_drop_bytes = None
                                                                    self.atm_clp1_drop_packets = None
                                                                    self.atm_clp1_drop_bytes = None
                                                                    self.queue_drop_threshold = None
                                                                    self.forced_wred_stats_display = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None

                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_max_length = YList(self)
                                                                    self._segment_path = lambda: "queue-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-instance-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-average-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-max-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.violate_packets = None
                                                                    self.violate_bytes = None
                                                                    self.parent_drop_packets = None
                                                                    self.parent_drop_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None
                                                                    self.violate_rate = None

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._segment_path = lambda: "police-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                        ])
                                                                        self.conform_class_conform_packets = None
                                                                        self.conform_class_conform_bytes = None
                                                                        self.conform_class_conform_rate = None
                                                                        self.conform_class_exceed_packets = None
                                                                        self.conform_class_exceed_bytes = None
                                                                        self.conform_class_exceed_rate = None
                                                                        self.conform_class_violate_packets = None
                                                                        self.conform_class_violate_bytes = None
                                                                        self.conform_class_violate_rate = None
                                                                        self.exceed_class_exceed_packets = None
                                                                        self.exceed_class_exceed_bytes = None
                                                                        self.exceed_class_exceed_rate = None
                                                                        self.exceed_class_violate_packets = None
                                                                        self.exceed_class_violate_bytes = None
                                                                        self.exceed_class_violate_rate = None
                                                                        self.violate_class_violate_packets = None
                                                                        self.violate_class_violate_bytes = None
                                                                        self.violate_class_violate_rate = None
                                                                        self._segment_path = lambda: "color-class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                                    self._leafs = OrderedDict([
                                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                    ])
                                                                    self.profile_title = None
                                                                    self.red_transmit_packets = None
                                                                    self.red_transmit_bytes = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.red_ecn_marked_packets = None
                                                                    self.red_ecn_marked_bytes = None

                                                                    self.red_label = YList(self)
                                                                    self._segment_path = lambda: "wred-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                        ])
                                                                        self.wred_type = None
                                                                        self.value = None
                                                                        self._segment_path = lambda: "red-label"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class Output(Entity):
                                            """
                                            A piece of QoS policy\-map operational data for
                                            an interface
                                            
                                            .. attribute:: service_policy_names
                                            
                                            	Operational data for all Policy instance
                                            	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, self).__init__()

                                                self.yang_name = "output"
                                                self.yang_parent_name = "satellite-id"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames))])
                                                self._leafs = OrderedDict()

                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                                self._segment_path = lambda: "output"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, [], name, value)


                                            class ServicePolicyNames(Entity):
                                                """
                                                Operational data for all Policy instance
                                                
                                                .. attribute:: service_policy_instance
                                                
                                                	QoS policy\-map operational data for a particular Policy 
                                                	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                                    self.yang_name = "service-policy-names"
                                                    self.yang_parent_name = "output"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance))])
                                                    self._leafs = OrderedDict()

                                                    self.service_policy_instance = YList(self)
                                                    self._segment_path = lambda: "service-policy-names"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, [], name, value)


                                                class ServicePolicyInstance(Entity):
                                                    """
                                                    QoS policy\-map operational data for a
                                                    particular Policy 
                                                    
                                                    .. attribute:: service_policy_name  (key)
                                                    
                                                    	Name of the policy instance
                                                    	**type**\: str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    .. attribute:: statistics
                                                    
                                                    	Policy\-map statistics operational data for an interface
                                                    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                        self.yang_name = "service-policy-instance"
                                                        self.yang_parent_name = "service-policy-names"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = ['service_policy_name']
                                                        self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                        self._leafs = OrderedDict([
                                                            ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                        ])
                                                        self.service_policy_name = None

                                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                        self.statistics.parent = self
                                                        self._children_name_map["statistics"] = "statistics"
                                                        self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                                    class Statistics(Entity):
                                                        """
                                                        Policy\-map statistics operational data for an
                                                        interface
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                            self.yang_name = "statistics"
                                                            self.yang_parent_name = "service-policy-instance"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                            ])
                                                            self.policy_name = None
                                                            self.state = None
                                                            self.state_description = None
                                                            self.satid = None

                                                            self.class_stats = YList(self)
                                                            self._segment_path = lambda: "statistics"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                        class ClassStats(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                            
                                                            .. attribute:: child_policy
                                                            
                                                            	child policy
                                                            	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "statistics"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                                self._leafs = OrderedDict([
                                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                ])
                                                                self.counter_validity_bitmask = None
                                                                self.class_name = None
                                                                self.shared_queue_id = None
                                                                self.queue_descr = None
                                                                self.cac_state = None

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                                self.child_policy.parent = self
                                                                self._children_name_map["child_policy"] = "child-policy"

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                                self.queue_stats_array = YList(self)
                                                                self.police_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)
                                                                self._segment_path = lambda: "class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                    ])
                                                                    self.transmit_packets = None
                                                                    self.transmit_bytes = None
                                                                    self.total_drop_packets = None
                                                                    self.total_drop_bytes = None
                                                                    self.total_drop_rate = None
                                                                    self.match_data_rate = None
                                                                    self.total_transmit_rate = None
                                                                    self.pre_policy_matched_packets = None
                                                                    self.pre_policy_matched_bytes = None
                                                                    self._segment_path = lambda: "general-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                    ])
                                                                    self.non_tcp_total_out_packets = None
                                                                    self.non_tcp_total_out_bytes = None
                                                                    self.non_tcp_bytes_saved = None
                                                                    self.non_tcp_compressed_packets_out = None
                                                                    self.non_tcp_bytes_sent_rate = None
                                                                    self.non_tcp_full_header_packets_out = None
                                                                    self.tcp_total_out_packets = None
                                                                    self.tcp_total_out_bytes = None
                                                                    self.tcp_bytes_saved = None
                                                                    self.tcp_compressed_packets_out = None
                                                                    self.tcp_bytes_sent_rate = None
                                                                    self.tcp_full_header_packets_out = None
                                                                    self._segment_path = lambda: "iphc-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                            class ChildPolicy(Entity):
                                                                """
                                                                child policy
                                                                
                                                                .. attribute:: policy_name
                                                                
                                                                	PolicyName
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: state
                                                                
                                                                	State
                                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                                
                                                                .. attribute:: state_description
                                                                
                                                                	StateDescription
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..128
                                                                
                                                                .. attribute:: satid
                                                                
                                                                	to maintain satellite id
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: class_stats
                                                                
                                                                	array of classes contained in policy
                                                                	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                                    self.yang_name = "child-policy"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                                    self._leafs = OrderedDict([
                                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                                    ])
                                                                    self.policy_name = None
                                                                    self.state = None
                                                                    self.state_description = None
                                                                    self.satid = None

                                                                    self.class_stats = YList(self)
                                                                    self._segment_path = lambda: "child-policy"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                                class ClassStats_(Entity):
                                                                    """
                                                                    array of classes contained in policy
                                                                    
                                                                    .. attribute:: general_stats
                                                                    
                                                                    	general stats
                                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                                    
                                                                    .. attribute:: iphc_stats
                                                                    
                                                                    	IPHC stats
                                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                                    
                                                                    .. attribute:: cac_stats
                                                                    
                                                                    	bag for cac stats
                                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                                    
                                                                    .. attribute:: counter_validity_bitmask
                                                                    
                                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: megabyte
                                                                    
                                                                    .. attribute:: class_name
                                                                    
                                                                    	ClassName
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: shared_queue_id
                                                                    
                                                                    	q\-id of the  shared queue for this class
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: queue_descr
                                                                    
                                                                    	Description of queue for the class
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..256
                                                                    
                                                                    .. attribute:: cac_state
                                                                    
                                                                    	CACState
                                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                                    
                                                                    .. attribute:: queue_stats_array
                                                                    
                                                                    	array of queue stats
                                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                                    
                                                                    .. attribute:: police_stats_array
                                                                    
                                                                    	array of police stats
                                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                                    
                                                                    .. attribute:: wred_stats_array
                                                                    
                                                                    	array of red stats
                                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                        self.yang_name = "class-stats"
                                                                        self.yang_parent_name = "child-policy"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                        self._leafs = OrderedDict([
                                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                        ])
                                                                        self.counter_validity_bitmask = None
                                                                        self.class_name = None
                                                                        self.shared_queue_id = None
                                                                        self.queue_descr = None
                                                                        self.cac_state = None

                                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                        self.general_stats.parent = self
                                                                        self._children_name_map["general_stats"] = "general-stats"

                                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                        self.iphc_stats.parent = self
                                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                        self.cac_stats.parent = self
                                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                                        self.queue_stats_array = YList(self)
                                                                        self.police_stats_array = YList(self)
                                                                        self.wred_stats_array = YList(self)
                                                                        self._segment_path = lambda: "class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                                    class GeneralStats(Entity):
                                                                        """
                                                                        general stats
                                                                        
                                                                        .. attribute:: transmit_packets
                                                                        
                                                                        	Transmitted packets (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: transmit_bytes
                                                                        
                                                                        	Transmitted bytes (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: total_drop_packets
                                                                        
                                                                        	Dropped packets (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: total_drop_bytes
                                                                        
                                                                        	Dropped bytes (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: total_drop_rate
                                                                        
                                                                        	Total drop rate (packets/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: match_data_rate
                                                                        
                                                                        	Incoming matched data rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: total_transmit_rate
                                                                        
                                                                        	Total transmit rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: pre_policy_matched_packets
                                                                        
                                                                        	Matched pkts before applying policy
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: pre_policy_matched_bytes
                                                                        
                                                                        	Matched bytes before applying policy
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                            self.yang_name = "general-stats"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                            ])
                                                                            self.transmit_packets = None
                                                                            self.transmit_bytes = None
                                                                            self.total_drop_packets = None
                                                                            self.total_drop_bytes = None
                                                                            self.total_drop_rate = None
                                                                            self.match_data_rate = None
                                                                            self.total_transmit_rate = None
                                                                            self.pre_policy_matched_packets = None
                                                                            self.pre_policy_matched_bytes = None
                                                                            self._segment_path = lambda: "general-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                                    class IphcStats(Entity):
                                                                        """
                                                                        IPHC stats
                                                                        
                                                                        .. attribute:: non_tcp_total_out_packets
                                                                        
                                                                        	TotalNum of Non tcp pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: non_tcp_total_out_bytes
                                                                        
                                                                        	TotalNum of Non Tcp Bytes sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: non_tcp_bytes_saved
                                                                        
                                                                        	Non Tcp Bytes saved due to compression
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: non_tcp_compressed_packets_out
                                                                        
                                                                        	Num of non tcp compressed pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                                        
                                                                        	Compressed Non Tcp Bytes sent rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: non_tcp_full_header_packets_out
                                                                        
                                                                        	Num of non tcp fullheader pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tcp_total_out_packets
                                                                        
                                                                        	Total Num of tcp pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tcp_total_out_bytes
                                                                        
                                                                        	TotalNum of Tcp Bytes sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: tcp_bytes_saved
                                                                        
                                                                        	Tcp Bytes saved due to compression
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: tcp_compressed_packets_out
                                                                        
                                                                        	Num of tcp compressed pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tcp_bytes_sent_rate
                                                                        
                                                                        	Compressed Tcp Bytes sent rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: tcp_full_header_packets_out
                                                                        
                                                                        	Num of tcp fullheader pkts sent
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                            self.yang_name = "iphc-stats"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                            ])
                                                                            self.non_tcp_total_out_packets = None
                                                                            self.non_tcp_total_out_bytes = None
                                                                            self.non_tcp_bytes_saved = None
                                                                            self.non_tcp_compressed_packets_out = None
                                                                            self.non_tcp_bytes_sent_rate = None
                                                                            self.non_tcp_full_header_packets_out = None
                                                                            self.tcp_total_out_packets = None
                                                                            self.tcp_total_out_bytes = None
                                                                            self.tcp_bytes_saved = None
                                                                            self.tcp_compressed_packets_out = None
                                                                            self.tcp_bytes_sent_rate = None
                                                                            self.tcp_full_header_packets_out = None
                                                                            self._segment_path = lambda: "iphc-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                                    class CacStats(Entity):
                                                                        """
                                                                        bag for cac stats
                                                                        
                                                                        .. attribute:: drop_packets
                                                                        
                                                                        	CAC dropped packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: drop_bytes
                                                                        
                                                                        	CAC dropped bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: drop_rates
                                                                        
                                                                        	CAC dropped rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: admitpackets
                                                                        
                                                                        	Admitted packets (pkts/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: admit_bytes
                                                                        
                                                                        	Admitted bytes (pkts/bytes)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: admit_rates
                                                                        
                                                                        	CAC admit rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                            self.yang_name = "cac-stats"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                            ])
                                                                            self.drop_packets = None
                                                                            self.drop_bytes = None
                                                                            self.drop_rates = None
                                                                            self.admitpackets = None
                                                                            self.admit_bytes = None
                                                                            self.admit_rates = None
                                                                            self._segment_path = lambda: "cac-stats"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                                    class QueueStatsArray(Entity):
                                                                        """
                                                                        array of queue stats
                                                                        
                                                                        .. attribute:: queue_id
                                                                        
                                                                        	Queue Id used for Fabric Stats
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: tail_drop_packets
                                                                        
                                                                        	Packets tail dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: tail_drop_bytes
                                                                        
                                                                        	Bytes tail dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: atm_clp0_drop_packets
                                                                        
                                                                        	ATP CLP 0 matched packets dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: atm_clp0_drop_bytes
                                                                        
                                                                        	ATP CLP 0 matched bytes dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: atm_clp1_drop_packets
                                                                        
                                                                        	ATP CLP 0 matched packets dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: atm_clp1_drop_bytes
                                                                        
                                                                        	ATP CLP 0 matched bytes dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: queue_drop_threshold
                                                                        
                                                                        	tail drop threshold of the queue in bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: forced_wred_stats_display
                                                                        
                                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                        	**type**\: bool
                                                                        
                                                                        .. attribute:: random_drop_packets
                                                                        
                                                                        	Packets probabilistically dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: random_drop_bytes
                                                                        
                                                                        	Bytes probabilistically dropped
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: max_threshold_packets
                                                                        
                                                                        	Dropped packets with the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: max_threshold_bytes
                                                                        
                                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_packets
                                                                        
                                                                        	Packets that conform  to the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_bytes
                                                                        
                                                                        	Bytes that conform to the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_packets
                                                                        
                                                                        	Packets that exceed the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_bytes
                                                                        
                                                                        	Bytes that exceed  the queue rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_rate
                                                                        
                                                                        	Conform rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: exceed_rate
                                                                        
                                                                        	Exceed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: queue_instance_length
                                                                        
                                                                        	Queue instance length
                                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                        
                                                                        .. attribute:: queue_average_length
                                                                        
                                                                        	Queue average length
                                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                        
                                                                        .. attribute:: queue_max_length
                                                                        
                                                                        	Queue maximum length
                                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                            self.yang_name = "queue-stats-array"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                            self._leafs = OrderedDict([
                                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                            ])
                                                                            self.queue_id = None
                                                                            self.tail_drop_packets = None
                                                                            self.tail_drop_bytes = None
                                                                            self.atm_clp0_drop_packets = None
                                                                            self.atm_clp0_drop_bytes = None
                                                                            self.atm_clp1_drop_packets = None
                                                                            self.atm_clp1_drop_bytes = None
                                                                            self.queue_drop_threshold = None
                                                                            self.forced_wred_stats_display = None
                                                                            self.random_drop_packets = None
                                                                            self.random_drop_bytes = None
                                                                            self.max_threshold_packets = None
                                                                            self.max_threshold_bytes = None
                                                                            self.conform_packets = None
                                                                            self.conform_bytes = None
                                                                            self.exceed_packets = None
                                                                            self.exceed_bytes = None
                                                                            self.conform_rate = None
                                                                            self.exceed_rate = None

                                                                            self.queue_instance_length = YList(self)
                                                                            self.queue_average_length = YList(self)
                                                                            self.queue_max_length = YList(self)
                                                                            self._segment_path = lambda: "queue-stats-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                        class QueueInstanceLength(Entity):
                                                                            """
                                                                            Queue instance length
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                                self.yang_name = "queue-instance-length"
                                                                                self.yang_parent_name = "queue-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "queue-instance-length"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                        class QueueAverageLength(Entity):
                                                                            """
                                                                            Queue average length
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                                self.yang_name = "queue-average-length"
                                                                                self.yang_parent_name = "queue-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "queue-average-length"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                        class QueueMaxLength(Entity):
                                                                            """
                                                                            Queue maximum length
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                                self.yang_name = "queue-max-length"
                                                                                self.yang_parent_name = "queue-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "queue-max-length"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                                    class PoliceStatsArray(Entity):
                                                                        """
                                                                        array of police stats
                                                                        
                                                                        .. attribute:: color_class_stats
                                                                        
                                                                        	color class stats
                                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                        
                                                                        .. attribute:: drop_packets
                                                                        
                                                                        	Police dropped packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: drop_bytes
                                                                        
                                                                        	Police dropped bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_packets
                                                                        
                                                                        	Packets that conform  to the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_bytes
                                                                        
                                                                        	Bytes that conform to the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_packets
                                                                        
                                                                        	Packets that exceed the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_bytes
                                                                        
                                                                        	Bytes that exceed  the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: violate_packets
                                                                        
                                                                        	Packets violating the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: violate_bytes
                                                                        
                                                                        	Bytes that violate the policed rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: parent_drop_packets
                                                                        
                                                                        	Dropped pkts by the parent policer
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: parent_drop_bytes
                                                                        
                                                                        	Dropped bytes by the parent policer
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_rate
                                                                        
                                                                        	Conform rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_rate
                                                                        
                                                                        	Exceed rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: violate_rate
                                                                        
                                                                        	Violate rate in kbps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                            self.yang_name = "police-stats-array"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                            self._leafs = OrderedDict([
                                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                            ])
                                                                            self.drop_packets = None
                                                                            self.drop_bytes = None
                                                                            self.conform_packets = None
                                                                            self.conform_bytes = None
                                                                            self.exceed_packets = None
                                                                            self.exceed_bytes = None
                                                                            self.violate_packets = None
                                                                            self.violate_bytes = None
                                                                            self.parent_drop_packets = None
                                                                            self.parent_drop_bytes = None
                                                                            self.conform_rate = None
                                                                            self.exceed_rate = None
                                                                            self.violate_rate = None

                                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                            self.color_class_stats.parent = self
                                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                            self._segment_path = lambda: "police-stats-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                        class ColorClassStats(Entity):
                                                                            """
                                                                            color class stats
                                                                            
                                                                            .. attribute:: conform_class_conform_packets
                                                                            
                                                                            	Packets with classification result conform and policer result conform
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_class_conform_bytes
                                                                            
                                                                            	Bytes with classification result conform and policer result conform
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_class_conform_rate
                                                                            
                                                                            	Conform Class Conform rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: conform_class_exceed_packets
                                                                            
                                                                            	Packets with classification result conform and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_class_exceed_bytes
                                                                            
                                                                            	Bytes with classification result conform and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_class_exceed_rate
                                                                            
                                                                            	Conform Class Exceed rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: conform_class_violate_packets
                                                                            
                                                                            	Packets with classification result conform and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: conform_class_violate_bytes
                                                                            
                                                                            	Bytes with classification result conform and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: conform_class_violate_rate
                                                                            
                                                                            	Conform Class Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: exceed_class_exceed_packets
                                                                            
                                                                            	Packets with classification result exceed and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: exceed_class_exceed_bytes
                                                                            
                                                                            	Bytes with classification result exceed and policer result exceed
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: exceed_class_exceed_rate
                                                                            
                                                                            	Exceed Class Exceed rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: exceed_class_violate_packets
                                                                            
                                                                            	Packets with classification result exceed and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: exceed_class_violate_bytes
                                                                            
                                                                            	Bytes with classification result exceed and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: exceed_class_violate_rate
                                                                            
                                                                            	Exceed Class Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            .. attribute:: violate_class_violate_packets
                                                                            
                                                                            	Packets with classification result violate and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: violate_class_violate_bytes
                                                                            
                                                                            	Bytes with classification result violate and policer result violate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: violate_class_violate_rate
                                                                            
                                                                            	Violate Class Violate rate in kbps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: kbit/s
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                                self.yang_name = "color-class-stats"
                                                                                self.yang_parent_name = "police-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                                ])
                                                                                self.conform_class_conform_packets = None
                                                                                self.conform_class_conform_bytes = None
                                                                                self.conform_class_conform_rate = None
                                                                                self.conform_class_exceed_packets = None
                                                                                self.conform_class_exceed_bytes = None
                                                                                self.conform_class_exceed_rate = None
                                                                                self.conform_class_violate_packets = None
                                                                                self.conform_class_violate_bytes = None
                                                                                self.conform_class_violate_rate = None
                                                                                self.exceed_class_exceed_packets = None
                                                                                self.exceed_class_exceed_bytes = None
                                                                                self.exceed_class_exceed_rate = None
                                                                                self.exceed_class_violate_packets = None
                                                                                self.exceed_class_violate_bytes = None
                                                                                self.exceed_class_violate_rate = None
                                                                                self.violate_class_violate_packets = None
                                                                                self.violate_class_violate_bytes = None
                                                                                self.violate_class_violate_rate = None
                                                                                self._segment_path = lambda: "color-class-stats"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                                    class WredStatsArray(Entity):
                                                                        """
                                                                        array of red stats
                                                                        
                                                                        .. attribute:: profile_title
                                                                        
                                                                        	ProfileTitle
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..300
                                                                        
                                                                        .. attribute:: red_transmit_packets
                                                                        
                                                                        	Transmitted packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: red_transmit_bytes
                                                                        
                                                                        	Transmitted bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: random_drop_packets
                                                                        
                                                                        	Probabilistically dropped  packets
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: random_drop_bytes
                                                                        
                                                                        	Probabilisticallydropped bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: max_threshold_packets
                                                                        
                                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: max_threshold_bytes
                                                                        
                                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: red_ecn_marked_packets
                                                                        
                                                                        	ECN marked packets 
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: red_ecn_marked_bytes
                                                                        
                                                                        	ECN marked bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: red_label
                                                                        
                                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-09-13'

                                                                        def __init__(self):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                            self.yang_name = "wred-stats-array"
                                                                            self.yang_parent_name = "class-stats"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                            self._leafs = OrderedDict([
                                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                            ])
                                                                            self.profile_title = None
                                                                            self.red_transmit_packets = None
                                                                            self.red_transmit_bytes = None
                                                                            self.random_drop_packets = None
                                                                            self.random_drop_bytes = None
                                                                            self.max_threshold_packets = None
                                                                            self.max_threshold_bytes = None
                                                                            self.red_ecn_marked_packets = None
                                                                            self.red_ecn_marked_bytes = None

                                                                            self.red_label = YList(self)
                                                                            self._segment_path = lambda: "wred-stats-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                        class RedLabel(Entity):
                                                                            """
                                                                            Array of WRED Typevalues as in PRP stats is
                                                                            available per threshold   
                                                                            
                                                                            .. attribute:: wred_type
                                                                            
                                                                            	WRED type DSCP, EXP, PREC etc
                                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	WRED value for this type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'qos-ma-oper'
                                                                            _revision = '2017-09-13'

                                                                            def __init__(self):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                                self.yang_name = "red-label"
                                                                                self.yang_parent_name = "wred-stats-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                                ])
                                                                                self.wred_type = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "red-label"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.drop_rates = None
                                                                    self.admitpackets = None
                                                                    self.admit_bytes = None
                                                                    self.admit_rates = None
                                                                    self._segment_path = lambda: "cac-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\: bool
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                                    self._leafs = OrderedDict([
                                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ])
                                                                    self.queue_id = None
                                                                    self.tail_drop_packets = None
                                                                    self.tail_drop_bytes = None
                                                                    self.atm_clp0_drop_packets = None
                                                                    self.atm_clp0_drop_bytes = None
                                                                    self.atm_clp1_drop_packets = None
                                                                    self.atm_clp1_drop_bytes = None
                                                                    self.queue_drop_threshold = None
                                                                    self.forced_wred_stats_display = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None

                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_max_length = YList(self)
                                                                    self._segment_path = lambda: "queue-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-instance-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-average-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-max-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.violate_packets = None
                                                                    self.violate_bytes = None
                                                                    self.parent_drop_packets = None
                                                                    self.parent_drop_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None
                                                                    self.violate_rate = None

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._segment_path = lambda: "police-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                        ])
                                                                        self.conform_class_conform_packets = None
                                                                        self.conform_class_conform_bytes = None
                                                                        self.conform_class_conform_rate = None
                                                                        self.conform_class_exceed_packets = None
                                                                        self.conform_class_exceed_bytes = None
                                                                        self.conform_class_exceed_rate = None
                                                                        self.conform_class_violate_packets = None
                                                                        self.conform_class_violate_bytes = None
                                                                        self.conform_class_violate_rate = None
                                                                        self.exceed_class_exceed_packets = None
                                                                        self.exceed_class_exceed_bytes = None
                                                                        self.exceed_class_exceed_rate = None
                                                                        self.exceed_class_violate_packets = None
                                                                        self.exceed_class_violate_bytes = None
                                                                        self.exceed_class_violate_rate = None
                                                                        self.violate_class_violate_packets = None
                                                                        self.violate_class_violate_bytes = None
                                                                        self.violate_class_violate_rate = None
                                                                        self._segment_path = lambda: "color-class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                                    self._leafs = OrderedDict([
                                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                    ])
                                                                    self.profile_title = None
                                                                    self.red_transmit_packets = None
                                                                    self.red_transmit_bytes = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.red_ecn_marked_packets = None
                                                                    self.red_ecn_marked_bytes = None

                                                                    self.red_label = YList(self)
                                                                    self._segment_path = lambda: "wred-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                        ])
                                                                        self.wred_type = None
                                                                        self.value = None
                                                                        self._segment_path = lambda: "red-label"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                class Input(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input, self).__init__()

                                        self.yang_name = "input"
                                        self.yang_parent_name = "member-interface"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._segment_path = lambda: "input"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input, [], name, value)


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "input"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance))])
                                            self._leafs = OrderedDict()

                                            self.service_policy_instance = YList(self)
                                            self._segment_path = lambda: "service-policy-names"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, [], name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  (key)
                                            
                                            	Name of the policy instance
                                            	**type**\: str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            .. attribute:: statistics
                                            
                                            	Policy\-map statistics operational data for an interface
                                            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = ['service_policy_name']
                                                self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                self._leafs = OrderedDict([
                                                    ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                ])
                                                self.service_policy_name = None

                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                                self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                            class Statistics(Entity):
                                                """
                                                Policy\-map statistics operational data for an
                                                interface
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                    self.yang_name = "statistics"
                                                    self.yang_parent_name = "service-policy-instance"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "statistics"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: child_policy
                                                    
                                                    	child policy
                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "statistics"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class ChildPolicy(Entity):
                                                        """
                                                        child policy
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                            self.yang_name = "child-policy"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                            ])
                                                            self.policy_name = None
                                                            self.state = None
                                                            self.state_description = None
                                                            self.satid = None

                                                            self.class_stats = YList(self)
                                                            self._segment_path = lambda: "child-policy"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                        class ClassStats_(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "child-policy"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                self._leafs = OrderedDict([
                                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                ])
                                                                self.counter_validity_bitmask = None
                                                                self.class_name = None
                                                                self.shared_queue_id = None
                                                                self.queue_descr = None
                                                                self.cac_state = None

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                                self.queue_stats_array = YList(self)
                                                                self.police_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)
                                                                self._segment_path = lambda: "class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                    ])
                                                                    self.transmit_packets = None
                                                                    self.transmit_bytes = None
                                                                    self.total_drop_packets = None
                                                                    self.total_drop_bytes = None
                                                                    self.total_drop_rate = None
                                                                    self.match_data_rate = None
                                                                    self.total_transmit_rate = None
                                                                    self.pre_policy_matched_packets = None
                                                                    self.pre_policy_matched_bytes = None
                                                                    self._segment_path = lambda: "general-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                    ])
                                                                    self.non_tcp_total_out_packets = None
                                                                    self.non_tcp_total_out_bytes = None
                                                                    self.non_tcp_bytes_saved = None
                                                                    self.non_tcp_compressed_packets_out = None
                                                                    self.non_tcp_bytes_sent_rate = None
                                                                    self.non_tcp_full_header_packets_out = None
                                                                    self.tcp_total_out_packets = None
                                                                    self.tcp_total_out_bytes = None
                                                                    self.tcp_bytes_saved = None
                                                                    self.tcp_compressed_packets_out = None
                                                                    self.tcp_bytes_sent_rate = None
                                                                    self.tcp_full_header_packets_out = None
                                                                    self._segment_path = lambda: "iphc-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.drop_rates = None
                                                                    self.admitpackets = None
                                                                    self.admit_bytes = None
                                                                    self.admit_rates = None
                                                                    self._segment_path = lambda: "cac-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\: bool
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                    self._leafs = OrderedDict([
                                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ])
                                                                    self.queue_id = None
                                                                    self.tail_drop_packets = None
                                                                    self.tail_drop_bytes = None
                                                                    self.atm_clp0_drop_packets = None
                                                                    self.atm_clp0_drop_bytes = None
                                                                    self.atm_clp1_drop_packets = None
                                                                    self.atm_clp1_drop_bytes = None
                                                                    self.queue_drop_threshold = None
                                                                    self.forced_wred_stats_display = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None

                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_max_length = YList(self)
                                                                    self._segment_path = lambda: "queue-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-instance-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-average-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-max-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.violate_packets = None
                                                                    self.violate_bytes = None
                                                                    self.parent_drop_packets = None
                                                                    self.parent_drop_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None
                                                                    self.violate_rate = None

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._segment_path = lambda: "police-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                        ])
                                                                        self.conform_class_conform_packets = None
                                                                        self.conform_class_conform_bytes = None
                                                                        self.conform_class_conform_rate = None
                                                                        self.conform_class_exceed_packets = None
                                                                        self.conform_class_exceed_bytes = None
                                                                        self.conform_class_exceed_rate = None
                                                                        self.conform_class_violate_packets = None
                                                                        self.conform_class_violate_bytes = None
                                                                        self.conform_class_violate_rate = None
                                                                        self.exceed_class_exceed_packets = None
                                                                        self.exceed_class_exceed_bytes = None
                                                                        self.exceed_class_exceed_rate = None
                                                                        self.exceed_class_violate_packets = None
                                                                        self.exceed_class_violate_bytes = None
                                                                        self.exceed_class_violate_rate = None
                                                                        self.violate_class_violate_packets = None
                                                                        self.violate_class_violate_bytes = None
                                                                        self.violate_class_violate_rate = None
                                                                        self._segment_path = lambda: "color-class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                    self._leafs = OrderedDict([
                                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                    ])
                                                                    self.profile_title = None
                                                                    self.red_transmit_packets = None
                                                                    self.red_transmit_bytes = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.red_ecn_marked_packets = None
                                                                    self.red_ecn_marked_bytes = None

                                                                    self.red_label = YList(self)
                                                                    self._segment_path = lambda: "wred-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                        ])
                                                                        self.wred_type = None
                                                                        self.value = None
                                                                        self._segment_path = lambda: "red-label"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                class Output(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output, self).__init__()

                                        self.yang_name = "output"
                                        self.yang_parent_name = "member-interface"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._segment_path = lambda: "output"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output, [], name, value)


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "output"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance))])
                                            self._leafs = OrderedDict()

                                            self.service_policy_instance = YList(self)
                                            self._segment_path = lambda: "service-policy-names"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, [], name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  (key)
                                            
                                            	Name of the policy instance
                                            	**type**\: str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            .. attribute:: statistics
                                            
                                            	Policy\-map statistics operational data for an interface
                                            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = ['service_policy_name']
                                                self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                self._leafs = OrderedDict([
                                                    ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                ])
                                                self.service_policy_name = None

                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                                self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                            class Statistics(Entity):
                                                """
                                                Policy\-map statistics operational data for an
                                                interface
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                    self.yang_name = "statistics"
                                                    self.yang_parent_name = "service-policy-instance"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "statistics"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: child_policy
                                                    
                                                    	child policy
                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "statistics"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class ChildPolicy(Entity):
                                                        """
                                                        child policy
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                            self.yang_name = "child-policy"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                            ])
                                                            self.policy_name = None
                                                            self.state = None
                                                            self.state_description = None
                                                            self.satid = None

                                                            self.class_stats = YList(self)
                                                            self._segment_path = lambda: "child-policy"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                        class ClassStats_(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "child-policy"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                self._leafs = OrderedDict([
                                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                ])
                                                                self.counter_validity_bitmask = None
                                                                self.class_name = None
                                                                self.shared_queue_id = None
                                                                self.queue_descr = None
                                                                self.cac_state = None

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                                self.queue_stats_array = YList(self)
                                                                self.police_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)
                                                                self._segment_path = lambda: "class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                    ])
                                                                    self.transmit_packets = None
                                                                    self.transmit_bytes = None
                                                                    self.total_drop_packets = None
                                                                    self.total_drop_bytes = None
                                                                    self.total_drop_rate = None
                                                                    self.match_data_rate = None
                                                                    self.total_transmit_rate = None
                                                                    self.pre_policy_matched_packets = None
                                                                    self.pre_policy_matched_bytes = None
                                                                    self._segment_path = lambda: "general-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                    ])
                                                                    self.non_tcp_total_out_packets = None
                                                                    self.non_tcp_total_out_bytes = None
                                                                    self.non_tcp_bytes_saved = None
                                                                    self.non_tcp_compressed_packets_out = None
                                                                    self.non_tcp_bytes_sent_rate = None
                                                                    self.non_tcp_full_header_packets_out = None
                                                                    self.tcp_total_out_packets = None
                                                                    self.tcp_total_out_bytes = None
                                                                    self.tcp_bytes_saved = None
                                                                    self.tcp_compressed_packets_out = None
                                                                    self.tcp_bytes_sent_rate = None
                                                                    self.tcp_full_header_packets_out = None
                                                                    self._segment_path = lambda: "iphc-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.drop_rates = None
                                                                    self.admitpackets = None
                                                                    self.admit_bytes = None
                                                                    self.admit_rates = None
                                                                    self._segment_path = lambda: "cac-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\: bool
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                    self._leafs = OrderedDict([
                                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ])
                                                                    self.queue_id = None
                                                                    self.tail_drop_packets = None
                                                                    self.tail_drop_bytes = None
                                                                    self.atm_clp0_drop_packets = None
                                                                    self.atm_clp0_drop_bytes = None
                                                                    self.atm_clp1_drop_packets = None
                                                                    self.atm_clp1_drop_bytes = None
                                                                    self.queue_drop_threshold = None
                                                                    self.forced_wred_stats_display = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None

                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_max_length = YList(self)
                                                                    self._segment_path = lambda: "queue-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-instance-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-average-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-max-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.violate_packets = None
                                                                    self.violate_bytes = None
                                                                    self.parent_drop_packets = None
                                                                    self.parent_drop_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None
                                                                    self.violate_rate = None

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._segment_path = lambda: "police-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                        ])
                                                                        self.conform_class_conform_packets = None
                                                                        self.conform_class_conform_bytes = None
                                                                        self.conform_class_conform_rate = None
                                                                        self.conform_class_exceed_packets = None
                                                                        self.conform_class_exceed_bytes = None
                                                                        self.conform_class_exceed_rate = None
                                                                        self.conform_class_violate_packets = None
                                                                        self.conform_class_violate_bytes = None
                                                                        self.conform_class_violate_rate = None
                                                                        self.exceed_class_exceed_packets = None
                                                                        self.exceed_class_exceed_bytes = None
                                                                        self.exceed_class_exceed_rate = None
                                                                        self.exceed_class_violate_packets = None
                                                                        self.exceed_class_violate_bytes = None
                                                                        self.exceed_class_violate_rate = None
                                                                        self.violate_class_violate_packets = None
                                                                        self.violate_class_violate_bytes = None
                                                                        self.violate_class_violate_rate = None
                                                                        self._segment_path = lambda: "color-class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                    self._leafs = OrderedDict([
                                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                    ])
                                                                    self.profile_title = None
                                                                    self.red_transmit_packets = None
                                                                    self.red_transmit_bytes = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.red_ecn_marked_packets = None
                                                                    self.red_ecn_marked_bytes = None

                                                                    self.red_label = YList(self)
                                                                    self._segment_path = lambda: "wred-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                        ])
                                                                        self.wred_type = None
                                                                        self.value = None
                                                                        self._segment_path = lambda: "red-label"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                        class SatelliteIds(Entity):
                            """
                            Satellite ID information
                            
                            .. attribute:: satellite_id
                            
                            	Satellite ID information
                            	**type**\: list of  		 :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds, self).__init__()

                                self.yang_name = "satellite-ids"
                                self.yang_parent_name = "interface"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("satellite-id", ("satellite_id", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId))])
                                self._leafs = OrderedDict()

                                self.satellite_id = YList(self)
                                self._segment_path = lambda: "satellite-ids"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds, [], name, value)


                            class SatelliteId(Entity):
                                """
                                Satellite ID information
                                
                                .. attribute:: nv_satellite_id  (key)
                                
                                	Satellite ID
                                	**type**\: int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: input
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input>`
                                
                                .. attribute:: output
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId, self).__init__()

                                    self.yang_name = "satellite-id"
                                    self.yang_parent_name = "satellite-ids"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['nv_satellite_id']
                                    self._child_classes = OrderedDict([("input", ("input", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input)), ("output", ("output", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output))])
                                    self._leafs = OrderedDict([
                                        ('nv_satellite_id', (YLeaf(YType.int32, 'nv-satellite-id'), ['int'])),
                                    ])
                                    self.nv_satellite_id = None

                                    self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input()
                                    self.input.parent = self
                                    self._children_name_map["input"] = "input"

                                    self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output()
                                    self.output.parent = self
                                    self._children_name_map["output"] = "output"
                                    self._segment_path = lambda: "satellite-id" + "[nv-satellite-id='" + str(self.nv_satellite_id) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId, ['nv_satellite_id'], name, value)


                                class Input(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input, self).__init__()

                                        self.yang_name = "input"
                                        self.yang_parent_name = "satellite-id"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._segment_path = lambda: "input"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input, [], name, value)


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "input"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance))])
                                            self._leafs = OrderedDict()

                                            self.service_policy_instance = YList(self)
                                            self._segment_path = lambda: "service-policy-names"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, [], name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  (key)
                                            
                                            	Name of the policy instance
                                            	**type**\: str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            .. attribute:: statistics
                                            
                                            	Policy\-map statistics operational data for an interface
                                            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = ['service_policy_name']
                                                self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                self._leafs = OrderedDict([
                                                    ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                ])
                                                self.service_policy_name = None

                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                                self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                            class Statistics(Entity):
                                                """
                                                Policy\-map statistics operational data for an
                                                interface
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                    self.yang_name = "statistics"
                                                    self.yang_parent_name = "service-policy-instance"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "statistics"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: child_policy
                                                    
                                                    	child policy
                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "statistics"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class ChildPolicy(Entity):
                                                        """
                                                        child policy
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                            self.yang_name = "child-policy"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                            ])
                                                            self.policy_name = None
                                                            self.state = None
                                                            self.state_description = None
                                                            self.satid = None

                                                            self.class_stats = YList(self)
                                                            self._segment_path = lambda: "child-policy"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                        class ClassStats_(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "child-policy"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                self._leafs = OrderedDict([
                                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                ])
                                                                self.counter_validity_bitmask = None
                                                                self.class_name = None
                                                                self.shared_queue_id = None
                                                                self.queue_descr = None
                                                                self.cac_state = None

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                                self.queue_stats_array = YList(self)
                                                                self.police_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)
                                                                self._segment_path = lambda: "class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                    ])
                                                                    self.transmit_packets = None
                                                                    self.transmit_bytes = None
                                                                    self.total_drop_packets = None
                                                                    self.total_drop_bytes = None
                                                                    self.total_drop_rate = None
                                                                    self.match_data_rate = None
                                                                    self.total_transmit_rate = None
                                                                    self.pre_policy_matched_packets = None
                                                                    self.pre_policy_matched_bytes = None
                                                                    self._segment_path = lambda: "general-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                    ])
                                                                    self.non_tcp_total_out_packets = None
                                                                    self.non_tcp_total_out_bytes = None
                                                                    self.non_tcp_bytes_saved = None
                                                                    self.non_tcp_compressed_packets_out = None
                                                                    self.non_tcp_bytes_sent_rate = None
                                                                    self.non_tcp_full_header_packets_out = None
                                                                    self.tcp_total_out_packets = None
                                                                    self.tcp_total_out_bytes = None
                                                                    self.tcp_bytes_saved = None
                                                                    self.tcp_compressed_packets_out = None
                                                                    self.tcp_bytes_sent_rate = None
                                                                    self.tcp_full_header_packets_out = None
                                                                    self._segment_path = lambda: "iphc-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.drop_rates = None
                                                                    self.admitpackets = None
                                                                    self.admit_bytes = None
                                                                    self.admit_rates = None
                                                                    self._segment_path = lambda: "cac-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\: bool
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                    self._leafs = OrderedDict([
                                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ])
                                                                    self.queue_id = None
                                                                    self.tail_drop_packets = None
                                                                    self.tail_drop_bytes = None
                                                                    self.atm_clp0_drop_packets = None
                                                                    self.atm_clp0_drop_bytes = None
                                                                    self.atm_clp1_drop_packets = None
                                                                    self.atm_clp1_drop_bytes = None
                                                                    self.queue_drop_threshold = None
                                                                    self.forced_wred_stats_display = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None

                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_max_length = YList(self)
                                                                    self._segment_path = lambda: "queue-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-instance-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-average-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-max-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.violate_packets = None
                                                                    self.violate_bytes = None
                                                                    self.parent_drop_packets = None
                                                                    self.parent_drop_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None
                                                                    self.violate_rate = None

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._segment_path = lambda: "police-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                        ])
                                                                        self.conform_class_conform_packets = None
                                                                        self.conform_class_conform_bytes = None
                                                                        self.conform_class_conform_rate = None
                                                                        self.conform_class_exceed_packets = None
                                                                        self.conform_class_exceed_bytes = None
                                                                        self.conform_class_exceed_rate = None
                                                                        self.conform_class_violate_packets = None
                                                                        self.conform_class_violate_bytes = None
                                                                        self.conform_class_violate_rate = None
                                                                        self.exceed_class_exceed_packets = None
                                                                        self.exceed_class_exceed_bytes = None
                                                                        self.exceed_class_exceed_rate = None
                                                                        self.exceed_class_violate_packets = None
                                                                        self.exceed_class_violate_bytes = None
                                                                        self.exceed_class_violate_rate = None
                                                                        self.violate_class_violate_packets = None
                                                                        self.violate_class_violate_bytes = None
                                                                        self.violate_class_violate_rate = None
                                                                        self._segment_path = lambda: "color-class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                    self._leafs = OrderedDict([
                                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                    ])
                                                                    self.profile_title = None
                                                                    self.red_transmit_packets = None
                                                                    self.red_transmit_bytes = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.red_ecn_marked_packets = None
                                                                    self.red_ecn_marked_bytes = None

                                                                    self.red_label = YList(self)
                                                                    self._segment_path = lambda: "wred-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                        ])
                                                                        self.wred_type = None
                                                                        self.value = None
                                                                        self._segment_path = lambda: "red-label"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                class Output(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output, self).__init__()

                                        self.yang_name = "output"
                                        self.yang_parent_name = "satellite-id"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._segment_path = lambda: "output"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output, [], name, value)


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "output"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance))])
                                            self._leafs = OrderedDict()

                                            self.service_policy_instance = YList(self)
                                            self._segment_path = lambda: "service-policy-names"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, [], name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  (key)
                                            
                                            	Name of the policy instance
                                            	**type**\: str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            .. attribute:: statistics
                                            
                                            	Policy\-map statistics operational data for an interface
                                            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = ['service_policy_name']
                                                self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                                self._leafs = OrderedDict([
                                                    ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                                ])
                                                self.service_policy_name = None

                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                                self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                            class Statistics(Entity):
                                                """
                                                Policy\-map statistics operational data for an
                                                interface
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                    self.yang_name = "statistics"
                                                    self.yang_parent_name = "service-policy-instance"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "statistics"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: child_policy
                                                    
                                                    	child policy
                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "statistics"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class ChildPolicy(Entity):
                                                        """
                                                        child policy
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                            self.yang_name = "child-policy"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                            ])
                                                            self.policy_name = None
                                                            self.state = None
                                                            self.state_description = None
                                                            self.satid = None

                                                            self.class_stats = YList(self)
                                                            self._segment_path = lambda: "child-policy"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                        class ClassStats_(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "child-policy"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                                self._leafs = OrderedDict([
                                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                                ])
                                                                self.counter_validity_bitmask = None
                                                                self.class_name = None
                                                                self.shared_queue_id = None
                                                                self.queue_descr = None
                                                                self.cac_state = None

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                                self.queue_stats_array = YList(self)
                                                                self.police_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)
                                                                self._segment_path = lambda: "class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                    ])
                                                                    self.transmit_packets = None
                                                                    self.transmit_bytes = None
                                                                    self.total_drop_packets = None
                                                                    self.total_drop_bytes = None
                                                                    self.total_drop_rate = None
                                                                    self.match_data_rate = None
                                                                    self.total_transmit_rate = None
                                                                    self.pre_policy_matched_packets = None
                                                                    self.pre_policy_matched_bytes = None
                                                                    self._segment_path = lambda: "general-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                    ])
                                                                    self.non_tcp_total_out_packets = None
                                                                    self.non_tcp_total_out_bytes = None
                                                                    self.non_tcp_bytes_saved = None
                                                                    self.non_tcp_compressed_packets_out = None
                                                                    self.non_tcp_bytes_sent_rate = None
                                                                    self.non_tcp_full_header_packets_out = None
                                                                    self.tcp_total_out_packets = None
                                                                    self.tcp_total_out_bytes = None
                                                                    self.tcp_bytes_saved = None
                                                                    self.tcp_compressed_packets_out = None
                                                                    self.tcp_bytes_sent_rate = None
                                                                    self.tcp_full_header_packets_out = None
                                                                    self._segment_path = lambda: "iphc-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.drop_rates = None
                                                                    self.admitpackets = None
                                                                    self.admit_bytes = None
                                                                    self.admit_rates = None
                                                                    self._segment_path = lambda: "cac-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\: bool
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                    self._leafs = OrderedDict([
                                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ])
                                                                    self.queue_id = None
                                                                    self.tail_drop_packets = None
                                                                    self.tail_drop_bytes = None
                                                                    self.atm_clp0_drop_packets = None
                                                                    self.atm_clp0_drop_bytes = None
                                                                    self.atm_clp1_drop_packets = None
                                                                    self.atm_clp1_drop_bytes = None
                                                                    self.queue_drop_threshold = None
                                                                    self.forced_wred_stats_display = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None

                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_max_length = YList(self)
                                                                    self._segment_path = lambda: "queue-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-instance-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-average-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "queue-max-length"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                    self._leafs = OrderedDict([
                                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                    ])
                                                                    self.drop_packets = None
                                                                    self.drop_bytes = None
                                                                    self.conform_packets = None
                                                                    self.conform_bytes = None
                                                                    self.exceed_packets = None
                                                                    self.exceed_bytes = None
                                                                    self.violate_packets = None
                                                                    self.violate_bytes = None
                                                                    self.parent_drop_packets = None
                                                                    self.parent_drop_bytes = None
                                                                    self.conform_rate = None
                                                                    self.exceed_rate = None
                                                                    self.violate_rate = None

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._segment_path = lambda: "police-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                        ])
                                                                        self.conform_class_conform_packets = None
                                                                        self.conform_class_conform_bytes = None
                                                                        self.conform_class_conform_rate = None
                                                                        self.conform_class_exceed_packets = None
                                                                        self.conform_class_exceed_bytes = None
                                                                        self.conform_class_exceed_rate = None
                                                                        self.conform_class_violate_packets = None
                                                                        self.conform_class_violate_bytes = None
                                                                        self.conform_class_violate_rate = None
                                                                        self.exceed_class_exceed_packets = None
                                                                        self.exceed_class_exceed_bytes = None
                                                                        self.exceed_class_exceed_rate = None
                                                                        self.exceed_class_violate_packets = None
                                                                        self.exceed_class_violate_bytes = None
                                                                        self.exceed_class_violate_rate = None
                                                                        self.violate_class_violate_packets = None
                                                                        self.violate_class_violate_bytes = None
                                                                        self.violate_class_violate_rate = None
                                                                        self._segment_path = lambda: "color-class-stats"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                    self._leafs = OrderedDict([
                                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                    ])
                                                                    self.profile_title = None
                                                                    self.red_transmit_packets = None
                                                                    self.red_transmit_bytes = None
                                                                    self.random_drop_packets = None
                                                                    self.random_drop_bytes = None
                                                                    self.max_threshold_packets = None
                                                                    self.max_threshold_bytes = None
                                                                    self.red_ecn_marked_packets = None
                                                                    self.red_ecn_marked_bytes = None

                                                                    self.red_label = YList(self)
                                                                    self._segment_path = lambda: "wred-stats-array"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-09-13'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                        ])
                                                                        self.wred_type = None
                                                                        self.value = None
                                                                        self._segment_path = lambda: "red-label"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                        class Input(Entity):
                            """
                            A piece of QoS policy\-map operational data for
                            an interface
                            
                            .. attribute:: service_policy_names
                            
                            	Operational data for all Policy instance
                            	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input, self).__init__()

                                self.yang_name = "input"
                                self.yang_parent_name = "interface"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames))])
                                self._leafs = OrderedDict()

                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames()
                                self.service_policy_names.parent = self
                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                self._segment_path = lambda: "input"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input, [], name, value)


                            class ServicePolicyNames(Entity):
                                """
                                Operational data for all Policy instance
                                
                                .. attribute:: service_policy_instance
                                
                                	QoS policy\-map operational data for a particular Policy 
                                	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames, self).__init__()

                                    self.yang_name = "service-policy-names"
                                    self.yang_parent_name = "input"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance))])
                                    self._leafs = OrderedDict()

                                    self.service_policy_instance = YList(self)
                                    self._segment_path = lambda: "service-policy-names"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames, [], name, value)


                                class ServicePolicyInstance(Entity):
                                    """
                                    QoS policy\-map operational data for a
                                    particular Policy 
                                    
                                    .. attribute:: service_policy_name  (key)
                                    
                                    	Name of the policy instance
                                    	**type**\: str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    .. attribute:: statistics
                                    
                                    	Policy\-map statistics operational data for an interface
                                    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                        self.yang_name = "service-policy-instance"
                                        self.yang_parent_name = "service-policy-names"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = ['service_policy_name']
                                        self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                        self._leafs = OrderedDict([
                                            ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                        ])
                                        self.service_policy_name = None

                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                        self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                    class Statistics(Entity):
                                        """
                                        Policy\-map statistics operational data for an
                                        interface
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\: str
                                        
                                        	**length:** 0..128
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                            self.yang_name = "statistics"
                                            self.yang_parent_name = "service-policy-instance"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                            self._leafs = OrderedDict([
                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                            ])
                                            self.policy_name = None
                                            self.state = None
                                            self.state_description = None
                                            self.satid = None

                                            self.class_stats = YList(self)
                                            self._segment_path = lambda: "statistics"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\: str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "statistics"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                self._leafs = OrderedDict([
                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                ])
                                                self.counter_validity_bitmask = None
                                                self.class_name = None
                                                self.shared_queue_id = None
                                                self.queue_descr = None
                                                self.cac_state = None

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                self.queue_stats_array = YList(self)
                                                self.police_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)
                                                self._segment_path = lambda: "class-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                    ])
                                                    self.transmit_packets = None
                                                    self.transmit_bytes = None
                                                    self.total_drop_packets = None
                                                    self.total_drop_bytes = None
                                                    self.total_drop_rate = None
                                                    self.match_data_rate = None
                                                    self.total_transmit_rate = None
                                                    self.pre_policy_matched_packets = None
                                                    self.pre_policy_matched_bytes = None
                                                    self._segment_path = lambda: "general-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                    ])
                                                    self.non_tcp_total_out_packets = None
                                                    self.non_tcp_total_out_bytes = None
                                                    self.non_tcp_bytes_saved = None
                                                    self.non_tcp_compressed_packets_out = None
                                                    self.non_tcp_bytes_sent_rate = None
                                                    self.non_tcp_full_header_packets_out = None
                                                    self.tcp_total_out_packets = None
                                                    self.tcp_total_out_bytes = None
                                                    self.tcp_bytes_saved = None
                                                    self.tcp_compressed_packets_out = None
                                                    self.tcp_bytes_sent_rate = None
                                                    self.tcp_full_header_packets_out = None
                                                    self._segment_path = lambda: "iphc-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "child-policy"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats_(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.drop_rates = None
                                                    self.admitpackets = None
                                                    self.admit_bytes = None
                                                    self.admit_rates = None
                                                    self._segment_path = lambda: "cac-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\: bool
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                    self._leafs = OrderedDict([
                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ])
                                                    self.queue_id = None
                                                    self.tail_drop_packets = None
                                                    self.tail_drop_bytes = None
                                                    self.atm_clp0_drop_packets = None
                                                    self.atm_clp0_drop_bytes = None
                                                    self.atm_clp1_drop_packets = None
                                                    self.atm_clp1_drop_bytes = None
                                                    self.queue_drop_threshold = None
                                                    self.forced_wred_stats_display = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None

                                                    self.queue_instance_length = YList(self)
                                                    self.queue_average_length = YList(self)
                                                    self.queue_max_length = YList(self)
                                                    self._segment_path = lambda: "queue-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-instance-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-average-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-max-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.violate_packets = None
                                                    self.violate_bytes = None
                                                    self.parent_drop_packets = None
                                                    self.parent_drop_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None
                                                    self.violate_rate = None

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._segment_path = lambda: "police-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                        ])
                                                        self.conform_class_conform_packets = None
                                                        self.conform_class_conform_bytes = None
                                                        self.conform_class_conform_rate = None
                                                        self.conform_class_exceed_packets = None
                                                        self.conform_class_exceed_bytes = None
                                                        self.conform_class_exceed_rate = None
                                                        self.conform_class_violate_packets = None
                                                        self.conform_class_violate_bytes = None
                                                        self.conform_class_violate_rate = None
                                                        self.exceed_class_exceed_packets = None
                                                        self.exceed_class_exceed_bytes = None
                                                        self.exceed_class_exceed_rate = None
                                                        self.exceed_class_violate_packets = None
                                                        self.exceed_class_violate_bytes = None
                                                        self.exceed_class_violate_rate = None
                                                        self.violate_class_violate_packets = None
                                                        self.violate_class_violate_bytes = None
                                                        self.violate_class_violate_rate = None
                                                        self._segment_path = lambda: "color-class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\: str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                    self._leafs = OrderedDict([
                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                    ])
                                                    self.profile_title = None
                                                    self.red_transmit_packets = None
                                                    self.red_transmit_bytes = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.red_ecn_marked_packets = None
                                                    self.red_ecn_marked_bytes = None

                                                    self.red_label = YList(self)
                                                    self._segment_path = lambda: "wred-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                        ])
                                                        self.wred_type = None
                                                        self.value = None
                                                        self._segment_path = lambda: "red-label"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                        class Output(Entity):
                            """
                            A piece of QoS policy\-map operational data for
                            an interface
                            
                            .. attribute:: service_policy_names
                            
                            	Operational data for all Policy instance
                            	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output, self).__init__()

                                self.yang_name = "output"
                                self.yang_parent_name = "interface"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames))])
                                self._leafs = OrderedDict()

                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames()
                                self.service_policy_names.parent = self
                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                self._segment_path = lambda: "output"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output, [], name, value)


                            class ServicePolicyNames(Entity):
                                """
                                Operational data for all Policy instance
                                
                                .. attribute:: service_policy_instance
                                
                                	QoS policy\-map operational data for a particular Policy 
                                	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames, self).__init__()

                                    self.yang_name = "service-policy-names"
                                    self.yang_parent_name = "output"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance))])
                                    self._leafs = OrderedDict()

                                    self.service_policy_instance = YList(self)
                                    self._segment_path = lambda: "service-policy-names"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames, [], name, value)


                                class ServicePolicyInstance(Entity):
                                    """
                                    QoS policy\-map operational data for a
                                    particular Policy 
                                    
                                    .. attribute:: service_policy_name  (key)
                                    
                                    	Name of the policy instance
                                    	**type**\: str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    .. attribute:: statistics
                                    
                                    	Policy\-map statistics operational data for an interface
                                    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                        self.yang_name = "service-policy-instance"
                                        self.yang_parent_name = "service-policy-names"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = ['service_policy_name']
                                        self._child_classes = OrderedDict([("statistics", ("statistics", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                        self._leafs = OrderedDict([
                                            ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                        ])
                                        self.service_policy_name = None

                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                        self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                    class Statistics(Entity):
                                        """
                                        Policy\-map statistics operational data for an
                                        interface
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\: str
                                        
                                        	**length:** 0..128
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                            self.yang_name = "statistics"
                                            self.yang_parent_name = "service-policy-instance"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                            self._leafs = OrderedDict([
                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                            ])
                                            self.policy_name = None
                                            self.state = None
                                            self.state_description = None
                                            self.satid = None

                                            self.class_stats = YList(self)
                                            self._segment_path = lambda: "statistics"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\: str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "statistics"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                self._leafs = OrderedDict([
                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                ])
                                                self.counter_validity_bitmask = None
                                                self.class_name = None
                                                self.shared_queue_id = None
                                                self.queue_descr = None
                                                self.cac_state = None

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                self.queue_stats_array = YList(self)
                                                self.police_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)
                                                self._segment_path = lambda: "class-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                    ])
                                                    self.transmit_packets = None
                                                    self.transmit_bytes = None
                                                    self.total_drop_packets = None
                                                    self.total_drop_bytes = None
                                                    self.total_drop_rate = None
                                                    self.match_data_rate = None
                                                    self.total_transmit_rate = None
                                                    self.pre_policy_matched_packets = None
                                                    self.pre_policy_matched_bytes = None
                                                    self._segment_path = lambda: "general-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                    ])
                                                    self.non_tcp_total_out_packets = None
                                                    self.non_tcp_total_out_bytes = None
                                                    self.non_tcp_bytes_saved = None
                                                    self.non_tcp_compressed_packets_out = None
                                                    self.non_tcp_bytes_sent_rate = None
                                                    self.non_tcp_full_header_packets_out = None
                                                    self.tcp_total_out_packets = None
                                                    self.tcp_total_out_bytes = None
                                                    self.tcp_bytes_saved = None
                                                    self.tcp_compressed_packets_out = None
                                                    self.tcp_bytes_sent_rate = None
                                                    self.tcp_full_header_packets_out = None
                                                    self._segment_path = lambda: "iphc-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "child-policy"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats_(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.drop_rates = None
                                                    self.admitpackets = None
                                                    self.admit_bytes = None
                                                    self.admit_rates = None
                                                    self._segment_path = lambda: "cac-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\: bool
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                    self._leafs = OrderedDict([
                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ])
                                                    self.queue_id = None
                                                    self.tail_drop_packets = None
                                                    self.tail_drop_bytes = None
                                                    self.atm_clp0_drop_packets = None
                                                    self.atm_clp0_drop_bytes = None
                                                    self.atm_clp1_drop_packets = None
                                                    self.atm_clp1_drop_bytes = None
                                                    self.queue_drop_threshold = None
                                                    self.forced_wred_stats_display = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None

                                                    self.queue_instance_length = YList(self)
                                                    self.queue_average_length = YList(self)
                                                    self.queue_max_length = YList(self)
                                                    self._segment_path = lambda: "queue-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-instance-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-average-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-max-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.violate_packets = None
                                                    self.violate_bytes = None
                                                    self.parent_drop_packets = None
                                                    self.parent_drop_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None
                                                    self.violate_rate = None

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._segment_path = lambda: "police-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                        ])
                                                        self.conform_class_conform_packets = None
                                                        self.conform_class_conform_bytes = None
                                                        self.conform_class_conform_rate = None
                                                        self.conform_class_exceed_packets = None
                                                        self.conform_class_exceed_bytes = None
                                                        self.conform_class_exceed_rate = None
                                                        self.conform_class_violate_packets = None
                                                        self.conform_class_violate_bytes = None
                                                        self.conform_class_violate_rate = None
                                                        self.exceed_class_exceed_packets = None
                                                        self.exceed_class_exceed_bytes = None
                                                        self.exceed_class_exceed_rate = None
                                                        self.exceed_class_violate_packets = None
                                                        self.exceed_class_violate_bytes = None
                                                        self.exceed_class_violate_rate = None
                                                        self.violate_class_violate_packets = None
                                                        self.violate_class_violate_bytes = None
                                                        self.violate_class_violate_rate = None
                                                        self._segment_path = lambda: "color-class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\: str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                    self._leafs = OrderedDict([
                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                    ])
                                                    self.profile_title = None
                                                    self.red_transmit_packets = None
                                                    self.red_transmit_bytes = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.red_ecn_marked_packets = None
                                                    self.red_ecn_marked_bytes = None

                                                    self.red_label = YList(self)
                                                    self._segment_path = lambda: "wred-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                        ])
                                                        self.wred_type = None
                                                        self.value = None
                                                        self._segment_path = lambda: "red-label"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


    class QosGlobal(Entity):
        """
        For global registrations
        
        .. attribute:: vo_q
        
        	For VoQ operational data
        	**type**\:  :py:class:`VoQ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ>`
        
        

        """

        _prefix = 'qos-ma-oper'
        _revision = '2017-09-13'

        def __init__(self):
            super(Qos.QosGlobal, self).__init__()

            self.yang_name = "qos-global"
            self.yang_parent_name = "qos"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("vo-q", ("vo_q", Qos.QosGlobal.VoQ))])
            self._leafs = OrderedDict()

            self.vo_q = Qos.QosGlobal.VoQ()
            self.vo_q.parent = self
            self._children_name_map["vo_q"] = "vo-q"
            self._segment_path = lambda: "qos-global"
            self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Qos.QosGlobal, [], name, value)


        class VoQ(Entity):
            """
            For VoQ operational data
            
            .. attribute:: vo_q_statistics
            
            	For VoQ statistics
            	**type**\:  :py:class:`VoQStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics>`
            
            

            """

            _prefix = 'qos-ma-oper'
            _revision = '2017-09-13'

            def __init__(self):
                super(Qos.QosGlobal.VoQ, self).__init__()

                self.yang_name = "vo-q"
                self.yang_parent_name = "qos-global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("vo-q-statistics", ("vo_q_statistics", Qos.QosGlobal.VoQ.VoQStatistics))])
                self._leafs = OrderedDict()

                self.vo_q_statistics = Qos.QosGlobal.VoQ.VoQStatistics()
                self.vo_q_statistics.parent = self
                self._children_name_map["vo_q_statistics"] = "vo-q-statistics"
                self._segment_path = lambda: "vo-q"
                self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/qos-global/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Qos.QosGlobal.VoQ, [], name, value)


            class VoQStatistics(Entity):
                """
                For VoQ statistics
                
                .. attribute:: vo_qinterfaces
                
                	VoQ interface
                	**type**\:  :py:class:`VoQinterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.QosGlobal.VoQ.VoQStatistics, self).__init__()

                    self.yang_name = "vo-q-statistics"
                    self.yang_parent_name = "vo-q"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("vo-qinterfaces", ("vo_qinterfaces", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces))])
                    self._leafs = OrderedDict()

                    self.vo_qinterfaces = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces()
                    self.vo_qinterfaces.parent = self
                    self._children_name_map["vo_qinterfaces"] = "vo-qinterfaces"
                    self._segment_path = lambda: "vo-q-statistics"
                    self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/qos-global/vo-q/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics, [], name, value)


                class VoQinterfaces(Entity):
                    """
                    VoQ interface
                    
                    .. attribute:: vo_qinterface
                    
                    	QoS policy\-map operational data for a particular interface
                    	**type**\: list of  		 :py:class:`VoQinterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces, self).__init__()

                        self.yang_name = "vo-qinterfaces"
                        self.yang_parent_name = "vo-q-statistics"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("vo-qinterface", ("vo_qinterface", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface))])
                        self._leafs = OrderedDict()

                        self.vo_qinterface = YList(self)
                        self._segment_path = lambda: "vo-qinterfaces"
                        self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/qos-global/vo-q/vo-q-statistics/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces, [], name, value)


                    class VoQinterface(Entity):
                        """
                        QoS policy\-map operational data for a
                        particular interface
                        
                        .. attribute:: interface_name  (key)
                        
                        	Name of the interface
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        .. attribute:: output_vo_q
                        
                        	output VoQ interface
                        	**type**\:  :py:class:`OutputVoQ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ>`
                        
                        .. attribute:: vo_q_member_interfaces
                        
                        	VoQ QoS policy\-map member interface table
                        	**type**\:  :py:class:`VoQMemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface, self).__init__()

                            self.yang_name = "vo-qinterface"
                            self.yang_parent_name = "vo-qinterfaces"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = ['interface_name']
                            self._child_classes = OrderedDict([("output-vo-q", ("output_vo_q", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ)), ("vo-q-member-interfaces", ("vo_q_member_interfaces", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces))])
                            self._leafs = OrderedDict([
                                ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                            ])
                            self.interface_name = None

                            self.output_vo_q = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ()
                            self.output_vo_q.parent = self
                            self._children_name_map["output_vo_q"] = "output-vo-q"

                            self.vo_q_member_interfaces = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces()
                            self.vo_q_member_interfaces.parent = self
                            self._children_name_map["vo_q_member_interfaces"] = "vo-q-member-interfaces"
                            self._segment_path = lambda: "vo-qinterface" + "[interface-name='" + str(self.interface_name) + "']"
                            self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/qos-global/vo-q/vo-q-statistics/vo-qinterfaces/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface, ['interface_name'], name, value)


                        class OutputVoQ(Entity):
                            """
                            output VoQ interface
                            
                            .. attribute:: locationvo_qs
                            
                            	QoS policy\-map location table
                            	**type**\:  :py:class:`LocationvoQs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs>`
                            
                            .. attribute:: vo_q_stats
                            
                            	VoQ statistics operational data for an interface
                            	**type**\:  :py:class:`VoQStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ, self).__init__()

                                self.yang_name = "output-vo-q"
                                self.yang_parent_name = "vo-qinterface"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("locationvo-qs", ("locationvo_qs", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs)), ("vo-q-stats", ("vo_q_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats))])
                                self._leafs = OrderedDict()

                                self.locationvo_qs = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs()
                                self.locationvo_qs.parent = self
                                self._children_name_map["locationvo_qs"] = "locationvo-qs"

                                self.vo_q_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats()
                                self.vo_q_stats.parent = self
                                self._children_name_map["vo_q_stats"] = "vo-q-stats"
                                self._segment_path = lambda: "output-vo-q"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ, [], name, value)


                            class LocationvoQs(Entity):
                                """
                                QoS policy\-map location table
                                
                                .. attribute:: locationvo_q
                                
                                	QoS operational data for a particular location
                                	**type**\: list of  		 :py:class:`LocationvoQ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs, self).__init__()

                                    self.yang_name = "locationvo-qs"
                                    self.yang_parent_name = "output-vo-q"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("locationvo-q", ("locationvo_q", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ))])
                                    self._leafs = OrderedDict()

                                    self.locationvo_q = YList(self)
                                    self._segment_path = lambda: "locationvo-qs"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs, [], name, value)


                                class LocationvoQ(Entity):
                                    """
                                    QoS operational data for a particular
                                    location
                                    
                                    .. attribute:: node_name  (key)
                                    
                                    	The node
                                    	**type**\: str
                                    
                                    	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
                                    
                                    .. attribute:: vo_q_stats
                                    
                                    	VoQ statistics operational data for an interface
                                    	**type**\:  :py:class:`VoQStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ, self).__init__()

                                        self.yang_name = "locationvo-q"
                                        self.yang_parent_name = "locationvo-qs"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = ['node_name']
                                        self._child_classes = OrderedDict([("vo-q-stats", ("vo_q_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats))])
                                        self._leafs = OrderedDict([
                                            ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                        ])
                                        self.node_name = None

                                        self.vo_q_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats()
                                        self.vo_q_stats.parent = self
                                        self._children_name_map["vo_q_stats"] = "vo-q-stats"
                                        self._segment_path = lambda: "locationvo-q" + "[node-name='" + str(self.node_name) + "']"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ, ['node_name'], name, value)


                                    class VoQStats(Entity):
                                        """
                                        VoQ statistics operational data for an interface
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\: str
                                        
                                        	**length:** 0..128
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats, self).__init__()

                                            self.yang_name = "vo-q-stats"
                                            self.yang_parent_name = "locationvo-q"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats))])
                                            self._leafs = OrderedDict([
                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                            ])
                                            self.policy_name = None
                                            self.state = None
                                            self.state_description = None
                                            self.satid = None

                                            self.class_stats = YList(self)
                                            self._segment_path = lambda: "vo-q-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.IphcStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.CacStats>`
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\: str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "vo-q-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray))])
                                                self._leafs = OrderedDict([
                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                ])
                                                self.counter_validity_bitmask = None
                                                self.class_name = None
                                                self.shared_queue_id = None
                                                self.queue_descr = None
                                                self.cac_state = None

                                                self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"

                                                self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                self.child_policy = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"

                                                self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                self.queue_stats_array = YList(self)
                                                self.police_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)
                                                self._segment_path = lambda: "class-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                    ])
                                                    self.transmit_packets = None
                                                    self.transmit_bytes = None
                                                    self.total_drop_packets = None
                                                    self.total_drop_bytes = None
                                                    self.total_drop_rate = None
                                                    self.match_data_rate = None
                                                    self.total_transmit_rate = None
                                                    self.pre_policy_matched_packets = None
                                                    self.pre_policy_matched_bytes = None
                                                    self._segment_path = lambda: "general-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                    ])
                                                    self.non_tcp_total_out_packets = None
                                                    self.non_tcp_total_out_bytes = None
                                                    self.non_tcp_bytes_saved = None
                                                    self.non_tcp_compressed_packets_out = None
                                                    self.non_tcp_bytes_sent_rate = None
                                                    self.non_tcp_full_header_packets_out = None
                                                    self.tcp_total_out_packets = None
                                                    self.tcp_total_out_bytes = None
                                                    self.tcp_bytes_saved = None
                                                    self.tcp_compressed_packets_out = None
                                                    self.tcp_bytes_sent_rate = None
                                                    self.tcp_full_header_packets_out = None
                                                    self._segment_path = lambda: "iphc-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "child-policy"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats_(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.drop_rates = None
                                                    self.admitpackets = None
                                                    self.admit_bytes = None
                                                    self.admit_rates = None
                                                    self._segment_path = lambda: "cac-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\: bool
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                    self._leafs = OrderedDict([
                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ])
                                                    self.queue_id = None
                                                    self.tail_drop_packets = None
                                                    self.tail_drop_bytes = None
                                                    self.atm_clp0_drop_packets = None
                                                    self.atm_clp0_drop_bytes = None
                                                    self.atm_clp1_drop_packets = None
                                                    self.atm_clp1_drop_bytes = None
                                                    self.queue_drop_threshold = None
                                                    self.forced_wred_stats_display = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None

                                                    self.queue_instance_length = YList(self)
                                                    self.queue_average_length = YList(self)
                                                    self.queue_max_length = YList(self)
                                                    self._segment_path = lambda: "queue-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-instance-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-average-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-max-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.violate_packets = None
                                                    self.violate_bytes = None
                                                    self.parent_drop_packets = None
                                                    self.parent_drop_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None
                                                    self.violate_rate = None

                                                    self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._segment_path = lambda: "police-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                        ])
                                                        self.conform_class_conform_packets = None
                                                        self.conform_class_conform_bytes = None
                                                        self.conform_class_conform_rate = None
                                                        self.conform_class_exceed_packets = None
                                                        self.conform_class_exceed_bytes = None
                                                        self.conform_class_exceed_rate = None
                                                        self.conform_class_violate_packets = None
                                                        self.conform_class_violate_bytes = None
                                                        self.conform_class_violate_rate = None
                                                        self.exceed_class_exceed_packets = None
                                                        self.exceed_class_exceed_bytes = None
                                                        self.exceed_class_exceed_rate = None
                                                        self.exceed_class_violate_packets = None
                                                        self.exceed_class_violate_bytes = None
                                                        self.exceed_class_violate_rate = None
                                                        self.violate_class_violate_packets = None
                                                        self.violate_class_violate_bytes = None
                                                        self.violate_class_violate_rate = None
                                                        self._segment_path = lambda: "color-class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\: str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray.RedLabel))])
                                                    self._leafs = OrderedDict([
                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                    ])
                                                    self.profile_title = None
                                                    self.red_transmit_packets = None
                                                    self.red_transmit_bytes = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.red_ecn_marked_packets = None
                                                    self.red_ecn_marked_bytes = None

                                                    self.red_label = YList(self)
                                                    self._segment_path = lambda: "wred-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                        ])
                                                        self.wred_type = None
                                                        self.value = None
                                                        self._segment_path = lambda: "red-label"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                            class VoQStats(Entity):
                                """
                                VoQ statistics operational data for an interface
                                
                                .. attribute:: policy_name
                                
                                	PolicyName
                                	**type**\: str
                                
                                	**length:** 0..65
                                
                                .. attribute:: state
                                
                                	State
                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                
                                .. attribute:: state_description
                                
                                	StateDescription
                                	**type**\: str
                                
                                	**length:** 0..128
                                
                                .. attribute:: satid
                                
                                	to maintain satellite id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: class_stats
                                
                                	array of classes contained in policy
                                	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats, self).__init__()

                                    self.yang_name = "vo-q-stats"
                                    self.yang_parent_name = "output-vo-q"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats))])
                                    self._leafs = OrderedDict([
                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                    ])
                                    self.policy_name = None
                                    self.state = None
                                    self.state_description = None
                                    self.satid = None

                                    self.class_stats = YList(self)
                                    self._segment_path = lambda: "vo-q-stats"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                class ClassStats(Entity):
                                    """
                                    array of classes contained in policy
                                    
                                    .. attribute:: general_stats
                                    
                                    	general stats
                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.GeneralStats>`
                                    
                                    .. attribute:: iphc_stats
                                    
                                    	IPHC stats
                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.IphcStats>`
                                    
                                    .. attribute:: child_policy
                                    
                                    	child policy
                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy>`
                                    
                                    .. attribute:: cac_stats
                                    
                                    	bag for cac stats
                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.CacStats>`
                                    
                                    .. attribute:: counter_validity_bitmask
                                    
                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: megabyte
                                    
                                    .. attribute:: class_name
                                    
                                    	ClassName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: shared_queue_id
                                    
                                    	q\-id of the  shared queue for this class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_descr
                                    
                                    	Description of queue for the class
                                    	**type**\: str
                                    
                                    	**length:** 0..256
                                    
                                    .. attribute:: cac_state
                                    
                                    	CACState
                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                    
                                    .. attribute:: queue_stats_array
                                    
                                    	array of queue stats
                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray>`
                                    
                                    .. attribute:: police_stats_array
                                    
                                    	array of police stats
                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray>`
                                    
                                    .. attribute:: wred_stats_array
                                    
                                    	array of red stats
                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats, self).__init__()

                                        self.yang_name = "class-stats"
                                        self.yang_parent_name = "vo-q-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray))])
                                        self._leafs = OrderedDict([
                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                        ])
                                        self.counter_validity_bitmask = None
                                        self.class_name = None
                                        self.shared_queue_id = None
                                        self.queue_descr = None
                                        self.cac_state = None

                                        self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.GeneralStats()
                                        self.general_stats.parent = self
                                        self._children_name_map["general_stats"] = "general-stats"

                                        self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.IphcStats()
                                        self.iphc_stats.parent = self
                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                        self.child_policy = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy()
                                        self.child_policy.parent = self
                                        self._children_name_map["child_policy"] = "child-policy"

                                        self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.CacStats()
                                        self.cac_stats.parent = self
                                        self._children_name_map["cac_stats"] = "cac-stats"

                                        self.queue_stats_array = YList(self)
                                        self.police_stats_array = YList(self)
                                        self.wred_stats_array = YList(self)
                                        self._segment_path = lambda: "class-stats"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                    class GeneralStats(Entity):
                                        """
                                        general stats
                                        
                                        .. attribute:: transmit_packets
                                        
                                        	Transmitted packets (packets/bytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: transmit_bytes
                                        
                                        	Transmitted bytes (packets/bytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_drop_packets
                                        
                                        	Dropped packets (packets/bytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_drop_bytes
                                        
                                        	Dropped bytes (packets/bytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_drop_rate
                                        
                                        	Total drop rate (packets/bytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: match_data_rate
                                        
                                        	Incoming matched data rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: total_transmit_rate
                                        
                                        	Total transmit rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: pre_policy_matched_packets
                                        
                                        	Matched pkts before applying policy
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: pre_policy_matched_bytes
                                        
                                        	Matched bytes before applying policy
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.GeneralStats, self).__init__()

                                            self.yang_name = "general-stats"
                                            self.yang_parent_name = "class-stats"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                            ])
                                            self.transmit_packets = None
                                            self.transmit_bytes = None
                                            self.total_drop_packets = None
                                            self.total_drop_bytes = None
                                            self.total_drop_rate = None
                                            self.match_data_rate = None
                                            self.total_transmit_rate = None
                                            self.pre_policy_matched_packets = None
                                            self.pre_policy_matched_bytes = None
                                            self._segment_path = lambda: "general-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                    class IphcStats(Entity):
                                        """
                                        IPHC stats
                                        
                                        .. attribute:: non_tcp_total_out_packets
                                        
                                        	TotalNum of Non tcp pkts sent
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: non_tcp_total_out_bytes
                                        
                                        	TotalNum of Non Tcp Bytes sent
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_bytes_saved
                                        
                                        	Non Tcp Bytes saved due to compression
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_compressed_packets_out
                                        
                                        	Num of non tcp compressed pkts sent
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: non_tcp_bytes_sent_rate
                                        
                                        	Compressed Non Tcp Bytes sent rate
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_full_header_packets_out
                                        
                                        	Num of non tcp fullheader pkts sent
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_total_out_packets
                                        
                                        	Total Num of tcp pkts sent
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_total_out_bytes
                                        
                                        	TotalNum of Tcp Bytes sent
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_bytes_saved
                                        
                                        	Tcp Bytes saved due to compression
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_compressed_packets_out
                                        
                                        	Num of tcp compressed pkts sent
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_bytes_sent_rate
                                        
                                        	Compressed Tcp Bytes sent rate
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_full_header_packets_out
                                        
                                        	Num of tcp fullheader pkts sent
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.IphcStats, self).__init__()

                                            self.yang_name = "iphc-stats"
                                            self.yang_parent_name = "class-stats"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                            ])
                                            self.non_tcp_total_out_packets = None
                                            self.non_tcp_total_out_bytes = None
                                            self.non_tcp_bytes_saved = None
                                            self.non_tcp_compressed_packets_out = None
                                            self.non_tcp_bytes_sent_rate = None
                                            self.non_tcp_full_header_packets_out = None
                                            self.tcp_total_out_packets = None
                                            self.tcp_total_out_bytes = None
                                            self.tcp_bytes_saved = None
                                            self.tcp_compressed_packets_out = None
                                            self.tcp_bytes_sent_rate = None
                                            self.tcp_full_header_packets_out = None
                                            self._segment_path = lambda: "iphc-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                    class ChildPolicy(Entity):
                                        """
                                        child policy
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\: str
                                        
                                        	**length:** 0..128
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy, self).__init__()

                                            self.yang_name = "child-policy"
                                            self.yang_parent_name = "class-stats"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_))])
                                            self._leafs = OrderedDict([
                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                            ])
                                            self.policy_name = None
                                            self.state = None
                                            self.state_description = None
                                            self.satid = None

                                            self.class_stats = YList(self)
                                            self._segment_path = lambda: "child-policy"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                        class ClassStats_(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\: str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "child-policy"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                self._leafs = OrderedDict([
                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                ])
                                                self.counter_validity_bitmask = None
                                                self.class_name = None
                                                self.shared_queue_id = None
                                                self.queue_descr = None
                                                self.cac_state = None

                                                self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"

                                                self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                self.queue_stats_array = YList(self)
                                                self.police_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)
                                                self._segment_path = lambda: "class-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                    ])
                                                    self.transmit_packets = None
                                                    self.transmit_bytes = None
                                                    self.total_drop_packets = None
                                                    self.total_drop_bytes = None
                                                    self.total_drop_rate = None
                                                    self.match_data_rate = None
                                                    self.total_transmit_rate = None
                                                    self.pre_policy_matched_packets = None
                                                    self.pre_policy_matched_bytes = None
                                                    self._segment_path = lambda: "general-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                    ])
                                                    self.non_tcp_total_out_packets = None
                                                    self.non_tcp_total_out_bytes = None
                                                    self.non_tcp_bytes_saved = None
                                                    self.non_tcp_compressed_packets_out = None
                                                    self.non_tcp_bytes_sent_rate = None
                                                    self.non_tcp_full_header_packets_out = None
                                                    self.tcp_total_out_packets = None
                                                    self.tcp_total_out_bytes = None
                                                    self.tcp_bytes_saved = None
                                                    self.tcp_compressed_packets_out = None
                                                    self.tcp_bytes_sent_rate = None
                                                    self.tcp_full_header_packets_out = None
                                                    self._segment_path = lambda: "iphc-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.drop_rates = None
                                                    self.admitpackets = None
                                                    self.admit_bytes = None
                                                    self.admit_rates = None
                                                    self._segment_path = lambda: "cac-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\: bool
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                    self._leafs = OrderedDict([
                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ])
                                                    self.queue_id = None
                                                    self.tail_drop_packets = None
                                                    self.tail_drop_bytes = None
                                                    self.atm_clp0_drop_packets = None
                                                    self.atm_clp0_drop_bytes = None
                                                    self.atm_clp1_drop_packets = None
                                                    self.atm_clp1_drop_bytes = None
                                                    self.queue_drop_threshold = None
                                                    self.forced_wred_stats_display = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None

                                                    self.queue_instance_length = YList(self)
                                                    self.queue_average_length = YList(self)
                                                    self.queue_max_length = YList(self)
                                                    self._segment_path = lambda: "queue-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-instance-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-average-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-max-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.violate_packets = None
                                                    self.violate_bytes = None
                                                    self.parent_drop_packets = None
                                                    self.parent_drop_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None
                                                    self.violate_rate = None

                                                    self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._segment_path = lambda: "police-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                        ])
                                                        self.conform_class_conform_packets = None
                                                        self.conform_class_conform_bytes = None
                                                        self.conform_class_conform_rate = None
                                                        self.conform_class_exceed_packets = None
                                                        self.conform_class_exceed_bytes = None
                                                        self.conform_class_exceed_rate = None
                                                        self.conform_class_violate_packets = None
                                                        self.conform_class_violate_bytes = None
                                                        self.conform_class_violate_rate = None
                                                        self.exceed_class_exceed_packets = None
                                                        self.exceed_class_exceed_bytes = None
                                                        self.exceed_class_exceed_rate = None
                                                        self.exceed_class_violate_packets = None
                                                        self.exceed_class_violate_bytes = None
                                                        self.exceed_class_violate_rate = None
                                                        self.violate_class_violate_packets = None
                                                        self.violate_class_violate_bytes = None
                                                        self.violate_class_violate_rate = None
                                                        self._segment_path = lambda: "color-class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\: str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                    self._leafs = OrderedDict([
                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                    ])
                                                    self.profile_title = None
                                                    self.red_transmit_packets = None
                                                    self.red_transmit_bytes = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.red_ecn_marked_packets = None
                                                    self.red_ecn_marked_bytes = None

                                                    self.red_label = YList(self)
                                                    self._segment_path = lambda: "wred-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                        ])
                                                        self.wred_type = None
                                                        self.value = None
                                                        self._segment_path = lambda: "red-label"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                    class CacStats(Entity):
                                        """
                                        bag for cac stats
                                        
                                        .. attribute:: drop_packets
                                        
                                        	CAC dropped packets
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: drop_bytes
                                        
                                        	CAC dropped bytes
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_rates
                                        
                                        	CAC dropped rate
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: admitpackets
                                        
                                        	Admitted packets (pkts/bytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: admit_bytes
                                        
                                        	Admitted bytes (pkts/bytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: admit_rates
                                        
                                        	CAC admit rate
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.CacStats, self).__init__()

                                            self.yang_name = "cac-stats"
                                            self.yang_parent_name = "class-stats"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                            ])
                                            self.drop_packets = None
                                            self.drop_bytes = None
                                            self.drop_rates = None
                                            self.admitpackets = None
                                            self.admit_bytes = None
                                            self.admit_rates = None
                                            self._segment_path = lambda: "cac-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                    class QueueStatsArray(Entity):
                                        """
                                        array of queue stats
                                        
                                        .. attribute:: queue_id
                                        
                                        	Queue Id used for Fabric Stats
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tail_drop_packets
                                        
                                        	Packets tail dropped
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tail_drop_bytes
                                        
                                        	Bytes tail dropped
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: atm_clp0_drop_packets
                                        
                                        	ATP CLP 0 matched packets dropped
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: atm_clp0_drop_bytes
                                        
                                        	ATP CLP 0 matched bytes dropped
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: atm_clp1_drop_packets
                                        
                                        	ATP CLP 0 matched packets dropped
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: atm_clp1_drop_bytes
                                        
                                        	ATP CLP 0 matched bytes dropped
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: queue_drop_threshold
                                        
                                        	tail drop threshold of the queue in bytes
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: forced_wred_stats_display
                                        
                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                        	**type**\: bool
                                        
                                        .. attribute:: random_drop_packets
                                        
                                        	Packets probabilistically dropped
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: random_drop_bytes
                                        
                                        	Bytes probabilistically dropped
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: max_threshold_packets
                                        
                                        	Dropped packets with the average queue size at the max\-threshold
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: max_threshold_bytes
                                        
                                        	Dropped bytes with the average queue size at the max\-threshold
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_packets
                                        
                                        	Packets that conform  to the queue rate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_bytes
                                        
                                        	Bytes that conform to the queue rate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_packets
                                        
                                        	Packets that exceed the queue rate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_bytes
                                        
                                        	Bytes that exceed  the queue rate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_rate
                                        
                                        	Conform rate
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: exceed_rate
                                        
                                        	Exceed rate
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_instance_length
                                        
                                        	Queue instance length
                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                        
                                        .. attribute:: queue_average_length
                                        
                                        	Queue average length
                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength>`
                                        
                                        .. attribute:: queue_max_length
                                        
                                        	Queue maximum length
                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray, self).__init__()

                                            self.yang_name = "queue-stats-array"
                                            self.yang_parent_name = "class-stats"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength))])
                                            self._leafs = OrderedDict([
                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                            ])
                                            self.queue_id = None
                                            self.tail_drop_packets = None
                                            self.tail_drop_bytes = None
                                            self.atm_clp0_drop_packets = None
                                            self.atm_clp0_drop_bytes = None
                                            self.atm_clp1_drop_packets = None
                                            self.atm_clp1_drop_bytes = None
                                            self.queue_drop_threshold = None
                                            self.forced_wred_stats_display = None
                                            self.random_drop_packets = None
                                            self.random_drop_bytes = None
                                            self.max_threshold_packets = None
                                            self.max_threshold_bytes = None
                                            self.conform_packets = None
                                            self.conform_bytes = None
                                            self.exceed_packets = None
                                            self.exceed_bytes = None
                                            self.conform_rate = None
                                            self.exceed_rate = None

                                            self.queue_instance_length = YList(self)
                                            self.queue_average_length = YList(self)
                                            self.queue_max_length = YList(self)
                                            self._segment_path = lambda: "queue-stats-array"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                        class QueueInstanceLength(Entity):
                                            """
                                            Queue instance length
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                self.yang_name = "queue-instance-length"
                                                self.yang_parent_name = "queue-stats-array"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                ])
                                                self.value = None
                                                self.unit = None
                                                self._segment_path = lambda: "queue-instance-length"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                        class QueueAverageLength(Entity):
                                            """
                                            Queue average length
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                self.yang_name = "queue-average-length"
                                                self.yang_parent_name = "queue-stats-array"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                ])
                                                self.value = None
                                                self.unit = None
                                                self._segment_path = lambda: "queue-average-length"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                        class QueueMaxLength(Entity):
                                            """
                                            Queue maximum length
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                self.yang_name = "queue-max-length"
                                                self.yang_parent_name = "queue-stats-array"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                ])
                                                self.value = None
                                                self.unit = None
                                                self._segment_path = lambda: "queue-max-length"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                    class PoliceStatsArray(Entity):
                                        """
                                        array of police stats
                                        
                                        .. attribute:: color_class_stats
                                        
                                        	color class stats
                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats>`
                                        
                                        .. attribute:: drop_packets
                                        
                                        	Police dropped packets
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: drop_bytes
                                        
                                        	Police dropped bytes
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_packets
                                        
                                        	Packets that conform  to the policed rate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_bytes
                                        
                                        	Bytes that conform to the policed rate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_packets
                                        
                                        	Packets that exceed the policed rate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_bytes
                                        
                                        	Bytes that exceed  the policed rate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_packets
                                        
                                        	Packets violating the policed rate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_bytes
                                        
                                        	Bytes that violate the policed rate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: parent_drop_packets
                                        
                                        	Dropped pkts by the parent policer
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: parent_drop_bytes
                                        
                                        	Dropped bytes by the parent policer
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_rate
                                        
                                        	Conform rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_rate
                                        
                                        	Exceed rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_rate
                                        
                                        	Violate rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray, self).__init__()

                                            self.yang_name = "police-stats-array"
                                            self.yang_parent_name = "class-stats"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats))])
                                            self._leafs = OrderedDict([
                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                            ])
                                            self.drop_packets = None
                                            self.drop_bytes = None
                                            self.conform_packets = None
                                            self.conform_bytes = None
                                            self.exceed_packets = None
                                            self.exceed_bytes = None
                                            self.violate_packets = None
                                            self.violate_bytes = None
                                            self.parent_drop_packets = None
                                            self.parent_drop_bytes = None
                                            self.conform_rate = None
                                            self.exceed_rate = None
                                            self.violate_rate = None

                                            self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats()
                                            self.color_class_stats.parent = self
                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                            self._segment_path = lambda: "police-stats-array"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                        class ColorClassStats(Entity):
                                            """
                                            color class stats
                                            
                                            .. attribute:: conform_class_conform_packets
                                            
                                            	Packets with classification result conform and policer result conform
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_conform_bytes
                                            
                                            	Bytes with classification result conform and policer result conform
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_conform_rate
                                            
                                            	Conform Class Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: conform_class_exceed_packets
                                            
                                            	Packets with classification result conform and policer result exceed
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_exceed_bytes
                                            
                                            	Bytes with classification result conform and policer result exceed
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_exceed_rate
                                            
                                            	Conform Class Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: conform_class_violate_packets
                                            
                                            	Packets with classification result conform and policer result violate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_violate_bytes
                                            
                                            	Bytes with classification result conform and policer result violate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_violate_rate
                                            
                                            	Conform Class Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_class_exceed_packets
                                            
                                            	Packets with classification result exceed and policer result exceed
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_class_exceed_bytes
                                            
                                            	Bytes with classification result exceed and policer result exceed
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_class_exceed_rate
                                            
                                            	Exceed Class Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_class_violate_packets
                                            
                                            	Packets with classification result exceed and policer result violate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_class_violate_bytes
                                            
                                            	Bytes with classification result exceed and policer result violate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_class_violate_rate
                                            
                                            	Exceed Class Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_class_violate_packets
                                            
                                            	Packets with classification result violate and policer result violate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_class_violate_bytes
                                            
                                            	Bytes with classification result violate and policer result violate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_class_violate_rate
                                            
                                            	Violate Class Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                self.yang_name = "color-class-stats"
                                                self.yang_parent_name = "police-stats-array"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                ])
                                                self.conform_class_conform_packets = None
                                                self.conform_class_conform_bytes = None
                                                self.conform_class_conform_rate = None
                                                self.conform_class_exceed_packets = None
                                                self.conform_class_exceed_bytes = None
                                                self.conform_class_exceed_rate = None
                                                self.conform_class_violate_packets = None
                                                self.conform_class_violate_bytes = None
                                                self.conform_class_violate_rate = None
                                                self.exceed_class_exceed_packets = None
                                                self.exceed_class_exceed_bytes = None
                                                self.exceed_class_exceed_rate = None
                                                self.exceed_class_violate_packets = None
                                                self.exceed_class_violate_bytes = None
                                                self.exceed_class_violate_rate = None
                                                self.violate_class_violate_packets = None
                                                self.violate_class_violate_bytes = None
                                                self.violate_class_violate_rate = None
                                                self._segment_path = lambda: "color-class-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                    class WredStatsArray(Entity):
                                        """
                                        array of red stats
                                        
                                        .. attribute:: profile_title
                                        
                                        	ProfileTitle
                                        	**type**\: str
                                        
                                        	**length:** 0..300
                                        
                                        .. attribute:: red_transmit_packets
                                        
                                        	Transmitted packets
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: red_transmit_bytes
                                        
                                        	Transmitted bytes
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: random_drop_packets
                                        
                                        	Probabilistically dropped  packets
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: random_drop_bytes
                                        
                                        	Probabilisticallydropped bytes
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: max_threshold_packets
                                        
                                        	Dropped packets with  the average queue size at the max\-threshold
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: max_threshold_bytes
                                        
                                        	Dropped bytes with  the average queue size at the max\-threshold
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: red_ecn_marked_packets
                                        
                                        	ECN marked packets 
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: red_ecn_marked_bytes
                                        
                                        	ECN marked bytes
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: red_label
                                        
                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray.RedLabel>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray, self).__init__()

                                            self.yang_name = "wred-stats-array"
                                            self.yang_parent_name = "class-stats"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray.RedLabel))])
                                            self._leafs = OrderedDict([
                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                            ])
                                            self.profile_title = None
                                            self.red_transmit_packets = None
                                            self.red_transmit_bytes = None
                                            self.random_drop_packets = None
                                            self.random_drop_bytes = None
                                            self.max_threshold_packets = None
                                            self.max_threshold_bytes = None
                                            self.red_ecn_marked_packets = None
                                            self.red_ecn_marked_bytes = None

                                            self.red_label = YList(self)
                                            self._segment_path = lambda: "wred-stats-array"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                        class RedLabel(Entity):
                                            """
                                            Array of WRED Typevalues as in PRP stats is
                                            available per threshold   
                                            
                                            .. attribute:: wred_type
                                            
                                            	WRED type DSCP, EXP, PREC etc
                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                            
                                            .. attribute:: value
                                            
                                            	WRED value for this type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                self.yang_name = "red-label"
                                                self.yang_parent_name = "wred-stats-array"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                ])
                                                self.wred_type = None
                                                self.value = None
                                                self._segment_path = lambda: "red-label"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                        class VoQMemberInterfaces(Entity):
                            """
                            VoQ QoS policy\-map member interface table
                            
                            .. attribute:: vo_q_member_interface
                            
                            	QoS policy\-map member interface statistics
                            	**type**\: list of  		 :py:class:`VoQMemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces, self).__init__()

                                self.yang_name = "vo-q-member-interfaces"
                                self.yang_parent_name = "vo-qinterface"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("vo-q-member-interface", ("vo_q_member_interface", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface))])
                                self._leafs = OrderedDict()

                                self.vo_q_member_interface = YList(self)
                                self._segment_path = lambda: "vo-q-member-interfaces"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces, [], name, value)


                            class VoQMemberInterface(Entity):
                                """
                                QoS policy\-map member interface statistics
                                
                                .. attribute:: interface_name  (key)
                                
                                	Name of member interface
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                .. attribute:: vo_qoutput
                                
                                	output VoQ interface
                                	**type**\:  :py:class:`VoQoutput <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface, self).__init__()

                                    self.yang_name = "vo-q-member-interface"
                                    self.yang_parent_name = "vo-q-member-interfaces"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['interface_name']
                                    self._child_classes = OrderedDict([("vo-qoutput", ("vo_qoutput", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput))])
                                    self._leafs = OrderedDict([
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ])
                                    self.interface_name = None

                                    self.vo_qoutput = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput()
                                    self.vo_qoutput.parent = self
                                    self._children_name_map["vo_qoutput"] = "vo-qoutput"
                                    self._segment_path = lambda: "vo-q-member-interface" + "[interface-name='" + str(self.interface_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface, ['interface_name'], name, value)


                                class VoQoutput(Entity):
                                    """
                                    output VoQ interface
                                    
                                    .. attribute:: vo_q_stats
                                    
                                    	VoQ statistics operational data for an interface
                                    	**type**\:  :py:class:`VoQStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput, self).__init__()

                                        self.yang_name = "vo-qoutput"
                                        self.yang_parent_name = "vo-q-member-interface"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("vo-q-stats", ("vo_q_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats))])
                                        self._leafs = OrderedDict()

                                        self.vo_q_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats()
                                        self.vo_q_stats.parent = self
                                        self._children_name_map["vo_q_stats"] = "vo-q-stats"
                                        self._segment_path = lambda: "vo-qoutput"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput, [], name, value)


                                    class VoQStats(Entity):
                                        """
                                        VoQ statistics operational data for an interface
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\: str
                                        
                                        	**length:** 0..128
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats, self).__init__()

                                            self.yang_name = "vo-q-stats"
                                            self.yang_parent_name = "vo-qoutput"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats))])
                                            self._leafs = OrderedDict([
                                                ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                            ])
                                            self.policy_name = None
                                            self.state = None
                                            self.state_description = None
                                            self.satid = None

                                            self.class_stats = YList(self)
                                            self._segment_path = lambda: "vo-q-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.IphcStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.CacStats>`
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\: str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "vo-q-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray))])
                                                self._leafs = OrderedDict([
                                                    ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                    ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                    ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                    ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                ])
                                                self.counter_validity_bitmask = None
                                                self.class_name = None
                                                self.shared_queue_id = None
                                                self.queue_descr = None
                                                self.cac_state = None

                                                self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"

                                                self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"

                                                self.child_policy = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"

                                                self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"

                                                self.queue_stats_array = YList(self)
                                                self.police_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)
                                                self._segment_path = lambda: "class-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                        ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                        ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                        ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                        ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                        ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                        ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                        ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                        ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                    ])
                                                    self.transmit_packets = None
                                                    self.transmit_bytes = None
                                                    self.total_drop_packets = None
                                                    self.total_drop_bytes = None
                                                    self.total_drop_rate = None
                                                    self.match_data_rate = None
                                                    self.total_transmit_rate = None
                                                    self.pre_policy_matched_packets = None
                                                    self.pre_policy_matched_bytes = None
                                                    self._segment_path = lambda: "general-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                        ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                        ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                        ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                        ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                        ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                        ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                        ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                        ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                        ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                        ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                        ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                    ])
                                                    self.non_tcp_total_out_packets = None
                                                    self.non_tcp_total_out_bytes = None
                                                    self.non_tcp_bytes_saved = None
                                                    self.non_tcp_compressed_packets_out = None
                                                    self.non_tcp_bytes_sent_rate = None
                                                    self.non_tcp_full_header_packets_out = None
                                                    self.tcp_total_out_packets = None
                                                    self.tcp_total_out_bytes = None
                                                    self.tcp_bytes_saved = None
                                                    self.tcp_compressed_packets_out = None
                                                    self.tcp_bytes_sent_rate = None
                                                    self.tcp_full_header_packets_out = None
                                                    self._segment_path = lambda: "iphc-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\: str
                                                
                                                	**length:** 0..128
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                        ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                        ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                    ])
                                                    self.policy_name = None
                                                    self.state = None
                                                    self.state_description = None
                                                    self.satid = None

                                                    self.class_stats = YList(self)
                                                    self._segment_path = lambda: "child-policy"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                class ClassStats_(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                        self._leafs = OrderedDict([
                                                            ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                            ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                            ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                        ])
                                                        self.counter_validity_bitmask = None
                                                        self.class_name = None
                                                        self.shared_queue_id = None
                                                        self.queue_descr = None
                                                        self.cac_state = None

                                                        self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"

                                                        self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"

                                                        self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"

                                                        self.queue_stats_array = YList(self)
                                                        self.police_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)
                                                        self._segment_path = lambda: "class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                            ])
                                                            self.transmit_packets = None
                                                            self.transmit_bytes = None
                                                            self.total_drop_packets = None
                                                            self.total_drop_bytes = None
                                                            self.total_drop_rate = None
                                                            self.match_data_rate = None
                                                            self.total_transmit_rate = None
                                                            self.pre_policy_matched_packets = None
                                                            self.pre_policy_matched_bytes = None
                                                            self._segment_path = lambda: "general-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                            ])
                                                            self.non_tcp_total_out_packets = None
                                                            self.non_tcp_total_out_bytes = None
                                                            self.non_tcp_bytes_saved = None
                                                            self.non_tcp_compressed_packets_out = None
                                                            self.non_tcp_bytes_sent_rate = None
                                                            self.non_tcp_full_header_packets_out = None
                                                            self.tcp_total_out_packets = None
                                                            self.tcp_total_out_bytes = None
                                                            self.tcp_bytes_saved = None
                                                            self.tcp_compressed_packets_out = None
                                                            self.tcp_bytes_sent_rate = None
                                                            self.tcp_full_header_packets_out = None
                                                            self._segment_path = lambda: "iphc-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.drop_rates = None
                                                            self.admitpackets = None
                                                            self.admit_bytes = None
                                                            self.admit_rates = None
                                                            self._segment_path = lambda: "cac-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\: bool
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                            self._leafs = OrderedDict([
                                                                ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ])
                                                            self.queue_id = None
                                                            self.tail_drop_packets = None
                                                            self.tail_drop_bytes = None
                                                            self.atm_clp0_drop_packets = None
                                                            self.atm_clp0_drop_bytes = None
                                                            self.atm_clp1_drop_packets = None
                                                            self.atm_clp1_drop_bytes = None
                                                            self.queue_drop_threshold = None
                                                            self.forced_wred_stats_display = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None

                                                            self.queue_instance_length = YList(self)
                                                            self.queue_average_length = YList(self)
                                                            self.queue_max_length = YList(self)
                                                            self._segment_path = lambda: "queue-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-instance-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-average-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                ])
                                                                self.value = None
                                                                self.unit = None
                                                                self._segment_path = lambda: "queue-max-length"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                            self._leafs = OrderedDict([
                                                                ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                            ])
                                                            self.drop_packets = None
                                                            self.drop_bytes = None
                                                            self.conform_packets = None
                                                            self.conform_bytes = None
                                                            self.exceed_packets = None
                                                            self.exceed_bytes = None
                                                            self.violate_packets = None
                                                            self.violate_bytes = None
                                                            self.parent_drop_packets = None
                                                            self.parent_drop_bytes = None
                                                            self.conform_rate = None
                                                            self.exceed_rate = None
                                                            self.violate_rate = None

                                                            self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._segment_path = lambda: "police-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                    ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                    ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                    ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                    ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                    ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                    ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                    ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                    ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                    ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                    ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                    ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                    ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                    ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                    ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                    ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                    ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                    ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                ])
                                                                self.conform_class_conform_packets = None
                                                                self.conform_class_conform_bytes = None
                                                                self.conform_class_conform_rate = None
                                                                self.conform_class_exceed_packets = None
                                                                self.conform_class_exceed_bytes = None
                                                                self.conform_class_exceed_rate = None
                                                                self.conform_class_violate_packets = None
                                                                self.conform_class_violate_bytes = None
                                                                self.conform_class_violate_rate = None
                                                                self.exceed_class_exceed_packets = None
                                                                self.exceed_class_exceed_bytes = None
                                                                self.exceed_class_exceed_rate = None
                                                                self.exceed_class_violate_packets = None
                                                                self.exceed_class_violate_bytes = None
                                                                self.exceed_class_violate_rate = None
                                                                self.violate_class_violate_packets = None
                                                                self.violate_class_violate_bytes = None
                                                                self.violate_class_violate_rate = None
                                                                self._segment_path = lambda: "color-class-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("red-label", ("red_label", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                            self._leafs = OrderedDict([
                                                                ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                            ])
                                                            self.profile_title = None
                                                            self.red_transmit_packets = None
                                                            self.red_transmit_bytes = None
                                                            self.random_drop_packets = None
                                                            self.random_drop_bytes = None
                                                            self.max_threshold_packets = None
                                                            self.max_threshold_bytes = None
                                                            self.red_ecn_marked_packets = None
                                                            self.red_ecn_marked_bytes = None

                                                            self.red_label = YList(self)
                                                            self._segment_path = lambda: "wred-stats-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                    ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                ])
                                                                self.wred_type = None
                                                                self.value = None
                                                                self._segment_path = lambda: "red-label"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                        ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                        ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                        ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.drop_rates = None
                                                    self.admitpackets = None
                                                    self.admit_bytes = None
                                                    self.admit_rates = None
                                                    self._segment_path = lambda: "cac-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\: bool
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                    self._leafs = OrderedDict([
                                                        ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                        ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                        ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                        ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                        ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                        ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                        ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                        ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                        ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ])
                                                    self.queue_id = None
                                                    self.tail_drop_packets = None
                                                    self.tail_drop_bytes = None
                                                    self.atm_clp0_drop_packets = None
                                                    self.atm_clp0_drop_bytes = None
                                                    self.atm_clp1_drop_packets = None
                                                    self.atm_clp1_drop_bytes = None
                                                    self.queue_drop_threshold = None
                                                    self.forced_wred_stats_display = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None

                                                    self.queue_instance_length = YList(self)
                                                    self.queue_average_length = YList(self)
                                                    self.queue_max_length = YList(self)
                                                    self._segment_path = lambda: "queue-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-instance-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-average-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                        ])
                                                        self.value = None
                                                        self.unit = None
                                                        self._segment_path = lambda: "queue-max-length"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                    self._leafs = OrderedDict([
                                                        ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                        ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                        ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                        ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                        ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                        ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                        ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                        ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                        ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                        ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                        ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                        ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                    ])
                                                    self.drop_packets = None
                                                    self.drop_bytes = None
                                                    self.conform_packets = None
                                                    self.conform_bytes = None
                                                    self.exceed_packets = None
                                                    self.exceed_bytes = None
                                                    self.violate_packets = None
                                                    self.violate_bytes = None
                                                    self.parent_drop_packets = None
                                                    self.parent_drop_bytes = None
                                                    self.conform_rate = None
                                                    self.exceed_rate = None
                                                    self.violate_rate = None

                                                    self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._segment_path = lambda: "police-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                            ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                            ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                            ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                            ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                            ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                            ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                            ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                            ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                            ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                            ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                            ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                            ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                            ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                            ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                            ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                            ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                            ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                        ])
                                                        self.conform_class_conform_packets = None
                                                        self.conform_class_conform_bytes = None
                                                        self.conform_class_conform_rate = None
                                                        self.conform_class_exceed_packets = None
                                                        self.conform_class_exceed_bytes = None
                                                        self.conform_class_exceed_rate = None
                                                        self.conform_class_violate_packets = None
                                                        self.conform_class_violate_bytes = None
                                                        self.conform_class_violate_rate = None
                                                        self.exceed_class_exceed_packets = None
                                                        self.exceed_class_exceed_bytes = None
                                                        self.exceed_class_exceed_rate = None
                                                        self.exceed_class_violate_packets = None
                                                        self.exceed_class_violate_bytes = None
                                                        self.exceed_class_violate_rate = None
                                                        self.violate_class_violate_packets = None
                                                        self.violate_class_violate_bytes = None
                                                        self.violate_class_violate_rate = None
                                                        self._segment_path = lambda: "color-class-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\: str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("red-label", ("red_label", Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray.RedLabel))])
                                                    self._leafs = OrderedDict([
                                                        ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                        ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                        ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                        ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                        ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                        ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                        ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                        ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                        ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                    ])
                                                    self.profile_title = None
                                                    self.red_transmit_packets = None
                                                    self.red_transmit_bytes = None
                                                    self.random_drop_packets = None
                                                    self.random_drop_bytes = None
                                                    self.max_threshold_packets = None
                                                    self.max_threshold_bytes = None
                                                    self.red_ecn_marked_packets = None
                                                    self.red_ecn_marked_bytes = None

                                                    self.red_label = YList(self)
                                                    self._segment_path = lambda: "wred-stats-array"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                            ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                        ])
                                                        self.wred_type = None
                                                        self.value = None
                                                        self._segment_path = lambda: "red-label"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


    class InterfaceTable(Entity):
        """
        Operational data for all interfaces
        
        .. attribute:: interface
        
        	QoS policy\-map operational data for a particular interface
        	**type**\: list of  		 :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface>`
        
        

        """

        _prefix = 'qos-ma-oper'
        _revision = '2017-09-13'

        def __init__(self):
            super(Qos.InterfaceTable, self).__init__()

            self.yang_name = "interface-table"
            self.yang_parent_name = "qos"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("interface", ("interface", Qos.InterfaceTable.Interface))])
            self._leafs = OrderedDict()

            self.interface = YList(self)
            self._segment_path = lambda: "interface-table"
            self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Qos.InterfaceTable, [], name, value)


        class Interface(Entity):
            """
            QoS policy\-map operational data for a particular
            interface
            
            .. attribute:: interface_name  (key)
            
            	Name of the interface
            	**type**\: str
            
            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
            
            .. attribute:: nodes
            
            	QoS policy\-map node table
            	**type**\:  :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes>`
            
            .. attribute:: member_interfaces
            
            	QoS policy\-map member interface table
            	**type**\:  :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces>`
            
            .. attribute:: satellite_ids
            
            	Satellite ID information
            	**type**\:  :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds>`
            
            .. attribute:: input
            
            	A piece of QoS policy\-map operational data for an interface
            	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input>`
            
            .. attribute:: output
            
            	A piece of QoS policy\-map operational data for an interface
            	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output>`
            
            

            """

            _prefix = 'qos-ma-oper'
            _revision = '2017-09-13'

            def __init__(self):
                super(Qos.InterfaceTable.Interface, self).__init__()

                self.yang_name = "interface"
                self.yang_parent_name = "interface-table"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['interface_name']
                self._child_classes = OrderedDict([("nodes", ("nodes", Qos.InterfaceTable.Interface.Nodes)), ("member-interfaces", ("member_interfaces", Qos.InterfaceTable.Interface.MemberInterfaces)), ("satellite-ids", ("satellite_ids", Qos.InterfaceTable.Interface.SatelliteIds)), ("input", ("input", Qos.InterfaceTable.Interface.Input)), ("output", ("output", Qos.InterfaceTable.Interface.Output))])
                self._leafs = OrderedDict([
                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                ])
                self.interface_name = None

                self.nodes = Qos.InterfaceTable.Interface.Nodes()
                self.nodes.parent = self
                self._children_name_map["nodes"] = "nodes"

                self.member_interfaces = Qos.InterfaceTable.Interface.MemberInterfaces()
                self.member_interfaces.parent = self
                self._children_name_map["member_interfaces"] = "member-interfaces"

                self.satellite_ids = Qos.InterfaceTable.Interface.SatelliteIds()
                self.satellite_ids.parent = self
                self._children_name_map["satellite_ids"] = "satellite-ids"

                self.input = Qos.InterfaceTable.Interface.Input()
                self.input.parent = self
                self._children_name_map["input"] = "input"

                self.output = Qos.InterfaceTable.Interface.Output()
                self.output.parent = self
                self._children_name_map["output"] = "output"
                self._segment_path = lambda: "interface" + "[interface-name='" + str(self.interface_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-qos-ma-oper:qos/interface-table/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Qos.InterfaceTable.Interface, ['interface_name'], name, value)


            class Nodes(Entity):
                """
                QoS policy\-map node table
                
                .. attribute:: node
                
                	QoS operational data for a particular node
                	**type**\: list of  		 :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.InterfaceTable.Interface.Nodes, self).__init__()

                    self.yang_name = "nodes"
                    self.yang_parent_name = "interface"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("node", ("node", Qos.InterfaceTable.Interface.Nodes.Node))])
                    self._leafs = OrderedDict()

                    self.node = YList(self)
                    self._segment_path = lambda: "nodes"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes, [], name, value)


                class Node(Entity):
                    """
                    QoS operational data for a particular node
                    
                    .. attribute:: node_name  (key)
                    
                    	The node
                    	**type**\: str
                    
                    	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
                    
                    .. attribute:: input
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input>`
                    
                    .. attribute:: output
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.InterfaceTable.Interface.Nodes.Node, self).__init__()

                        self.yang_name = "node"
                        self.yang_parent_name = "nodes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = ['node_name']
                        self._child_classes = OrderedDict([("input", ("input", Qos.InterfaceTable.Interface.Nodes.Node.Input)), ("output", ("output", Qos.InterfaceTable.Interface.Nodes.Node.Output))])
                        self._leafs = OrderedDict([
                            ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                        ])
                        self.node_name = None

                        self.input = Qos.InterfaceTable.Interface.Nodes.Node.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"

                        self.output = Qos.InterfaceTable.Interface.Nodes.Node.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                        self._segment_path = lambda: "node" + "[node-name='" + str(self.node_name) + "']"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node, ['node_name'], name, value)


                    class Input(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input, self).__init__()

                            self.yang_name = "input"
                            self.yang_parent_name = "node"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames))])
                            self._leafs = OrderedDict()

                            self.service_policy_names = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._segment_path = lambda: "input"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input, [], name, value)


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "input"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance))])
                                self._leafs = OrderedDict()

                                self.service_policy_instance = YList(self)
                                self._segment_path = lambda: "service-policy-names"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames, [], name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  (key)
                                
                                	Name of the policy instance
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['service_policy_name']
                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                    ])
                                    self.service_policy_name = None

                                    self.statistics = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "service-policy-instance"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.child_policy = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"

                                            self.cac_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "child-policy"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats_(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.cac_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                    class Output(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output, self).__init__()

                            self.yang_name = "output"
                            self.yang_parent_name = "node"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames))])
                            self._leafs = OrderedDict()

                            self.service_policy_names = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._segment_path = lambda: "output"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output, [], name, value)


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "output"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance))])
                                self._leafs = OrderedDict()

                                self.service_policy_instance = YList(self)
                                self._segment_path = lambda: "service-policy-names"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames, [], name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  (key)
                                
                                	Name of the policy instance
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['service_policy_name']
                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                    ])
                                    self.service_policy_name = None

                                    self.statistics = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "service-policy-instance"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.child_policy = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"

                                            self.cac_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "child-policy"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats_(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.cac_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


            class MemberInterfaces(Entity):
                """
                QoS policy\-map member interface table
                
                .. attribute:: member_interface
                
                	QoS policy\-map member interface statistics
                	**type**\: list of  		 :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.InterfaceTable.Interface.MemberInterfaces, self).__init__()

                    self.yang_name = "member-interfaces"
                    self.yang_parent_name = "interface"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("member-interface", ("member_interface", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface))])
                    self._leafs = OrderedDict()

                    self.member_interface = YList(self)
                    self._segment_path = lambda: "member-interfaces"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces, [], name, value)


                class MemberInterface(Entity):
                    """
                    QoS policy\-map member interface statistics
                    
                    .. attribute:: interface_name  (key)
                    
                    	Name of member interface
                    	**type**\: str
                    
                    	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                    
                    .. attribute:: satellite_ids
                    
                    	Satellite ID information
                    	**type**\:  :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds>`
                    
                    .. attribute:: input
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input>`
                    
                    .. attribute:: output
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface, self).__init__()

                        self.yang_name = "member-interface"
                        self.yang_parent_name = "member-interfaces"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = ['interface_name']
                        self._child_classes = OrderedDict([("satellite-ids", ("satellite_ids", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds)), ("input", ("input", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input)), ("output", ("output", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output))])
                        self._leafs = OrderedDict([
                            ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ])
                        self.interface_name = None

                        self.satellite_ids = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds()
                        self.satellite_ids.parent = self
                        self._children_name_map["satellite_ids"] = "satellite-ids"

                        self.input = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"

                        self.output = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                        self._segment_path = lambda: "member-interface" + "[interface-name='" + str(self.interface_name) + "']"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface, ['interface_name'], name, value)


                    class SatelliteIds(Entity):
                        """
                        Satellite ID information
                        
                        .. attribute:: satellite_id
                        
                        	Satellite ID information
                        	**type**\: list of  		 :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, self).__init__()

                            self.yang_name = "satellite-ids"
                            self.yang_parent_name = "member-interface"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("satellite-id", ("satellite_id", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId))])
                            self._leafs = OrderedDict()

                            self.satellite_id = YList(self)
                            self._segment_path = lambda: "satellite-ids"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, [], name, value)


                        class SatelliteId(Entity):
                            """
                            Satellite ID information
                            
                            .. attribute:: nv_satellite_id  (key)
                            
                            	Satellite ID
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: input
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input>`
                            
                            .. attribute:: output
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__init__()

                                self.yang_name = "satellite-id"
                                self.yang_parent_name = "satellite-ids"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['nv_satellite_id']
                                self._child_classes = OrderedDict([("input", ("input", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input)), ("output", ("output", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output))])
                                self._leafs = OrderedDict([
                                    ('nv_satellite_id', (YLeaf(YType.int32, 'nv-satellite-id'), ['int'])),
                                ])
                                self.nv_satellite_id = None

                                self.input = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"

                                self.output = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                                self._segment_path = lambda: "satellite-id" + "[nv-satellite-id='" + str(self.nv_satellite_id) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, ['nv_satellite_id'], name, value)


                            class Input(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: service_policy_names
                                
                                	Operational data for all Policy instance
                                	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, self).__init__()

                                    self.yang_name = "input"
                                    self.yang_parent_name = "satellite-id"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames))])
                                    self._leafs = OrderedDict()

                                    self.service_policy_names = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                    self._segment_path = lambda: "input"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, [], name, value)


                                class ServicePolicyNames(Entity):
                                    """
                                    Operational data for all Policy instance
                                    
                                    .. attribute:: service_policy_instance
                                    
                                    	QoS policy\-map operational data for a particular Policy 
                                    	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                        self.yang_name = "service-policy-names"
                                        self.yang_parent_name = "input"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_instance = YList(self)
                                        self._segment_path = lambda: "service-policy-names"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, [], name, value)


                                    class ServicePolicyInstance(Entity):
                                        """
                                        QoS policy\-map operational data for a
                                        particular Policy 
                                        
                                        .. attribute:: service_policy_name  (key)
                                        
                                        	Name of the policy instance
                                        	**type**\: str
                                        
                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                        
                                        .. attribute:: statistics
                                        
                                        	Policy\-map statistics operational data for an interface
                                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                            self.yang_name = "service-policy-instance"
                                            self.yang_parent_name = "service-policy-names"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = ['service_policy_name']
                                            self._child_classes = OrderedDict([("statistics", ("statistics", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                            self._leafs = OrderedDict([
                                                ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                            ])
                                            self.service_policy_name = None

                                            self.statistics = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                            self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                        class Statistics(Entity):
                                            """
                                            Policy\-map statistics operational data for an
                                            interface
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                self.yang_name = "statistics"
                                                self.yang_parent_name = "service-policy-instance"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "statistics"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                
                                                .. attribute:: child_policy
                                                
                                                	child policy
                                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "statistics"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.child_policy = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"

                                                    self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class ChildPolicy(Entity):
                                                    """
                                                    child policy
                                                    
                                                    .. attribute:: policy_name
                                                    
                                                    	PolicyName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: state
                                                    
                                                    	State
                                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                    
                                                    .. attribute:: state_description
                                                    
                                                    	StateDescription
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..128
                                                    
                                                    .. attribute:: satid
                                                    
                                                    	to maintain satellite id
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: class_stats
                                                    
                                                    	array of classes contained in policy
                                                    	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                        self.yang_name = "child-policy"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                        self._leafs = OrderedDict([
                                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                        ])
                                                        self.policy_name = None
                                                        self.state = None
                                                        self.state_description = None
                                                        self.satid = None

                                                        self.class_stats = YList(self)
                                                        self._segment_path = lambda: "child-policy"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                    class ClassStats_(Entity):
                                                        """
                                                        array of classes contained in policy
                                                        
                                                        .. attribute:: general_stats
                                                        
                                                        	general stats
                                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                        
                                                        .. attribute:: iphc_stats
                                                        
                                                        	IPHC stats
                                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                        
                                                        .. attribute:: cac_stats
                                                        
                                                        	bag for cac stats
                                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                        
                                                        .. attribute:: counter_validity_bitmask
                                                        
                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: megabyte
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	ClassName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: shared_queue_id
                                                        
                                                        	q\-id of the  shared queue for this class
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_descr
                                                        
                                                        	Description of queue for the class
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..256
                                                        
                                                        .. attribute:: cac_state
                                                        
                                                        	CACState
                                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                        
                                                        .. attribute:: queue_stats_array
                                                        
                                                        	array of queue stats
                                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                        
                                                        .. attribute:: police_stats_array
                                                        
                                                        	array of police stats
                                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                        
                                                        .. attribute:: wred_stats_array
                                                        
                                                        	array of red stats
                                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                            self.yang_name = "class-stats"
                                                            self.yang_parent_name = "child-policy"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                            self._leafs = OrderedDict([
                                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                            ])
                                                            self.counter_validity_bitmask = None
                                                            self.class_name = None
                                                            self.shared_queue_id = None
                                                            self.queue_descr = None
                                                            self.cac_state = None

                                                            self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"

                                                            self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                                            self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"

                                                            self.queue_stats_array = YList(self)
                                                            self.police_stats_array = YList(self)
                                                            self.wred_stats_array = YList(self)
                                                            self._segment_path = lambda: "class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                        class GeneralStats(Entity):
                                                            """
                                                            general stats
                                                            
                                                            .. attribute:: transmit_packets
                                                            
                                                            	Transmitted packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: transmit_bytes
                                                            
                                                            	Transmitted bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_packets
                                                            
                                                            	Dropped packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_bytes
                                                            
                                                            	Dropped bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_rate
                                                            
                                                            	Total drop rate (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: match_data_rate
                                                            
                                                            	Incoming matched data rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: total_transmit_rate
                                                            
                                                            	Total transmit rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: pre_policy_matched_packets
                                                            
                                                            	Matched pkts before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: pre_policy_matched_bytes
                                                            
                                                            	Matched bytes before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                self.yang_name = "general-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                ])
                                                                self.transmit_packets = None
                                                                self.transmit_bytes = None
                                                                self.total_drop_packets = None
                                                                self.total_drop_bytes = None
                                                                self.total_drop_rate = None
                                                                self.match_data_rate = None
                                                                self.total_transmit_rate = None
                                                                self.pre_policy_matched_packets = None
                                                                self.pre_policy_matched_bytes = None
                                                                self._segment_path = lambda: "general-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                        class IphcStats(Entity):
                                                            """
                                                            IPHC stats
                                                            
                                                            .. attribute:: non_tcp_total_out_packets
                                                            
                                                            	TotalNum of Non tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_total_out_bytes
                                                            
                                                            	TotalNum of Non Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_bytes_saved
                                                            
                                                            	Non Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_compressed_packets_out
                                                            
                                                            	Num of non tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                            
                                                            	Compressed Non Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_full_header_packets_out
                                                            
                                                            	Num of non tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_packets
                                                            
                                                            	Total Num of tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_bytes
                                                            
                                                            	TotalNum of Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_bytes_saved
                                                            
                                                            	Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_compressed_packets_out
                                                            
                                                            	Num of tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_bytes_sent_rate
                                                            
                                                            	Compressed Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_full_header_packets_out
                                                            
                                                            	Num of tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                self.yang_name = "iphc-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                ])
                                                                self.non_tcp_total_out_packets = None
                                                                self.non_tcp_total_out_bytes = None
                                                                self.non_tcp_bytes_saved = None
                                                                self.non_tcp_compressed_packets_out = None
                                                                self.non_tcp_bytes_sent_rate = None
                                                                self.non_tcp_full_header_packets_out = None
                                                                self.tcp_total_out_packets = None
                                                                self.tcp_total_out_bytes = None
                                                                self.tcp_bytes_saved = None
                                                                self.tcp_compressed_packets_out = None
                                                                self.tcp_bytes_sent_rate = None
                                                                self.tcp_full_header_packets_out = None
                                                                self._segment_path = lambda: "iphc-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                        class CacStats(Entity):
                                                            """
                                                            bag for cac stats
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	CAC dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	CAC dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_rates
                                                            
                                                            	CAC dropped rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: admitpackets
                                                            
                                                            	Admitted packets (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_bytes
                                                            
                                                            	Admitted bytes (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_rates
                                                            
                                                            	CAC admit rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                self.yang_name = "cac-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.drop_rates = None
                                                                self.admitpackets = None
                                                                self.admit_bytes = None
                                                                self.admit_rates = None
                                                                self._segment_path = lambda: "cac-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                        class QueueStatsArray(Entity):
                                                            """
                                                            array of queue stats
                                                            
                                                            .. attribute:: queue_id
                                                            
                                                            	Queue Id used for Fabric Stats
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: tail_drop_packets
                                                            
                                                            	Packets tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tail_drop_bytes
                                                            
                                                            	Bytes tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp0_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp0_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp1_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp1_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: queue_drop_threshold
                                                            
                                                            	tail drop threshold of the queue in bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: forced_wred_stats_display
                                                            
                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                            	**type**\: bool
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Packets probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Bytes probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_instance_length
                                                            
                                                            	Queue instance length
                                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                            
                                                            .. attribute:: queue_average_length
                                                            
                                                            	Queue average length
                                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                            
                                                            .. attribute:: queue_max_length
                                                            
                                                            	Queue maximum length
                                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                self.yang_name = "queue-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                self._leafs = OrderedDict([
                                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ])
                                                                self.queue_id = None
                                                                self.tail_drop_packets = None
                                                                self.tail_drop_bytes = None
                                                                self.atm_clp0_drop_packets = None
                                                                self.atm_clp0_drop_bytes = None
                                                                self.atm_clp1_drop_packets = None
                                                                self.atm_clp1_drop_bytes = None
                                                                self.queue_drop_threshold = None
                                                                self.forced_wred_stats_display = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None

                                                                self.queue_instance_length = YList(self)
                                                                self.queue_average_length = YList(self)
                                                                self.queue_max_length = YList(self)
                                                                self._segment_path = lambda: "queue-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                            class QueueInstanceLength(Entity):
                                                                """
                                                                Queue instance length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                    self.yang_name = "queue-instance-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-instance-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                            class QueueAverageLength(Entity):
                                                                """
                                                                Queue average length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                    self.yang_name = "queue-average-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-average-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                            class QueueMaxLength(Entity):
                                                                """
                                                                Queue maximum length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                    self.yang_name = "queue-max-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-max-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                        class PoliceStatsArray(Entity):
                                                            """
                                                            array of police stats
                                                            
                                                            .. attribute:: color_class_stats
                                                            
                                                            	color class stats
                                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	Police dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	Police dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_packets
                                                            
                                                            	Packets violating the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_bytes
                                                            
                                                            	Bytes that violate the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: parent_drop_packets
                                                            
                                                            	Dropped pkts by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: parent_drop_bytes
                                                            
                                                            	Dropped bytes by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_rate
                                                            
                                                            	Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                self.yang_name = "police-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.violate_packets = None
                                                                self.violate_bytes = None
                                                                self.parent_drop_packets = None
                                                                self.parent_drop_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None
                                                                self.violate_rate = None

                                                                self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                self._segment_path = lambda: "police-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                            class ColorClassStats(Entity):
                                                                """
                                                                color class stats
                                                                
                                                                .. attribute:: conform_class_conform_packets
                                                                
                                                                	Packets with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_conform_bytes
                                                                
                                                                	Bytes with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_conform_rate
                                                                
                                                                	Conform Class Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_exceed_packets
                                                                
                                                                	Packets with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_exceed_bytes
                                                                
                                                                	Bytes with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_exceed_rate
                                                                
                                                                	Conform Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_violate_packets
                                                                
                                                                	Packets with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_violate_bytes
                                                                
                                                                	Bytes with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_violate_rate
                                                                
                                                                	Conform Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_exceed_packets
                                                                
                                                                	Packets with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_exceed_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_exceed_rate
                                                                
                                                                	Exceed Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_violate_packets
                                                                
                                                                	Packets with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_violate_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_violate_rate
                                                                
                                                                	Exceed Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_class_violate_packets
                                                                
                                                                	Packets with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_class_violate_bytes
                                                                
                                                                	Bytes with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_class_violate_rate
                                                                
                                                                	Violate Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                    self.yang_name = "color-class-stats"
                                                                    self.yang_parent_name = "police-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                    ])
                                                                    self.conform_class_conform_packets = None
                                                                    self.conform_class_conform_bytes = None
                                                                    self.conform_class_conform_rate = None
                                                                    self.conform_class_exceed_packets = None
                                                                    self.conform_class_exceed_bytes = None
                                                                    self.conform_class_exceed_rate = None
                                                                    self.conform_class_violate_packets = None
                                                                    self.conform_class_violate_bytes = None
                                                                    self.conform_class_violate_rate = None
                                                                    self.exceed_class_exceed_packets = None
                                                                    self.exceed_class_exceed_bytes = None
                                                                    self.exceed_class_exceed_rate = None
                                                                    self.exceed_class_violate_packets = None
                                                                    self.exceed_class_violate_bytes = None
                                                                    self.exceed_class_violate_rate = None
                                                                    self.violate_class_violate_packets = None
                                                                    self.violate_class_violate_bytes = None
                                                                    self.violate_class_violate_rate = None
                                                                    self._segment_path = lambda: "color-class-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                        class WredStatsArray(Entity):
                                                            """
                                                            array of red stats
                                                            
                                                            .. attribute:: profile_title
                                                            
                                                            	ProfileTitle
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..300
                                                            
                                                            .. attribute:: red_transmit_packets
                                                            
                                                            	Transmitted packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_transmit_bytes
                                                            
                                                            	Transmitted bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Probabilistically dropped  packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Probabilisticallydropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_ecn_marked_packets
                                                            
                                                            	ECN marked packets 
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_ecn_marked_bytes
                                                            
                                                            	ECN marked bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_label
                                                            
                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                self.yang_name = "wred-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                self._leafs = OrderedDict([
                                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                ])
                                                                self.profile_title = None
                                                                self.red_transmit_packets = None
                                                                self.red_transmit_bytes = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.red_ecn_marked_packets = None
                                                                self.red_ecn_marked_bytes = None

                                                                self.red_label = YList(self)
                                                                self._segment_path = lambda: "wred-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                            class RedLabel(Entity):
                                                                """
                                                                Array of WRED Typevalues as in PRP stats is
                                                                available per threshold   
                                                                
                                                                .. attribute:: wred_type
                                                                
                                                                	WRED type DSCP, EXP, PREC etc
                                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	WRED value for this type
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                    self.yang_name = "red-label"
                                                                    self.yang_parent_name = "wred-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                    ])
                                                                    self.wred_type = None
                                                                    self.value = None
                                                                    self._segment_path = lambda: "red-label"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                            class Output(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: service_policy_names
                                
                                	Operational data for all Policy instance
                                	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, self).__init__()

                                    self.yang_name = "output"
                                    self.yang_parent_name = "satellite-id"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames))])
                                    self._leafs = OrderedDict()

                                    self.service_policy_names = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                    self._segment_path = lambda: "output"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, [], name, value)


                                class ServicePolicyNames(Entity):
                                    """
                                    Operational data for all Policy instance
                                    
                                    .. attribute:: service_policy_instance
                                    
                                    	QoS policy\-map operational data for a particular Policy 
                                    	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                        self.yang_name = "service-policy-names"
                                        self.yang_parent_name = "output"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance))])
                                        self._leafs = OrderedDict()

                                        self.service_policy_instance = YList(self)
                                        self._segment_path = lambda: "service-policy-names"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, [], name, value)


                                    class ServicePolicyInstance(Entity):
                                        """
                                        QoS policy\-map operational data for a
                                        particular Policy 
                                        
                                        .. attribute:: service_policy_name  (key)
                                        
                                        	Name of the policy instance
                                        	**type**\: str
                                        
                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                        
                                        .. attribute:: statistics
                                        
                                        	Policy\-map statistics operational data for an interface
                                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                            self.yang_name = "service-policy-instance"
                                            self.yang_parent_name = "service-policy-names"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = ['service_policy_name']
                                            self._child_classes = OrderedDict([("statistics", ("statistics", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                            self._leafs = OrderedDict([
                                                ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                            ])
                                            self.service_policy_name = None

                                            self.statistics = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                            self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                        class Statistics(Entity):
                                            """
                                            Policy\-map statistics operational data for an
                                            interface
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                                self.yang_name = "statistics"
                                                self.yang_parent_name = "service-policy-instance"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "statistics"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                                
                                                .. attribute:: child_policy
                                                
                                                	child policy
                                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "statistics"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.child_policy = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"

                                                    self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class ChildPolicy(Entity):
                                                    """
                                                    child policy
                                                    
                                                    .. attribute:: policy_name
                                                    
                                                    	PolicyName
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: state
                                                    
                                                    	State
                                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                    
                                                    .. attribute:: state_description
                                                    
                                                    	StateDescription
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..128
                                                    
                                                    .. attribute:: satid
                                                    
                                                    	to maintain satellite id
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: class_stats
                                                    
                                                    	array of classes contained in policy
                                                    	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                        self.yang_name = "child-policy"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                        self._leafs = OrderedDict([
                                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                        ])
                                                        self.policy_name = None
                                                        self.state = None
                                                        self.state_description = None
                                                        self.satid = None

                                                        self.class_stats = YList(self)
                                                        self._segment_path = lambda: "child-policy"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                                    class ClassStats_(Entity):
                                                        """
                                                        array of classes contained in policy
                                                        
                                                        .. attribute:: general_stats
                                                        
                                                        	general stats
                                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                        
                                                        .. attribute:: iphc_stats
                                                        
                                                        	IPHC stats
                                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                        
                                                        .. attribute:: cac_stats
                                                        
                                                        	bag for cac stats
                                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                        
                                                        .. attribute:: counter_validity_bitmask
                                                        
                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: megabyte
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	ClassName
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: shared_queue_id
                                                        
                                                        	q\-id of the  shared queue for this class
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_descr
                                                        
                                                        	Description of queue for the class
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..256
                                                        
                                                        .. attribute:: cac_state
                                                        
                                                        	CACState
                                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                        
                                                        .. attribute:: queue_stats_array
                                                        
                                                        	array of queue stats
                                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                        
                                                        .. attribute:: police_stats_array
                                                        
                                                        	array of police stats
                                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                        
                                                        .. attribute:: wred_stats_array
                                                        
                                                        	array of red stats
                                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                            self.yang_name = "class-stats"
                                                            self.yang_parent_name = "child-policy"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                            self._leafs = OrderedDict([
                                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                            ])
                                                            self.counter_validity_bitmask = None
                                                            self.class_name = None
                                                            self.shared_queue_id = None
                                                            self.queue_descr = None
                                                            self.cac_state = None

                                                            self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"

                                                            self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                                            self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"

                                                            self.queue_stats_array = YList(self)
                                                            self.police_stats_array = YList(self)
                                                            self.wred_stats_array = YList(self)
                                                            self._segment_path = lambda: "class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                        class GeneralStats(Entity):
                                                            """
                                                            general stats
                                                            
                                                            .. attribute:: transmit_packets
                                                            
                                                            	Transmitted packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: transmit_bytes
                                                            
                                                            	Transmitted bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_packets
                                                            
                                                            	Dropped packets (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_bytes
                                                            
                                                            	Dropped bytes (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_rate
                                                            
                                                            	Total drop rate (packets/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: match_data_rate
                                                            
                                                            	Incoming matched data rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: total_transmit_rate
                                                            
                                                            	Total transmit rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: pre_policy_matched_packets
                                                            
                                                            	Matched pkts before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: pre_policy_matched_bytes
                                                            
                                                            	Matched bytes before applying policy
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                                self.yang_name = "general-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                                ])
                                                                self.transmit_packets = None
                                                                self.transmit_bytes = None
                                                                self.total_drop_packets = None
                                                                self.total_drop_bytes = None
                                                                self.total_drop_rate = None
                                                                self.match_data_rate = None
                                                                self.total_transmit_rate = None
                                                                self.pre_policy_matched_packets = None
                                                                self.pre_policy_matched_bytes = None
                                                                self._segment_path = lambda: "general-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                        class IphcStats(Entity):
                                                            """
                                                            IPHC stats
                                                            
                                                            .. attribute:: non_tcp_total_out_packets
                                                            
                                                            	TotalNum of Non tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_total_out_bytes
                                                            
                                                            	TotalNum of Non Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_bytes_saved
                                                            
                                                            	Non Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_compressed_packets_out
                                                            
                                                            	Num of non tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                            
                                                            	Compressed Non Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_full_header_packets_out
                                                            
                                                            	Num of non tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_packets
                                                            
                                                            	Total Num of tcp pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_bytes
                                                            
                                                            	TotalNum of Tcp Bytes sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_bytes_saved
                                                            
                                                            	Tcp Bytes saved due to compression
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_compressed_packets_out
                                                            
                                                            	Num of tcp compressed pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_bytes_sent_rate
                                                            
                                                            	Compressed Tcp Bytes sent rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_full_header_packets_out
                                                            
                                                            	Num of tcp fullheader pkts sent
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                                self.yang_name = "iphc-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                                ])
                                                                self.non_tcp_total_out_packets = None
                                                                self.non_tcp_total_out_bytes = None
                                                                self.non_tcp_bytes_saved = None
                                                                self.non_tcp_compressed_packets_out = None
                                                                self.non_tcp_bytes_sent_rate = None
                                                                self.non_tcp_full_header_packets_out = None
                                                                self.tcp_total_out_packets = None
                                                                self.tcp_total_out_bytes = None
                                                                self.tcp_bytes_saved = None
                                                                self.tcp_compressed_packets_out = None
                                                                self.tcp_bytes_sent_rate = None
                                                                self.tcp_full_header_packets_out = None
                                                                self._segment_path = lambda: "iphc-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                        class CacStats(Entity):
                                                            """
                                                            bag for cac stats
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	CAC dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	CAC dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_rates
                                                            
                                                            	CAC dropped rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: admitpackets
                                                            
                                                            	Admitted packets (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_bytes
                                                            
                                                            	Admitted bytes (pkts/bytes)
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_rates
                                                            
                                                            	CAC admit rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                                self.yang_name = "cac-stats"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.drop_rates = None
                                                                self.admitpackets = None
                                                                self.admit_bytes = None
                                                                self.admit_rates = None
                                                                self._segment_path = lambda: "cac-stats"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                        class QueueStatsArray(Entity):
                                                            """
                                                            array of queue stats
                                                            
                                                            .. attribute:: queue_id
                                                            
                                                            	Queue Id used for Fabric Stats
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: tail_drop_packets
                                                            
                                                            	Packets tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tail_drop_bytes
                                                            
                                                            	Bytes tail dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp0_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp0_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp1_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp1_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: queue_drop_threshold
                                                            
                                                            	tail drop threshold of the queue in bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: forced_wred_stats_display
                                                            
                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                            	**type**\: bool
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Packets probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Bytes probabilistically dropped
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the queue rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_instance_length
                                                            
                                                            	Queue instance length
                                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                            
                                                            .. attribute:: queue_average_length
                                                            
                                                            	Queue average length
                                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                            
                                                            .. attribute:: queue_max_length
                                                            
                                                            	Queue maximum length
                                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                                self.yang_name = "queue-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                                self._leafs = OrderedDict([
                                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                ])
                                                                self.queue_id = None
                                                                self.tail_drop_packets = None
                                                                self.tail_drop_bytes = None
                                                                self.atm_clp0_drop_packets = None
                                                                self.atm_clp0_drop_bytes = None
                                                                self.atm_clp1_drop_packets = None
                                                                self.atm_clp1_drop_bytes = None
                                                                self.queue_drop_threshold = None
                                                                self.forced_wred_stats_display = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None

                                                                self.queue_instance_length = YList(self)
                                                                self.queue_average_length = YList(self)
                                                                self.queue_max_length = YList(self)
                                                                self._segment_path = lambda: "queue-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                            class QueueInstanceLength(Entity):
                                                                """
                                                                Queue instance length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                    self.yang_name = "queue-instance-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-instance-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                            class QueueAverageLength(Entity):
                                                                """
                                                                Queue average length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                    self.yang_name = "queue-average-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-average-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                            class QueueMaxLength(Entity):
                                                                """
                                                                Queue maximum length
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                    self.yang_name = "queue-max-length"
                                                                    self.yang_parent_name = "queue-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                                    ])
                                                                    self.value = None
                                                                    self.unit = None
                                                                    self._segment_path = lambda: "queue-max-length"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                        class PoliceStatsArray(Entity):
                                                            """
                                                            array of police stats
                                                            
                                                            .. attribute:: color_class_stats
                                                            
                                                            	color class stats
                                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	Police dropped packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	Police dropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_packets
                                                            
                                                            	Packets violating the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_bytes
                                                            
                                                            	Bytes that violate the policed rate
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: parent_drop_packets
                                                            
                                                            	Dropped pkts by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: parent_drop_bytes
                                                            
                                                            	Dropped bytes by the parent policer
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_rate
                                                            
                                                            	Violate rate in kbps
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                                self.yang_name = "police-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                                self._leafs = OrderedDict([
                                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                                ])
                                                                self.drop_packets = None
                                                                self.drop_bytes = None
                                                                self.conform_packets = None
                                                                self.conform_bytes = None
                                                                self.exceed_packets = None
                                                                self.exceed_bytes = None
                                                                self.violate_packets = None
                                                                self.violate_bytes = None
                                                                self.parent_drop_packets = None
                                                                self.parent_drop_bytes = None
                                                                self.conform_rate = None
                                                                self.exceed_rate = None
                                                                self.violate_rate = None

                                                                self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                self._segment_path = lambda: "police-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                            class ColorClassStats(Entity):
                                                                """
                                                                color class stats
                                                                
                                                                .. attribute:: conform_class_conform_packets
                                                                
                                                                	Packets with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_conform_bytes
                                                                
                                                                	Bytes with classification result conform and policer result conform
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_conform_rate
                                                                
                                                                	Conform Class Conform rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_exceed_packets
                                                                
                                                                	Packets with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_exceed_bytes
                                                                
                                                                	Bytes with classification result conform and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_exceed_rate
                                                                
                                                                	Conform Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_violate_packets
                                                                
                                                                	Packets with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_violate_bytes
                                                                
                                                                	Bytes with classification result conform and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_violate_rate
                                                                
                                                                	Conform Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_exceed_packets
                                                                
                                                                	Packets with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_exceed_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result exceed
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_exceed_rate
                                                                
                                                                	Exceed Class Exceed rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_violate_packets
                                                                
                                                                	Packets with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_violate_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_violate_rate
                                                                
                                                                	Exceed Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_class_violate_packets
                                                                
                                                                	Packets with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_class_violate_bytes
                                                                
                                                                	Bytes with classification result violate and policer result violate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_class_violate_rate
                                                                
                                                                	Violate Class Violate rate in kbps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                    self.yang_name = "color-class-stats"
                                                                    self.yang_parent_name = "police-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                                    ])
                                                                    self.conform_class_conform_packets = None
                                                                    self.conform_class_conform_bytes = None
                                                                    self.conform_class_conform_rate = None
                                                                    self.conform_class_exceed_packets = None
                                                                    self.conform_class_exceed_bytes = None
                                                                    self.conform_class_exceed_rate = None
                                                                    self.conform_class_violate_packets = None
                                                                    self.conform_class_violate_bytes = None
                                                                    self.conform_class_violate_rate = None
                                                                    self.exceed_class_exceed_packets = None
                                                                    self.exceed_class_exceed_bytes = None
                                                                    self.exceed_class_exceed_rate = None
                                                                    self.exceed_class_violate_packets = None
                                                                    self.exceed_class_violate_bytes = None
                                                                    self.exceed_class_violate_rate = None
                                                                    self.violate_class_violate_packets = None
                                                                    self.violate_class_violate_bytes = None
                                                                    self.violate_class_violate_rate = None
                                                                    self._segment_path = lambda: "color-class-stats"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                        class WredStatsArray(Entity):
                                                            """
                                                            array of red stats
                                                            
                                                            .. attribute:: profile_title
                                                            
                                                            	ProfileTitle
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..300
                                                            
                                                            .. attribute:: red_transmit_packets
                                                            
                                                            	Transmitted packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_transmit_bytes
                                                            
                                                            	Transmitted bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Probabilistically dropped  packets
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Probabilisticallydropped bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_ecn_marked_packets
                                                            
                                                            	ECN marked packets 
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_ecn_marked_bytes
                                                            
                                                            	ECN marked bytes
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_label
                                                            
                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-09-13'

                                                            def __init__(self):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                                self.yang_name = "wred-stats-array"
                                                                self.yang_parent_name = "class-stats"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                                self._leafs = OrderedDict([
                                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                                ])
                                                                self.profile_title = None
                                                                self.red_transmit_packets = None
                                                                self.red_transmit_bytes = None
                                                                self.random_drop_packets = None
                                                                self.random_drop_bytes = None
                                                                self.max_threshold_packets = None
                                                                self.max_threshold_bytes = None
                                                                self.red_ecn_marked_packets = None
                                                                self.red_ecn_marked_bytes = None

                                                                self.red_label = YList(self)
                                                                self._segment_path = lambda: "wred-stats-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                            class RedLabel(Entity):
                                                                """
                                                                Array of WRED Typevalues as in PRP stats is
                                                                available per threshold   
                                                                
                                                                .. attribute:: wred_type
                                                                
                                                                	WRED type DSCP, EXP, PREC etc
                                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	WRED value for this type
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-09-13'

                                                                def __init__(self):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                                    self.yang_name = "red-label"
                                                                    self.yang_parent_name = "wred-stats-array"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                                    ])
                                                                    self.wred_type = None
                                                                    self.value = None
                                                                    self._segment_path = lambda: "red-label"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                    class Input(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input, self).__init__()

                            self.yang_name = "input"
                            self.yang_parent_name = "member-interface"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames))])
                            self._leafs = OrderedDict()

                            self.service_policy_names = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._segment_path = lambda: "input"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input, [], name, value)


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "input"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance))])
                                self._leafs = OrderedDict()

                                self.service_policy_instance = YList(self)
                                self._segment_path = lambda: "service-policy-names"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, [], name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  (key)
                                
                                	Name of the policy instance
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['service_policy_name']
                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                    ])
                                    self.service_policy_name = None

                                    self.statistics = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "service-policy-instance"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.child_policy = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"

                                            self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "child-policy"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats_(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                    class Output(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output, self).__init__()

                            self.yang_name = "output"
                            self.yang_parent_name = "member-interface"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames))])
                            self._leafs = OrderedDict()

                            self.service_policy_names = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._segment_path = lambda: "output"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output, [], name, value)


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "output"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance))])
                                self._leafs = OrderedDict()

                                self.service_policy_instance = YList(self)
                                self._segment_path = lambda: "service-policy-names"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, [], name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  (key)
                                
                                	Name of the policy instance
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['service_policy_name']
                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                    ])
                                    self.service_policy_name = None

                                    self.statistics = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "service-policy-instance"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.child_policy = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"

                                            self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "child-policy"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats_(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


            class SatelliteIds(Entity):
                """
                Satellite ID information
                
                .. attribute:: satellite_id
                
                	Satellite ID information
                	**type**\: list of  		 :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.InterfaceTable.Interface.SatelliteIds, self).__init__()

                    self.yang_name = "satellite-ids"
                    self.yang_parent_name = "interface"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("satellite-id", ("satellite_id", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId))])
                    self._leafs = OrderedDict()

                    self.satellite_id = YList(self)
                    self._segment_path = lambda: "satellite-ids"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds, [], name, value)


                class SatelliteId(Entity):
                    """
                    Satellite ID information
                    
                    .. attribute:: nv_satellite_id  (key)
                    
                    	Satellite ID
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: input
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input>`
                    
                    .. attribute:: output
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId, self).__init__()

                        self.yang_name = "satellite-id"
                        self.yang_parent_name = "satellite-ids"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = ['nv_satellite_id']
                        self._child_classes = OrderedDict([("input", ("input", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input)), ("output", ("output", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output))])
                        self._leafs = OrderedDict([
                            ('nv_satellite_id', (YLeaf(YType.int32, 'nv-satellite-id'), ['int'])),
                        ])
                        self.nv_satellite_id = None

                        self.input = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"

                        self.output = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                        self._segment_path = lambda: "satellite-id" + "[nv-satellite-id='" + str(self.nv_satellite_id) + "']"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId, ['nv_satellite_id'], name, value)


                    class Input(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input, self).__init__()

                            self.yang_name = "input"
                            self.yang_parent_name = "satellite-id"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames))])
                            self._leafs = OrderedDict()

                            self.service_policy_names = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._segment_path = lambda: "input"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input, [], name, value)


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "input"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance))])
                                self._leafs = OrderedDict()

                                self.service_policy_instance = YList(self)
                                self._segment_path = lambda: "service-policy-names"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, [], name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  (key)
                                
                                	Name of the policy instance
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['service_policy_name']
                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                    ])
                                    self.service_policy_name = None

                                    self.statistics = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "service-policy-instance"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.child_policy = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"

                                            self.cac_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "child-policy"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats_(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.cac_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                    class Output(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output, self).__init__()

                            self.yang_name = "output"
                            self.yang_parent_name = "satellite-id"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames))])
                            self._leafs = OrderedDict()

                            self.service_policy_names = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._segment_path = lambda: "output"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output, [], name, value)


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "output"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance))])
                                self._leafs = OrderedDict()

                                self.service_policy_instance = YList(self)
                                self._segment_path = lambda: "service-policy-names"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, [], name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  (key)
                                
                                	Name of the policy instance
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['service_policy_name']
                                    self._child_classes = OrderedDict([("statistics", ("statistics", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                                    ])
                                    self.service_policy_name = None

                                    self.statistics = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "service-policy-instance"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.child_policy = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"

                                            self.cac_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\: str
                                            
                                            	**length:** 0..128
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                                self._leafs = OrderedDict([
                                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                                ])
                                                self.policy_name = None
                                                self.state = None
                                                self.state_description = None
                                                self.satid = None

                                                self.class_stats = YList(self)
                                                self._segment_path = lambda: "child-policy"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                            class ClassStats_(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\: str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                                    self._leafs = OrderedDict([
                                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                                    ])
                                                    self.counter_validity_bitmask = None
                                                    self.class_name = None
                                                    self.shared_queue_id = None
                                                    self.queue_descr = None
                                                    self.cac_state = None

                                                    self.general_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"

                                                    self.iphc_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                                    self.cac_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"

                                                    self.queue_stats_array = YList(self)
                                                    self.police_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)
                                                    self._segment_path = lambda: "class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                        ])
                                                        self.transmit_packets = None
                                                        self.transmit_bytes = None
                                                        self.total_drop_packets = None
                                                        self.total_drop_bytes = None
                                                        self.total_drop_rate = None
                                                        self.match_data_rate = None
                                                        self.total_transmit_rate = None
                                                        self.pre_policy_matched_packets = None
                                                        self.pre_policy_matched_bytes = None
                                                        self._segment_path = lambda: "general-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                        ])
                                                        self.non_tcp_total_out_packets = None
                                                        self.non_tcp_total_out_bytes = None
                                                        self.non_tcp_bytes_saved = None
                                                        self.non_tcp_compressed_packets_out = None
                                                        self.non_tcp_bytes_sent_rate = None
                                                        self.non_tcp_full_header_packets_out = None
                                                        self.tcp_total_out_packets = None
                                                        self.tcp_total_out_bytes = None
                                                        self.tcp_bytes_saved = None
                                                        self.tcp_compressed_packets_out = None
                                                        self.tcp_bytes_sent_rate = None
                                                        self.tcp_full_header_packets_out = None
                                                        self._segment_path = lambda: "iphc-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.drop_rates = None
                                                        self.admitpackets = None
                                                        self.admit_bytes = None
                                                        self.admit_rates = None
                                                        self._segment_path = lambda: "cac-stats"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\: bool
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                        self._leafs = OrderedDict([
                                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                        ])
                                                        self.queue_id = None
                                                        self.tail_drop_packets = None
                                                        self.tail_drop_bytes = None
                                                        self.atm_clp0_drop_packets = None
                                                        self.atm_clp0_drop_bytes = None
                                                        self.atm_clp1_drop_packets = None
                                                        self.atm_clp1_drop_bytes = None
                                                        self.queue_drop_threshold = None
                                                        self.forced_wred_stats_display = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None

                                                        self.queue_instance_length = YList(self)
                                                        self.queue_average_length = YList(self)
                                                        self.queue_max_length = YList(self)
                                                        self._segment_path = lambda: "queue-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-instance-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-average-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                            ])
                                                            self.value = None
                                                            self.unit = None
                                                            self._segment_path = lambda: "queue-max-length"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                        self._leafs = OrderedDict([
                                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                        ])
                                                        self.drop_packets = None
                                                        self.drop_bytes = None
                                                        self.conform_packets = None
                                                        self.conform_bytes = None
                                                        self.exceed_packets = None
                                                        self.exceed_bytes = None
                                                        self.violate_packets = None
                                                        self.violate_bytes = None
                                                        self.parent_drop_packets = None
                                                        self.parent_drop_bytes = None
                                                        self.conform_rate = None
                                                        self.exceed_rate = None
                                                        self.violate_rate = None

                                                        self.color_class_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._segment_path = lambda: "police-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                            ])
                                                            self.conform_class_conform_packets = None
                                                            self.conform_class_conform_bytes = None
                                                            self.conform_class_conform_rate = None
                                                            self.conform_class_exceed_packets = None
                                                            self.conform_class_exceed_bytes = None
                                                            self.conform_class_exceed_rate = None
                                                            self.conform_class_violate_packets = None
                                                            self.conform_class_violate_bytes = None
                                                            self.conform_class_violate_rate = None
                                                            self.exceed_class_exceed_packets = None
                                                            self.exceed_class_exceed_bytes = None
                                                            self.exceed_class_exceed_rate = None
                                                            self.exceed_class_violate_packets = None
                                                            self.exceed_class_violate_bytes = None
                                                            self.exceed_class_violate_rate = None
                                                            self.violate_class_violate_packets = None
                                                            self.violate_class_violate_bytes = None
                                                            self.violate_class_violate_rate = None
                                                            self._segment_path = lambda: "color-class-stats"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-09-13'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                        self._leafs = OrderedDict([
                                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                        ])
                                                        self.profile_title = None
                                                        self.red_transmit_packets = None
                                                        self.red_transmit_bytes = None
                                                        self.random_drop_packets = None
                                                        self.random_drop_bytes = None
                                                        self.max_threshold_packets = None
                                                        self.max_threshold_bytes = None
                                                        self.red_ecn_marked_packets = None
                                                        self.red_ecn_marked_bytes = None

                                                        self.red_label = YList(self)
                                                        self._segment_path = lambda: "wred-stats-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-09-13'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                            ])
                                                            self.wred_type = None
                                                            self.value = None
                                                            self._segment_path = lambda: "red-label"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


            class Input(Entity):
                """
                A piece of QoS policy\-map operational data for
                an interface
                
                .. attribute:: service_policy_names
                
                	Operational data for all Policy instance
                	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.InterfaceTable.Interface.Input, self).__init__()

                    self.yang_name = "input"
                    self.yang_parent_name = "interface"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.InterfaceTable.Interface.Input.ServicePolicyNames))])
                    self._leafs = OrderedDict()

                    self.service_policy_names = Qos.InterfaceTable.Interface.Input.ServicePolicyNames()
                    self.service_policy_names.parent = self
                    self._children_name_map["service_policy_names"] = "service-policy-names"
                    self._segment_path = lambda: "input"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.InterfaceTable.Interface.Input, [], name, value)


                class ServicePolicyNames(Entity):
                    """
                    Operational data for all Policy instance
                    
                    .. attribute:: service_policy_instance
                    
                    	QoS policy\-map operational data for a particular Policy 
                    	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames, self).__init__()

                        self.yang_name = "service-policy-names"
                        self.yang_parent_name = "input"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance))])
                        self._leafs = OrderedDict()

                        self.service_policy_instance = YList(self)
                        self._segment_path = lambda: "service-policy-names"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames, [], name, value)


                    class ServicePolicyInstance(Entity):
                        """
                        QoS policy\-map operational data for a
                        particular Policy 
                        
                        .. attribute:: service_policy_name  (key)
                        
                        	Name of the policy instance
                        	**type**\: str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                            self.yang_name = "service-policy-instance"
                            self.yang_parent_name = "service-policy-names"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['service_policy_name']
                            self._child_classes = OrderedDict([("statistics", ("statistics", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                            self._leafs = OrderedDict([
                                ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                            ])
                            self.service_policy_name = None

                            self.statistics = Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\: str
                            
                            	**length:** 0..65
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\: str
                            
                            	**length:** 0..128
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "service-policy-instance"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                self._leafs = OrderedDict([
                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                ])
                                self.policy_name = None
                                self.state = None
                                self.state_description = None
                                self.satid = None

                                self.class_stats = YList(self)
                                self._segment_path = lambda: "statistics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\: str
                                
                                	**length:** 0..65
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\: str
                                
                                	**length:** 0..256
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                    self._leafs = OrderedDict([
                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                    ])
                                    self.counter_validity_bitmask = None
                                    self.class_name = None
                                    self.shared_queue_id = None
                                    self.queue_descr = None
                                    self.cac_state = None

                                    self.general_stats = Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"

                                    self.iphc_stats = Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                    self.child_policy = Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"

                                    self.cac_stats = Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"

                                    self.queue_stats_array = YList(self)
                                    self.police_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)
                                    self._segment_path = lambda: "class-stats"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                        ])
                                        self.transmit_packets = None
                                        self.transmit_bytes = None
                                        self.total_drop_packets = None
                                        self.total_drop_bytes = None
                                        self.total_drop_rate = None
                                        self.match_data_rate = None
                                        self.total_transmit_rate = None
                                        self.pre_policy_matched_packets = None
                                        self.pre_policy_matched_bytes = None
                                        self._segment_path = lambda: "general-stats"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                        ])
                                        self.non_tcp_total_out_packets = None
                                        self.non_tcp_total_out_bytes = None
                                        self.non_tcp_bytes_saved = None
                                        self.non_tcp_compressed_packets_out = None
                                        self.non_tcp_bytes_sent_rate = None
                                        self.non_tcp_full_header_packets_out = None
                                        self.tcp_total_out_packets = None
                                        self.tcp_total_out_bytes = None
                                        self.tcp_bytes_saved = None
                                        self.tcp_compressed_packets_out = None
                                        self.tcp_bytes_sent_rate = None
                                        self.tcp_full_header_packets_out = None
                                        self._segment_path = lambda: "iphc-stats"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "child-policy"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats_(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.cac_stats = Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                        ])
                                        self.drop_packets = None
                                        self.drop_bytes = None
                                        self.drop_rates = None
                                        self.admitpackets = None
                                        self.admit_bytes = None
                                        self.admit_rates = None
                                        self._segment_path = lambda: "cac-stats"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\: bool
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                        self._leafs = OrderedDict([
                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                        ])
                                        self.queue_id = None
                                        self.tail_drop_packets = None
                                        self.tail_drop_bytes = None
                                        self.atm_clp0_drop_packets = None
                                        self.atm_clp0_drop_bytes = None
                                        self.atm_clp1_drop_packets = None
                                        self.atm_clp1_drop_bytes = None
                                        self.queue_drop_threshold = None
                                        self.forced_wred_stats_display = None
                                        self.random_drop_packets = None
                                        self.random_drop_bytes = None
                                        self.max_threshold_packets = None
                                        self.max_threshold_bytes = None
                                        self.conform_packets = None
                                        self.conform_bytes = None
                                        self.exceed_packets = None
                                        self.exceed_bytes = None
                                        self.conform_rate = None
                                        self.exceed_rate = None

                                        self.queue_instance_length = YList(self)
                                        self.queue_average_length = YList(self)
                                        self.queue_max_length = YList(self)
                                        self._segment_path = lambda: "queue-stats-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                            ])
                                            self.value = None
                                            self.unit = None
                                            self._segment_path = lambda: "queue-instance-length"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                            ])
                                            self.value = None
                                            self.unit = None
                                            self._segment_path = lambda: "queue-average-length"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                            ])
                                            self.value = None
                                            self.unit = None
                                            self._segment_path = lambda: "queue-max-length"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                        self._leafs = OrderedDict([
                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                        ])
                                        self.drop_packets = None
                                        self.drop_bytes = None
                                        self.conform_packets = None
                                        self.conform_bytes = None
                                        self.exceed_packets = None
                                        self.exceed_bytes = None
                                        self.violate_packets = None
                                        self.violate_bytes = None
                                        self.parent_drop_packets = None
                                        self.parent_drop_bytes = None
                                        self.conform_rate = None
                                        self.exceed_rate = None
                                        self.violate_rate = None

                                        self.color_class_stats = Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._segment_path = lambda: "police-stats-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                            ])
                                            self.conform_class_conform_packets = None
                                            self.conform_class_conform_bytes = None
                                            self.conform_class_conform_rate = None
                                            self.conform_class_exceed_packets = None
                                            self.conform_class_exceed_bytes = None
                                            self.conform_class_exceed_rate = None
                                            self.conform_class_violate_packets = None
                                            self.conform_class_violate_bytes = None
                                            self.conform_class_violate_rate = None
                                            self.exceed_class_exceed_packets = None
                                            self.exceed_class_exceed_bytes = None
                                            self.exceed_class_exceed_rate = None
                                            self.exceed_class_violate_packets = None
                                            self.exceed_class_violate_bytes = None
                                            self.exceed_class_violate_rate = None
                                            self.violate_class_violate_packets = None
                                            self.violate_class_violate_bytes = None
                                            self.violate_class_violate_rate = None
                                            self._segment_path = lambda: "color-class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\: str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                        self._leafs = OrderedDict([
                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                        ])
                                        self.profile_title = None
                                        self.red_transmit_packets = None
                                        self.red_transmit_bytes = None
                                        self.random_drop_packets = None
                                        self.random_drop_bytes = None
                                        self.max_threshold_packets = None
                                        self.max_threshold_bytes = None
                                        self.red_ecn_marked_packets = None
                                        self.red_ecn_marked_bytes = None

                                        self.red_label = YList(self)
                                        self._segment_path = lambda: "wred-stats-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                            ])
                                            self.wred_type = None
                                            self.value = None
                                            self._segment_path = lambda: "red-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


            class Output(Entity):
                """
                A piece of QoS policy\-map operational data for
                an interface
                
                .. attribute:: service_policy_names
                
                	Operational data for all Policy instance
                	**type**\:  :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-09-13'

                def __init__(self):
                    super(Qos.InterfaceTable.Interface.Output, self).__init__()

                    self.yang_name = "output"
                    self.yang_parent_name = "interface"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("service-policy-names", ("service_policy_names", Qos.InterfaceTable.Interface.Output.ServicePolicyNames))])
                    self._leafs = OrderedDict()

                    self.service_policy_names = Qos.InterfaceTable.Interface.Output.ServicePolicyNames()
                    self.service_policy_names.parent = self
                    self._children_name_map["service_policy_names"] = "service-policy-names"
                    self._segment_path = lambda: "output"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Qos.InterfaceTable.Interface.Output, [], name, value)


                class ServicePolicyNames(Entity):
                    """
                    Operational data for all Policy instance
                    
                    .. attribute:: service_policy_instance
                    
                    	QoS policy\-map operational data for a particular Policy 
                    	**type**\: list of  		 :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-09-13'

                    def __init__(self):
                        super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames, self).__init__()

                        self.yang_name = "service-policy-names"
                        self.yang_parent_name = "output"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("service-policy-instance", ("service_policy_instance", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance))])
                        self._leafs = OrderedDict()

                        self.service_policy_instance = YList(self)
                        self._segment_path = lambda: "service-policy-names"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames, [], name, value)


                    class ServicePolicyInstance(Entity):
                        """
                        QoS policy\-map operational data for a
                        particular Policy 
                        
                        .. attribute:: service_policy_name  (key)
                        
                        	Name of the policy instance
                        	**type**\: str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-09-13'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                            self.yang_name = "service-policy-instance"
                            self.yang_parent_name = "service-policy-names"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['service_policy_name']
                            self._child_classes = OrderedDict([("statistics", ("statistics", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics))])
                            self._leafs = OrderedDict([
                                ('service_policy_name', (YLeaf(YType.str, 'service-policy-name'), ['str'])),
                            ])
                            self.service_policy_name = None

                            self.statistics = Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._segment_path = lambda: "service-policy-instance" + "[service-policy-name='" + str(self.service_policy_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, ['service_policy_name'], name, value)


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\: str
                            
                            	**length:** 0..65
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\: str
                            
                            	**length:** 0..128
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of  		 :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-09-13'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "service-policy-instance"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats))])
                                self._leafs = OrderedDict([
                                    ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                    ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                    ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                ])
                                self.policy_name = None
                                self.state = None
                                self.state_description = None
                                self.satid = None

                                self.class_stats = YList(self)
                                self._segment_path = lambda: "statistics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\: str
                                
                                	**length:** 0..65
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\: str
                                
                                	**length:** 0..256
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-09-13'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats)), ("child-policy", ("child_policy", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray))])
                                    self._leafs = OrderedDict([
                                        ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                        ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                        ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                        ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                    ])
                                    self.counter_validity_bitmask = None
                                    self.class_name = None
                                    self.shared_queue_id = None
                                    self.queue_descr = None
                                    self.cac_state = None

                                    self.general_stats = Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"

                                    self.iphc_stats = Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"

                                    self.child_policy = Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"

                                    self.cac_stats = Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"

                                    self.queue_stats_array = YList(self)
                                    self.police_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)
                                    self._segment_path = lambda: "class-stats"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                            ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                            ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                            ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                            ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                            ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                            ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                            ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                            ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                        ])
                                        self.transmit_packets = None
                                        self.transmit_bytes = None
                                        self.total_drop_packets = None
                                        self.total_drop_bytes = None
                                        self.total_drop_rate = None
                                        self.match_data_rate = None
                                        self.total_transmit_rate = None
                                        self.pre_policy_matched_packets = None
                                        self.pre_policy_matched_bytes = None
                                        self._segment_path = lambda: "general-stats"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                            ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                            ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                            ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                            ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                            ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                            ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                            ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                            ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                            ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                            ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                            ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                        ])
                                        self.non_tcp_total_out_packets = None
                                        self.non_tcp_total_out_bytes = None
                                        self.non_tcp_bytes_saved = None
                                        self.non_tcp_compressed_packets_out = None
                                        self.non_tcp_bytes_sent_rate = None
                                        self.non_tcp_full_header_packets_out = None
                                        self.tcp_total_out_packets = None
                                        self.tcp_total_out_bytes = None
                                        self.tcp_bytes_saved = None
                                        self.tcp_compressed_packets_out = None
                                        self.tcp_bytes_sent_rate = None
                                        self.tcp_full_header_packets_out = None
                                        self._segment_path = lambda: "iphc-stats"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:  :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\: str
                                    
                                    	**length:** 0..128
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of  		 :py:class:`ClassStats_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-stats", ("class_stats", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_))])
                                        self._leafs = OrderedDict([
                                            ('policy_name', (YLeaf(YType.str, 'policy-name'), ['str'])),
                                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyState', '')])),
                                            ('state_description', (YLeaf(YType.str, 'state-description'), ['str'])),
                                            ('satid', (YLeaf(YType.uint32, 'satid'), ['int'])),
                                        ])
                                        self.policy_name = None
                                        self.state = None
                                        self.state_description = None
                                        self.satid = None

                                        self.class_stats = YList(self)
                                        self._segment_path = lambda: "child-policy"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy, ['policy_name', 'state', 'state_description', 'satid'], name, value)


                                    class ClassStats_(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:  :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:  :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:  :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats>`
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\: str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:  :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of  		 :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of  		 :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray>`
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of  		 :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("general-stats", ("general_stats", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats)), ("iphc-stats", ("iphc_stats", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats)), ("cac-stats", ("cac_stats", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats)), ("queue-stats-array", ("queue_stats_array", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray)), ("police-stats-array", ("police_stats_array", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray)), ("wred-stats-array", ("wred_stats_array", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray))])
                                            self._leafs = OrderedDict([
                                                ('counter_validity_bitmask', (YLeaf(YType.uint64, 'counter-validity-bitmask'), ['int'])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('shared_queue_id', (YLeaf(YType.uint32, 'shared-queue-id'), ['int'])),
                                                ('queue_descr', (YLeaf(YType.str, 'queue-descr'), ['str'])),
                                                ('cac_state', (YLeaf(YType.enumeration, 'cac-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'CacState', '')])),
                                            ])
                                            self.counter_validity_bitmask = None
                                            self.class_name = None
                                            self.shared_queue_id = None
                                            self.queue_descr = None
                                            self.cac_state = None

                                            self.general_stats = Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"

                                            self.iphc_stats = Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"

                                            self.cac_stats = Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"

                                            self.queue_stats_array = YList(self)
                                            self.police_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)
                                            self._segment_path = lambda: "class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_, ['counter_validity_bitmask', 'class_name', 'shared_queue_id', 'queue_descr', 'cac_state'], name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('transmit_packets', (YLeaf(YType.uint64, 'transmit-packets'), ['int'])),
                                                    ('transmit_bytes', (YLeaf(YType.uint64, 'transmit-bytes'), ['int'])),
                                                    ('total_drop_packets', (YLeaf(YType.uint64, 'total-drop-packets'), ['int'])),
                                                    ('total_drop_bytes', (YLeaf(YType.uint64, 'total-drop-bytes'), ['int'])),
                                                    ('total_drop_rate', (YLeaf(YType.uint32, 'total-drop-rate'), ['int'])),
                                                    ('match_data_rate', (YLeaf(YType.uint32, 'match-data-rate'), ['int'])),
                                                    ('total_transmit_rate', (YLeaf(YType.uint32, 'total-transmit-rate'), ['int'])),
                                                    ('pre_policy_matched_packets', (YLeaf(YType.uint64, 'pre-policy-matched-packets'), ['int'])),
                                                    ('pre_policy_matched_bytes', (YLeaf(YType.uint64, 'pre-policy-matched-bytes'), ['int'])),
                                                ])
                                                self.transmit_packets = None
                                                self.transmit_bytes = None
                                                self.total_drop_packets = None
                                                self.total_drop_bytes = None
                                                self.total_drop_rate = None
                                                self.match_data_rate = None
                                                self.total_transmit_rate = None
                                                self.pre_policy_matched_packets = None
                                                self.pre_policy_matched_bytes = None
                                                self._segment_path = lambda: "general-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.GeneralStats, ['transmit_packets', 'transmit_bytes', 'total_drop_packets', 'total_drop_bytes', 'total_drop_rate', 'match_data_rate', 'total_transmit_rate', 'pre_policy_matched_packets', 'pre_policy_matched_bytes'], name, value)


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('non_tcp_total_out_packets', (YLeaf(YType.uint64, 'non-tcp-total-out-packets'), ['int'])),
                                                    ('non_tcp_total_out_bytes', (YLeaf(YType.uint64, 'non-tcp-total-out-bytes'), ['int'])),
                                                    ('non_tcp_bytes_saved', (YLeaf(YType.uint64, 'non-tcp-bytes-saved'), ['int'])),
                                                    ('non_tcp_compressed_packets_out', (YLeaf(YType.uint64, 'non-tcp-compressed-packets-out'), ['int'])),
                                                    ('non_tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'non-tcp-bytes-sent-rate'), ['int'])),
                                                    ('non_tcp_full_header_packets_out', (YLeaf(YType.uint64, 'non-tcp-full-header-packets-out'), ['int'])),
                                                    ('tcp_total_out_packets', (YLeaf(YType.uint64, 'tcp-total-out-packets'), ['int'])),
                                                    ('tcp_total_out_bytes', (YLeaf(YType.uint64, 'tcp-total-out-bytes'), ['int'])),
                                                    ('tcp_bytes_saved', (YLeaf(YType.uint64, 'tcp-bytes-saved'), ['int'])),
                                                    ('tcp_compressed_packets_out', (YLeaf(YType.uint64, 'tcp-compressed-packets-out'), ['int'])),
                                                    ('tcp_bytes_sent_rate', (YLeaf(YType.uint32, 'tcp-bytes-sent-rate'), ['int'])),
                                                    ('tcp_full_header_packets_out', (YLeaf(YType.uint64, 'tcp-full-header-packets-out'), ['int'])),
                                                ])
                                                self.non_tcp_total_out_packets = None
                                                self.non_tcp_total_out_bytes = None
                                                self.non_tcp_bytes_saved = None
                                                self.non_tcp_compressed_packets_out = None
                                                self.non_tcp_bytes_sent_rate = None
                                                self.non_tcp_full_header_packets_out = None
                                                self.tcp_total_out_packets = None
                                                self.tcp_total_out_bytes = None
                                                self.tcp_bytes_saved = None
                                                self.tcp_compressed_packets_out = None
                                                self.tcp_bytes_sent_rate = None
                                                self.tcp_full_header_packets_out = None
                                                self._segment_path = lambda: "iphc-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.IphcStats, ['non_tcp_total_out_packets', 'non_tcp_total_out_bytes', 'non_tcp_bytes_saved', 'non_tcp_compressed_packets_out', 'non_tcp_bytes_sent_rate', 'non_tcp_full_header_packets_out', 'tcp_total_out_packets', 'tcp_total_out_bytes', 'tcp_bytes_saved', 'tcp_compressed_packets_out', 'tcp_bytes_sent_rate', 'tcp_full_header_packets_out'], name, value)


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                                    ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                                    ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                                    ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.drop_rates = None
                                                self.admitpackets = None
                                                self.admit_bytes = None
                                                self.admit_rates = None
                                                self._segment_path = lambda: "cac-stats"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\: bool
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength))])
                                                self._leafs = OrderedDict([
                                                    ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                                    ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                                    ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                                    ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                                    ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                                    ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                                    ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                                    ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                                    ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                ])
                                                self.queue_id = None
                                                self.tail_drop_packets = None
                                                self.tail_drop_bytes = None
                                                self.atm_clp0_drop_packets = None
                                                self.atm_clp0_drop_bytes = None
                                                self.atm_clp1_drop_packets = None
                                                self.atm_clp1_drop_bytes = None
                                                self.queue_drop_threshold = None
                                                self.forced_wred_stats_display = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None

                                                self.queue_instance_length = YList(self)
                                                self.queue_average_length = YList(self)
                                                self.queue_max_length = YList(self)
                                                self._segment_path = lambda: "queue-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-instance-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-average-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                                    ])
                                                    self.value = None
                                                    self.unit = None
                                                    self._segment_path = lambda: "queue-max-length"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats))])
                                                self._leafs = OrderedDict([
                                                    ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                                    ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                                    ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                                    ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                                    ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                                    ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                                    ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                                    ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                                    ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                                    ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                                    ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                                    ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                                    ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                                ])
                                                self.drop_packets = None
                                                self.drop_bytes = None
                                                self.conform_packets = None
                                                self.conform_bytes = None
                                                self.exceed_packets = None
                                                self.exceed_bytes = None
                                                self.violate_packets = None
                                                self.violate_bytes = None
                                                self.parent_drop_packets = None
                                                self.parent_drop_bytes = None
                                                self.conform_rate = None
                                                self.exceed_rate = None
                                                self.violate_rate = None

                                                self.color_class_stats = Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._segment_path = lambda: "police-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\: int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                        ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                        ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                        ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                        ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                        ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                        ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                        ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                        ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                        ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                        ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                        ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                        ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                        ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                        ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                        ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                        ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                        ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                                    ])
                                                    self.conform_class_conform_packets = None
                                                    self.conform_class_conform_bytes = None
                                                    self.conform_class_conform_rate = None
                                                    self.conform_class_exceed_packets = None
                                                    self.conform_class_exceed_bytes = None
                                                    self.conform_class_exceed_rate = None
                                                    self.conform_class_violate_packets = None
                                                    self.conform_class_violate_bytes = None
                                                    self.conform_class_violate_rate = None
                                                    self.exceed_class_exceed_packets = None
                                                    self.exceed_class_exceed_bytes = None
                                                    self.exceed_class_exceed_rate = None
                                                    self.exceed_class_violate_packets = None
                                                    self.exceed_class_violate_bytes = None
                                                    self.exceed_class_violate_rate = None
                                                    self.violate_class_violate_packets = None
                                                    self.violate_class_violate_bytes = None
                                                    self.violate_class_violate_rate = None
                                                    self._segment_path = lambda: "color-class-stats"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\: str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\: int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-09-13'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel))])
                                                self._leafs = OrderedDict([
                                                    ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                                    ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                                    ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                                    ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                                    ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                                    ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                                    ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                                    ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                                    ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                                ])
                                                self.profile_title = None
                                                self.red_transmit_packets = None
                                                self.red_transmit_bytes = None
                                                self.random_drop_packets = None
                                                self.random_drop_bytes = None
                                                self.max_threshold_packets = None
                                                self.max_threshold_bytes = None
                                                self.red_ecn_marked_packets = None
                                                self.red_ecn_marked_bytes = None

                                                self.red_label = YList(self)
                                                self._segment_path = lambda: "wred-stats-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-09-13'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                        ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                                    ])
                                                    self.wred_type = None
                                                    self.value = None
                                                    self._segment_path = lambda: "red-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.ChildPolicy.ClassStats_.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                            ('drop_rates', (YLeaf(YType.uint32, 'drop-rates'), ['int'])),
                                            ('admitpackets', (YLeaf(YType.uint64, 'admitpackets'), ['int'])),
                                            ('admit_bytes', (YLeaf(YType.uint64, 'admit-bytes'), ['int'])),
                                            ('admit_rates', (YLeaf(YType.uint32, 'admit-rates'), ['int'])),
                                        ])
                                        self.drop_packets = None
                                        self.drop_bytes = None
                                        self.drop_rates = None
                                        self.admitpackets = None
                                        self.admit_bytes = None
                                        self.admit_rates = None
                                        self._segment_path = lambda: "cac-stats"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.CacStats, ['drop_packets', 'drop_bytes', 'drop_rates', 'admitpackets', 'admit_bytes', 'admit_rates'], name, value)


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\: bool
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of  		 :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of  		 :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of  		 :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("queue-instance-length", ("queue_instance_length", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength)), ("queue-average-length", ("queue_average_length", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength)), ("queue-max-length", ("queue_max_length", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength))])
                                        self._leafs = OrderedDict([
                                            ('queue_id', (YLeaf(YType.uint32, 'queue-id'), ['int'])),
                                            ('tail_drop_packets', (YLeaf(YType.uint64, 'tail-drop-packets'), ['int'])),
                                            ('tail_drop_bytes', (YLeaf(YType.uint64, 'tail-drop-bytes'), ['int'])),
                                            ('atm_clp0_drop_packets', (YLeaf(YType.uint64, 'atm-clp0-drop-packets'), ['int'])),
                                            ('atm_clp0_drop_bytes', (YLeaf(YType.uint64, 'atm-clp0-drop-bytes'), ['int'])),
                                            ('atm_clp1_drop_packets', (YLeaf(YType.uint64, 'atm-clp1-drop-packets'), ['int'])),
                                            ('atm_clp1_drop_bytes', (YLeaf(YType.uint64, 'atm-clp1-drop-bytes'), ['int'])),
                                            ('queue_drop_threshold', (YLeaf(YType.uint32, 'queue-drop-threshold'), ['int'])),
                                            ('forced_wred_stats_display', (YLeaf(YType.boolean, 'forced-wred-stats-display'), ['bool'])),
                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                        ])
                                        self.queue_id = None
                                        self.tail_drop_packets = None
                                        self.tail_drop_bytes = None
                                        self.atm_clp0_drop_packets = None
                                        self.atm_clp0_drop_bytes = None
                                        self.atm_clp1_drop_packets = None
                                        self.atm_clp1_drop_bytes = None
                                        self.queue_drop_threshold = None
                                        self.forced_wred_stats_display = None
                                        self.random_drop_packets = None
                                        self.random_drop_bytes = None
                                        self.max_threshold_packets = None
                                        self.max_threshold_bytes = None
                                        self.conform_packets = None
                                        self.conform_bytes = None
                                        self.exceed_packets = None
                                        self.exceed_bytes = None
                                        self.conform_rate = None
                                        self.exceed_rate = None

                                        self.queue_instance_length = YList(self)
                                        self.queue_average_length = YList(self)
                                        self.queue_max_length = YList(self)
                                        self._segment_path = lambda: "queue-stats-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray, ['queue_id', 'tail_drop_packets', 'tail_drop_bytes', 'atm_clp0_drop_packets', 'atm_clp0_drop_bytes', 'atm_clp1_drop_packets', 'atm_clp1_drop_bytes', 'queue_drop_threshold', 'forced_wred_stats_display', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'conform_rate', 'exceed_rate'], name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                            ])
                                            self.value = None
                                            self.unit = None
                                            self._segment_path = lambda: "queue-instance-length"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, ['value', 'unit'], name, value)


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                            ])
                                            self.value = None
                                            self.unit = None
                                            self._segment_path = lambda: "queue-average-length"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, ['value', 'unit'], name, value)


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:  :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'PolicyParamUnit', '')])),
                                            ])
                                            self.value = None
                                            self.unit = None
                                            self._segment_path = lambda: "queue-max-length"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, ['value', 'unit'], name, value)


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:  :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("color-class-stats", ("color_class_stats", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats))])
                                        self._leafs = OrderedDict([
                                            ('drop_packets', (YLeaf(YType.uint64, 'drop-packets'), ['int'])),
                                            ('drop_bytes', (YLeaf(YType.uint64, 'drop-bytes'), ['int'])),
                                            ('conform_packets', (YLeaf(YType.uint64, 'conform-packets'), ['int'])),
                                            ('conform_bytes', (YLeaf(YType.uint64, 'conform-bytes'), ['int'])),
                                            ('exceed_packets', (YLeaf(YType.uint64, 'exceed-packets'), ['int'])),
                                            ('exceed_bytes', (YLeaf(YType.uint64, 'exceed-bytes'), ['int'])),
                                            ('violate_packets', (YLeaf(YType.uint64, 'violate-packets'), ['int'])),
                                            ('violate_bytes', (YLeaf(YType.uint64, 'violate-bytes'), ['int'])),
                                            ('parent_drop_packets', (YLeaf(YType.uint64, 'parent-drop-packets'), ['int'])),
                                            ('parent_drop_bytes', (YLeaf(YType.uint64, 'parent-drop-bytes'), ['int'])),
                                            ('conform_rate', (YLeaf(YType.uint32, 'conform-rate'), ['int'])),
                                            ('exceed_rate', (YLeaf(YType.uint32, 'exceed-rate'), ['int'])),
                                            ('violate_rate', (YLeaf(YType.uint32, 'violate-rate'), ['int'])),
                                        ])
                                        self.drop_packets = None
                                        self.drop_bytes = None
                                        self.conform_packets = None
                                        self.conform_bytes = None
                                        self.exceed_packets = None
                                        self.exceed_bytes = None
                                        self.violate_packets = None
                                        self.violate_bytes = None
                                        self.parent_drop_packets = None
                                        self.parent_drop_bytes = None
                                        self.conform_rate = None
                                        self.exceed_rate = None
                                        self.violate_rate = None

                                        self.color_class_stats = Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._segment_path = lambda: "police-stats-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray, ['drop_packets', 'drop_bytes', 'conform_packets', 'conform_bytes', 'exceed_packets', 'exceed_bytes', 'violate_packets', 'violate_bytes', 'parent_drop_packets', 'parent_drop_bytes', 'conform_rate', 'exceed_rate', 'violate_rate'], name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('conform_class_conform_packets', (YLeaf(YType.uint64, 'conform-class-conform-packets'), ['int'])),
                                                ('conform_class_conform_bytes', (YLeaf(YType.uint64, 'conform-class-conform-bytes'), ['int'])),
                                                ('conform_class_conform_rate', (YLeaf(YType.uint32, 'conform-class-conform-rate'), ['int'])),
                                                ('conform_class_exceed_packets', (YLeaf(YType.uint64, 'conform-class-exceed-packets'), ['int'])),
                                                ('conform_class_exceed_bytes', (YLeaf(YType.uint64, 'conform-class-exceed-bytes'), ['int'])),
                                                ('conform_class_exceed_rate', (YLeaf(YType.uint32, 'conform-class-exceed-rate'), ['int'])),
                                                ('conform_class_violate_packets', (YLeaf(YType.uint64, 'conform-class-violate-packets'), ['int'])),
                                                ('conform_class_violate_bytes', (YLeaf(YType.uint64, 'conform-class-violate-bytes'), ['int'])),
                                                ('conform_class_violate_rate', (YLeaf(YType.uint32, 'conform-class-violate-rate'), ['int'])),
                                                ('exceed_class_exceed_packets', (YLeaf(YType.uint64, 'exceed-class-exceed-packets'), ['int'])),
                                                ('exceed_class_exceed_bytes', (YLeaf(YType.uint64, 'exceed-class-exceed-bytes'), ['int'])),
                                                ('exceed_class_exceed_rate', (YLeaf(YType.uint32, 'exceed-class-exceed-rate'), ['int'])),
                                                ('exceed_class_violate_packets', (YLeaf(YType.uint64, 'exceed-class-violate-packets'), ['int'])),
                                                ('exceed_class_violate_bytes', (YLeaf(YType.uint64, 'exceed-class-violate-bytes'), ['int'])),
                                                ('exceed_class_violate_rate', (YLeaf(YType.uint32, 'exceed-class-violate-rate'), ['int'])),
                                                ('violate_class_violate_packets', (YLeaf(YType.uint64, 'violate-class-violate-packets'), ['int'])),
                                                ('violate_class_violate_bytes', (YLeaf(YType.uint64, 'violate-class-violate-bytes'), ['int'])),
                                                ('violate_class_violate_rate', (YLeaf(YType.uint32, 'violate-class-violate-rate'), ['int'])),
                                            ])
                                            self.conform_class_conform_packets = None
                                            self.conform_class_conform_bytes = None
                                            self.conform_class_conform_rate = None
                                            self.conform_class_exceed_packets = None
                                            self.conform_class_exceed_bytes = None
                                            self.conform_class_exceed_rate = None
                                            self.conform_class_violate_packets = None
                                            self.conform_class_violate_bytes = None
                                            self.conform_class_violate_rate = None
                                            self.exceed_class_exceed_packets = None
                                            self.exceed_class_exceed_bytes = None
                                            self.exceed_class_exceed_rate = None
                                            self.exceed_class_violate_packets = None
                                            self.exceed_class_violate_bytes = None
                                            self.exceed_class_violate_rate = None
                                            self.violate_class_violate_packets = None
                                            self.violate_class_violate_bytes = None
                                            self.violate_class_violate_rate = None
                                            self._segment_path = lambda: "color-class-stats"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, ['conform_class_conform_packets', 'conform_class_conform_bytes', 'conform_class_conform_rate', 'conform_class_exceed_packets', 'conform_class_exceed_bytes', 'conform_class_exceed_rate', 'conform_class_violate_packets', 'conform_class_violate_bytes', 'conform_class_violate_rate', 'exceed_class_exceed_packets', 'exceed_class_exceed_bytes', 'exceed_class_exceed_rate', 'exceed_class_violate_packets', 'exceed_class_violate_bytes', 'exceed_class_violate_rate', 'violate_class_violate_packets', 'violate_class_violate_bytes', 'violate_class_violate_rate'], name, value)


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\: str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of  		 :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-09-13'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("red-label", ("red_label", Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel))])
                                        self._leafs = OrderedDict([
                                            ('profile_title', (YLeaf(YType.str, 'profile-title'), ['str'])),
                                            ('red_transmit_packets', (YLeaf(YType.uint64, 'red-transmit-packets'), ['int'])),
                                            ('red_transmit_bytes', (YLeaf(YType.uint64, 'red-transmit-bytes'), ['int'])),
                                            ('random_drop_packets', (YLeaf(YType.uint64, 'random-drop-packets'), ['int'])),
                                            ('random_drop_bytes', (YLeaf(YType.uint64, 'random-drop-bytes'), ['int'])),
                                            ('max_threshold_packets', (YLeaf(YType.uint64, 'max-threshold-packets'), ['int'])),
                                            ('max_threshold_bytes', (YLeaf(YType.uint64, 'max-threshold-bytes'), ['int'])),
                                            ('red_ecn_marked_packets', (YLeaf(YType.uint64, 'red-ecn-marked-packets'), ['int'])),
                                            ('red_ecn_marked_bytes', (YLeaf(YType.uint64, 'red-ecn-marked-bytes'), ['int'])),
                                        ])
                                        self.profile_title = None
                                        self.red_transmit_packets = None
                                        self.red_transmit_bytes = None
                                        self.random_drop_packets = None
                                        self.random_drop_bytes = None
                                        self.max_threshold_packets = None
                                        self.max_threshold_bytes = None
                                        self.red_ecn_marked_packets = None
                                        self.red_ecn_marked_bytes = None

                                        self.red_label = YList(self)
                                        self._segment_path = lambda: "wred-stats-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray, ['profile_title', 'red_transmit_packets', 'red_transmit_bytes', 'random_drop_packets', 'random_drop_bytes', 'max_threshold_packets', 'max_threshold_bytes', 'red_ecn_marked_packets', 'red_ecn_marked_bytes'], name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-09-13'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('wred_type', (YLeaf(YType.enumeration, 'wred-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper', 'Wred', '')])),
                                                ('value', (YLeaf(YType.uint8, 'value'), ['int'])),
                                            ])
                                            self.wred_type = None
                                            self.value = None
                                            self._segment_path = lambda: "red-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance.Statistics.ClassStats.WredStatsArray.RedLabel, ['wred_type', 'value'], name, value)

    def clone_ptr(self):
        self._top_entity = Qos()
        return self._top_entity

